/* Arquivo             : Janelas.C       */
/* Autores             : Lanza - Calixto */
/* Data Inicio         : 24-04-91        */
/* Data Ultima Revisao : 04-06-91        */

#ifndef JANELAS_C
#define JANELAS_C

#include <conio.h>
#include <alloc.h>
#include <string.h>

#include <CntGlob.H>
#include <TipGlob.H>
#include <FncGlob.H>


/* Constantes */
#define Sup_Esq                         0xC9
#define Sup_Dir                         0XBB
#define Inf_Esq                         0xC8
#define Inf_Dir                         0xBC
#define Horiz                           0xCD
#define Vert                            0xBA
#define Horiz_Vert_Sup                  0xCA
#define Horiz_Vert_Inf                  0xCB


/* Tipos */

typedef struct Janela
  {
    /* Valores referentes a janela a ser criada */
    unsigned char        Absc_Sup_Esq,
                         Ordn_Sup_Esq,
                         Absc_Inf_Dir,
                         Ordn_Inf_Dir;
    unsigned char        Cor_Fundo;

    /* Valores referentes a janela sobreposta, utilizados para restauracao da mesma */
    struct text_info     Info_Texto_Janela_Anterior;
    void                 *Ptr_Texto_Janela;

    /* Ponteiro de encadeamento */
    struct Janela        *Ptr_Anterior;
  } Janela;

typedef struct Janela    *Ptr_Janela;


/* Variaveis */

Ptr_Janela               Ptr_Prim = NULL,Ptr_Ult = NULL;


/* Prototipos */

Boolean Salvar_Janela (unsigned char,unsigned char,
                       unsigned char,unsigned char);

void Abrir_Janela (unsigned char,unsigned char,
                   unsigned char,unsigned char,
                   unsigned char,unsigned char,
                   char *);

void Fechar_Janela (void);


/****************************************************************************/

Boolean Salvar_Janela
 (unsigned char Absc_Sup_Esq,
  unsigned char Ordn_Sup_Esq,
  unsigned char Absc_Inf_Dir,
  unsigned char Ordn_Inf_Dir)

  {

    Ptr_Janela           Ptr_Temp_Janela;
    unsigned             Tam_Janela;

    if ((Ptr_Temp_Janela = malloc (sizeof (Janela))) != NULL)
      {
        Tam_Janela = (Absc_Inf_Dir - Absc_Sup_Esq + 1) *
                     (Ordn_Inf_Dir - Ordn_Sup_Esq + 1) * 2;
        if ((Ptr_Temp_Janela->Ptr_Texto_Janela = malloc (Tam_Janela)) != NULL)
          {

            if (Ptr_Prim == NULL)
              {
                Ptr_Prim = Ptr_Temp_Janela;
                Ptr_Prim->Ptr_Anterior = NULL;
              }
            else
              Ptr_Temp_Janela->Ptr_Anterior = Ptr_Ult;
            Ptr_Ult = Ptr_Temp_Janela;

            gettext (Absc_Sup_Esq,Ordn_Sup_Esq,Absc_Inf_Dir,Ordn_Inf_Dir,
                     Ptr_Ult->Ptr_Texto_Janela);

            Ptr_Ult->Absc_Sup_Esq = Absc_Sup_Esq;
            Ptr_Ult->Ordn_Sup_Esq = Ordn_Sup_Esq;
            Ptr_Ult->Absc_Inf_Dir = Absc_Inf_Dir;
            Ptr_Ult->Ordn_Inf_Dir = Ordn_Inf_Dir;
            gettextinfo (&(Ptr_Ult->Info_Texto_Janela_Anterior));
            return (True);
          }
        else
          {
            free (Ptr_Temp_Janela);
            return (False);
          }
      }
    else
      return (False);
  }


/****************************************************************************/

void Abrir_Janela (unsigned char Absc_Sup_Esq,
                   unsigned char Ordn_Sup_Esq,
                   unsigned char Absc_Inf_Dir,
                   unsigned char Ordn_Inf_Dir,
                   unsigned char Cor_Fundo,
                   unsigned char Cor_Texto,
                   char *Titulo)

  {

    unsigned char                       Ind_Absc;
    unsigned char                       Ind_Ordn;

    if ((Absc_Sup_Esq < Absc_Inf_Dir) &&
        (Ordn_Sup_Esq < Ordn_Inf_Dir))
      {
        if (Ordn_Inf_Dir > 24)
          Ordn_Inf_Dir = 24;
        Salvar_Janela (Absc_Sup_Esq,Ordn_Sup_Esq,Absc_Inf_Dir,Ordn_Inf_Dir);
        Ptr_Ult->Cor_Fundo = Cor_Fundo;
        textbackground (Cor_Fundo);
        textcolor (Cor_Texto);
        window (Absc_Sup_Esq,Ordn_Sup_Esq,Absc_Inf_Dir,Ordn_Inf_Dir);
        clrscr ();
        window (Absc_Sup_Esq,Ordn_Sup_Esq,Absc_Inf_Dir,Ordn_Inf_Dir + 1);
        Absc_Inf_Dir = Absc_Inf_Dir - Absc_Sup_Esq + 1;
        Ordn_Inf_Dir = Ordn_Inf_Dir - Ordn_Sup_Esq + 1;
        Absc_Sup_Esq = 1;
        Ordn_Sup_Esq = 1;
        putch (Sup_Esq);
        for (Ind_Absc = Absc_Sup_Esq + 1;Ind_Absc < Absc_Inf_Dir;Ind_Absc++)
          putch (Horiz);
        putch (Sup_Dir);
        for (Ind_Ordn = Ordn_Sup_Esq + 1;Ind_Ordn < Ordn_Inf_Dir;Ind_Ordn++)
          {
            gotoxy (Absc_Sup_Esq,Ind_Ordn);
            putch (Vert);
            gotoxy (Absc_Inf_Dir,Ind_Ordn);
            putch (Vert);
          }
        gotoxy (Absc_Sup_Esq,Ordn_Inf_Dir);
        putch (Inf_Esq);
        for (Ind_Absc = Absc_Sup_Esq + 1;Ind_Absc < Absc_Inf_Dir;Ind_Absc++)
          putch (Horiz);
        putch (Inf_Dir);
        if ((Titulo != NULL) &&
            (strlen (Titulo) < (Absc_Inf_Dir - Absc_Sup_Esq)))
          {
            gotoxy ((((Absc_Inf_Dir - Absc_Sup_Esq) / 2 + 1 - strlen (Titulo) / 2)),
                    Ordn_Sup_Esq);
            cprintf ("%s",Titulo);
          }
        window (Ptr_Ult->Absc_Sup_Esq + 1,
                Ptr_Ult->Ordn_Sup_Esq + 1,
                Ptr_Ult->Absc_Inf_Dir - 1,
                Ptr_Ult->Ordn_Inf_Dir - 1);
      }

  } /* Abrir_Janela */


/****************************************************************************/

void Fechar_Janela (void)

  {
    Ptr_Janela           Ptr_Temp_Janela;

    if (Ptr_Ult != NULL)
      {
        puttext (Ptr_Ult->Absc_Sup_Esq,Ptr_Ult->Ordn_Sup_Esq,
                 Ptr_Ult->Absc_Inf_Dir,Ptr_Ult->Ordn_Inf_Dir,
                 Ptr_Ult->Ptr_Texto_Janela);
        textattr (Ptr_Ult->Info_Texto_Janela_Anterior.attribute);
        window (Ptr_Ult->Info_Texto_Janela_Anterior.winleft,
                Ptr_Ult->Info_Texto_Janela_Anterior.wintop,
                Ptr_Ult->Info_Texto_Janela_Anterior.winright,
                Ptr_Ult->Info_Texto_Janela_Anterior.winbottom);
        gotoxy (Ptr_Ult->Info_Texto_Janela_Anterior.curx,
                Ptr_Ult->Info_Texto_Janela_Anterior.cury);
        Ptr_Temp_Janela = Ptr_Ult;
        Ptr_Ult = Ptr_Ult->Ptr_Anterior;
        free (Ptr_Temp_Janela->Ptr_Texto_Janela);
        free (Ptr_Temp_Janela);
      }
  } /* Fechar_Janela */


#endif