/* Arquivo             : MemRX.C  */
/* Data Inicio         : 30-10-90 */
/* ultimas modificacoes - Marcos Tadeu                                       */
/* 15-07-92 :registro liberado (inicio e fim=NULL) no meio da fila de livres,*/
/*           nao era descartado quando houvesse uma sequencia de livres ate  */
/*           o ultimo. o "do {} while" introduzido resolveu. (lin 358)       */

/****************************************************************************/
/*                                                                          */
/*                        Gerenciador de Memoria RX                         */
/*                                                                          */
/****************************************************************************/

#include <dos.h>
#include <alloc.h>
#include <stdio.h>
#include <conio.h>
#include <string.h>
#include <TipGlob.h>
#include <MemTx.h>

/* CONSTANTES */

#define   Nr_Max_Elem_Est_Prim         256   /*  Constantes da regiao de alocacao */
#define   Tamanho_Elem_Est_Prim         10   /*  de estruturas de Primitivas      */
#define   Tamanho_Mem_Est_Prim    Nr_Max_Elem_Est_Prim * Tamanho_Elem_Est_Prim

#define   Nr_Max_Elem_Est_Param        256   /*  Constantes da regiao de alocacao */
#define   Tamanho_Elem_Est_Param        15   /*  de estruturas de parametros      */
#define   Tamanho_Mem_Est_Param   Nr_Max_Elem_Est_Param * Tamanho_Elem_Est_Param

#define   Tamanho_Heap       0xFFF0l   /* Tamanho da Heap                 */
#define   Tamanho_Ptr               4   /* numero de bytes de um ponteiro  */
#define   Nr_Regs_Lista_Livre    501 /*4096*/   /* numero de registros da Lista_Livre */

/* TIPOS */

typedef struct
  {
    unsigned char  *Ptr_Inicio;
    unsigned char  *Ptr_Fim;
  } Estrutura_Livre;

typedef Estrutura_Livre    *Tipo_Ptr_Estrutura_Livre;

typedef Estrutura_Livre    Tipo_Lista_Livre[Nr_Regs_Lista_Livre];

typedef Tipo_Lista_Livre   *Tipo_Ptr_Lista_Livre;

/* VARIAVEIS */

Boolean         Estado_Mem_Est_Prim_Rx[Nr_Max_Elem_Est_Prim];
unsigned char            *Ptr_Base_Mem_Est_Prim_Rx;
unsigned int    N_Prim_Rx;
unsigned int    Ind_Prim_Livre_Rx;

Boolean         Estado_Mem_Est_Param_Rx[Nr_Max_Elem_Est_Param];
unsigned char            *Ptr_Base_Mem_Est_Param_Rx;
unsigned int    N_Param_Rx;
unsigned int    Ind_Param_Livre_Rx;

Tipo_Ptr_Lista_Livre            Ptr_Lista_Livre_Rx;
unsigned char                            *Ptr_Heap_Rx;
unsigned char                            *Ptr_Base_Heap_Rx;
unsigned char                            *Ptr_Topo_Heap_Rx;
int                             Indice_Reg_Livre_Rx;
Tipo_Ptr_Estrutura_Livre        Ptr_Reg_Livre_Rx;
Tipo_Ptr_Estrutura_Livre        Ptr_Base_Reg_Livre_Rx;
unsigned int                    N_Aloc_Rx;
unsigned int                    N_Dealoc_Rx;

/* CABECALOS DAS FUNCOES */

void Imp_RX (void);

void Imprimir_Estado_Heap_Rx (void);
void Imprimir_Estado_Prim_Rx (void);
void Imprimir_Estado_Param_Rx (void);
Boolean Inicializar_Mem_Rx (void);
void Finalizar_Mem_Rx (void);
unsigned char *Alocar_Estrutura_Primitiva_Rx (void);
void Liberar_Estrutura_Primitiva_Rx (unsigned char  *Ptr);
unsigned char *Alocar_Memoria_Rx (unsigned int Tamanho);
unsigned char *Liberar_Memoria_Rx (unsigned char *Ptr,unsigned int Tamanho);
unsigned int Tamanho_Cadeia_Rx (Estrutura_Parametros *Ptr);

/* FUNCOES */

void Imp_RX(void)
{
    printf ("\n************************** ESTADO HEAP RX *****************************\n\n");
    printf ("Numero de Alocacoes RX : %u      Numero de Dealocacoes RX : %u\n",N_Aloc_Rx,N_Dealoc_Rx);
    printf ("Ptr_Base_Heap_Rx :");
    Imprimir_Ptr (Ptr_Base_Heap_Rx);
    printf ("  Ptr_Topo_Heap_Rx :");
    Imprimir_Ptr (Ptr_Topo_Heap_Rx);
    printf ("  Ptr_Base_Livre :");
    Imprimir_Ptr ((unsigned char *) Ptr_Base_Reg_Livre_Rx);
    printf ("\n--> Ptr_Heap_Rx      :");
    Imprimir_Ptr (Ptr_Heap_Rx);
    printf ("\n--> Ptr_Reg_Livre_Rx :");
    Imprimir_Ptr ((unsigned char *) Ptr_Reg_Livre_Rx);
    printf ("                 Indice_Livre : %u\n",Indice_Reg_Livre_Rx);
}

void Imprimir_Estado_Heap_Rx (void)
  {
    unsigned int  Indice;

    Imp_RX();

    /* Imprimir Conteudo da Lista_Livre */

      for (Indice = Nr_Regs_Lista_Livre - 1;
           Indice > Indice_Reg_Livre_Rx;
           Indice--)
         {
           printf ("Lista[%u] ->  Inicio = ",Indice);
           Imprimir_Ptr (Ptr_Base_Reg_Livre_Rx[Indice].Ptr_Inicio);
           printf ("  Fim = ");
           Imprimir_Ptr (Ptr_Base_Reg_Livre_Rx[Indice].Ptr_Fim);
           printf ("\n");
         }

    getch ();
  }

void Imprimir_Estado_Prim_Rx (void)
  {
    printf ("\nNumero de Estruturas de Primitivas_Rx Alocadas : %u\n",N_Prim_Rx);
  }

void Imprimir_Estado_Param_Rx (void)
  {
    printf ("\nNumero de Estruturas de Parametros_Rx Alocadas : %u\n",N_Param_Rx);
  }

Boolean Inicializar_Mem_Rx (void)
  {
    int i;

    N_Aloc_Rx = 0;
    N_Dealoc_Rx = 0;
    N_Prim_Rx = 0;
    N_Param_Rx = 0;


    Ptr_Heap_Rx = malloc((unsigned int) (Tamanho_Heap));
    Ptr_Topo_Heap_Rx = Ptr_Heap_Rx + (unsigned int) (Tamanho_Heap);
    Ptr_Base_Heap_Rx = Ptr_Heap_Rx;
    Indice_Reg_Livre_Rx = Nr_Regs_Lista_Livre-1;
    Ptr_Reg_Livre_Rx = (Tipo_Ptr_Estrutura_Livre) (Ptr_Topo_Heap_Rx - 2*Tamanho_Ptr);
    Ptr_Base_Reg_Livre_Rx = (Tipo_Ptr_Estrutura_Livre) (Ptr_Topo_Heap_Rx - 2 * Tamanho_Ptr * Nr_Regs_Lista_Livre);

    for (i = 0; i < Nr_Max_Elem_Est_Prim; i++)  /* Inicialmente todos os campos livres */
      Estado_Mem_Est_Prim_Rx[i] = FALSE;
    Ptr_Base_Mem_Est_Prim_Rx = malloc(Tamanho_Mem_Est_Prim);    /* Reserva Memoria para alocacao dos elementos */
    Ind_Prim_Livre_Rx = 0;

    for (i = 0; i < Nr_Max_Elem_Est_Param; i++)  /* Inicialmente todos os campos livres */
      Estado_Mem_Est_Param_Rx[i] = FALSE;
    Ptr_Base_Mem_Est_Param_Rx = malloc(Tamanho_Mem_Est_Param);    /* Reserva Memoria para alocacao dos elementos */
    Ind_Param_Livre_Rx = 0;

    if ((Ptr_Base_Mem_Est_Prim_Rx != NULL) && (Ptr_Base_Mem_Est_Param_Rx != NULL) && (Ptr_Heap_Rx != NULL))
      return (TRUE);
    else
      return (FALSE);

  }

void Finalizar_Mem_Rx (void)
  {
    Imprimir_Estado_Heap_Rx ();
    Imprimir_Estado_Param_Rx ();
    Imprimir_Estado_Prim_Rx ();
    free(Ptr_Base_Mem_Est_Prim_Rx);
    free(Ptr_Base_Mem_Est_Param_Rx);
    free(Ptr_Base_Heap_Rx);
  }

unsigned char *Alocar_Estrutura_Primitiva_Rx (void)
  {
     unsigned int   Indice;
     unsigned char *Ptr_Temp;

     Indice = Ind_Prim_Livre_Rx;
     while (Estado_Mem_Est_Prim_Rx[Ind_Prim_Livre_Rx]) {
       Ind_Prim_Livre_Rx = (++Ind_Prim_Livre_Rx) & (Nr_Max_Elem_Est_Prim - 1);
       if (Indice == Ind_Prim_Livre_Rx)
         return (NULL);
     }
     N_Prim_Rx++;
     Estado_Mem_Est_Prim_Rx[Ind_Prim_Livre_Rx] = TRUE;
     Ptr_Temp = Ptr_Base_Mem_Est_Prim_Rx + Ind_Prim_Livre_Rx * Tamanho_Elem_Est_Prim;
     Ind_Prim_Livre_Rx = (++Ind_Prim_Livre_Rx) & (Nr_Max_Elem_Est_Prim - 1);
     return (Ptr_Temp);

  } /* Fim Alocar_Estrutura_Primitiva_Rx */

void Liberar_Estrutura_Primitiva_Rx (unsigned char  *Ptr)
  {
    unsigned int  Indice;

    if (Ptr != NULL)
      {
        N_Prim_Rx--;
        Indice = ((int) (Ptr - Ptr_Base_Mem_Est_Prim_Rx)) / Tamanho_Elem_Est_Prim;
        Estado_Mem_Est_Prim_Rx[Indice] = FALSE;
      }
    else ;

  } /* Fim Liberar_Estrutura_Primitiva_Rx */



Estrutura_Parametros *Alocar_Estrutura_Parametros_Rx (void)
  {
  unsigned int           Indice;
  Estrutura_Parametros  *Ptr_Temp;

  Indice = Ind_Param_Livre_Rx;
  while (Estado_Mem_Est_Param_Rx[Ind_Param_Livre_Rx]) {
    Ind_Param_Livre_Rx = (++Ind_Param_Livre_Rx) & (Nr_Max_Elem_Est_Param - 1);
    if (Indice == Ind_Param_Livre_Rx)
      return (NULL);
  }
  N_Param_Rx++;
  Estado_Mem_Est_Param_Rx[Ind_Param_Livre_Rx] = TRUE;
  Ptr_Temp = (Estrutura_Parametros *) (Ptr_Base_Mem_Est_Param_Rx + Ind_Param_Livre_Rx * Tamanho_Elem_Est_Param);
  Ind_Param_Livre_Rx = (++Ind_Param_Livre_Rx) & (Nr_Max_Elem_Est_Param - 1);
  memset (Ptr_Temp,0,Tamanho_Elem_Est_Param);
  return (Ptr_Temp);

  } /* Fim Alocar_Estrutura_Parametros_Rx */

void Liberar_Estrutura_Parametros_Rx (Estrutura_Parametros *Ptr)
  {
    unsigned int  Indice;

    while (Ptr != NULL)
      {
        if (Ptr->Num_Alocacoes == 0)
          {
            N_Param_Rx--;
            if ((Ptr->Ptr_Dados_Usuario != NULL) && (Ptr->Tam_Dados_Usuario != 0))
              Liberar_Memoria_Rx ((unsigned char *) (Ptr->Ptr_Dados_Usuario),Ptr->Tam_Dados_Usuario);
            Indice = ((int) (((unsigned char *) Ptr) - Ptr_Base_Mem_Est_Param_Rx)) / Tamanho_Elem_Est_Param;
            Estado_Mem_Est_Param_Rx[Indice] = FALSE;
            Ptr = Ptr->Ptr_Proximo;
          }
        else
          {
            Ptr->Num_Alocacoes--;
            Ptr = Ptr->Ptr_Proximo;
          }
      }
  } /* Fim Liberar_Estrutura_Parametros_Rx */


unsigned char *Alocar_Memoria_Rx (unsigned int Tamanho)
  {
    unsigned char *Ptr_Temp,*Ptr_Temp2;
    unsigned int  Indice;

    N_Aloc_Rx++;

    Indice = Nr_Regs_Lista_Livre;    /* Procura a primeira area em que Tamanho e' alocavel */
    do {
       Indice--;
       Ptr_Temp = Ptr_Base_Reg_Livre_Rx[Indice].Ptr_Inicio + Tamanho;
       } while ((Indice > Indice_Reg_Livre_Rx) &&
             (Ptr_Temp > Ptr_Base_Reg_Livre_Rx[Indice].Ptr_Fim));

    if (Indice > Indice_Reg_Livre_Rx)  /* Existe registro onde Tamanho e' alocavel */

      if (Ptr_Temp < Ptr_Base_Reg_Livre_Rx[Indice].Ptr_Fim)        /* Regiao livre menor que tamanho */
        {
        Ptr_Temp2 = Ptr_Base_Reg_Livre_Rx[Indice].Ptr_Inicio;
        Ptr_Base_Reg_Livre_Rx[Indice].Ptr_Inicio = Ptr_Temp;
        return (Ptr_Temp2);
        }
      else   /* (Ptr_Temp = Ptr_Base_Reg_Livre_Rx[Indice].Ptr_Fim) */        /* Regiao livre igual a tamanho */
        {
        Ptr_Temp2 = Ptr_Base_Reg_Livre_Rx[Indice].Ptr_Inicio;
        Ptr_Base_Reg_Livre_Rx[Indice].Ptr_Inicio = NULL;
        Ptr_Base_Reg_Livre_Rx[Indice].Ptr_Fim = NULL;
        if (Indice == (Indice_Reg_Livre_Rx+1))       /* Atualizo Ptr_Reg e Indice_Reg se o */
          do
            {                                        /* registro liberado e' o ultimo       */
            Ptr_Reg_Livre_Rx++;
            Indice_Reg_Livre_Rx++;
            } while ((Indice_Reg_Livre_Rx < Nr_Regs_Lista_Livre-1)
                  &&(Ptr_Base_Reg_Livre_Rx[Indice_Reg_Livre_Rx+1].Ptr_Inicio == NULL));
        return (Ptr_Temp2);
        }

    else
      if ((Ptr_Heap_Rx + Tamanho) > (unsigned char *) (Ptr_Reg_Livre_Rx))
        return (NULL);
      else                           /* Nao ha' regiao livre em que caiba Tamanho */
        {
        Ptr_Temp = Ptr_Heap_Rx;   /* alocar area alterando o Ptr_Heap_Rx */
        Ptr_Heap_Rx += Tamanho;
        return(Ptr_Temp);
        }
  } /* Fim Alocar_Memoria_Rx */


/* Condicoes para nao gerar outro registro na lista de Livres               */
/*     1 - area a ser liberada e' e primeira do topo da Heap                */
/*              depois verifica-se se ha' alguma area livre no topo da Heap */
/*              constando da lista de livres                                */
/*     2 - area abaixo da regiao a ser liberada consta da lista de livres   */
/*     3 - area acima da regiao a ser liberada consta da lista de livres    */
/*     4 - existe registro livre e nao houve liberacao a partir das condicoes acima */


unsigned char *Liberar_Memoria_Rx (unsigned char *Ptr,unsigned int Tamanho)
{
unsigned char *Ptr_Temp;
int Indice;
Boolean Nao_Criar;
int Indice_Temp;
unsigned char *Ptr_Retorno;

N_Dealoc_Rx++;
Ptr_Retorno = Ptr;
Ptr_Temp = Ptr + Tamanho;
Indice_Temp = 0;

if ((Ptr == NULL) || (Tamanho == 0))
  ;
else
  if (Ptr_Temp > Ptr_Heap_Rx)
    ;                              /* tentando dealocar area maior que a de alocacao */

  else
    if (Ptr_Temp == Ptr_Heap_Rx)   /* Condicao 1 - dealocacao ordenada */
      {
      Ptr_Heap_Rx -= Tamanho;
      for (Indice = Nr_Regs_Lista_Livre - 1;                      /* Verifica se na Lista Livre ha algum */
           Indice > Indice_Reg_Livre_Rx;                             /* Ptr_Fim = Ptr_Heap_Rx                  */
           Indice--)
          if (Ptr_Heap_Rx == Ptr_Base_Reg_Livre_Rx[Indice].Ptr_Fim)
            {
              Ptr_Heap_Rx = Ptr_Base_Reg_Livre_Rx[Indice].Ptr_Inicio;   /* Atualiza Ptr_Heap_Rx e limpa registro  */
              Ptr_Base_Reg_Livre_Rx[Indice].Ptr_Inicio = NULL;       /* da Lista Livre                      */
              Ptr_Base_Reg_Livre_Rx[Indice].Ptr_Fim = NULL;
              if (Indice == (Indice_Reg_Livre_Rx+1))       /* Atualizo Ptr_Reg e Indice_Reg se o */
                do
                  {                                        /* registro liberado e' o ultimo       */
                  Ptr_Reg_Livre_Rx++;
                  Indice_Reg_Livre_Rx++;
                  } while ((Indice_Reg_Livre_Rx < Nr_Regs_Lista_Livre-1)
                        &&(Ptr_Base_Reg_Livre_Rx[Indice_Reg_Livre_Rx+1].Ptr_Inicio == NULL));
            }

      Ptr_Retorno = Ptr_Heap_Rx; /*return (Ptr_Heap_Rx);*/
      }
    else  /* (Ptr_Temp < Ptr_Heap_Rx) */        /* Condicoes 2 e 3 - dealocacao desordenada */
      {
      Nao_Criar = FALSE;
      for (Indice = Nr_Regs_Lista_Livre - 1;                      /* Verifica se na Lista Livre ha algum */
           Indice > Indice_Reg_Livre_Rx;                            /* Ptr_Fim = Ptr_Heap_Rx                  */
           Indice--)
        {
        if (Ptr_Temp == Ptr_Base_Reg_Livre_Rx[Indice].Ptr_Inicio)   /* juncao com a regiao superior */
          {
          Ptr_Base_Reg_Livre_Rx[Indice].Ptr_Inicio = Ptr;         /* junta as regioes livres */
          Ptr_Temp = Ptr_Base_Reg_Livre_Rx[Indice].Ptr_Fim;       /* prepara possivel juncao com inferior */
          if (Nao_Criar) /* ja' houve juncao com a de cima */
            {
            Ptr_Base_Reg_Livre_Rx[Indice_Temp].Ptr_Inicio = NULL;
            Ptr_Base_Reg_Livre_Rx[Indice_Temp].Ptr_Fim = NULL;
            if (Indice_Temp == Indice_Reg_Livre_Rx)             /* Atualizo Ptr_Reg e Indice_Reg se o */
              do
                {                                                 /* registro liberado e' o ultimo       */
                Ptr_Reg_Livre_Rx++;
                Indice_Reg_Livre_Rx++;
                } while ((Indice_Reg_Livre_Rx < Nr_Regs_Lista_Livre-1)
                      &&(Ptr_Base_Reg_Livre_Rx[Indice_Reg_Livre_Rx+1].Ptr_Inicio == NULL));
            }
          Nao_Criar = TRUE;
          Indice_Temp = Indice;
          }
        if (Ptr == Ptr_Base_Reg_Livre_Rx[Indice].Ptr_Fim)
          {
          Ptr_Base_Reg_Livre_Rx[Indice].Ptr_Fim = Ptr_Temp;
          Ptr = Ptr_Base_Reg_Livre_Rx[Indice].Ptr_Inicio;
          if (Nao_Criar) /* ja' houve juncao com a de cima */
            {
            Ptr_Base_Reg_Livre_Rx[Indice_Temp].Ptr_Inicio = NULL;
            Ptr_Base_Reg_Livre_Rx[Indice_Temp].Ptr_Fim = NULL;
            if (Indice_Temp == Indice_Reg_Livre_Rx)                     /* Atulalizo Ptr_Reg e Indice_Reg se o */
              do
                {                                                 /* registro liberado e' o ultimo       */
                Ptr_Reg_Livre_Rx++;
                Indice_Reg_Livre_Rx++;
                } while ((Indice_Reg_Livre_Rx < Nr_Regs_Lista_Livre-1)
                      &&(Ptr_Base_Reg_Livre_Rx[Indice_Reg_Livre_Rx+1].Ptr_Inicio == NULL));
            }
          Nao_Criar = TRUE;
          Indice_Temp = Indice;
          }
        }
      if (Nao_Criar)
        Ptr_Retorno = Ptr_Temp; /*return (Ptr_Temp);*/
      else
        {
        Indice = Nr_Regs_Lista_Livre;                        /* Procura um registro livre */
        do {
           Indice--;
           } while ((Indice > Indice_Reg_Livre_Rx) &&
                   (Ptr_Base_Reg_Livre_Rx[Indice].Ptr_Inicio != NULL));
        if (Indice > Indice_Reg_Livre_Rx)
          {
          Ptr_Base_Reg_Livre_Rx[Indice].Ptr_Inicio = Ptr;     /* Se achou registro livre */
          Ptr_Base_Reg_Livre_Rx[Indice].Ptr_Fim = Ptr_Temp;    /* entao ocupar            */
          Ptr_Retorno = Ptr_Temp;
          }
        else
          if ((Indice < 0) || ((unsigned char *) (Ptr_Reg_Livre_Rx) <= Ptr_Heap_Rx)) /* Overflow na Lista LIvre */
            Ptr_Retorno = NULL;
          else  /* (Indice = Indice_Reg_Livre_Rx) */
            {
            Ptr_Reg_Livre_Rx->Ptr_Inicio = Ptr;     /* Se nao achou registro livre */
            Ptr_Reg_Livre_Rx->Ptr_Fim = Ptr_Temp;   /* cria novo registro          */
            Indice_Reg_Livre_Rx--;
            Ptr_Reg_Livre_Rx--;
            Ptr_Retorno = Ptr_Temp; /*return(Ptr_Temp);*/
            }
          }
      }
return (Ptr_Retorno);
} /* Fim Liberar_Memoria_Rx */


Estrutura_Parametros *Liberar_Parte_Cadeia_Rx (Estrutura_Parametros *Ptr,unsigned int Tamanho)
  {
    unsigned int Indice;

    while (Tamanho > 0) {
      if (Tamanho < Ptr->Tam_Dados_Usuario) {
        Ptr->Ptr_Dados_Usuario = (unsigned unsigned char *)
                                 (Liberar_Memoria_Rx ((unsigned char *) (Ptr->Ptr_Dados_Usuario),Tamanho));
        Ptr->Tam_Dados_Usuario -= Tamanho;
        Tamanho = 0;
      }
      else {
        Ptr->Ptr_Dados_Usuario = (unsigned unsigned char *)
                                 (Liberar_Memoria_Rx ((unsigned char *) (Ptr->Ptr_Dados_Usuario),Ptr->Tam_Dados_Usuario));
        Tamanho -= Ptr->Tam_Dados_Usuario;
        N_Param_Rx--;
        Indice = ((int) (((unsigned char *) Ptr) - Ptr_Base_Mem_Est_Param_Rx)) / Tamanho_Elem_Est_Param;
        Estado_Mem_Est_Param_Rx[Indice] = FALSE;
        Ptr = Ptr->Ptr_Proximo;
      }
    }
    return (Ptr);
  } /* Fim Liberar_Parte_Cadeia_Rx */


unsigned int Tamanho_Cadeia_Rx (Estrutura_Parametros *Ptr)
  {
    unsigned int Tamanho;

    Tamanho = 0;
    while (Ptr != NULL)
      {
        Tamanho += Ptr->Tam_Dados_Usuario;
        Ptr = Ptr->Ptr_Proximo;
      }
    return (Tamanho);

  } /* Fim  Tamanho_Cadeia_Rx */
