/* Arquivo             : MemTX.C  */
/* Data Inicio         : 30-10-90 */
/* (Marcos Tadeu)                   no meio da fila de livres, nao era des- */
/* 15-07-92                         cartado quando houvesse uma sequencia   */
/*                                  de livres ate o ultimo. o "do {} while" */
/*                                  introduzido resolveu. (lin 358)         */
/* 15-12-92 :farmalloc na iniciacao do heap. Acesso a mais de 64K           */
/*           Rotinas de soma e subtracao de ponteiros Far                   */

/*****************************************************************************/
/*                                                                           */
/*                         Gerenciador de Memoria TX                         */
/*                                                                           */
/*****************************************************************************/


#include <alloc.h>
#include <conio.h>
#include <stdio.h>
#include <string.h>
#include <TipGlob.H>

/* CONSTANTES */

#define   Nr_Max_Elem_Est_Prim         128   /*  Constantes da regiao de alocacao */
#define   Tamanho_Elem_Est_Prim         10   /*  de estruturas de Primitivas      */
#define   Tamanho_Mem_Est_Prim    Nr_Max_Elem_Est_Prim * Tamanho_Elem_Est_Prim

#define   Nr_Max_Elem_Est_Param        128   /*  Constantes da regiao de alocacao */
#define   Tamanho_Elem_Est_Param        15   /*  de estruturas de parametros      */
#define   Tamanho_Mem_Est_Param   Nr_Max_Elem_Est_Param * Tamanho_Elem_Est_Param

#define   Tamanho_Heap       0x5FFF0l   /* Tamanho da Heap                 */
#define   Tamanho_Ptr               4   /* numero de bytes de um ponteiro  */
#define   Nr_Regs_Lista_Livre    1501   /* numero de registros da Lista_Livre */

/* TIPOS */

typedef struct
  {
    unsigned char  *Ptr_Inicio;
    unsigned char  *Ptr_Fim;
  } Estrutura_Livre;

typedef Estrutura_Livre   far *Tipo_Ptr_Estrutura_Livre;

typedef Estrutura_Livre    Tipo_Lista_Livre[Nr_Regs_Lista_Livre];

typedef Tipo_Lista_Livre far *Tipo_Ptr_Lista_Livre;

/* VARIAVEIS */

Boolean         Estado_Mem_Est_Prim[Nr_Max_Elem_Est_Prim];
unsigned char   *Ptr_Base_Mem_Est_Prim;
unsigned int    N_Prim;
unsigned int    Ind_Prim_Livre;

Boolean         Estado_Mem_Est_Param[Nr_Max_Elem_Est_Param];
unsigned char   *Ptr_Base_Mem_Est_Param;
unsigned int    N_Param;
unsigned int    Ind_Param_Livre;

Tipo_Ptr_Lista_Livre            Ptr_Lista_Livre;
unsigned char far               *Ptr_Heap;
unsigned char far               *Ptr_Base_Heap;
unsigned char far               *Ptr_Topo_Heap;
int                             Indice_Reg_Livre;
Tipo_Ptr_Estrutura_Livre        Ptr_Reg_Livre;
Tipo_Ptr_Estrutura_Livre        Ptr_Base_Reg_Livre;
/*
unsigned long                   Real_Ptr_Lista_Livre;
                                Real_Ptr_Heap;
                                Real_Ptr_Base_Heap;
                                Real_Ptr_Topo_Heap;
                                Real_Ptr_Reg_Livre;
                                Real_Ptr_Base_Reg_Livre;
*/
unsigned int                    N_Aloc;
unsigned int                    N_Dealoc;

/* CABECALOS DAS FUNCOES */

void Imprimir_Ptr (unsigned char *Ptr);
void Imprimir_Estado_Heap_Tx (void);
void Imprimir_Estado_Prim_Tx (void);
void Imprimir_Estado_Param_Tx (void);
Boolean Inicializar_Mem_Tx (void);
void Finalizar_Mem_Tx (void);
unsigned char *Alocar_Estrutura_Primitiva_Tx (void);
void Liberar_Estrutura_Primitiva_Tx (unsigned char  *Ptr);
unsigned char *Alocar_Memoria_Tx (unsigned int Tamanho);
unsigned char *Liberar_Memoria_Tx (unsigned char *Ptr,unsigned int Tamanho);
void Realocar_Estrutura_Primitiva_Tx (Estrutura_Parametros *Ptr);
unsigned int Tamanho_Cadeia_Tx (Estrutura_Parametros *Ptr);

unsigned char far * Soma_Ptr_Far (unsigned char far * ptr, unsigned long tam);
unsigned char far * Sub_Ptr_Far (unsigned char far * ptr, unsigned long tam);
boolean P1_Maior_P2(unsigned char far *p1,unsigned char far *p2);
boolean P1_Menor_P2(unsigned char far *p1,unsigned char far *p2);
boolean P1_Igual_P2(unsigned char far *p1,unsigned char far *p2);
Tipo_Ptr_Estrutura_Livre Inc_Ptr_Far(Tipo_Ptr_Estrutura_Livre ptr);
Tipo_Ptr_Estrutura_Livre Dec_Ptr_Far(Tipo_Ptr_Estrutura_Livre ptr);

/* FUNCOES */

void Imprimir_Ptr (unsigned char *Ptr)
  {
    unsigned int  Lo;
    unsigned int  Hi;
    unsigned long int temp;

    if (Ptr != NULL)
      {
        temp = (long int) (Ptr);
        Lo = (unsigned int) (temp);
        Hi = (unsigned int) (temp >> 16);
        printf (" %x:%x ",Hi,Lo);
      }
    else
      printf (" NULL ");
  }

void Imprimir_Estado_Heap_Tx (void)
  {
    unsigned int  Indice;
    unsigned long Total_Heap;
    unsigned long Total_LL;

    printf ("\n************************** ESTADO HEAP TX *****************************\n\n");
    printf ("Numero de Alocacoes TX : %u     Num.Dealoc. TX : %u\n",N_Aloc,N_Dealoc);
    printf ("Ptr_Base_Heap :");
    Imprimir_Ptr (Ptr_Base_Heap);
    printf ("  Ptr_Topo_Heap :");
    Imprimir_Ptr (Ptr_Topo_Heap);
    printf ("  Ptr_Base_Livre :");
    Imprimir_Ptr ((unsigned char *) Ptr_Base_Reg_Livre);
    printf ("\n\n--> Ptr_Heap      :");
    Imprimir_Ptr (Ptr_Heap);
    printf ("\n\n--> Ptr_Reg_Livre :");
    Imprimir_Ptr ((unsigned char *) Ptr_Reg_Livre);
    printf ("                 Indice_Livre : %u",Indice_Reg_Livre);
    printf ("\n");

    /* Imprimir Conteudo da Lista_Livre */

      Total_LL = 0;
      Total_Heap = (unsigned char *) (Ptr_Reg_Livre) - Ptr_Heap;

      for (Indice = Nr_Regs_Lista_Livre - 1;
           Indice > Indice_Reg_Livre;
           Indice--)
         {
           printf ("Lista[%u] ->  Inicio = ",Indice);
           Imprimir_Ptr (Ptr_Base_Reg_Livre[Indice].Ptr_Inicio);
           printf ("  Fim = ");
           Imprimir_Ptr (Ptr_Base_Reg_Livre[Indice].Ptr_Fim);
           printf ("\n");
           if (Ptr_Base_Reg_Livre[Indice].Ptr_Inicio != NULL)
             Total_LL += Ptr_Base_Reg_Livre[Indice].Ptr_Fim - Ptr_Base_Reg_Livre[Indice].Ptr_Inicio;
         }

    printf ("\n Total_Livre = %lu     Total_LL = %lu\n",Total_Heap,Total_LL);

    getch ();
  }

void Imprimir_Estado_Prim_Tx (void)
  {
    printf ("Numero de Estruturas de Primitivas_Tx Alocadas : %u\n",N_Prim);
  }

void Imprimir_Estado_Param_Tx (void)
  {
    printf ("Numero de Estruturas de Parametros_Tx Alocadas : %u\n",N_Param);
  }

Boolean Inicializar_Mem_Tx (void)
  {
    int i;

    N_Aloc = 0;
    N_Dealoc = 0;
    N_Prim = 0;
    N_Param = 0;

    Ptr_Heap = farmalloc((unsigned long) (Tamanho_Heap));
    Ptr_Topo_Heap = Soma_Ptr_Far(Ptr_Heap,Tamanho_Heap);

    Ptr_Base_Heap = Ptr_Heap;
    Indice_Reg_Livre = Nr_Regs_Lista_Livre-1;
    Ptr_Reg_Livre = (Tipo_Ptr_Estrutura_Livre) Sub_Ptr_Far(Ptr_Topo_Heap, 2*Tamanho_Ptr);
    Ptr_Base_Reg_Livre = (Tipo_Ptr_Estrutura_Livre) Sub_Ptr_Far(Ptr_Topo_Heap, 2 * Tamanho_Ptr * Nr_Regs_Lista_Livre);

    for (i = 0; i < Nr_Max_Elem_Est_Prim; i++)  /* Inicialmente todos os campos livres */
      Estado_Mem_Est_Prim[i] = FALSE;
    Ptr_Base_Mem_Est_Prim = malloc(Tamanho_Mem_Est_Prim);    /* Reserva Memoria para alocacao dos elementos */
    Ind_Prim_Livre = 0;

    for (i = 0; i < Nr_Max_Elem_Est_Param; i++)  /* Inicialmente todos os campos livres */
      Estado_Mem_Est_Param[i] = FALSE;
    Ptr_Base_Mem_Est_Param = malloc(Tamanho_Mem_Est_Param);    /* Reserva Memoria para alocacao dos elementos */
    Ind_Param_Livre = 0;

    if ((Ptr_Base_Mem_Est_Prim != NULL) && (Ptr_Base_Mem_Est_Param != NULL) && (Ptr_Heap != NULL))
      return (TRUE);
    else
      return (FALSE);

  }

void Finalizar_Mem_Tx (void)
  {
    Imprimir_Estado_Heap_Tx ();
    Imprimir_Estado_Prim_Tx ();
    Imprimir_Estado_Param_Tx ();
    free(Ptr_Base_Mem_Est_Prim);
    free(Ptr_Base_Mem_Est_Param);
    free(Ptr_Base_Heap);
  }

unsigned char *Alocar_Estrutura_Primitiva_Tx (void)
  {
     unsigned int   Indice;
     unsigned char *Ptr_Temp;

     Indice = Ind_Prim_Livre;
     while (Estado_Mem_Est_Prim[Ind_Prim_Livre]) {
       Ind_Prim_Livre = (++Ind_Prim_Livre) & (Nr_Max_Elem_Est_Prim - 1);
       if (Indice == Ind_Prim_Livre)
         return (NULL);
     }

     N_Prim++;
     Estado_Mem_Est_Prim[Ind_Prim_Livre] = TRUE;
     Ptr_Temp = Ptr_Base_Mem_Est_Prim + Ind_Prim_Livre * Tamanho_Elem_Est_Prim;
     Ind_Prim_Livre = (++Ind_Prim_Livre) & (Nr_Max_Elem_Est_Prim - 1);
     return ((unsigned char *) (Ptr_Temp));

  } /* Fim Alocar_Estrutura_Primitiva_Tx */

void Liberar_Estrutura_Primitiva_Tx (unsigned char  *Ptr)
  {
    unsigned int  Indice;

    if (Ptr != NULL)
      {
        N_Prim--;
        Indice = ((int) (Ptr - (unsigned char *) (Ptr_Base_Mem_Est_Prim))) / Tamanho_Elem_Est_Prim;
        Estado_Mem_Est_Prim[Indice] = FALSE;
      }
    else ;

  } /* Fim Liberar_Estrutura_Primitiva_Tx */



Estrutura_Parametros *Alocar_Estrutura_Parametros_Tx (void)
  {
     unsigned int           Indice;
     Estrutura_Parametros  *Ptr_Temp;

     Indice = Ind_Param_Livre;
     while (Estado_Mem_Est_Param[Ind_Param_Livre]) {
       Ind_Param_Livre = (++Ind_Param_Livre) & (Nr_Max_Elem_Est_Param - 1);
       if (Indice == Ind_Param_Livre)
         return (NULL);
     }

     N_Param++;
     Estado_Mem_Est_Param[Ind_Param_Livre] = TRUE;
     Ptr_Temp = (Estrutura_Parametros *) (Ptr_Base_Mem_Est_Param + Ind_Param_Livre * Tamanho_Elem_Est_Param);
     Ind_Param_Livre = (++Ind_Param_Livre) & (Nr_Max_Elem_Est_Param - 1);
     memset (Ptr_Temp,0,Tamanho_Elem_Est_Param);
     return (Ptr_Temp);

  } /* Fim Alocar_Estrutura_Parametros_Tx */

void Liberar_Estrutura_Parametros_Tx (Estrutura_Parametros *Ptr)
  {
    unsigned int  Indice;

    while (Ptr != NULL)
      {
        if (Ptr->Num_Alocacoes == 0)
          {
            N_Param--;
            if ((Ptr->Ptr_Dados_Usuario != NULL) && (Ptr->Tam_Dados_Usuario != 0))
              Liberar_Memoria_Tx ((unsigned char *) (Ptr->Ptr_Dados_Usuario),Ptr->Tam_Dados_Usuario);
            Indice = ((int) ((unsigned char *) (Ptr) - Ptr_Base_Mem_Est_Param)) / Tamanho_Elem_Est_Param;
            Estado_Mem_Est_Param[Indice] = FALSE;
            Ptr = Ptr->Ptr_Proximo;
          }
        else
          {
            Ptr->Num_Alocacoes--;
            Ptr = Ptr->Ptr_Proximo;
          }
      }
  } /* Fim Liberar_Estrutura_Parametros_Tx */


unsigned char *Alocar_Memoria_Tx (unsigned int Tamanho)
  {
    unsigned char *Ptr_Temp,*Ptr_Temp2;
    unsigned int  Indice;

    N_Aloc++;

    Indice = Nr_Regs_Lista_Livre;    /* Procura a primeira area em que Tamanho e' alocavel */
    do {
      Indice--;

      Ptr_Temp = Soma_Ptr_Far(Ptr_Base_Reg_Livre[Indice].Ptr_Inicio,Tamanho);
/*      Ptr_Temp = Ptr_Base_Reg_Livre[Indice].Ptr_Inicio + Tamanho;*/

    } while ((Indice > Indice_Reg_Livre) &&
             P1_Maior_P2(Ptr_Temp , Ptr_Base_Reg_Livre[Indice].Ptr_Fim));

    if (Indice > Indice_Reg_Livre)  /* Existe registro onde Tamanho e' alocavel */

      if (P1_Menor_P2(Ptr_Temp, Ptr_Base_Reg_Livre[Indice].Ptr_Fim)) /* Regiao livre menor que tamanho */
        {
          Ptr_Temp2 = Ptr_Base_Reg_Livre[Indice].Ptr_Inicio;
          Ptr_Base_Reg_Livre[Indice].Ptr_Inicio = Ptr_Temp;
          return (Ptr_Temp2);
        }
      else   /* (Ptr_Temp = Ptr_Base_Reg_Livre[Indice].Ptr_Fim)  Regiao livre igual a tamanho */
        {
          Ptr_Temp2 = Ptr_Base_Reg_Livre[Indice].Ptr_Inicio;
          Ptr_Base_Reg_Livre[Indice].Ptr_Inicio = NULL;
          Ptr_Base_Reg_Livre[Indice].Ptr_Fim = NULL;

          /* incluido em 17-7-92 */
          if (Indice == (Indice_Reg_Livre+1))                 /* Atualizo Ptr_Reg e Indice_Reg se o  */
            do
              {                                                 /* registro liberado e' o ultimo       */
              Ptr_Reg_Livre=Inc_Ptr_Far(Ptr_Reg_Livre);
              Indice_Reg_Livre++;
              } while ((Indice_Reg_Livre < Nr_Regs_Lista_Livre-1)
                    &&(Ptr_Base_Reg_Livre[Indice_Reg_Livre+1].Ptr_Inicio == NULL));

          return (Ptr_Temp2);
        }
                   /* Ptr_Heap + Tamanho */
    else if (P1_Maior_P2(Soma_Ptr_Far(Ptr_Heap, Tamanho) , (unsigned char *) (Ptr_Reg_Livre))) /* Heap Overflow */
           return (NULL);
         else              /* Nao ha' regiao livre em que caiba Tamanho */
           {
             Ptr_Temp = Ptr_Heap;   /* alocar area alterando o Ptr_Heap */
           /*Ptr_Heap += Tamanho;*/
             Ptr_Heap = Soma_Ptr_Far(Ptr_Heap, Tamanho);
             return(Ptr_Temp);
           }

    /* verificar se ha' espaco entre o Ptr_Heap e o Ptr_Lista_Livre */

  } /* Fim Alocar_Memoria_Tx */


/* Condicoes para nao gerar outro registro na lista de Livres               */
/*     1 - area a ser liberada e' e primeira do topo da Heap                */
/*              depois verifica-se se ha' alguma area livre no topo da Heap */
/*              constando da lista de livres                                */
/*     2 - area abaixo da regiao a ser liberada consta da lista de livres   */
/*     3 - area acima da regiao a ser liberada consta da lista de livres    */
/*     4 - existe registro livre e nao houve liberacao a partir das condicoes acima */


unsigned char *Liberar_Memoria_Tx (unsigned char *Ptr,unsigned int Tamanho)
{
unsigned char *Ptr_Temp;
/*unsigned*/ int Indice;
Boolean Nao_Criar;
int Indice_Temp;
unsigned char *Ptr_Retorno;

N_Dealoc++;
Ptr_Retorno = Ptr;
Indice_Temp = 0;

/*Ptr_Temp = Ptr + Tamanho;*/
Ptr_Temp = Soma_Ptr_Far(Ptr, Tamanho);

if ((Ptr == NULL) || (Tamanho == 0)) ;

else
  if (P1_Maior_P2(Ptr_Temp , Ptr_Heap))
    ;             /* tentando dealocar area maior que a de alocacao */
  else
    if (P1_Igual_P2(Ptr_Temp ,Ptr_Heap))   /* Condicao 1 - dealocacao ordenada */
      {

/*      Ptr_Heap -= Tamanho;*/
      Ptr_Heap = Sub_Ptr_Far(Ptr_Heap, Tamanho);

      for (Indice = Nr_Regs_Lista_Livre - 1;                      /* Verifica se na Lista Livre ha algum */
           Indice > Indice_Reg_Livre;                             /* Ptr_Fim = Ptr_Heap                  */
           Indice--)
          if (P1_Igual_P2(Ptr_Heap, Ptr_Base_Reg_Livre[Indice].Ptr_Fim))
            {
            Ptr_Heap = Ptr_Base_Reg_Livre[Indice].Ptr_Inicio;   /* Atualiza Ptr_Heap e limpa registro  */
            Ptr_Base_Reg_Livre[Indice].Ptr_Inicio = NULL;       /* da Lista Livre                      */
            Ptr_Base_Reg_Livre[Indice].Ptr_Fim = NULL;
            if (Indice == (Indice_Reg_Livre+1))                 /* Atualizo Ptr_Reg e Indice_Reg se o  */
              do
                {                                                 /* registro liberado e' o ultimo       */
                Ptr_Reg_Livre=Inc_Ptr_Far(Ptr_Reg_Livre);
                Indice_Reg_Livre++;
                } while ((Indice_Reg_Livre < Nr_Regs_Lista_Livre-1)
                      &&(Ptr_Base_Reg_Livre[Indice_Reg_Livre+1].Ptr_Inicio == NULL));
            }

      Ptr_Retorno = Ptr_Heap; /*return (Ptr_Heap);*/
      }
    else  /* (Ptr_Temp < Ptr_Heap) */        /* Condicoes 2 e 3 - dealocacao desordenada */
      {
      Nao_Criar = FALSE;
      for (Indice = Nr_Regs_Lista_Livre - 1;                      /* Verifica se na Lista Livre ha algum */
           Indice > Indice_Reg_Livre;                            /* Ptr_Fim = Ptr_Heap                  */
           Indice--)
         {
         if (P1_Igual_P2(Ptr_Temp, Ptr_Base_Reg_Livre[Indice].Ptr_Inicio))   /* juncao com a regiao superior */
           {
           Ptr_Base_Reg_Livre[Indice].Ptr_Inicio = Ptr;         /* junta as regioes livres */
           Ptr_Temp = Ptr_Base_Reg_Livre[Indice].Ptr_Fim;       /* prepara possivel juncao com inferior */
           if (Nao_Criar) /* ja' houve juncao com a de cima */
             {
             Ptr_Base_Reg_Livre[Indice_Temp].Ptr_Inicio = NULL;
             Ptr_Base_Reg_Livre[Indice_Temp].Ptr_Fim = NULL;
             if (Indice_Temp == (Indice_Reg_Livre+1))            /* Atualizo Ptr_Reg e Indice_Reg se o */
               do
                 {                                                 /* registro liberado e' o ultimo       */
                 Ptr_Reg_Livre=Inc_Ptr_Far(Ptr_Reg_Livre);
                 Indice_Reg_Livre++;
                 } while ((Indice_Reg_Livre < Nr_Regs_Lista_Livre-1)
                       &&(Ptr_Base_Reg_Livre[Indice_Reg_Livre+1].Ptr_Inicio == NULL));

             }
           Nao_Criar = TRUE;
           Indice_Temp = Indice;
           }
         if (P1_Igual_P2(Ptr, Ptr_Base_Reg_Livre[Indice].Ptr_Fim))
           {
           Ptr_Base_Reg_Livre[Indice].Ptr_Fim = Ptr_Temp;
           Ptr = Ptr_Base_Reg_Livre[Indice].Ptr_Inicio;
           if (Nao_Criar) /* ja' houve juncao com a de cima */
             {
             Ptr_Base_Reg_Livre[Indice_Temp].Ptr_Inicio = NULL;
             Ptr_Base_Reg_Livre[Indice_Temp].Ptr_Fim = NULL;
             if (Indice_Temp == (Indice_Reg_Livre+1))            /* Atualizo Ptr_Reg e Indice_Reg se o */
               do                                                /* registro liberado e' o ultimo       */
                 {
                 Ptr_Reg_Livre=Inc_Ptr_Far(Ptr_Reg_Livre);
                 Indice_Reg_Livre++;
                 } while ((Indice_Reg_Livre < Nr_Regs_Lista_Livre-1)
                       &&(Ptr_Base_Reg_Livre[Indice_Reg_Livre+1].Ptr_Inicio == NULL));

             }
           Nao_Criar = TRUE;
           Indice_Temp = Indice;
           }
         }
      if (Nao_Criar)
        Ptr_Retorno = Ptr_Temp; /*return (Ptr_Temp);*/
      else
        {
        Indice = Nr_Regs_Lista_Livre;                        /* Procura um registro livre */
        do
         {
         Indice--;
         } while ((Indice > Indice_Reg_Livre) &&
               (Ptr_Base_Reg_Livre[Indice].Ptr_Inicio != NULL));

        if (Indice > Indice_Reg_Livre)
          {
          Ptr_Base_Reg_Livre[Indice].Ptr_Inicio = Ptr;     /* Se achou registro livre */
          Ptr_Base_Reg_Livre[Indice].Ptr_Fim = Ptr_Temp;    /* entao ocupar            */
          Ptr_Retorno = Ptr_Temp;
          }
        else
          if ((Indice < 0) || (P1_Maior_P2(Ptr_Heap,(unsigned char *) (Ptr_Reg_Livre))))
            Ptr_Retorno = NULL;
          else   /* (Indice = Indice_Reg_Livre) */
            {
            Ptr_Reg_Livre->Ptr_Inicio = Ptr;     /* Se nao achou registro livre */
            Ptr_Reg_Livre->Ptr_Fim = Ptr_Temp;   /* cria novo registro          */
            Indice_Reg_Livre--;
            Ptr_Reg_Livre=Dec_Ptr_Far(Ptr_Reg_Livre);
            Ptr_Retorno = Ptr_Temp; /*return(Ptr_Temp);*/
            }
        }
      }
return (Ptr_Retorno);

} /* Fim Liberar_Memoria_Tx */



void Realocar_Estrutura_Primitiva_Tx (Estrutura_Parametros *Ptr)
  {
    while (Ptr != NULL)
      {
        Ptr->Num_Alocacoes++;
        Ptr = Ptr->Ptr_Proximo;
      }
  } /* Realocar_Estrutura_Primitiva_Tx */


unsigned int Tamanho_Cadeia_Tx (Estrutura_Parametros *Ptr)
  {
    unsigned int Tamanho;

    Tamanho = 0;
    while (Ptr != NULL)
      {
        Tamanho += Ptr->Tam_Dados_Usuario;
        Ptr = Ptr->Ptr_Proximo;
      }
    return (Tamanho);

  } /* Fim Tamanho_Cadeia_Tx */


unsigned char far *Soma_Ptr_Far (unsigned char far *ptr, unsigned long tam)
{
unsigned long ofs_ptr, seg_ptr;

ofs_ptr = ((unsigned long) ptr & 0xFFFF) + (((unsigned long) ptr >> 12) & 0xFFFF0l);
ofs_ptr += tam;
seg_ptr = ((ofs_ptr & 0x000FFFF0l) - 0x0FF0)<<12;
return (unsigned char *) (seg_ptr + (ofs_ptr & 0x0F) +0x0FF0);
}


unsigned char far *Sub_Ptr_Far (unsigned char far *ptr, unsigned long tam)
{
unsigned long ofs_ptr, seg_ptr;

ofs_ptr = ((unsigned long) ptr & 0xFFFF) + (((unsigned long) ptr >> 12) & 0xFFFF0l);
ofs_ptr -= tam;
seg_ptr = ((ofs_ptr & 0x000FFFF0l) - 0x0FF0)<<12;
return (unsigned char *) (seg_ptr + (ofs_ptr & 0x0F) +0x0FF0);
}

boolean P1_Maior_P2(unsigned char far *p1,unsigned char far *p2)
{
unsigned long np1,np2;

np1=(((((unsigned long) p1)&0xFFFF0000l) >>12) + (unsigned int) p1);
np2=(((((unsigned long) p2)&0xFFFF0000l) >>12) + (unsigned int) p2);
return (np1 > np2);
}

boolean P1_Menor_P2(unsigned char far *p1,unsigned char far *p2)
{
return ((((((unsigned long) p1)&0xFFFF0000l) >>12) + (unsigned int) p1) <
       (((((unsigned long) p2)&0xFFFF0000l) >>12) + (unsigned int) p2));
}

boolean P1_Igual_P2(unsigned char far *p1,unsigned char far *p2)
{
return ((((((unsigned long) p1)&0xFFFF0000l) >>12) + (unsigned int) p1) ==
       (((((unsigned long) p2)&0xFFFF0000l) >>12) + (unsigned int) p2));
}

Tipo_Ptr_Estrutura_Livre Inc_Ptr_Far(Tipo_Ptr_Estrutura_Livre ptr)
{
if (((unsigned int) ptr) == 0xffff)
  return ((Tipo_Ptr_Estrutura_Livre ) ((unsigned long) ptr + 0xFFF0001l));
 else
  return ++ptr;
}

Tipo_Ptr_Estrutura_Livre Dec_Ptr_Far(Tipo_Ptr_Estrutura_Livre ptr)
{
if (((unsigned int) ptr) == 0x0000)
  return ((Tipo_Ptr_Estrutura_Livre ) ((unsigned long) ptr - 0xFFF0001l));
 else
  return --ptr;
}
