/* Arquivo             : FncLM.C    */
/* Data Inicio         : 06-10-91   */
/* Data Ultima Revisao : 17-10-91   */

#include <MemTX.h>
#include <MemRX.h>

#include <alloc.h>
#include <TipGlob.H>
#include <CntGLOB.H>
#include <CntLM.H>
#include <TipLM.H>
#include <VarLM.H>
#include <FncEsc.h>
/* include <FncLM.h>*/
#include <FncMAC.h>
#include <FncLLC.h>

/*************************************************************************/
/*                                                                       */
/*                 Cabecalho das funcoes para a Interface                */
/*                 entre as Camadas LLC E MAC.                           */
/*                                                                       */
/*************************************************************************/

void Inicializar_Interface_L_M (void);

void Enviar_Primitiva_L_M (unsigned int,Ptr_Estrutura_Primitiva_L_M);

void Enviar_Primitiva_M_L (unsigned int,Ptr_Estrutura_Primitiva_M_L);

Ptr_Estrutura_Primitiva_L_M Receber_Primitiva_L_M (unsigned int);

Ptr_Estrutura_Primitiva_M_L Receber_Primitiva_M_L (unsigned int);

void Retirar_Primitiva_Fila_L_M (unsigned int);

void Retirar_Primitiva_Fila_M_L (unsigned int);

void Finalizar_Interface_L_M (void);


/*************************************************************************/
/*                                                                       */
/*         Inicializa as variaveis da Interface LLC - MAC                */
/*                                                                       */
/*************************************************************************/

void Inicializar_Interface_L_M (void)

  {

    unsigned int i;

     for(i=0;i<Nr_Max_Conexoes_L_M;i++)
     {
	Fila_Primitivas_L_M[i].Ptr_Prim = NULL;
	Fila_Primitivas_L_M[i].Nr_Elem = 0;
	Fila_Primitivas_M_L[i].Ptr_Prim = NULL;
	Fila_Primitivas_M_L[i].Nr_Elem = 0;
     }

  } /* Fim Inicializar_Interface_L_M */

/*************************************************************************/
/*                                                                       */
/*          Envia Primitiva da Camada LLC  para a Camada MAC             */
/*                                                                       */
/*************************************************************************/

void Enviar_Primitiva_L_M (unsigned int Nr_Conexao,Ptr_Estrutura_Primitiva_L_M Ptr_Primitiva)

  {

    if (Fila_Primitivas_L_M[Nr_Conexao].Ptr_Prim == NULL)
      Fila_Primitivas_L_M[Nr_Conexao].Ptr_Prim = Ptr_Primitiva;
    else
      Fila_Primitivas_L_M[Nr_Conexao].Ptr_Ult->Ptr_Proximo = Ptr_Primitiva;
    Fila_Primitivas_L_M[Nr_Conexao].Ptr_Ult = Ptr_Primitiva;
    Fila_Primitivas_L_M[Nr_Conexao].Ptr_Ult->Ptr_Proximo = NULL;
    ++Fila_Primitivas_L_M[Nr_Conexao].Nr_Elem;
    Enviar_Rotina_Fila_Gerente_RMOSI (Maquina_Estados_LLC_MAC,Nr_Conexao);

  } /* Fim Enviar_Primitiva_L_M */


/*************************************************************************/
/*                                                                       */
/*               Envia Primitiva da Camada MAC para a Camada LLC         */
/*                                                                       */
/*************************************************************************/

void Enviar_Primitiva_M_L (unsigned int Nr_Conexao,Ptr_Estrutura_Primitiva_M_L Ptr_Primitiva)

  {

    if (Fila_Primitivas_M_L[Nr_Conexao].Ptr_Prim == NULL)
      Fila_Primitivas_M_L[Nr_Conexao].Ptr_Prim = Ptr_Primitiva;
    else
      Fila_Primitivas_M_L[Nr_Conexao].Ptr_Ult->Ptr_Proximo = Ptr_Primitiva;
    Fila_Primitivas_M_L[Nr_Conexao].Ptr_Ult = Ptr_Primitiva;
    Fila_Primitivas_M_L[Nr_Conexao].Ptr_Ult->Ptr_Proximo = NULL;
    ++Fila_Primitivas_M_L[Nr_Conexao].Nr_Elem;
    Enviar_Rotina_Fila_Gerente_RMOSI (Maquina_Estados_MAC_LLC,Nr_Conexao);

  } /* Fim Enviar_Primitiva_M_L */


/*************************************************************************/
/*                                                                       */
/*           Recebe a primitiva enviada pela Camada LLC                  */
/*                                                                       */
/*************************************************************************/

Ptr_Estrutura_Primitiva_L_M Receber_Primitiva_L_M (unsigned int Nr_Conexao)

  {

    return (Fila_Primitivas_L_M[Nr_Conexao].Ptr_Prim);

  } /* Fim Receber_Primitiva_L_M */


/*************************************************************************/
/*                                                                       */
/*                Recebe a primitiva enviada pela Camada MAC             */
/*                                                                       */
/*************************************************************************/

Ptr_Estrutura_Primitiva_M_L Receber_Primitiva_M_L (unsigned int Nr_Conexao)

  {

    return (Fila_Primitivas_M_L[Nr_Conexao].Ptr_Prim);

  } /* Fim Receber_Primitiva_M_L */

/*************************************************************************/
/*                                                                       */
/* Libera a area ocupada pela primitiva enviada pela camada LLC          */
/*                                                                       */
/*************************************************************************/

void Retirar_Primitiva_Fila_L_M (unsigned int Nr_Conexao)

  {
     Ptr_Estrutura_Primitiva_L_M    Ptr_Temp_Primitiva_L_M;

     if (Fila_Primitivas_L_M[Nr_Conexao].Ptr_Prim != NULL)
       {
         Ptr_Temp_Primitiva_L_M = Fila_Primitivas_L_M[Nr_Conexao].Ptr_Prim;
         Fila_Primitivas_L_M[Nr_Conexao].Ptr_Prim = Fila_Primitivas_L_M[Nr_Conexao].Ptr_Prim->Ptr_Proximo;
         Liberar_Estrutura_Primitiva_Tx((unsigned char *)Ptr_Temp_Primitiva_L_M);
         --Fila_Primitivas_L_M[Nr_Conexao].Nr_Elem;
       }

  } /* Fim Retirar_Fila_Primitiva_L_M */

/*************************************************************************/
/*                                                                       */
/*    Libera a area ocupada pela primitiva enviada pela camada MAC       */
/*                                                                       */
/*************************************************************************/

void Retirar_Primitiva_Fila_M_L (unsigned int Nr_Conexao)

  {
     Ptr_Estrutura_Primitiva_M_L    Ptr_Temp_Primitiva_M_L;

     if (Fila_Primitivas_M_L[Nr_Conexao].Ptr_Prim != NULL)
       {
         Ptr_Temp_Primitiva_M_L = Fila_Primitivas_M_L[Nr_Conexao].Ptr_Prim;
         Fila_Primitivas_M_L[Nr_Conexao].Ptr_Prim = Fila_Primitivas_M_L[Nr_Conexao].Ptr_Prim->Ptr_Proximo;
         Liberar_Estrutura_Primitiva_Rx((unsigned char *)Ptr_Temp_Primitiva_M_L);
         --Fila_Primitivas_M_L[Nr_Conexao].Nr_Elem;
       }

  } /* Fim Retirar_Fila_Primitiva_M_L */


/*************************************************************************/
/*                                                                       */
/*  Libera a area ocupada pelas filas de primitivas LLC-MAC              */
/*                                                                       */
/*************************************************************************/

void Finalizar_Interface_L_M (void)

  {
     Ptr_Estrutura_Primitiva_L_M      Ptr_Temp_Primitiva_L_M;
     Ptr_Estrutura_Primitiva_M_L      Ptr_Temp_Primitiva_M_L;

     unsigned int i;

     for(i=0;i<Nr_Max_Conexoes_L_M;i++)
     {
	while (Fila_Primitivas_L_M[i].Ptr_Prim != NULL)
	  {
	    Ptr_Temp_Primitiva_L_M = Fila_Primitivas_L_M[i].Ptr_Prim;
	    Fila_Primitivas_L_M[i].Ptr_Prim =  Fila_Primitivas_L_M[i].Ptr_Prim->Ptr_Proximo;
	    Liberar_Estrutura_Primitiva_Tx((unsigned char *)Ptr_Temp_Primitiva_L_M);
	  } /* fim-while */

	while (Fila_Primitivas_M_L[i].Ptr_Prim != NULL)
	  {
	    Ptr_Temp_Primitiva_M_L = Fila_Primitivas_M_L[i].Ptr_Prim;
	    Fila_Primitivas_M_L[i].Ptr_Prim =  Fila_Primitivas_M_L[i].Ptr_Prim->Ptr_Proximo;
	    Liberar_Estrutura_Primitiva_Rx((unsigned char *)Ptr_Temp_Primitiva_M_L);
	  } /* fim-while */
      } /* for */

  }  /* Fim Finalizar_Interface_L_M */
