/* Arquivo             : TipLM.H   */
/* Data Inicio         : 10-06-91  */
/* Data Ultima Revisao : 17-06-91  */


/*************************************************************************/
/*                                                                       */
/*    Definicao dos tipos utilizados na Interface LLC - MAC              */
/*                                                                       */
/*************************************************************************/

#ifndef TIPOSLM
#define TIPOSLM

#include <CntLM.H>
#include <TipGLOB.H>

/* Primitivas de Servico da Camada MAC */

typedef enum
  {
    MA_DATA_Request
  }
Primitivas_L_M;

typedef enum
  {
    MA_DATA_Indication,
    MA_DATA_Confirm
  }
Primitivas_M_L;

/* Definicao das filas para trocas de primitivas */

typedef struct Estrutura_Primitiva_L_M
  {
    struct Estrutura_Primitiva_L_M        *Ptr_Proximo;
    Primitivas_L_M                        Nome_Primitiva;
    Ptr_Estrutura_Parametros              Ptr_Parametros_Primitiva;

  } Estrutura_Primitiva_L_M;

typedef struct Estrutura_Primitiva_L_M    *Ptr_Estrutura_Primitiva_L_M;

typedef struct Estrutura_Primitiva_M_L
  {
    struct Estrutura_Primitiva_M_L        *Ptr_Proximo;
    Primitivas_M_L                        Nome_Primitiva;
    Ptr_Estrutura_Parametros              Ptr_Parametros_Primitiva;
  } Estrutura_Primitiva_M_L;

typedef struct Estrutura_Primitiva_M_L    *Ptr_Estrutura_Primitiva_M_L;

typedef struct Tipo_Fila_L_M
  {
    Ptr_Estrutura_Primitiva_L_M           Ptr_Prim;
    Ptr_Estrutura_Primitiva_L_M           Ptr_Ult;
    unsigned int                          Nr_Elem;
  };

typedef struct Tipo_Fila_M_L
  {
    Ptr_Estrutura_Primitiva_M_L           Ptr_Prim;
    Ptr_Estrutura_Primitiva_M_L           Ptr_Ult;
    unsigned int                          Nr_Elem;
  };


typedef struct Tipo_Parametros_MA_DATA_Req
  {
    unsigned int              End_Destino;
    unsigned int              Quality_of_Service;

  } Tipo_Parametros_MA_DATA_Req;

typedef   Tipo_Parametros_MA_DATA_Req      *Ptr_Parametros_MA_DATA_Request;

typedef struct Tipo_Parametros_MA_DATA_Ind
  {
    unsigned int              End_Origem;
    unsigned int              End_Destino;
    unsigned int              Status;
    unsigned int              Quality_of_Service;

  } Tipo_Parametros_MA_DATA_Ind;

typedef   Tipo_Parametros_MA_DATA_Ind      *Ptr_Parametros_MA_DATA_Indication;

typedef struct Tipo_Parametros_MA_DATA_Conf
  {
    unsigned int              Status;
    unsigned int              Quality_of_Service;

  } Tipo_Parametros_MA_DATA_Conf;

typedef   Tipo_Parametros_MA_DATA_Conf    *Ptr_Parametros_MA_DATA_Confirm;


#endif
