/* Arquivo             : FncLM.C   */
/* Autor               : GTA       */
/* Data Inicio         : 11-03-90  */
/* Data Ultima Revisao : 21-08-92  */
/* Versao incluindo Escalonador    */
/* MT: 12/11/93 : Incluida a procedure
       Dealocar_Quadro_Buffer_Tx_Recem_Alocado, que permite a dealocacao
       do ultimo quadro alocado, usada no caso da alocacao de primitiva
       nao ter sucesso. A rotina Dealocar_Quadro_Buffer_Tx nao pode ser
       usada por que ela faz a dealocacao no extremo oposto da fila. */
// MT: 17/01/94 : enable() e disable() em dealocar_quadro_buffer_rx.

#ifndef  FUNCOESINTERFACELM_C
#define  FUNCOESINTERFACELM_C

#include <stdio.h>
#include <stdlib.h>
#include <alloc.h>
#include <dos.h>

#include <TipGlob.H>
#include <FncEsc.H>
#include <CntLM.H>
#include <TipLM.H>
#include <VarLM.H>
#include <FncMAC.H>
#include <FncDL.h>
/*#include <FncLLC.H>*/

/*************************************************************************/
/*                                                                       */
/*                 Cabecalho das funcoes para a Interface                */
/*                    entre as Camadas LLC e MAC                         */
/*                                                                       */
/**************************************************************************/

Tipo_Codigo_Retorno Inicializar_Interface_L_M (void);

void Finalizar_Interface_L_M (void);

/* Funcoes relativas aos buffer's de transmissao - recepcao */

Tipo_Codigo_Retorno Criar_Alinhar_Buffer_Tx_Rx (void);
Boolean Sobre_Escrita_Rx (Ptr_Elem_Buffer_Rx);
Ptr_Elem_Buffer_Tx Alocar_Quadro_Buffer_Tx (void);
Ptr_Elem_Buffer_Rx Alocar_Quadro_Buffer_Rx (void);
void Dealocar_Quadro_Buffer_Tx (void);
void Dealocar_Quadro_Buffer_Tx_Recem_Alocado(void);
void Dealocar_Quadro_Buffer_Rx (void);
void Dealocar_Quadro_Buffer_Rx_Recem_Alocado (void);
Boolean Buffer_Tx_Cheio (void);
Boolean Buffer_Rx_Cheio (void);
unsigned char Nr_Liv_Buffer_Tx (void);
unsigned char Nr_Liv_Buffer_Rx (void);

/* Funcoes relativas as filas de Primitiva's */
Tipo_Codigo_Retorno Criar_Fila_Primitivas_L_M (void);
Tipo_Codigo_Retorno Criar_Fila_Primitivas_M_L (void);
Ptr_Estrutura_Primitiva_L_M Alocar_Fila_Primitivas_L_M (void);
Ptr_Estrutura_Primitiva_M_L Alocar_Fila_Primitivas_M_L (void);
void Dealocar_Fila_Primitivas_L_M (void);
void Dealocar_Fila_Primitivas_M_L (void);
Boolean Fila_Primitivas_L_M_Cheia (void);
Boolean Fila_Primitivas_M_L_Cheia (void);
Boolean Fila_Primitivas_L_M_Nao_Vazia (void);
Boolean Fila_Primitivas_M_L_Nao_Vazia (void);
unsigned char Nr_Liv_Fila_Primitivas_L_M (void);
unsigned char Nr_Liv_Fila_Primitivas_M_L (void);

void Enviar_Primitiva_L_M (void);
void Enviar_Primitiva_M_L (void);
Ptr_Estrutura_Primitiva_L_M Receber_Primitiva_L_M (void);
Ptr_Estrutura_Primitiva_M_L Receber_Primitiva_M_L (void);

/*************************************************************************/
/*                                                                       */
/*         Inicializa as variaveis da Interface LLC - MAC                */
/*                                                                       */
/*************************************************************************/

Tipo_Codigo_Retorno Inicializar_Interface_L_M (void)

  {
  if ((Criar_Alinhar_Buffer_Tx_Rx ()) &&
      (Criar_Fila_Primitivas_L_M ()) &&
      (Criar_Fila_Primitivas_M_L ()))
    return (Operacao_Bem_Sucedida);
  else
    return (Operacao_Falha);
  } /* Inicializar_Interface_L_M */


/*************************************************************************/
/*                                                                       */
/*           Finaliza as variaveis da Interface LLC - MAC          */
/*                                                                       */
/*************************************************************************/

void Finalizar_Interface_L_M (void)

  {
  unsigned int                    Ind;
  Ptr_Elem_Buffer_Tx              Ptr_Elem_Buffer_Tx;
  Ptr_Elem_Buffer_Rx              Ptr_Elem_Buffer_Rx;

  /* Libera as areas de memoria ocupadas pelos Buffer's e pelas filas de Primitiva's */

  for (Ind = 1;Ind <= Nr_Max_Quadros_Tx;Ind++)
    {
      Ptr_Elem_Buffer_Tx = Buffer_Tx;
      Buffer_Tx = Buffer_Tx->Ptr_Proximo;
      free (Ptr_Elem_Buffer_Tx);
    }
  for (Ind = 1; Ind <= Nr_Max_Quadros_Rx;Ind++)
    {
      Ptr_Elem_Buffer_Rx = Buffer_Rx;
      Buffer_Rx = Buffer_Rx->Ptr_Proximo;
      free (Ptr_Elem_Buffer_Rx);
    }
  free (Fila_Primitivas_L_M);
  free (Fila_Primitivas_M_L);
  }  /* Finalizar_Interface_L_M */


/*************************************************************************/
/*                                                                       */
/*  Cria os Buffer's Circulares de Transmissao e Recepcao em que cada    */
/*    elemento esta contido em uma unica pagina de memoria do PC         */
/*                                                                       */
/*************************************************************************/

Tipo_Codigo_Retorno Criar_Alinhar_Buffer_Tx_Rx (void)

  {
  int                 Ind_Elem_Tx;
  int                 Ind_Elem_Rx;
  unsigned long       L1,L2;
  unsigned int        Regiao_Livre;
  Ptr_Elem_Buffer_Tx  Ptr_Elem_Tx,Ptr_Ant_Tx,Ptr_Lixo_Tx [Nr_Max_Quadros_Tx];
  Ptr_Elem_Buffer_Rx  Ptr_Elem_Rx,Ptr_Ant_Rx,Ptr_Lixo_Rx [Nr_Max_Quadros_Rx];
  unsigned char       Nr_Ptr_Lixo_Tx,Nr_Ptr_Lixo_Rx;

  Ptr_Ant_Tx = NULL;
  Nr_Ptr_Lixo_Tx = 0;
  for (Ind_Elem_Tx = 1; Ind_Elem_Tx <= Nr_Max_Quadros_Tx; Ind_Elem_Tx++)
    {
      /* Aloca um novo elemento */
      Ptr_Elem_Tx = (Elem_Buffer_Tx *) malloc (sizeof(Elem_Buffer_Tx));
      /* guarda o ptr para o primeiro elemento */
      /* verifica se mudou de pagina */
      L1 = (unsigned long) Ptr_Elem_Tx;
      L1 = ((L1 & 0xFFFF0000l) >> 12) + (L1 & 0xFFFFl);
      L2 = (L1 + sizeof(Elem_Buffer_Tx)) & 0xF0000l;
      Regiao_Livre = (unsigned int) (L2 - L1);
      L1 = L1 & 0xF0000l;
      if (L1 != L2)
        {
          free (Ptr_Elem_Tx);
          Ptr_Lixo_Tx [Nr_Ptr_Lixo_Tx] = malloc (Regiao_Livre);
          Nr_Ptr_Lixo_Tx++;
          Ptr_Elem_Tx = malloc (sizeof(Elem_Buffer_Tx));
        }
      /* faz o encadeamento dos elementos da fila */
      Ptr_Elem_Tx->Ptr_Proximo = Ptr_Ant_Tx;
      Ptr_Ant_Tx = Ptr_Elem_Tx;
      if (!Ptr_Elem_Tx)
        return (Operacao_Falha);
      if (Ind_Elem_Tx == 1)
        Buffer_Tx = Ptr_Elem_Tx;
    } /* for Ind_Elem_Tx */
  Buffer_Tx->Ptr_Proximo = Ptr_Elem_Tx;
  Ptr_Ins_Buffer_Tx = Ptr_Ret_Buffer_Tx = Buffer_Tx;

  Ptr_Ant_Rx = NULL;
  Nr_Ptr_Lixo_Rx = 0;
  for (Ind_Elem_Rx = 1; Ind_Elem_Rx <= Nr_Max_Quadros_Rx; Ind_Elem_Rx++)
    {
      /* Aloca um novo elemento */
      Ptr_Elem_Rx = (Elem_Buffer_Rx *) malloc (sizeof(Elem_Buffer_Rx));
      /* guarda o ptr para o primeiro elemento */
      /* verifica se mudou de pagina */
      L1 = (unsigned long) Ptr_Elem_Rx;
      L1 = ((L1 & 0xFFFF0000l) >> 12) + (L1 & 0xFFFFl);
      L2 = (L1 + sizeof(Elem_Buffer_Rx)) & 0xF0000l;
      L2 = L2 & 0xF0000l;
      Regiao_Livre = (unsigned int) (L2 - L1);
      L1 = L1 & 0xF0000l;
      if (L1 != L2)
        {
          free (Ptr_Elem_Rx);
          Ptr_Lixo_Rx [Nr_Ptr_Lixo_Rx] = malloc (Regiao_Livre);
          Nr_Ptr_Lixo_Rx++;
          Ptr_Elem_Rx = malloc (sizeof(Elem_Buffer_Rx));
        }
      /* faz o encadeamento dos elementos da fila */
      Ptr_Elem_Rx->Ptr_Proximo = Ptr_Ant_Rx;
      Ptr_Ant_Rx = Ptr_Elem_Rx;
      if (!Ptr_Elem_Rx)
        return (Operacao_Falha);
      if (Ind_Elem_Rx == 1)
        Buffer_Rx = Ptr_Elem_Rx;
    } /* for Ind_Elem_Rx */
  Buffer_Rx->Ptr_Proximo = Ptr_Elem_Rx;
  Ptr_Ins_Buffer_Rx = Ptr_Ret_Buffer_Rx = Buffer_Rx;

  while (Nr_Ptr_Lixo_Tx)
    {
      Nr_Ptr_Lixo_Tx--;
      free (Ptr_Lixo_Tx [Nr_Ptr_Lixo_Tx]);
    }
  while (Nr_Ptr_Lixo_Rx)
    {
      Nr_Ptr_Lixo_Rx--;
      free (Ptr_Lixo_Rx [Nr_Ptr_Lixo_Rx]);
    }
  Nr_Elem_Buffer_Tx = 0;
  Nr_Elem_Buffer_Rx = 0;
  return (Operacao_Bem_Sucedida);
  } /* Criar_Alinhar_Buffer_Tx_Rx */

/*************************************************************************/
/*                                                                       */
/*    Indica se o elemento do Buffer Rx e o ultimo elemento disponivel   */
/*                                                                       */
/*************************************************************************/

Boolean Sobre_Escrita_Rx (Ptr_Elem_Buffer_Rx Ptr_Referencia_Rx)

  {
  if (Ptr_Referencia_Rx->Ptr_Proximo == Ptr_Ret_Buffer_Rx)
    return (True);
  else
    return (False);
  } /* Sobre_Escrita_Rx */


/*************************************************************************/
/*                                                                       */
/* Devolve o apontador para o proximo elemento do Buffer de Transmissao  */
/*                                                                       */
/*************************************************************************/

Ptr_Elem_Buffer_Tx Alocar_Quadro_Buffer_Tx (void)

  {
  Ptr_Elem_Buffer_Tx      Ptr_Temp_Ins_Buffer_Tx;

  if (Ptr_Ins_Buffer_Tx->Ptr_Proximo != Ptr_Ret_Buffer_Tx)
    {
    Nr_Elem_Buffer_Tx++;
    Ptr_Temp_Ins_Buffer_Tx = Ptr_Ins_Buffer_Tx;
    Ptr_Ins_Buffer_Tx = Ptr_Ins_Buffer_Tx->Ptr_Proximo;
    return (Ptr_Temp_Ins_Buffer_Tx);
    }
  else
    return (NULL);

  } /* Alocar_Quadro_Buffer_Tx */


/*************************************************************************/
/*                                                                       */
/*   Devolve o apontador para o proximo elemento do Buffer de Recepcao   */
/*   Se o Buffer esta cheio devolve NULL                                 */
/*                                                                       */
/*************************************************************************/

Ptr_Elem_Buffer_Rx Alocar_Quadro_Buffer_Rx (void)

  {
  Ptr_Elem_Buffer_Rx                  Ptr_Temp_Ins_Buffer_Rx;

  disable();
  if (Ptr_Ins_Buffer_Rx->Ptr_Proximo != Ptr_Ret_Buffer_Rx)
    {
    Nr_Elem_Buffer_Rx++;
    Ptr_Temp_Ins_Buffer_Rx = Ptr_Ins_Buffer_Rx;
    Ptr_Ins_Buffer_Rx = Ptr_Ins_Buffer_Rx->Ptr_Proximo;
    enable();
    return (Ptr_Temp_Ins_Buffer_Rx);
    }
  else
    {
    enable();
    return (NULL);
    }
  } /* Alocar_Quadro_Buffer_Rx */


Ptr_Elem_Buffer_Rx Int_Alocar_Quadro_Buffer_Rx (void)

  {
  Ptr_Elem_Buffer_Rx                  Ptr_Temp_Ins_Buffer_Rx;

  if (Ptr_Ins_Buffer_Rx->Ptr_Proximo != Ptr_Ret_Buffer_Rx)
    {
    Nr_Elem_Buffer_Rx++;
    Ptr_Temp_Ins_Buffer_Rx = Ptr_Ins_Buffer_Rx;
    Ptr_Ins_Buffer_Rx = Ptr_Ins_Buffer_Rx->Ptr_Proximo;
    return (Ptr_Temp_Ins_Buffer_Rx);
    }
  else
    return (NULL);
  } /* Alocar_Quadro_Buffer_Rx */


/*************************************************************************/
/*                                                                       */
/*  Libera o elemento do Buffer Tx para utilizacao em nova transmissao   */
/*                                                                       */
/*************************************************************************/

void Dealocar_Quadro_Buffer_Tx (void)


  {
  if (Ptr_Ret_Buffer_Tx != Ptr_Ins_Buffer_Tx)
    {
    Nr_Elem_Buffer_Tx--;
    Ptr_Ret_Buffer_Tx = Ptr_Ret_Buffer_Tx->Ptr_Proximo;
    }

  } /* Dealocar_Quadro_Buffer_Tx */


/*************************************************************************/
/*                                                                       */
/*  Libera o elemento do Buffer Tx recem alocado                         */
/*                                                                       */
/*************************************************************************/

void Dealocar_Quadro_Buffer_Tx_Recem_Alocado (void)
  {
  Ptr_Elem_Buffer_Tx      Ptr_Temp_Buffer_Tx;

  if (Ptr_Ret_Buffer_Tx != Ptr_Ins_Buffer_Tx)
    {
    Ptr_Temp_Buffer_Tx=Ptr_Ret_Buffer_Tx;
    while (Ptr_Temp_Buffer_Tx->Ptr_Proximo!=Ptr_Ins_Buffer_Tx)
      Ptr_Temp_Buffer_Tx=Ptr_Temp_Buffer_Tx->Ptr_Proximo;
    Nr_Elem_Buffer_Tx--;
    Ptr_Ins_Buffer_Tx = Ptr_Temp_Buffer_Tx;
    }
  } /* Dealocar_Quadro_Buffer_Tx_Recem_Alocado */


/*************************************************************************/
/*                                                                       */
/*     Libera o elemento do Buffer Rx para utilizacao em nova recepcao   */
/*                                                                       */
/*************************************************************************/

void Dealocar_Quadro_Buffer_Rx (void)


  {
  disable();
  if (Ptr_Ret_Buffer_Rx != Ptr_Ins_Buffer_Rx)
    {
      Nr_Elem_Buffer_Rx--;
      Ptr_Ret_Buffer_Rx = Ptr_Ret_Buffer_Rx->Ptr_Proximo;
    }
  enable();
  } /* Dealocar_Quadro_Buffer_Rx */


/*************************************************************************/
/*                                                                       */
/*  Libera o elemento do Buffer Rx recem alocado                         */
/*                                                                       */
/*************************************************************************/

void Dealocar_Quadro_Buffer_Rx_Recem_Alocado (void)
  {
  Ptr_Elem_Buffer_Rx      Ptr_Temp_Buffer_Rx;

  disable();
  if (Ptr_Ret_Buffer_Rx != Ptr_Ins_Buffer_Rx)
    {
    Ptr_Temp_Buffer_Rx=Ptr_Ret_Buffer_Rx;
    while (Ptr_Temp_Buffer_Rx->Ptr_Proximo!=Ptr_Ins_Buffer_Rx)
      Ptr_Temp_Buffer_Rx=Ptr_Temp_Buffer_Rx->Ptr_Proximo;
    Nr_Elem_Buffer_Rx--;
    Ptr_Ins_Buffer_Rx = Ptr_Temp_Buffer_Rx;
    }
  enable();

  } /* Dealocar_Quadro_Buffer_Rx_Recem_Alocado */


/*************************************************************************/
/*                                                                       */
/*          Devolve True se o Buffer de Transmissao esta cheio           */
/*                                                                       */
/*************************************************************************/

Boolean Buffer_Tx_Cheio (void)

  {
  return (Nr_Elem_Buffer_Tx == Nr_Max_Quadros_Tx-1);
  /*
  if (Nr_Elem_Buffer_Tx == Nr_Max_Quadros_Tx)
    return (True);
  else
    return (False);
  */
  } /* Buffer_Tx_Cheio */


/*************************************************************************/
/*                                                                       */
/*             Devolve True se o Buffer de Recepcao esta cheio           */
/*                                                                       */
/*************************************************************************/

Boolean Buffer_Rx_Cheio (void)

  {
  return (Nr_Elem_Buffer_Rx == Nr_Max_Quadros_Rx-1);
  /*
  if (Nr_Elem_Buffer_Rx == Nr_Max_Quadros_Rx)
    return (True);
  else
    return (False);
  */
  } /* Buffer_Rx_Cheio */


/*************************************************************************/
/*                                                                       */
/*    Devolve o numero de elementos livres no buffer de transmissao      */
/*                                                                       */
/*************************************************************************/

unsigned char Nr_Liv_Buffer_Tx (void)

  {
  unsigned char                       Nr_Livres;

  Nr_Livres = Nr_Max_Quadros_Tx - Nr_Elem_Buffer_Tx;
  return (Nr_Livres);
  } /* Nr_Liv_Buffer_Tx */


/*************************************************************************/
/*                                                                       */
/*       Devolve o numero de elementos livres no buffer de recepcao      */
/*                                                                       */
/*************************************************************************/

unsigned char Nr_Liv_Buffer_Rx (void)

  {
  unsigned char                       Nr_Livres;

  Nr_Livres = Nr_Max_Quadros_Rx - Nr_Elem_Buffer_Rx;
  return (Nr_Livres);
  } /* Nr_Liv_Buffer_Rx */


/*************************************************************************/
/*                                                                       */
/*  Cria a Fila de Primitiva's LLC -> MAC como um Buffer Circular        */
/*                                                                       */
/*************************************************************************/

Tipo_Codigo_Retorno Criar_Fila_Primitivas_L_M (void)
  {
  Ptr_Estrutura_Primitiva_L_M       Ptr_Temp1_Fila_Primitivas_L_M;
  Ptr_Estrutura_Primitiva_L_M       Ptr_Temp2_Fila_Primitivas_L_M;
  unsigned char                       Indice_Fila_Primitivas_L_M;

  if ((Fila_Primitivas_L_M =
         (Estrutura_Primitiva_L_M *)
          calloc (Nr_Max_Elem_Fila_Primitivas_L_M,sizeof(Estrutura_Primitiva_L_M))) != NULL)
    {
    Ptr_Temp1_Fila_Primitivas_L_M = Ptr_Ins_Fila_Primitivas_L_M
                                    = Ptr_Ret_Fila_Primitivas_L_M
                                    = Fila_Primitivas_L_M;
    for (Indice_Fila_Primitivas_L_M = 1;
         Indice_Fila_Primitivas_L_M < Nr_Max_Elem_Fila_Primitivas_L_M;
         Indice_Fila_Primitivas_L_M++)
      {
      Ptr_Temp2_Fila_Primitivas_L_M = Ptr_Temp1_Fila_Primitivas_L_M++;
      Ptr_Temp2_Fila_Primitivas_L_M->Ptr_Proximo = Ptr_Temp1_Fila_Primitivas_L_M;
      }
    Ptr_Temp1_Fila_Primitivas_L_M->Ptr_Proximo = Ptr_Ins_Fila_Primitivas_L_M;
    Nr_Elem_Fila_Primitivas_L_M = 0;
    return (Operacao_Bem_Sucedida);
    }
  else
    return (Operacao_Falha);
  } /* Criar_Fila_Primitivas_L_M */


/*************************************************************************/
/*                                                                       */
/*  Cria a Fila de Primitiva's MAC -> LLC como um Buffer Circular        */
/*                                                                       */
/*************************************************************************/

Tipo_Codigo_Retorno Criar_Fila_Primitivas_M_L (void)
  {
  Ptr_Estrutura_Primitiva_M_L       Ptr_Temp1_Fila_Primitivas_M_L;
  Ptr_Estrutura_Primitiva_M_L       Ptr_Temp2_Fila_Primitivas_M_L;
  unsigned char                     Indice_Fila_Primitivas_M_L;

  if ((Fila_Primitivas_M_L =
        (Estrutura_Primitiva_M_L *)
         calloc (Nr_Max_Elem_Fila_Primitivas_M_L,sizeof(Estrutura_Primitiva_M_L))) != NULL)
    {
    Ptr_Temp1_Fila_Primitivas_M_L = Ptr_Ins_Fila_Primitivas_M_L
                                    = Ptr_Ret_Fila_Primitivas_M_L
                                    = Fila_Primitivas_M_L;
    for (Indice_Fila_Primitivas_M_L = 1;
         Indice_Fila_Primitivas_M_L < Nr_Max_Elem_Fila_Primitivas_M_L;
         Indice_Fila_Primitivas_M_L++)
      {
      Ptr_Temp2_Fila_Primitivas_M_L = Ptr_Temp1_Fila_Primitivas_M_L++;
      Ptr_Temp2_Fila_Primitivas_M_L->Ptr_Proximo = Ptr_Temp1_Fila_Primitivas_M_L;
      }
    Ptr_Temp1_Fila_Primitivas_M_L->Ptr_Proximo = Ptr_Ins_Fila_Primitivas_M_L;
    Nr_Elem_Fila_Primitivas_M_L = 0;
    return (Operacao_Bem_Sucedida);
    }
  else
    return (Operacao_Falha);
  } /* Criar_Fila_Primitivas_M_L */

/*************************************************************************/
/*                                                                       */
/*  Devolve o ponteiro para o elemento livre da fila de Primitiva L_M    */
/*                                                                       */
/*************************************************************************/

Ptr_Estrutura_Primitiva_L_M Alocar_Fila_Primitivas_L_M (void)

  {
  Ptr_Estrutura_Primitiva_L_M       Ptr_Primitiva_L_M;

  if (!Fila_Primitivas_L_M_Cheia ())
    {
      Nr_Elem_Fila_Primitivas_L_M++;
      Ptr_Primitiva_L_M = Ptr_Ins_Fila_Primitivas_L_M;
      Ptr_Ins_Fila_Primitivas_L_M = Ptr_Ins_Fila_Primitivas_L_M->Ptr_Proximo;
      return (Ptr_Primitiva_L_M);
    }
  else
    return (NULL); /* Fila cheia */
  } /* Alocar_Fila_Primitivas_L_M */


/*************************************************************************/
/*                                                                       */
/*  Devolve o ponteiro para o elemento livre da fila de Primitiva M_L    */
/*                                                                       */
/*************************************************************************/

Ptr_Estrutura_Primitiva_M_L Alocar_Fila_Primitivas_M_L (void)

  {
  Ptr_Estrutura_Primitiva_M_L       Ptr_Primitiva_M_L;

  disable();
  if (!Fila_Primitivas_M_L_Cheia ())
    {
      Nr_Elem_Fila_Primitivas_M_L++;
      Ptr_Primitiva_M_L = Ptr_Ins_Fila_Primitivas_M_L;
      Ptr_Ins_Fila_Primitivas_M_L = Ptr_Ins_Fila_Primitivas_M_L->Ptr_Proximo;
      enable();
      return (Ptr_Primitiva_M_L);
    }
  else
    {
    enable();
    return (NULL); /* Fila cheia */
    }
  } /* Alocar_Fila_Primitivas_M_L */

Ptr_Estrutura_Primitiva_M_L Int_Alocar_Fila_Primitivas_M_L (void)

  {
  Ptr_Estrutura_Primitiva_M_L       Ptr_Primitiva_M_L;

  if (!Fila_Primitivas_M_L_Cheia ())
    {
      Nr_Elem_Fila_Primitivas_M_L++;
      Ptr_Primitiva_M_L = Ptr_Ins_Fila_Primitivas_M_L;
      Ptr_Ins_Fila_Primitivas_M_L = Ptr_Ins_Fila_Primitivas_M_L->Ptr_Proximo;
      return (Ptr_Primitiva_M_L);
    }
  else
    return (NULL); /* Fila cheia */
  } /* Alocar_Fila_Primitivas_M_L */

/*************************************************************************/
/*                                                                       */
/*             Libera o elemento da fila de Primitiva's L_M              */
/*                                                                       */
/*************************************************************************/

void Dealocar_Fila_Primitivas_L_M (void)

  {
  if (Ptr_Ret_Fila_Primitivas_L_M != Ptr_Ins_Fila_Primitivas_L_M)
    {
    Nr_Elem_Fila_Primitivas_L_M--;
    Ptr_Ret_Fila_Primitivas_L_M = Ptr_Ret_Fila_Primitivas_L_M->Ptr_Proximo;
    }
  } /* Dealocar_Fila_Primitivas_L_M */


/*************************************************************************/
/*                                                                       */
/*             Libera o elemento da fila de Primitiva's M_L              */
/*                                                                       */
/*************************************************************************/

void Dealocar_Fila_Primitivas_M_L (void)

  {
  if (Ptr_Ret_Fila_Primitivas_M_L != Ptr_Ins_Fila_Primitivas_M_L)
    {
    Nr_Elem_Fila_Primitivas_M_L--;
    Ptr_Ret_Fila_Primitivas_M_L = Ptr_Ret_Fila_Primitivas_M_L->Ptr_Proximo;
    }
  } /* Dealocar_Fila_Primitivas_M_L */


/*************************************************************************/
/*                                                                       */
/*        Devolve verdadeiro se a Fila Enlace-Fisica esta cheia          */
/*                                                                       */
/*************************************************************************/

Boolean Fila_Primitivas_L_M_Cheia (void)

  {
  if (Ptr_Ins_Fila_Primitivas_L_M->Ptr_Proximo == Ptr_Ret_Fila_Primitivas_L_M)
    return (True);
  else
    return (False);
  } /* Fila_Primitivas_L_M_Cheia */


/*************************************************************************/
/*                                                                       */
/*        Devolve verdadeiro se a Fila Fisica-Enlace esta cheia          */
/*                                                                       */
/*************************************************************************/

Boolean Fila_Primitivas_M_L_Cheia (void)

  {
  if (Ptr_Ins_Fila_Primitivas_M_L->Ptr_Proximo == Ptr_Ret_Fila_Primitivas_M_L)
    return (True);
  else
    return (False);
  } /* Fila_Primitivas_M_L_Cheia */


/*************************************************************************/
/*                                                                       */
/*        Devolve verdadeiro se a Fila Enlace-Fisica esta nao vazia      */
/*                                                                       */
/*************************************************************************/

Boolean Fila_Primitivas_L_M_Nao_Vazia (void)

  {
  if (Ptr_Ins_Fila_Primitivas_L_M == Ptr_Ret_Fila_Primitivas_L_M)
    return (False);
  else
    return (True);
  } /* Fila_Primitivas_L_M_Nao_Vazia */


/*************************************************************************/
/*                                                                       */
/*        Devolve verdadeiro se a Fila Fisica-Enlace esta nao vazia      */
/*                                                                       */
/*************************************************************************/

Boolean Fila_Primitivas_M_L_Nao_Vazia (void)

  {
  if (Ptr_Ins_Fila_Primitivas_M_L == Ptr_Ret_Fila_Primitivas_M_L)
    return (False);
  else
    return (True);
  } /* Fila_Primitivas_M_L_Nao_Vazia */


/*************************************************************************/
/*                                                                       */
/*       Devolve o numero de elementos livres na fila Enlace-Fisica      */
/*                                                                       */
/*************************************************************************/

unsigned char Nr_Liv_Fila_Primitivas_L_M (void)

  {
  unsigned char                       Nr_Livres;

  Nr_Livres = Nr_Max_Elem_Fila_Primitivas_L_M - Nr_Elem_Fila_Primitivas_L_M;
  return (Nr_Livres);
  } /* Nr_Liv_Fila_Primitivas_L_M */


/*************************************************************************/
/*                                                                       */
/*       Devolve o numero de elementos livres na fila Fisica-Enlace      */
/*                                                                       */
/*************************************************************************/

unsigned char Nr_Liv_Fila_Primitivas_M_L (void)

  {
  unsigned char                       Nr_Livres;

  Nr_Livres = Nr_Max_Elem_Fila_Primitivas_M_L - Nr_Elem_Fila_Primitivas_M_L;
  return (Nr_Livres);
  } /* Nr_Liv_Fila_Primitivas_M_L */


/*************************************************************************/
/*                                                                       */
/*          Envia Primitiva da Camada Enlace para a Fisica               */
/*                                                                       */
/*************************************************************************/

void Enviar_Primitiva_L_M (void)

  {
  Enviar_Rotina_Fila_Gerente_RMOSI (Maquina_Estados_LLC_MAC,0);
  } /* Enviar_Primitiva_L_M */


/*************************************************************************/
/*                                                                       */
/*               Envia Primitiva da Camada Fisica para a Enlace          */
/*                                                                       */
/*************************************************************************/

void Enviar_Primitiva_M_L (void)

  {
  Enviar_Rotina_Fila_Gerente_RMOSI (Maquina_Estados_MAC_LLC,0);
  } /* Enviar_Primitiva_M_L */

void Enviar_Primitiva_M_L_Int (void)

  {
  Enviar_Rotina_Fila_Gerente_RMOSI (Maquina_Estados_MAC_LLC,0);
  } /* Enviar_Primitiva_M_L */


/*************************************************************************/
/*                                                                       */
/*                Recebe a primitiva enviada pela Camada Enlace          */
/*                                                                       */
/*************************************************************************/

Ptr_Estrutura_Primitiva_L_M Receber_Primitiva_L_M (void)

  {
  return (Ptr_Ret_Fila_Primitivas_L_M);
  } /* Receber_Primitiva_L_M*/


/*************************************************************************/
/*                                                                       */
/*                Recebe a primitiva enviada pela Camada Fisica          */
/*                                                                       */
/*************************************************************************/

Ptr_Estrutura_Primitiva_M_L Receber_Primitiva_M_L (void)

  {
  return (Ptr_Ret_Fila_Primitivas_M_L);
  } /* Receber_Primitiva_M_L */

#endif
