/* Arquivo             : TipLM.H   */
/* Autor               : GTA       */
/* Data Inicio         : 30-07-92  */
/* Data Ultima Revisao : 30-07-92  */

/*************************************************************************/
/*                                                                       */
/*      Definicao dos tipos utilizados na Interface LLC - MAC            */
/*                                                                       */
/*************************************************************************/

#ifndef TIPOSINTERFACELM
#define TIPOSINTERFACELM

#include <CntLM.H>

/* Definicao das filas de transmissao e recepcao */

typedef struct Elem_Buffer_Tx
  {
    struct Elem_Buffer_Tx              *Ptr_Proximo;
    unsigned int                       End_Origem;
    unsigned int                       End_Destino;
    unsigned int                       Status;
    unsigned int                       Quality_of_Service;
    unsigned int                       Tam_Info;
    unsigned char                      Cab_Pack[Tam_Cab_Pack];
    unsigned char                      Info [Tam_Max_Quadro_Tx];
  } Elem_Buffer_Tx;

typedef struct Elem_Buffer_Tx          *Ptr_Elem_Buffer_Tx;

typedef struct Elem_Buffer_Rx
  {
    struct Elem_Buffer_Rx              *Ptr_Proximo;
    unsigned int                       End_Origem;
    unsigned int                       End_Destino;
    unsigned int                       Status;
    unsigned int                       Quality_of_Service;
    unsigned int                       Tam_Info;
    unsigned char                      Cab_Pack[Tam_Cab_Pack];
    unsigned char                      Info [Tam_Max_Quadro_Rx];
  } Elem_Buffer_Rx;

typedef struct Elem_Buffer_Rx          *Ptr_Elem_Buffer_Rx;

/* Primitivas de Servico da Camada Fisica */
typedef enum
  {
    MA_DATA_Request
  }
Primitivas_L_M;

typedef enum
  {
    MA_DATA_Indication,
    MA_DATA_Confirm
  }
Primitivas_M_L;


/* Definicao das filas para trocas de primitivas */

typedef struct Estrutura_Primitiva_L_M
  {
    struct Estrutura_Primitiva_L_M        *Ptr_Proximo;
    Primitivas_L_M                        Nome_Primitiva;
    Ptr_Elem_Buffer_Tx                    Ptr_Parametros_Primitiva;
  } Estrutura_Primitiva_L_M;

typedef struct Estrutura_Primitiva_L_M    *Ptr_Estrutura_Primitiva_L_M;

typedef struct Estrutura_Primitiva_M_L
  {
    struct Estrutura_Primitiva_M_L        *Ptr_Proximo;
    Primitivas_M_L                        Nome_Primitiva;
    Ptr_Elem_Buffer_Rx                    Ptr_Parametros_Primitiva;
  } Estrutura_Primitiva_M_L;

typedef struct Estrutura_Primitiva_M_L    *Ptr_Estrutura_Primitiva_M_L;

#endif
