/* Arquivo             : FncDLPH.C */
/* Autor               : Fernando M. C. de Barros */
/* Data Inicio         : 23-11-91  */
/* Versao para o simulador         */
/* Ultima rev. Marcos Tadeu        */
/* 23-07-92: Retirada dealocacao mem.Rx da area de dados do usuario.     */
/*           Motivo: retirada da recopia para a estrutura de parametros. */
/*           Alocacoes e dealocacoes RX a partir do tamanho real do      */
/*           quadro, e nao do maximo.                                    */

#ifndef  FUNCOESINTERFACEDLPH_C
#define  FUNCOESINTERFACEDLPH_C


#include <cntglob.h>
#include <tipglob.h>
#include <fncesc.h>
#include <memtx.h>
#include <memrx.h>
#include <cntdlph.h>
#include <tipdlph.h>
#include <vardlph.h>
#include <varmed.h>

/* Pontos de Entrada do escalonador */

#ifdef SIMUL_PMP
void  Tratar_Pedido_Servico_PHDL_Tx (void);
#endif
void  Tratar_Pedido_Servico_PHDL_Rx (unsigned char);
void  Executar_Camada_PH (unsigned char);



/*************************************************************************/
/*                                                                       */
/*                 Cabecalho das funcoes para a Interface                */
/*                    entre as Camadas Enlace e Fisica                   */
/*                                                                       */
/**************************************************************************/

Tipo_Codigo_Retorno Inicializar_Interface_DL_PH (void);

void Finalizar_Interface_DL_PH (void);


/* Funcoes relativas aos buffer's de transmissao - recepcao */

Tipo_Codigo_Retorno Criar_Alinhar_Buffer_Tx_Rx (void);
Boolean Sobre_Escrita_Rx (Ptr_Elem_Buffer_Rx);
Ptr_Elem_Buffer_Tx Alocar_Quadro_Buffer_Tx (unsigned char);
Ptr_Elem_Buffer_Rx Alocar_Quadro_Buffer_Rx (unsigned char,unsigned int);
void Dealocar_Quadro_Buffer_Tx (unsigned char);
void Dealocar_Quadro_Buffer_Rx (unsigned char,unsigned int);
Boolean Buffer_Tx_Cheio (unsigned char);
Boolean Buffer_Rx_Cheio (unsigned char);
unsigned char Nr_Liv_Buffer_Tx (unsigned char);
unsigned char Nr_Liv_Buffer_Rx (unsigned char);

/* Funcoes relativas as filas de Primitiva's */
Tipo_Codigo_Retorno Criar_Fila_Primitivas_DL_PH (void);
Tipo_Codigo_Retorno Criar_Fila_Primitivas_PH_DL (void);
Ptr_Estrutura_Primitiva_DL_PH Alocar_Fila_Primitivas_DL_PH (unsigned char);
Ptr_Estrutura_Primitiva_PH_DL Alocar_Fila_Primitivas_PH_DL (unsigned char);
void Dealocar_Fila_Primitivas_DL_PH (unsigned char);
void Dealocar_Fila_Primitivas_PH_DL (unsigned char);
Boolean Fila_Primitivas_DL_PH_Cheia (unsigned char);
Boolean Fila_Primitivas_PH_DL_Cheia (unsigned char);
Boolean Fila_Primitivas_DL_PH_Nao_Vazia (unsigned char);
Boolean Fila_Primitivas_PH_DL_Nao_Vazia (unsigned char);
unsigned char Nr_Liv_Fila_Primitivas_DL_PH (unsigned char);
unsigned char Nr_Liv_Fila_Primitivas_PH_DL (unsigned char);

void Enviar_Primitiva_DL_PH (unsigned char);
void Enviar_Primitiva_PH_DL (unsigned char);
Ptr_Estrutura_Primitiva_DL_PH Receber_Primitiva_DL_PH (unsigned char);
Ptr_Estrutura_Primitiva_PH_DL Receber_Primitiva_PH_DL (unsigned char);

/*************************************************************************/
/*                                                                       */
/*         Inicializa as variaveis da Interface Enlace - Fisica          */
/*                                                                       */
/*************************************************************************/

Tipo_Codigo_Retorno Inicializar_Interface_DL_PH (void)
{
unsigned char   i;

for (i = 0; i <= Num_Receptores; i++)
  {
  Ptr_Prim_Buffer_Tx [i] = NULL;
  Ptr_Ult_Buffer_Tx [i]  = NULL;
  Ptr_Prim_Buffer_Rx [i] = NULL;
  Ptr_Ult_Buffer_Rx [i]  = NULL;
  Nr_Elem_Buffer_Tx [i]  = 0;
  Nr_Elem_Buffer_Rx [i]  = 0;

  Ptr_Prim_Fila_Primitivas_PH_DL [i] = NULL;
  Ptr_Prim_Fila_Primitivas_DL_PH [i] = NULL;
  Nr_Elem_Fila_Primitivas_PH_DL [i]  = 0;
  Nr_Elem_Fila_Primitivas_DL_PH [i]  = 0;
  } /* for */

return (Operacao_Bem_Sucedida);

} /* Inicializar_Interface_DL_PH */


/*************************************************************************/
/*                                                                       */
/*           Finaliza as variaveis da Interface Enlace - Fisica          */
/*                                                                       */
/*************************************************************************/

void Finalizar_Interface_DL_PH (void)

{
unsigned char                        i;
Ptr_Estrutura_Primitiva_PH_DL        Ptr_Primitiva_PH_DL;
Ptr_Estrutura_Primitiva_DL_PH        Ptr_Primitiva_DL_PH;

Ptr_Elem_Buffer_Tx                   Ptr_Buffer_Tx;
Ptr_Elem_Buffer_Rx                   Ptr_Buffer_Rx;



for (i = 0; i <= Num_Receptores; i++)
  {
  /* Libera filas de Primitivas */

  while (Ptr_Prim_Fila_Primitivas_PH_DL [i])
    {
    Ptr_Primitiva_PH_DL = Ptr_Prim_Fila_Primitivas_PH_DL [i];
    Ptr_Prim_Fila_Primitivas_PH_DL [i] = Ptr_Prim_Fila_Primitivas_PH_DL [i]->Ptr_Proximo;
    Liberar_Estrutura_Primitiva_Rx ((unsigned char *) (Ptr_Primitiva_PH_DL));
    } /* while */

  while (Ptr_Prim_Fila_Primitivas_DL_PH [i])
    {
    Ptr_Primitiva_DL_PH = Ptr_Prim_Fila_Primitivas_DL_PH [i];
    Ptr_Prim_Fila_Primitivas_DL_PH [i] = Ptr_Prim_Fila_Primitivas_DL_PH [i]->Ptr_Proximo;
    Liberar_Estrutura_Primitiva_Tx ((unsigned char *) (Ptr_Primitiva_DL_PH));
    } /* while */

  /* Libera Buffers */

  while (Ptr_Prim_Buffer_Tx [i])
    {
    Ptr_Buffer_Tx = Ptr_Prim_Buffer_Tx [i];
    Ptr_Prim_Buffer_Tx [i] = Ptr_Prim_Buffer_Tx [i]->Ptr_Proximo;
    Liberar_Memoria_Tx (Ptr_Buffer_Tx->Info,Tam_Max_Quadro_Tx);
    Liberar_Memoria_Tx ((unsigned char *) (Ptr_Buffer_Tx), sizeof (Elem_Buffer_Tx));
    } /* while */

  while (Ptr_Prim_Buffer_Rx [i])
    {
    Ptr_Buffer_Rx = Ptr_Prim_Buffer_Rx [i];
    Ptr_Prim_Buffer_Rx [i] = Ptr_Prim_Buffer_Rx [i]->Ptr_Proximo;
/*23-7-92*
    Liberar_Memoria_Rx (Ptr_Buffer_Rx->Info,Tam_Max_Quadro_Rx);
*/
    Liberar_Memoria_Rx ((unsigned char *) (Ptr_Buffer_Rx), sizeof (Elem_Buffer_Rx));
    } /* while */
  } /* for */
}  /* Finalizar_Interface_DL_PH */


/*************************************************************************/
/*                                                                       */
/*  Cria os Buffer's Circulares de Transmissao e Recepcao em que cada    */
/*    elemento esta contido em uma unica pagina de memoria do PC         */
/*                                                                       */
/*************************************************************************/

Tipo_Codigo_Retorno Criar_Alinhar_Buffer_Tx_Rx (void)
{
return (Operacao_Bem_Sucedida);
} /* Criar_Alinhar_Buffer_Tx_Rx */


/*************************************************************************/
/*                                                                       */
/*    Indica se o elemento do Buffer Rx e o ultimo elemento disponivel   */
/*                                                                       */
/*************************************************************************/

Boolean Sobre_Escrita_Rx (Ptr_Elem_Buffer_Rx Ptr_Referencia_Rx)
{
Ptr_Referencia_Rx = Ptr_Referencia_Rx;
return (False);
} /* Sobre_Escrita_Rx */


/*************************************************************************/
/*                                                                       */
/* Devolve o apontador para o proximo elemento do Buffer de Transmissao  */
/*                                                                       */
/*************************************************************************/

Ptr_Elem_Buffer_Tx Alocar_Quadro_Buffer_Tx (unsigned char  Num_Estacao)

{
Ptr_Elem_Buffer_Tx      Ptr_Buffer_Tx;

if (!Buffer_Tx_Cheio (Num_Estacao))
  {
  Ptr_Buffer_Tx = (Ptr_Elem_Buffer_Tx) Alocar_Memoria_Tx (sizeof (Elem_Buffer_Tx));
  Ptr_Buffer_Tx->Info = Alocar_Memoria_Tx (Tam_Max_Quadro_Tx);
  if (Ptr_Buffer_Tx->Info)
    {
    if (!Ptr_Prim_Buffer_Tx [Num_Estacao])
      Ptr_Prim_Buffer_Tx [Num_Estacao] = Ptr_Buffer_Tx;
    else
      Ptr_Ult_Buffer_Tx [Num_Estacao]->Ptr_Proximo = Ptr_Buffer_Tx;
    Ptr_Ult_Buffer_Tx [Num_Estacao] = Ptr_Buffer_Tx;
    Ptr_Ult_Buffer_Tx [Num_Estacao] ->Ptr_Proximo = NULL;
    Nr_Elem_Buffer_Tx [Num_Estacao]++;
    return (Ptr_Buffer_Tx);
    }
  else
    {
    Liberar_Memoria_Tx ((unsigned char *) Ptr_Buffer_Tx, sizeof (Elem_Buffer_Tx));
    return (NULL); /* Nao conseguiu alocar memo para informacao */
    }
  }
else
  return (NULL); /* Fila cheia */

} /* Alocar_Quadro_Buffer_Tx */


/*************************************************************************/
/*                                                                       */
/*   Devolve o apontador para o proximo elemento do Buffer de Recepcao   */
/*   Se o Buffer esta cheio devolve NULL                                 */
/*                                                                       */
/*************************************************************************/

Ptr_Elem_Buffer_Rx Alocar_Quadro_Buffer_Rx (unsigned char   Num_Estacao,
                                            unsigned int    Tam_Quadro)
{
Ptr_Elem_Buffer_Rx      Ptr_Buffer_Rx;

if (!Buffer_Rx_Cheio (Num_Estacao))
  {
  Ptr_Buffer_Rx = (Ptr_Elem_Buffer_Rx) Alocar_Memoria_Rx (sizeof (Elem_Buffer_Rx));
  Ptr_Buffer_Rx->Info = Alocar_Memoria_Rx (Tam_Quadro);/*Tam_Max_Quadro_Rx);*/
  if (Ptr_Buffer_Rx->Info)
    {
    if (!Ptr_Prim_Buffer_Rx [Num_Estacao])
      Ptr_Prim_Buffer_Rx [Num_Estacao] = Ptr_Buffer_Rx;
    else
      Ptr_Ult_Buffer_Rx [Num_Estacao]->Ptr_Proximo = Ptr_Buffer_Rx;
    Ptr_Ult_Buffer_Rx [Num_Estacao] = Ptr_Buffer_Rx;
    Ptr_Ult_Buffer_Rx [Num_Estacao] ->Ptr_Proximo = NULL;
    Nr_Elem_Buffer_Rx [Num_Estacao]++;
    return (Ptr_Buffer_Rx);
    }
  else
    {
    Liberar_Memoria_Rx ((unsigned char *) Ptr_Buffer_Rx, sizeof (Elem_Buffer_Rx));
    return (NULL);  /* Nao conseguiu alocar memo para informacao */
    }
  }
else
  return (NULL); /* Fila cheia */

} /* Alocar_Quadro_Buffer_Rx */


/*************************************************************************/
/*                                                                       */
/*  Libera o elemento do Buffer Tx para utilizacao em nova transmissao   */
/*                                                                       */
/*************************************************************************/

void Dealocar_Quadro_Buffer_Tx (unsigned char   Num_Estacao)
{
Ptr_Elem_Buffer_Tx        Ptr_Buffer_Tx;

if (Ptr_Prim_Buffer_Tx [Num_Estacao])
  {
  Ptr_Buffer_Tx = Ptr_Prim_Buffer_Tx [Num_Estacao];
  Ptr_Prim_Buffer_Tx [Num_Estacao] = Ptr_Prim_Buffer_Tx [Num_Estacao]->Ptr_Proximo;
  Liberar_Memoria_Tx (Ptr_Buffer_Tx->Info, Tam_Max_Quadro_Tx);
  Liberar_Memoria_Tx ((unsigned char *) (Ptr_Buffer_Tx), sizeof (Elem_Buffer_Tx));
  Nr_Elem_Buffer_Tx [Num_Estacao]--;
  }

} /* Dealocar_Quadro_Buffer_Tx */


/*************************************************************************/
/*                                                                       */
/*     Libera o elemento do Buffer Rx para utilizacao em nova recepcao   */
/*                                                                       */
/*************************************************************************/

void Dealocar_Quadro_Buffer_Rx (unsigned char   Num_Estacao,unsigned int Tamanho)
{
Ptr_Elem_Buffer_Rx        Ptr_Buffer_Rx;

if (Ptr_Prim_Buffer_Rx [Num_Estacao])
  {
  Ptr_Buffer_Rx = Ptr_Prim_Buffer_Rx [Num_Estacao];
  Ptr_Prim_Buffer_Rx [Num_Estacao] = Ptr_Prim_Buffer_Rx [Num_Estacao]->Ptr_Proximo;
/*23* A informacao nao sera recopiada para a estrutura de parametros.
Sera feita transferencia de ponteiro.A liberacao eh necessaria nas outras PDUs */
  if (Tamanho > 0)
    Liberar_Memoria_Rx (Ptr_Buffer_Rx->Info,Tamanho/* Tam_Max_Quadro_Rx*/);
  Liberar_Memoria_Rx ((unsigned char *) (Ptr_Buffer_Rx), sizeof (Elem_Buffer_Rx));
  Nr_Elem_Buffer_Rx [Num_Estacao]--;
  }

} /* Dealocar_Quadro_Buffer_Rx */


/*************************************************************************/
/*                                                                       */
/*          Devolve True se o Buffer de Transmissao esta cheio           */
/*                                                                       */
/*************************************************************************/

Boolean Buffer_Tx_Cheio (unsigned char   Num_Estacao)
{
if (Nr_Elem_Buffer_Tx [Num_Estacao]== Nr_Max_Quadros_Tx)
  return (True);
else
  return (False);
} /* Buffer_Tx_Cheio */


/*************************************************************************/
/*                                                                       */
/*             Devolve True se o Buffer de Recepcao esta cheio           */
/*                                                                       */
/*************************************************************************/

Boolean Buffer_Rx_Cheio (unsigned char   Num_Estacao)
{
if (Nr_Elem_Buffer_Rx [Num_Estacao] == Nr_Max_Quadros_Rx)
  return (True);
else
  return (False);

} /* Buffer_Rx_Cheio */


/*************************************************************************/
/*                                                                       */
/*    Devolve o numero de elementos livres no buffer de transmissao      */
/*                                                                       */
/*************************************************************************/

unsigned char Nr_Liv_Buffer_Tx (unsigned char   Num_Estacao)
{
unsigned char                       Nr_Livres;

Nr_Livres = Nr_Max_Quadros_Tx - Nr_Elem_Buffer_Tx [Num_Estacao];
return (Nr_Livres);

} /* Nr_Liv_Buffer_Tx */


/*************************************************************************/
/*                                                                       */
/*       Devolve o numero de elementos livres no buffer de recepcao      */
/*                                                                       */
/*************************************************************************/

unsigned char Nr_Liv_Buffer_Rx (unsigned char   Num_Estacao)
{
unsigned char                       Nr_Livres;

Nr_Livres = Nr_Max_Quadros_Rx - Nr_Elem_Buffer_Rx [Num_Estacao];
return (Nr_Livres);

} /* Nr_Liv_Buffer_Rx */


/*************************************************************************/
/*                                                                       */
/*  Cria a Fila de Primitiva's Enlace -> Fisica como um Buffer Circular  */
/*                                                                       */
/*************************************************************************/

Tipo_Codigo_Retorno Criar_Fila_Primitivas_DL_PH (void)
{
return (Operacao_Bem_Sucedida);
} /* Criar_Fila_Primitivas_DL_PH */


/*************************************************************************/
/*                                                                       */
/*  Cria a Fila de Primitiva's Fisica -> Enlace como um Buffer Circular  */
/*                                                                       */
/*************************************************************************/

Tipo_Codigo_Retorno Criar_Fila_Primitivas_PH_DL (void)
{
return (Operacao_Bem_Sucedida);
} /* Criar_Fila_Primitivas_PH_DL */

/*************************************************************************/
/*                                                                       */
/*  Devolve o ponteiro para o elemento livre da fila de Primitiva DL-PH  */
/*                                                                       */
/*************************************************************************/

Ptr_Estrutura_Primitiva_DL_PH Alocar_Fila_Primitivas_DL_PH (unsigned char   Num_Estacao)
{
Ptr_Estrutura_Primitiva_DL_PH       Ptr_Primitiva_DL_PH;

if (!Fila_Primitivas_DL_PH_Cheia (Num_Estacao))
  {
  Ptr_Primitiva_DL_PH = (Ptr_Estrutura_Primitiva_DL_PH) Alocar_Estrutura_Primitiva_Tx ();
  if (!Ptr_Prim_Fila_Primitivas_DL_PH [Num_Estacao])
    Ptr_Prim_Fila_Primitivas_DL_PH [Num_Estacao] = Ptr_Primitiva_DL_PH;
  else
    Ptr_Ult_Fila_Primitivas_DL_PH [Num_Estacao]->Ptr_Proximo = Ptr_Primitiva_DL_PH;
  Ptr_Ult_Fila_Primitivas_DL_PH [Num_Estacao] = Ptr_Primitiva_DL_PH;
  Ptr_Ult_Fila_Primitivas_DL_PH [Num_Estacao] ->Ptr_Proximo = NULL;
  Nr_Elem_Fila_Primitivas_DL_PH [Num_Estacao]++;
  return (Ptr_Primitiva_DL_PH);
  }
else
  return (NULL); /* Fila cheia */

} /* Alocar_Fila_Primitivas_DL_PH */


/*************************************************************************/
/*                                                                       */
/*  Devolve o ponteiro para o elemento livre da fila de Primitiva PH-DL  */
/*                                                                       */
/*************************************************************************/

Ptr_Estrutura_Primitiva_PH_DL Alocar_Fila_Primitivas_PH_DL (unsigned char   Num_Estacao)
{
Ptr_Estrutura_Primitiva_PH_DL       Ptr_Primitiva_PH_DL;

if (!Fila_Primitivas_PH_DL_Cheia (Num_Estacao))
  {
  Ptr_Primitiva_PH_DL = (Ptr_Estrutura_Primitiva_PH_DL) Alocar_Estrutura_Primitiva_Rx ();
  if (!Ptr_Prim_Fila_Primitivas_PH_DL [Num_Estacao])
    Ptr_Prim_Fila_Primitivas_PH_DL [Num_Estacao] = Ptr_Primitiva_PH_DL;
  else
    Ptr_Ult_Fila_Primitivas_PH_DL [Num_Estacao]->Ptr_Proximo = Ptr_Primitiva_PH_DL;
  Ptr_Ult_Fila_Primitivas_PH_DL [Num_Estacao] = Ptr_Primitiva_PH_DL;
  Ptr_Ult_Fila_Primitivas_PH_DL [Num_Estacao] ->Ptr_Proximo = NULL;
  Nr_Elem_Fila_Primitivas_PH_DL [Num_Estacao]++;
  return (Ptr_Primitiva_PH_DL);
  }
else
  return (NULL); /* Fila cheia */

} /* Alocar_Fila_Primitivas_PH_DL */


/*************************************************************************/
/*                                                                       */
/*             Libera o elemento da fila de Primitiva's DL-PH            */
/*                                                                       */
/*************************************************************************/

void Dealocar_Fila_Primitivas_DL_PH (unsigned char   Num_Estacao)
{
Ptr_Estrutura_Primitiva_DL_PH        Ptr_Primitiva_DL_PH;

if (Ptr_Prim_Fila_Primitivas_DL_PH [Num_Estacao])
  {
  Ptr_Primitiva_DL_PH = Ptr_Prim_Fila_Primitivas_DL_PH [Num_Estacao];
  Ptr_Prim_Fila_Primitivas_DL_PH [Num_Estacao] = Ptr_Prim_Fila_Primitivas_DL_PH [Num_Estacao]->Ptr_Proximo;
  Liberar_Estrutura_Primitiva_Tx ((unsigned char *) (Ptr_Primitiva_DL_PH));
  Nr_Elem_Fila_Primitivas_DL_PH [Num_Estacao]--;
  }

} /* Dealocar_Fila_Primitivas_DL_PH */


/*************************************************************************/
/*                                                                       */
/*             Libera o elemento da fila de Primitiva's PH-DL                  */
/*                                                                       */
/*************************************************************************/

void Dealocar_Fila_Primitivas_PH_DL (unsigned char   Num_Estacao)
{
Ptr_Estrutura_Primitiva_PH_DL        Ptr_Primitiva_PH_DL;

if (Ptr_Prim_Fila_Primitivas_PH_DL [Num_Estacao])
  {
  Ptr_Primitiva_PH_DL = Ptr_Prim_Fila_Primitivas_PH_DL [Num_Estacao];
  Ptr_Prim_Fila_Primitivas_PH_DL [Num_Estacao] = Ptr_Prim_Fila_Primitivas_PH_DL [Num_Estacao]->Ptr_Proximo;
  Liberar_Estrutura_Primitiva_Rx ((unsigned char *) (Ptr_Primitiva_PH_DL));
  Nr_Elem_Fila_Primitivas_PH_DL [Num_Estacao]--;
  }

} /* Dealocar_Fila_Primitivas_PH_DL */


/*************************************************************************/
/*                                                                       */
/*        Devolve verdadeiro se a Fila Enlace-Fisica esta cheia          */
/*                                                                       */
/*************************************************************************/

Boolean Fila_Primitivas_DL_PH_Cheia (unsigned char   Num_Estacao)
{
if (Nr_Elem_Fila_Primitivas_DL_PH [Num_Estacao] == Nr_Max_Elem_Fila_Primitivas_DL_PH)
  return (True);
else
  return (False);

} /* Fila_Primitivas_DL_PH_Cheia */


/*************************************************************************/
/*                                                                       */
/*        Devolve verdadeiro se a Fila Fisica-Enlace esta cheia          */
/*                                                                       */
/*************************************************************************/

Boolean Fila_Primitivas_PH_DL_Cheia (unsigned char   Num_Estacao)
{
if (Nr_Elem_Fila_Primitivas_PH_DL [Num_Estacao] == Nr_Max_Elem_Fila_Primitivas_PH_DL)
  return (True);
else
  return (False);

} /* Fila_Primitivas_PH_DL_Cheia */


/*************************************************************************/
/*                                                                       */
/*        Devolve verdadeiro se a Fila Enlace-Fisica esta nao vazia      */
/*                                                                       */
/*************************************************************************/

Boolean Fila_Primitivas_DL_PH_Nao_Vazia (unsigned char   Num_Estacao)
{
if (!Ptr_Prim_Fila_Primitivas_DL_PH [Num_Estacao])
  return (False);
else
  return (True);

} /* Fila_Primitivas_DL_PH_Nao_Vazia */


/*************************************************************************/
/*                                                                       */
/*        Devolve verdadeiro se a Fila Fisica-Enlace esta nao vazia      */
/*                                                                       */
/*************************************************************************/

Boolean Fila_Primitivas_PH_DL_Nao_Vazia (unsigned char   Num_Estacao)
{
if (!Ptr_Prim_Fila_Primitivas_PH_DL [Num_Estacao])
  return (False);
else
  return (True);

} /* Fila_Primitivas_PH_DL_Nao_Vazia */


/*************************************************************************/
/*                                                                       */
/*       Devolve o numero de elementos livres na fila Enlace-Fisica      */
/*                                                                       */
/*************************************************************************/

unsigned char Nr_Liv_Fila_Primitivas_DL_PH (unsigned char   Num_Estacao)
{
unsigned char                       Nr_Livres;

Nr_Livres = Nr_Max_Elem_Fila_Primitivas_DL_PH - Nr_Elem_Fila_Primitivas_DL_PH [Num_Estacao];
return (Nr_Livres);

} /* Nr_Liv_Fila_Primitivas_DL_PH */


/*************************************************************************/
/*                                                                       */
/*       Devolve o numero de elementos livres na fila Fisica-Enlace      */
/*                                                                       */
/*************************************************************************/

unsigned char Nr_Liv_Fila_Primitivas_PH_DL (unsigned char   Num_Estacao)
{
unsigned char                       Nr_Livres;

Nr_Livres =Nr_Max_Elem_Fila_Primitivas_PH_DL - Nr_Elem_Fila_Primitivas_PH_DL [Num_Estacao];
return (Nr_Livres);

} /* Nr_Liv_Fila_Primitivas_PH_DL */


/*************************************************************************/
/*                                                                       */
/*          Envia Primitiva da Camada Enlace para a Fisica               */
/*                                                                       */
/*************************************************************************/

void Enviar_Primitiva_DL_PH (unsigned char   Num_Estacao)
{
Enviar_Rotina_Fila_Gerente_RMOSI (Executar_Camada_PH,Num_Estacao);
} /* Enviar_Primitiva_DL_PH */


/*************************************************************************/
/*                                                                       */
/*               Envia Primitiva da Camada Fisica para a Enlace          */
/*                                                                       */
/*************************************************************************/

void Enviar_Primitiva_PH_DL (unsigned char   Num_Estacao)
{
#ifdef SIMUL_PMP
if (Num_Estacao == 0)
  Enviar_Rotina_Fila_Gerente_RMOSI (Tratar_Pedido_Servico_PHDL_Tx,0);
else
#endif
  Enviar_Rotina_Fila_Gerente_RMOSI (Tratar_Pedido_Servico_PHDL_Rx,Num_Estacao);
} /* Enviar_Primitiva_PH_DL */


/*************************************************************************/
/*                                                                       */
/*                Recebe a primitiva enviada pela Camada Enlace          */
/*                                                                       */
/*************************************************************************/

Ptr_Estrutura_Primitiva_DL_PH Receber_Primitiva_DL_PH (unsigned char   Num_Estacao)
{
return (Ptr_Prim_Fila_Primitivas_DL_PH [Num_Estacao]);
} /* Receber_Primitiva_DL_PH */


/*************************************************************************/
/*                                                                       */
/*                Recebe a primitiva enviada pela Camada Fisica          */
/*                                                                       */
/*************************************************************************/

Ptr_Estrutura_Primitiva_PH_DL Receber_Primitiva_PH_DL (unsigned char   Num_Estacao)
{
return (Ptr_Prim_Fila_Primitivas_PH_DL [Num_Estacao]);
} /* Receber_Primitiva_PH_DL */

#endif