/* Arquivo             : FncMAC.C */
/* Data Inicio         : 30-07-92 */
/* Data Ultima Revisao : 30-07-92 */

#ifndef FUNCOESMAC
#define FUNCOESMAC

#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <alloc.h>
#include <dos.h>
#include <string.h>

#include <TipGLOB.H>
#include <MemRx.H>
#include <MemTx.H>
#include <CntLM.H>
#include <TipLM.h>
#include <FncLM.H>
#include <CntMAC.H>
#include <TipMAC.H>
#include <VarMAC.H>

void Inicializar_Camada_MAC (void);
void Maquina_Estados_LLC_MAC (void);
void Finalizar_Camada_MAC (void);
void far interrupt receiver (unsigned int,unsigned int,unsigned int,unsigned int,unsigned int,unsigned int,unsigned int,unsigned int,unsigned int);
int Procura_Pkt_Driver (void);
void Erro (unsigned char);
void driver_info (int);
int access_type (int,int,int,char far *,unsigned int,void far (*)());
int release_type (int);
int send_pkt (char far *,unsigned int);
void terminate (int);
void get_address (int,char far *,int);
void reset_interface (int);

extern unsigned char num_dealocacoes_Tx, num_alocacoes_Rx,
                     num_dealoc_fila_LM, num_aloc_fila_ML;

/*******************************************************/

int Procura_Pkt_Driver (void)
{
	int int_no;
        void interrupt (*int_vect) ();

        int_no = 0x60;
        do {
        	int_vect = getvect (int_no);
                if (!strcmp ((char *) int_vect + 3, "PKT DRVR"))
                        break;
                int_no ++;
        } while ((int_no < 0x81));
        if (int_no == 0x81) {
        	printf ("Packet driver nao instalado!\n");
                exit (0);
        }
        return (int_no);
}
/*******************************************************/

void Erro (unsigned char cod_erro)
{
	static char *msg_erro[] = {
        	"BAD_HANDLE",
                "NO_CLASS",
                "NO_TYPE",
                "NO_NUMBER",
                "BAD_TYPE",
                "NO_MULTICAST",
                "CANT_TERMINATE",
                "BAD_MODE",
                "NO_SPACE",
                "TYPE_INUSE",
                "BAD_COMMAND",
                "CANT_SEND",
                "CANT_SET",
                "BAD_ADDRESS",
                "CANT_RESET"
        };

        printf ("Erro durante acesso ao driver: %s\n",msg_erro [cod_erro - 1]);
}

void driver_info (int handler)
{
  void far *Ptr_Nome;

	cpu_reg.x.ax = 0x01FF;
        cpu_reg.x.bx = (unsigned int) handler;
        int86x (packet_int,&cpu_reg,&cpu_reg,&cpu_sreg);
        if (cpu_reg.x.flags & 0x01)
        	Erro (cpu_reg.h.dh);
        else {
        	class = (int) (cpu_reg.h.ch);
                number = (int) (cpu_reg.h.cl);
                type = cpu_reg.x.dx;

        	printf ("Informacoes sobre o driver:\n");
                printf ("Classe: %d\n",class);
                printf ("Tipo: %d\n",type);
                printf ("Numero: %d\n",number);
                Ptr_Nome = MK_FP (cpu_sreg.ds,cpu_reg.x.si);
                printf ("Nome: %s, Versao %d\n",(char far *) Ptr_Nome,cpu_reg.x.bx);

        	switch (cpu_reg.h.al) {
                	case 1:
                        	printf ("Funcoes basicas presentes\n");
                                break;
                        case 2:
                        	printf ("Funcoes basicas e extendidas presentes\n");
                                break;
                        case 5:
                        	printf ("Funcoes basicas e de alta performance presentes\n");
                                break;
                        case 6:
                        	printf ("Funcoes basicas, extendidas e de alta performance presentes\n");
                                break;
                        case 255:
                        	printf ("Driver nao instalado\n");
                                break;
                }
        }
}

int access_type (int if_class, int if_type, int if_number, char far *Ptr_Type_Spec, unsigned int typelen, void far (*receiver)(void))
{
	cpu_reg.x.ax = (unsigned int) (0x0200 | if_class);
        cpu_reg.x.bx = (unsigned int) if_type;
        cpu_reg.x.dx = (unsigned int) if_number;
        cpu_reg.x.cx = typelen;
        cpu_sreg.ds = FP_SEG (Ptr_Type_Spec);
        cpu_reg.x.si = FP_OFF (Ptr_Type_Spec);
        cpu_sreg.es = FP_SEG (receiver);
        cpu_reg.x.di = FP_OFF (receiver);
        int86x (packet_int,&cpu_reg,&cpu_reg,&cpu_sreg);
        if (cpu_reg.x.flags & 0x01)
        	Erro (cpu_reg.h.dh);
        else
        	handle = (int) cpu_reg.x.ax;
	return (0);
}

int release_type (int handle_rel)
{
	cpu_reg.x.ax = (unsigned int) 0x0300;
        cpu_reg.x.bx = (unsigned int) handle_rel;
        int86x (packet_int,&cpu_reg,&cpu_reg,&cpu_sreg);
        if (cpu_reg.x.flags & 0x01)
        	Erro (cpu_reg.h.dh);
        return (0);
}

int send_pkt (char far *buffer, unsigned int length)
{
	cpu_reg.x.ax = (unsigned int) 0x0400;
        cpu_reg.x.cx = length;
        cpu_sreg.ds = FP_SEG (buffer);
        cpu_reg.x.si = FP_OFF (buffer);
        int86x (packet_int,&cpu_reg,&cpu_reg,&cpu_sreg);
        if (cpu_reg.x.flags & 0x01)
        	Erro (cpu_reg.h.dh);
        return (0);
}

void terminate (int handle_ter)
{
	cpu_reg.x.ax = (unsigned int) 0x0500;
        cpu_reg.x.bx = (unsigned int) handle_ter;
        int86x (packet_int,&cpu_reg,&cpu_reg,&cpu_sreg);
        if (cpu_reg.x.flags & 0x01)
        	Erro (cpu_reg.h.dh);
}

void get_address (int handle_add, char far *buf, int len)
{
	cpu_reg.x.ax = (unsigned int) 0x0600;
        cpu_sreg.es = FP_SEG (buf);
        cpu_reg.x.di = FP_OFF (buf);
        cpu_reg.x.bx = (unsigned int) handle_add;
        cpu_reg.x.cx = (unsigned int) len;
        int86x (packet_int,&cpu_reg,&cpu_reg,&cpu_sreg);
        if (cpu_reg.x.flags & 0x01)
        	Erro (cpu_reg.h.dh);
}

void reset_interface (int handle_res)
{
	cpu_reg.x.ax = (unsigned int) 0x0700;
        cpu_reg.x.bx = (unsigned int) handle_res;
        int86x (packet_int,&cpu_reg,&cpu_reg,&cpu_sreg);
        if (cpu_reg.x.flags & 0x01)
        	Erro (cpu_reg.h.dh);
}
/***********************************************/
unsigned int Mapear_End_Fis_Log (Tipo_Endereco ender_fisico)
{
if ((ender_fisico[1] == 0x2D) && (ender_fisico[0] == 0x82))  return(0);
else if ((ender_fisico[1] == 0x2D) && (ender_fisico[0] == 0xF4)) return(1);
else if ((ender_fisico[1] == 0x2D) && (ender_fisico[0] == 0x78)) return(2);
/* teste em casa */
else if ((ender_fisico[4] == 0x40) && (ender_fisico[5] == 0x00)) return(0);
/*
else if ((ender_fisico[4] == 0x11) && (ender_fisico[5] == 0xFA)) return(4);*/
/*Nelio*/
else if ((ender_fisico[4] == 0x84) && (ender_fisico[5] == 0xD6)) return(1);
else if ((ender_fisico[4] == 0x14) && (ender_fisico[5] == 0xD9)) return(2);
else if ((ender_fisico[4] == 0x71) && (ender_fisico[5] == 0xE7)) return(0);
else
  return(0xFF);
}
/*******************************************************/
void Inicializar_Camada_MAC (void)
{
  char far *Ptr_Type_Spec;
  void far (*Ptr_Receiver)();
  unsigned int Type_Spec = TYPESPEC;


  Ptr_Receiver = (void far *) receiver;
  packet_int = Procura_Pkt_Driver();
  driver_info(0);
  Ptr_Type_Spec = (char far *) (&Type_Spec);
  access_type(class, type, number, Ptr_Type_Spec, 2, Ptr_Receiver);
  get_address(handle,(char far *) (origem), 6);
  estacao_local = Mapear_End_Fis_Log(origem);
  if (estacao_local == 0xFF)
    {
    printf("ERRO: O endereco desta placa ethernet nao esta previsto.\n");
    Finalizar_Camada_MAC ();
    _exit(0);
    }
  printf ("Estou na estacao %i\n",estacao_local);
} /* Inicializar_Camada_MAC */
/********************************************************/
void Maquina_Estados_LLC_MAC (void)
{

  Ptr_Estrutura_Primitiva_L_M	  Ptr_Primitiva_L_M;
  Ptr_Elem_Buffer_Tx              Ptr_Pack;

  Ptr_Primitiva_L_M = Receber_Primitiva_L_M ();
  if (Ptr_Primitiva_L_M->Nome_Primitiva == MA_DATA_Request)
    {

      Ptr_Pack = Ptr_Primitiva_L_M->Ptr_Parametros_Primitiva;

      /* Endereco Destino - Global */
      Ptr_Pack->Cab_Pack [0] = 0xFF;
      Ptr_Pack->Cab_Pack [1] = 0xFF;
      Ptr_Pack->Cab_Pack [2] = 0xFF;
      Ptr_Pack->Cab_Pack [3] = 0xFF;
      Ptr_Pack->Cab_Pack [4] = 0xFF;
      Ptr_Pack->Cab_Pack [5] = 0xFF;
      /* Endereco Origem */
      Ptr_Pack->Cab_Pack [6] = origem [0];
      Ptr_Pack->Cab_Pack [7] = origem [1];
      Ptr_Pack->Cab_Pack [8] = origem [2];
      Ptr_Pack->Cab_Pack [9] = origem [3];
      Ptr_Pack->Cab_Pack [10] = origem [4];
      Ptr_Pack->Cab_Pack [11] = origem [5];

      Ptr_Pack->Cab_Pack [12] = (unsigned char) (Type_Spec);
      Ptr_Pack->Cab_Pack [13] = (unsigned char) (Type_Spec >> 8);

      Ptr_Pack->Cab_Pack [14] = (unsigned char) (Ptr_Pack->Tam_Info);
      Ptr_Pack->Cab_Pack [15] = (unsigned char) (Ptr_Pack->Tam_Info >> 8);

      send_pkt((char far *) Ptr_Pack->Cab_Pack,Ptr_Pack->Tam_Info + Tam_Cab_Pack);
      Nr_Quadros_Tx++;
      Dealocar_Quadro_Buffer_Tx ();
      num_dealocacoes_Tx++;
    }
  Dealocar_Fila_Primitivas_L_M ();
  num_dealoc_fila_LM++;

} /* Executar_Camada_MAC */
/*******************************************************/
void far interrupt receiver (rBP,rDI,rSI,rDS,rES,rDX,rCX,rBX,rAX)
unsigned int rBP,rDI,rSI,rDS,rES,rDX,rCX,rBX,rAX;
{
 Ptr_Estrutura_Primitiva_M_L Ptr_Primitiva_M_L;
 unsigned int CX;

 CX = _CX;  /* TAMANHO P/ DEBUGAR */

 if (rAX == 0)
   {
     if ((!Buffer_Rx_Cheio ()) &&
         ((Ptr_Primitiva_M_L = Alocar_Fila_Primitivas_M_L ()) != NULL))
       {
         num_aloc_fila_ML++;
         Ptr_Quadro_Rx = Alocar_Quadro_Buffer_Rx ();
         num_alocacoes_Rx++;
         Ptr_Primitiva_M_L->Nome_Primitiva = MA_DATA_Indication;
         Ptr_Primitiva_M_L->Ptr_Parametros_Primitiva = Ptr_Quadro_Rx;
         rES = FP_SEG (Ptr_Quadro_Rx->Cab_Pack);
         rDI = FP_OFF (Ptr_Quadro_Rx->Cab_Pack);
       }
     else
       {
         rES = 00;
         rDI = 00;
       }
   }
 else
   {
     _fmemcpy((void far *) &(Ptr_Quadro_Rx->Tam_Info),
              ((unsigned int far *) &(Ptr_Quadro_Rx->Cab_Pack[14])),
              sizeof (unsigned int));
     Enviar_Primitiva_M_L ();
     Nr_Quadros_Rx++;
   };
}
/*******************************************************/
void Finalizar_Camada_MAC (void)
{
  release_type(handle);
  printf("Transmitido(s) %i quadro(s) pelo packet.\n",Nr_Quadros_Tx);
  printf("Recebido(s) %i quadro(s) pelo packet.\n",Nr_Quadros_Rx);
}

#endif
