/* Arquivo             : FncMAC.C */
/* Data Inicio         : 30-07-92 */
/* Data Ultima Revisao : 30-07-92 */
/* modificado para permitir enderecamento ponto a ponto, como estava */
/* so fazia difusao. Adaptado ao sistema ponto-a-multiponto       */
/* por Marcos Tadeu von Lutzow Vidal                              */
/* Ultima revisao      : 28-10-92 */
//        24/11/93 : Numero da primeira estacao comecando em 1 em vez de 0
//        26/01/94 : Send_pkt colocado em WHILE !ERRO

#ifndef FUNCOESMAC
#define FUNCOESMAC

#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <alloc.h>
#include <dos.h>
#include <string.h>
#include <mem.h>

#include <TipGLOB.H>
#include <MemRx.H>
#include <MemTx.H>
#include <CntLM.H>
#include <TipLM.h>
#include <FncLM.H>
#include <CntMACmt.H>
#include <TipMAC.H>
#include <VarMAC.H>
#include <VarMPDL.h> // faltou_primit

void Msg_Status(char [80]);

char far *video;
//Boolean ne2000;

unsigned int Le_Arq_Addr_Fisi(void);
void Inicializar_Camada_MAC (void);
void Inicializar_Camada_MAC2 (void);
void Maquina_Estados_LLC_MAC (void);
void Finalizar_Camada_MAC (void);
void far interrupt receiver (unsigned int,unsigned int,unsigned int,unsigned int,unsigned int,unsigned int,unsigned int,unsigned int,unsigned int);
int Procura_Pkt_Driver (void);
void Erro (unsigned char);
void driver_info (int);
int access_type (int,int,int,char far *,unsigned int,void far (*)());
int release_type (int);
int send_pkt (char far *,unsigned int);
void terminate (int);
void get_address (int,char far *,int);
void reset_interface (int);

extern unsigned char id_est;
/*
extern unsigned char num_dealocacoes_Tx, num_alocacoes_Rx,
                     num_dealoc_fila_LM, num_aloc_fila_ML;
*/
extern unsigned int Porcentagem_ERR;

unsigned int Le_Arq_Addr_Fisi(void) /* retorna numero de estacoes lidas */

/* O arquivo deve ter o formato conforme o exemplo abaixo para 3 estacoes

0x82,0x2D,0x00,0x00,0x80,0x00
0xF4,0x2D,0x00,0x00,0x80,0x00
0x78,0x2D,0x00,0x00,0x80,0x00
F

  note o F na ultima linha
*/

{
   FILE *stream;
   char buf[512];
//   char nom[20];
   unsigned int i=1,j=0;

   //cprintf("Qual o nome do arquivo com os enderecos fisicos? ");
   //scanf("%s",&nom);
   // Coloquei o nome fixo para evitar de ter digitar o nome toda hora.

   if ((stream = fopen("ADDRESS.PKT", "r")) == NULL)
     {
     fprintf(stderr, "Nao consegui abrir o arquivo ADDRESS.PKT\n");
     fprintf(stderr, "Este arquivo deve conter os enderecos fisicos das placas Ethernet\n");
     fprintf(stderr, "na ordem desejada para endereco logico, segundo o exemplo abaixo:\n\n");
     fprintf(stderr, "0x82,0x2D,0x00,0x00,0x80,0x00\n0xF4,0x2D,0x00,0x00,0x80,0x00\n0x78,0x2D,0x00,0x00,0x80,0x00\nF");
     fprintf(stderr, "\nEste exemplo contem enderecos de 3 estacoes. Note o F na ultima linha.\n");
     return 0;
     }
   fseek(stream, SEEK_SET, 0);
   cprintf("\r\n");
   do
    {
    do
      {
      fgets(buf, 5 , stream);
      if (buf[0]=='F')
        j=7;
       else
        {
        if ((buf[0]!='0')||(buf[1]!='x'))
          return 0;
        if (buf[2]>0x39)
          add_placa[i][j]=(buf[2]-0x37)*16;
         else
          add_placa[i][j]=(buf[2]-0x30)*16;
        if (buf[3]>0x39)
          add_placa[i][j++]+=buf[3]-0x37;
         else
          add_placa[i][j++]+=buf[3]-0x30;
        cprintf("%4X",add_placa[i][j-1]);

        fgets(buf, 2 , stream);
        }
      }
    while (j<6);
    cprintf("\r\n");
    j=0;
    i++;
/*    fgets(buf, 5 , stream);
    cprintf("%s\r\n", buf);*/
    }
   while (buf[0]!='F');

   fclose(stream);
   return i-2;  //-1;
} /* Le_Arq_Addr_Fisi */


int Procura_Pkt_Driver (void)
  {
  int int_no;
  void interrupt (*int_vect) ();

  int_no = 0x60;
  do
    {
    int_vect = getvect (int_no);
    if (!strcmp ((char *) int_vect + 3, "PKT DRVR"))
      break;
    int_no ++;
    } while ((int_no < 0x81));
  if (int_no == 0x81)
    {
    cprintf ("Packet driver nao instalado!\r\n");
    _exit (3);
    }
  return (int_no);
  }


void Erro (unsigned char cod_erro)
  {
  static char *msg_erro[] = {
          "BAD_HANDLE",
          "NO_CLASS",
          "NO_TYPE",
          "NO_NUMBER",
          "BAD_TYPE",
          "NO_MULTICAST",
          "CANT_TERMINATE",
          "BAD_MODE",
          "NO_SPACE",
          "TYPE_INUSE",
          "BAD_COMMAND",
          "CANT_SEND",
          "CANT_SET",
          "BAD_ADDRESS",
          "CANT_RESET"
  };

  cprintf ("ERRO-Packet Driver: %s\r\n",msg_erro [cod_erro - 1]);
  }


void driver_info (int handler)
{
  char far *Ptr_Nome;

  cpu_reg.x.ax = 0x01FF;
  cpu_reg.x.bx = (unsigned int) handler;
  int86x (packet_int,&cpu_reg,&cpu_reg,&cpu_sreg);
  if (cpu_reg.x.flags & 0x01)
    Erro (cpu_reg.h.dh);
  else
    {
    class = (int) (cpu_reg.h.ch);
    number = (int) (cpu_reg.h.cl);
    type = cpu_reg.x.dx;

    cprintf ("Informacoes sobre o driver:\r\n");
    cprintf ("Classe: %d\r\n",class);
    cprintf ("Tipo: %d\r\n",type);
    cprintf ("Numero: %d\r\n",number);
    Ptr_Nome = MK_FP (cpu_sreg.ds,cpu_reg.x.si);
    cprintf ("Nome: %s, Versao %d\r\n",(char far *) Ptr_Nome,cpu_reg.x.bx);
    Ptr_Nome++;
    Ptr_Nome++;
//    ne2000=(0x32==*Ptr_Nome);

    switch (cpu_reg.h.al)
      {
      case 1:
        cprintf ("Funcoes basicas presentes\r\n");
        break;

      case 2:
        cprintf ("Funcoes basicas e extendidas presentes\r\n");
        break;

      case 5:
        cprintf ("Funcoes basicas e de alta performance presentes\r\n");
        break;

      case 6:
        cprintf ("Funcoes basicas, extendidas e de alta performance presentes\r\n");
        break;

      case 255:
        cprintf ("Driver nao instalado\r\n");
        break;
      }
  }
}


int access_type (int if_class, int if_type, int if_number, char far *Ptr_Type_Spec, unsigned int typelen, void far (*receiver)(void))
{
  cpu_reg.x.ax = (unsigned int) (0x0200 | if_class);
  cpu_reg.x.bx = (unsigned int) if_type;
  cpu_reg.x.dx = (unsigned int) if_number;
  cpu_reg.x.cx = typelen;
  cpu_sreg.ds = FP_SEG (Ptr_Type_Spec);
  cpu_reg.x.si = FP_OFF (Ptr_Type_Spec);
  cpu_sreg.es = FP_SEG (receiver);
  cpu_reg.x.di = FP_OFF (receiver);
  int86x (packet_int,&cpu_reg,&cpu_reg,&cpu_sreg);
  if (cpu_reg.x.flags & 0x01)
    Erro (cpu_reg.h.dh);
  else
    handle = (int) cpu_reg.x.ax;
  return (0);
}

int release_type (int handle_rel)
{
  cpu_reg.x.ax = (unsigned int) 0x0300;
  cpu_reg.x.bx = (unsigned int) handle_rel;
  int86x (packet_int,&cpu_reg,&cpu_reg,&cpu_sreg);
  if (cpu_reg.x.flags & 0x01)
    Erro (cpu_reg.h.dh);
  return (0);
}


int send_pkt (char far *buffer, unsigned int length)
{
  cpu_reg.x.ax = (unsigned int) 0x0400;
  cpu_reg.x.cx = length;
  cpu_sreg.ds = FP_SEG (buffer);
  cpu_reg.x.si = FP_OFF (buffer);
  int86x (packet_int,&cpu_reg,&cpu_reg,&cpu_sreg);
  if (cpu_reg.x.flags & 0x01)
    return (cpu_reg.h.dh);
  else
    return (0);
}


void terminate (int handle_ter)
{
  cpu_reg.x.ax = (unsigned int) 0x0500;
  cpu_reg.x.bx = (unsigned int) handle_ter;
  int86x (packet_int,&cpu_reg,&cpu_reg,&cpu_sreg);
  if (cpu_reg.x.flags & 0x01)
    Erro (cpu_reg.h.dh);
}


void get_address (int handle_add, char far *buf, int len)
{
  cpu_reg.x.ax = (unsigned int) 0x0600;
  cpu_sreg.es = FP_SEG (buf);
  cpu_reg.x.di = FP_OFF (buf);
  cpu_reg.x.bx = (unsigned int) handle_add;
  cpu_reg.x.cx = (unsigned int) len;
  int86x (packet_int,&cpu_reg,&cpu_reg,&cpu_sreg);
  if (cpu_reg.x.flags & 0x01)
    Erro (cpu_reg.h.dh);
}


void reset_interface (int handle_res)
{
  cpu_reg.x.ax = (unsigned int) 0x0700;
  cpu_reg.x.bx = (unsigned int) handle_res;
  int86x (packet_int,&cpu_reg,&cpu_reg,&cpu_sreg);
  if (cpu_reg.x.flags & 0x01)
    Erro (cpu_reg.h.dh);
}


unsigned int Mapear_End_Fis_Log (Tipo_Endereco ender_fisico)
{
 unsigned int i;

 i=1;  // 0 p/ 1 em 24/11/93
 while (i<=num_estacoes)
   {
   if ((ender_fisico[0] == add_placa[i][0]) &&
      (ender_fisico[1] == add_placa[i][1]) &&
      (ender_fisico[2] == add_placa[i][2]) &&
      (ender_fisico[3] == add_placa[i][3]) &&
      (ender_fisico[4] == add_placa[i][4]) &&
      (ender_fisico[5] == add_placa[i][5]))
       return i;
   i++;
   }
 return 0xFF;
}


void Inicializar_Camada_MAC (void)
{
  char far *Ptr_Type_Spec;
  void far (*Ptr_Receiver)();
  unsigned int Type_Spec = TYPESPEC,i;

  video=MK_FP(0xB800,0);
  Ptr_Receiver = (void far *) receiver;
  packet_int = Procura_Pkt_Driver();
  driver_info(0);
  Ptr_Type_Spec = (char far *) (&Type_Spec);
  access_type(class, type, number, Ptr_Type_Spec, 2, Ptr_Receiver);
  get_address(handle,(char far *) (origem), 6);
  num_estacoes=Le_Arq_Addr_Fisi();
  if (num_estacoes < 2)
    {
    cprintf("ERRO: foram lidos enderecos de %d estacoes. Minimo de 2.\r\n",num_estacoes);
    Finalizar_Camada_MAC ();
    _exit(1);
    }
  estacao_local = Mapear_End_Fis_Log(origem);
  if (estacao_local == 0xFF)
    {
    cprintf("ERRO: O endereco desta placa ethernet nao esta previsto.\r\n");
    for (i=0;i<=5;cprintf("%2X:",origem[i++]));
    cprintf("\b\r\n");
    release_type(handle);
    _exit(2);
    }
  cprintf ("Estou na estacao %i\r\n",estacao_local);
  id_est=estacao_local;
} /* Inicializar_Camada_MAC */

void Inicializar_Camada_MAC2 (void)
{
  char far *Ptr_Type_Spec;
  void far (*Ptr_Receiver)();
  unsigned int Type_Spec = TYPESPEC;


  Ptr_Receiver = (void far *) receiver;
  packet_int = Procura_Pkt_Driver();
  driver_info(0);
  Ptr_Type_Spec = (char far *) (&Type_Spec);
  access_type(class, type, number, Ptr_Type_Spec, 2, Ptr_Receiver);
  get_address(handle,(char far *) (origem), 6);
}  /* Inicializar_Camada_MAC2 */

void Maquina_Estados_LLC_MAC (void)
{

  Ptr_Estrutura_Primitiva_L_M	 Ptr_Primitiva_L_M;
  Ptr_Elem_Buffer_Tx           Ptr_Pack;
  unsigned int                 end_dest;
  int                          i,j;


  Ptr_Primitiva_L_M = Receber_Primitiva_L_M ();
  if (Ptr_Primitiva_L_M->Nome_Primitiva == MA_DATA_Request)
    {

    Ptr_Pack = Ptr_Primitiva_L_M->Ptr_Parametros_Primitiva;
    if (Ptr_Pack->End_Destino == 0xFF)
      {
      /* Endereco Destino - Global */
      Ptr_Pack->Cab_Pack [0] = 0xFF;
      Ptr_Pack->Cab_Pack [1] = 0xFF;
      Ptr_Pack->Cab_Pack [2] = 0xFF;
      Ptr_Pack->Cab_Pack [3] = 0xFF;
      Ptr_Pack->Cab_Pack [4] = 0xFF;
      Ptr_Pack->Cab_Pack [5] = 0xFF;
//        Msg_Status("MAC => ALL");
      }
    else
      {
      end_dest = Ptr_Pack->End_Destino;
      Ptr_Pack->Cab_Pack [0] = add_placa[end_dest][0];
      Ptr_Pack->Cab_Pack [1] = add_placa[end_dest][1];
      Ptr_Pack->Cab_Pack [2] = add_placa[end_dest][2];
      Ptr_Pack->Cab_Pack [3] = add_placa[end_dest][3];
      Ptr_Pack->Cab_Pack [4] = add_placa[end_dest][4];
      Ptr_Pack->Cab_Pack [5] = add_placa[end_dest][5];
//        Msg_Status("MAC => UMA");
      }
    /* Endereco Origem */
    Ptr_Pack->Cab_Pack [6] = origem [0];
    Ptr_Pack->Cab_Pack [7] = origem [1];
    Ptr_Pack->Cab_Pack [8] = origem [2];
    Ptr_Pack->Cab_Pack [9] = origem [3];
    Ptr_Pack->Cab_Pack [10] = origem [4];
    Ptr_Pack->Cab_Pack [11] = origem [5];

    Ptr_Pack->Cab_Pack [12] = (unsigned char) (Type_Spec);
    Ptr_Pack->Cab_Pack [13] = (unsigned char) (Type_Spec >> 8);

    Ptr_Pack->Cab_Pack [14] = (unsigned char) (Ptr_Pack->Tam_Info);
    Ptr_Pack->Cab_Pack [15] = (unsigned char) (Ptr_Pack->Tam_Info >> 8);

    do
     {
//     if (ne2000)
//       for (j=1;j<250;j++);
     i=send_pkt((char far *) Ptr_Pack->Cab_Pack,Ptr_Pack->Tam_Info + Tam_Cab_Pack);
     if (i)
       {
       cprintf(" ERRO PKT: %u %hu",i,Ptr_Pack->Info[2]);
       for (j=1;j<10;j++);
       }
     } while(i);
    Nr_Quadros_Tx++;
    Dealocar_Quadro_Buffer_Tx ();
/*      num_dealocacoes_Tx++;*/
    }
  Dealocar_Fila_Primitivas_L_M ();
/*  num_dealoc_fila_LM++;*/

} /* Executar_Camada_MAC */


void far interrupt receiver (rBP,rDI,rSI,rDS,rES,rDX,rCX,rBX,rAX)
unsigned int rBP,rDI,rSI,rDS,rES,rDX,rCX,rBX,rAX;
{
 Ptr_Estrutura_Primitiva_M_L Ptr_Primitiva_M_L;
/* unsigned int CX;*/

 /*CX = _CX;*/  /* TAMANHO P/ DEBUGAR */

 if (rAX == 0)
   {
   if (random (100001l) >= Porcentagem_ERR)
     {
     if ((!Buffer_Rx_Cheio ()) &&
         ((Ptr_Primitiva_M_L = Int_Alocar_Fila_Primitivas_M_L ()) != NULL))
       {
       //video[10]=0x30;
       Ptr_Quadro_Rx = Int_Alocar_Quadro_Buffer_Rx ();
       Ptr_Primitiva_M_L->Nome_Primitiva = MA_DATA_Indication;
       Ptr_Primitiva_M_L->Ptr_Parametros_Primitiva = Ptr_Quadro_Rx;
       rES = FP_SEG (Ptr_Quadro_Rx->Cab_Pack);
       rDI = FP_OFF (Ptr_Quadro_Rx->Cab_Pack);
       //video[10]=0x34;
       }
     else
       {
       //video[10]=0x31;
       faltou_primit=true;
       rES = 0;
       rDI = 0;
       }
     }
   else /* erro simulado */
     {
     errforc++;
     rES = 0;
     rDI = 0;
     }
   }
 else
   {
   //video[10]=0x32;

   _fmemcpy((void far *) &(Ptr_Quadro_Rx->Tam_Info),
            ((unsigned int far *) &(Ptr_Quadro_Rx->Cab_Pack[14])),
            sizeof (unsigned int));
   Enviar_Primitiva_M_L ();
   Nr_Quadros_Rx++;
   //video[10]=0x33;
   }
}


void Finalizar_Camada_MAC (void)
{
  release_type(handle);
  cprintf("Transmitido(s) %i quadro(s) pelo packet.\r\n",Nr_Quadros_Tx);
  cprintf("Recebido(s) %i quadro(s) pelo packet.\r\n",Nr_Quadros_Rx);
}

#endif
