/* Arquivo             : TipDLPH.H */
/* Autor               : Lanza     */
/* Modificacoes        : Fernando M. C. de Barros */
/* Data Inicio         : 22-02-90  */
/* Data Ultima Revisao : 19-10-91  */

/*************************************************************************/
/*                                                                       */
/*      Definicao dos tipos utilizados na Interface Enlace - Fisica      */
/*                                                                       */
/*************************************************************************/

#ifndef TIPOSINTERFACEDLPH
#define TIPOSINTERFACEDLPH

#include <cntdlph.h>

/* Definicao das filas de transmissao e recepcao */

typedef struct Elem_Buffer_Tx
  {
    struct Elem_Buffer_Tx              *Ptr_Proximo;
    unsigned int                       Tam_Info;
    unsigned int                       End_Destino;
    unsigned char                      *Info;
  } Elem_Buffer_Tx;

typedef struct Elem_Buffer_Tx          *Ptr_Elem_Buffer_Tx;

typedef struct Elem_Buffer_Rx
  {
    struct Elem_Buffer_Rx              *Ptr_Proximo;
    unsigned int                       Tam_Info;
    unsigned int                       End_Origem;
    unsigned int                       End_Destino;
    unsigned char                      *Info;
  } Elem_Buffer_Rx;

typedef struct Elem_Buffer_Rx          *Ptr_Elem_Buffer_Rx;

/* Primitivas de Servico da Camada Fisica */
typedef enum
  {
    PH_ACTIVATE_Request,
    PH_DEACTIVATE_Request,
    PH_DATA_Request
  }
Primitivas_DL_PH;

typedef enum
  {
    PH_ACTIVATE_Indication,
    PH_DEACTIVATE_Indication,
    PH_DATA_Indication
  }
Primitivas_PH_DL;


/* Definicao das filas para trocas de primitivas */

typedef struct Estrutura_Primitiva_DL_PH
  {
    struct Estrutura_Primitiva_DL_PH        *Ptr_Proximo;
    Primitivas_DL_PH                        Nome_Primitiva;
    Ptr_Elem_Buffer_Tx                      Ptr_Parametros_Primitiva;
  } Estrutura_Primitiva_DL_PH;

typedef struct Estrutura_Primitiva_DL_PH    *Ptr_Estrutura_Primitiva_DL_PH;

typedef struct Estrutura_Primitiva_PH_DL
  {
    struct Estrutura_Primitiva_PH_DL        *Ptr_Proximo;
    Primitivas_PH_DL                        Nome_Primitiva;
    Ptr_Elem_Buffer_Rx                      Ptr_Parametros_Primitiva;
  } Estrutura_Primitiva_PH_DL;

typedef struct Estrutura_Primitiva_PH_DL    *Ptr_Estrutura_Primitiva_PH_DL;

typedef enum
  {
    Conexao_PH_Desativada,
    Conexao_PH_Tx_Ativada,
    Conexao_PH_Rx_Ativada,
    Conexao_PH_Tx_Rx_Ativada
          }
Tipo_Conexao_PH;

#endif