/* Arquivo             : FncNDLRx.C */
/* Autor               : Lanza      */
/* Modificacoes        : Fernando M. C. de Barros */
/* Data Inicio         : 05-12-89   */
/* Versao para A REDE               */
/* vERSAO REDE: Marcos Tadeu        */
/* Ult. mod. 12-12-92

/*************************************************************************/
/*                                                                       */
/* Definicao das funcoes para a Interface entre as Camadas Rede e Enlace */
/*                                                                       */
/*************************************************************************/

#ifndef FUNCOESINTERFACENDLRX_C
#define FUNCOESINTERFACENDLRX_C

#include <alloc.h>

#include <CntGlob.H>
#include <TipGlob.H>
#include <MemTx.H>
#include <MemRx.H>
#include <FncEsc.H>
#include <CntNDL.H>
#include <TipNDLRx.H>
#include <VarNDLRx.H>

/*include <cntdl_tx.h>   Definicao da constante Num_Receptores */

/*************************************************************************/
/*                                                                       */
/* Cabecalho dos pontos de entrada nas Camadas Rede e Enlace             */
/*                                                                       */
/*************************************************************************/

void  Tratar_Pedido_Servico_DLN_Rx (void); /*(unsigned char); */

void  Tratar_Pedido_Servico_NDL_Rx (void); /*(unsigned char); */

/*************************************************************************/
/*                                                                       */
/* Cabecalho das funcoes para a Interface entre as Camadas Rede e Enlace */
/*                                                                       */
/*************************************************************************/

void Inicializar_Interface_N_DL_Rx (void);

void Finalizar_Interface_N_DL_Rx (void);

Boolean Fila_Primitivas_N_DL_Rx_Cheia (void); /*(unsigned char); */

Boolean Fila_Primitivas_DL_N_Rx_Cheia (void); /*(unsigned char); */

Boolean Fila_Primitivas_N_DL_Rx_Nao_Vazia (void); /*(unsigned char); */

Boolean Fila_Primitivas_DL_N_Rx_Nao_Vazia (void); /*(unsigned char); */

void Enviar_Primitiva_N_DL_Rx (Ptr_Estrutura_Primitiva_N_DL_Rx); /*, unsigned char);*/

void Enviar_Primitiva_DL_N_Rx (Ptr_Estrutura_Primitiva_DL_N_Rx); /*, unsigned char);*/

Ptr_Estrutura_Primitiva_N_DL_Rx Receber_Primitiva_N_DL_Rx (void); /*(unsigned char); */

Ptr_Estrutura_Primitiva_DL_N_Rx Receber_Primitiva_DL_N_Rx (void); /*(unsigned char); */

void Retirar_Primitiva_Fila_N_DL_Rx (void); /*(unsigned char); */

void Retirar_Primitiva_Fila_DL_N_Rx (void); /*(unsigned char); */


/*************************************************************************/
/*                                                                       */
/*     Inicializa as variaveis de controle da interface Rede - Enlace    */
/*                                                                       */
/*************************************************************************/

void Inicializar_Interface_N_DL_Rx (void)

  {
/*    unsigned char   i;

    for (i = 0; i <= Num_Receptores; i++)
      {*/
       Ptr_Prim_Fila_Primitivas_N_DL_Rx = NULL;
       Ptr_Prim_Fila_Primitivas_DL_N_Rx = NULL;
       Nr_Elem_Fila_Primitivas_N_DL_Rx = 0;
       Nr_Elem_Fila_Primitivas_DL_N_Rx = 0;
/*      }  for */

  } /* Inicializar_Interface_N_DL_Rx */


/*************************************************************************/
/*                                                                       */
/*    Libera a area ocupada pelas filas de primitivas Rede-Gestao        */
/*                                                                       */
/*************************************************************************/

void Finalizar_Interface_N_DL_Rx (void)

  {
  /*  unsigned char                          i;*/
    Ptr_Estrutura_Primitiva_N_DL_Rx        Ptr_Primitiva_N_DL_Rx;
    Ptr_Estrutura_Primitiva_DL_N_Rx        Ptr_Primitiva_DL_N_Rx;

/*    for (i = 0; i <= Num_Receptores; i++)
      {*/
       while (Ptr_Prim_Fila_Primitivas_N_DL_Rx )
         {
          Ptr_Primitiva_N_DL_Rx = Ptr_Prim_Fila_Primitivas_N_DL_Rx ;
          Ptr_Prim_Fila_Primitivas_N_DL_Rx  = Ptr_Prim_Fila_Primitivas_N_DL_Rx ->Ptr_Proximo;
          Liberar_Estrutura_Parametros_Tx (Ptr_Primitiva_N_DL_Rx->Ptr_Parametros_Primitiva);
          Liberar_Estrutura_Primitiva_Tx ((unsigned char *) (Ptr_Primitiva_N_DL_Rx));
         } /* while */

       while (Ptr_Prim_Fila_Primitivas_DL_N_Rx )
         {
          Ptr_Primitiva_DL_N_Rx = Ptr_Prim_Fila_Primitivas_DL_N_Rx ;
          Ptr_Prim_Fila_Primitivas_DL_N_Rx  = Ptr_Prim_Fila_Primitivas_DL_N_Rx ->Ptr_Proximo;
          Liberar_Estrutura_Parametros_Rx (Ptr_Primitiva_DL_N_Rx->Ptr_Parametros_Primitiva);
          Liberar_Estrutura_Primitiva_Rx ((unsigned char *) (Ptr_Primitiva_DL_N_Rx));
         } /* while */
/*      } for */


  } /* Finalizar_Interface_N_DL_Rx */


/*************************************************************************/
/*                                                                       */
/*      Devolve verdadeiro se a fila Rede-Enlace esta cheia              */
/*                                                                       */
/*************************************************************************/

Boolean Fila_Primitivas_N_DL_Rx_Cheia (void)

  {

    if (Nr_Elem_Fila_Primitivas_N_DL_Rx /*[Id_Receptor]*/== Nr_Max_Elem_Fila_Primitivas_N_DL_Rx)
      return (True);
    else
      return (False);

  } /* Fila_Primitivas_N_DL_Rx_Cheia */


/*************************************************************************/
/*                                                                       */
/*      Devolve veradadeiro se a fila Enlace-Rede esta cheia             */
/*                                                                       */
/*************************************************************************/

Boolean Fila_Primitivas_DL_N_Rx_Cheia (void)

  {

    if (Nr_Elem_Fila_Primitivas_DL_N_Rx /*[Id_Receptor]*/== Nr_Max_Elem_Fila_Primitivas_DL_N_Rx)
      return (True);
    else
      return (False);

  } /* Fila_Primitivas_DL_N_Rx_Cheia */


/************************************************************************/
/*                                                                      */
/*      Devolve verdadeiro se a fila Rede-Enlace esta nao vazia         */
/*                                                                      */
/************************************************************************/

Boolean Fila_Primitivas_N_DL_Rx_Nao_Vazia (void)

  {

    if (Ptr_Prim_Fila_Primitivas_N_DL_Rx /*[Id_Receptor]*/)
      return (True);
    else
      return (False);

  } /* Fila_Primitivas_N_DL_Rx_Nao_Vazia */


/*************************************************************************/
/*                                                                       */
/*      Devolve veradadeiro se a fila Enlace-Rede esta nao vazia         */
/*                                                                       */
/*************************************************************************/

Boolean Fila_Primitivas_DL_N_Rx_Nao_Vazia (void)

  {

    if (Ptr_Prim_Fila_Primitivas_DL_N_Rx /*[Id_Receptor]*/)
      return (True);
    else
      return (False);

  } /* Fila_Primitivas_DL_N_Rx_Nao_Vazia */


/*************************************************************************/
/*                                                                       */
/*             Envia Primitiva da Camada Rede para a Enlace              */
/*                                                                       */
/*************************************************************************/

void Enviar_Primitiva_N_DL_Rx (Ptr_Estrutura_Primitiva_N_DL_Rx   Ptr_Primitiva)
   /*                            unsigned char                     Id_Receptor)*/

  {

    if (!Ptr_Prim_Fila_Primitivas_N_DL_Rx /*[Id_Receptor]*/)
      Ptr_Prim_Fila_Primitivas_N_DL_Rx /*[Id_Receptor]*/= Ptr_Primitiva;
    else
      Ptr_Ult_Fila_Primitivas_N_DL_Rx /*[Id_Receptor]*/->Ptr_Proximo = Ptr_Primitiva;
    Ptr_Ult_Fila_Primitivas_N_DL_Rx /*[Id_Receptor]*/ = Ptr_Primitiva;
    Ptr_Ult_Fila_Primitivas_N_DL_Rx /*[Id_Receptor]*/ ->Ptr_Proximo = NULL;
    Nr_Elem_Fila_Primitivas_N_DL_Rx /*[Id_Receptor]*/++;
    Enviar_Rotina_Fila_Gerente_RMOSI (Tratar_Pedido_Servico_NDL_Rx,0); /*,Id_Receptor);*/

  }  /* Enviar_Primitiva_N_DL_Rx */


/*************************************************************************/
/*                                                                       */
/*             Envia Primitiva da Camada Enlace para a Rede              */
/*                                                                       */
/*************************************************************************/

void Enviar_Primitiva_DL_N_Rx (Ptr_Estrutura_Primitiva_DL_N_Rx   Ptr_Primitiva)
/*                               unsigned char                     Id_Receptor)  */

  {

    if (!Ptr_Prim_Fila_Primitivas_DL_N_Rx /*[Id_Receptor]*/)
      Ptr_Prim_Fila_Primitivas_DL_N_Rx /*[Id_Receptor]*/ = Ptr_Primitiva;
    else
      Ptr_Ult_Fila_Primitivas_DL_N_Rx /*[Id_Receptor]*/->Ptr_Proximo = Ptr_Primitiva;
    Ptr_Ult_Fila_Primitivas_DL_N_Rx /*[Id_Receptor]*/ = Ptr_Primitiva;
    Ptr_Ult_Fila_Primitivas_DL_N_Rx /*[Id_Receptor]*/->Ptr_Proximo = NULL;
    Nr_Elem_Fila_Primitivas_DL_N_Rx /*[Id_Receptor]*/++;
    Enviar_Rotina_Fila_Gerente_RMOSI (Tratar_Pedido_Servico_DLN_Rx,0); /*,Id_Receptor);*/

  } /* Enviar_Primitiva_DL_N_Rx */


/*************************************************************************/
/*                                                                       */
/*               Recebe a Primitiva enviada pela Camada Rede             */
/*                                                                       */
/*************************************************************************/

Ptr_Estrutura_Primitiva_N_DL_Rx Receber_Primitiva_N_DL_Rx (void)

  {

    return (Ptr_Prim_Fila_Primitivas_N_DL_Rx /*[Id_Receptor]*/);

  } /* Receber_Primitiva_N_DL_Rx */


/*************************************************************************/
/*                                                                       */
/*               Recebe a Primitiva enviada pela Camada Enlace           */
/*                                                                       */
/*************************************************************************/

Ptr_Estrutura_Primitiva_DL_N_Rx Receber_Primitiva_DL_N_Rx (void)

  {

    return (Ptr_Prim_Fila_Primitivas_DL_N_Rx /*[Id_Receptor]*/);

  } /* Receber_Primitiva_DL_N_Rx */


/*************************************************************************/
/*                                                                       */
/*    Libera a area ocupada pela primitiva enviada pela Camada Rede      */
/*                                                                       */
/*************************************************************************/

void Retirar_Primitiva_Fila_N_DL_Rx (void)

  {

    Ptr_Estrutura_Primitiva_N_DL_Rx        Ptr_Primitiva_N_DL_Rx;

    if (Ptr_Prim_Fila_Primitivas_N_DL_Rx /*[Id_Receptor]*/)
      {
        Ptr_Primitiva_N_DL_Rx = Ptr_Prim_Fila_Primitivas_N_DL_Rx /*[Id_Receptor]*/;
        Ptr_Prim_Fila_Primitivas_N_DL_Rx /*[Id_Receptor]*/ = Ptr_Prim_Fila_Primitivas_N_DL_Rx /*[Id_Receptor]*/->Ptr_Proximo;
        Liberar_Estrutura_Primitiva_Tx ((unsigned char *) (Ptr_Primitiva_N_DL_Rx));
        Nr_Elem_Fila_Primitivas_N_DL_Rx /*[Id_Receptor]*/--;
      }


  } /* Retirar_Primitiva_Fila_N_DL_Rx */


/*************************************************************************/
/*                                                                       */
/*    Libera a area ocupada pela primitiva enviada pela Camada Enlace    */
/*                                                                       */
/*************************************************************************/

void Retirar_Primitiva_Fila_DL_N_Rx (void)

  {

    Ptr_Estrutura_Primitiva_DL_N_Rx        Ptr_Primitiva_DL_N_Rx;

    if (Ptr_Prim_Fila_Primitivas_DL_N_Rx /*[Id_Receptor]*/)
      {
        Ptr_Primitiva_DL_N_Rx = Ptr_Prim_Fila_Primitivas_DL_N_Rx /*[Id_Receptor]*/;
        Ptr_Prim_Fila_Primitivas_DL_N_Rx /*[Id_Receptor]*/ = Ptr_Prim_Fila_Primitivas_DL_N_Rx /*[Id_Receptor]*/->Ptr_Proximo;
        Liberar_Estrutura_Primitiva_Rx ((unsigned char *) (Ptr_Primitiva_DL_N_Rx));
        Nr_Elem_Fila_Primitivas_DL_N_Rx /*[Id_Receptor]*/--;
      }


  } /* Retirar_Primitiva_Fila_DL_N_Rx */


#endif
