/* Arquivo             : FncNDLTx.C               */
/* Autor               : Lanza                    */
/* Modificacoes        : Fernando M. C. de Barros */
/* Data Inicio         : 05-12-89                 */
/* Versao incluindo Escalonador                   */

/*************************************************************************/
/*                                                                       */
/* Definicao das funcoes para a Interface entre as Camadas Rede e Enlace */
/*                                                                       */
/*************************************************************************/

#ifndef FUNCOESINTERFACENDLTX_C
#define FUNCOESINTERFACENDLTX_C


#include <CntGlob.H>
#include <TipGlob.H>
#include <MemTx.H>
#include <MemRx.H>
#include <FncEsc.H>
#include <CntNDL.H>
#include <TipNDLTx.H>
#include <VarNDLTx.H>

/*************************************************************************/
/*                                                                       */
/* Cabecalho dos pontos de entrada nas Camadas Rede e Enlace             */
/*                                                                       */
/*************************************************************************/

void  Tratar_Pedido_Servico_NDL_Tx (void);

void  Tratar_Pedido_Servico_DLN_Tx (void);

/*************************************************************************/
/*                                                                       */
/* Cabecalho das funcoes para a Interface entre as Camadas Rede e Enlace */
/*                                                                       */
/*************************************************************************/

void Inicializar_Interface_N_DL_Tx (void);

void Finalizar_Interface_N_DL_Tx (void);

Boolean Fila_Primitivas_N_DL_Tx_Cheia (void);

Boolean Fila_Primitivas_DL_N_Tx_Cheia (void);

Boolean Fila_Primitivas_N_DL_Tx_Nao_Vazia (void);

Boolean Fila_Primitivas_DL_N_Tx_Nao_Vazia (void);

void Enviar_Primitiva_N_DL_Tx (Ptr_Estrutura_Primitiva_N_DL_Tx);

void Enviar_Primitiva_DL_N_Tx (Ptr_Estrutura_Primitiva_DL_N_Tx);

Ptr_Estrutura_Primitiva_N_DL_Tx Receber_Primitiva_N_DL_Tx (void);

Ptr_Estrutura_Primitiva_DL_N_Tx Receber_Primitiva_DL_N_Tx (void);

void Retirar_Primitiva_Fila_N_DL_Tx (void);

void Retirar_Primitiva_Fila_DL_N_Tx (void);


/*************************************************************************/
/*                                                                       */
/*     Inicializa as variaveis de controle da interface Rede - Enlace    */
/*                                                                       */
/*************************************************************************/

void Inicializar_Interface_N_DL_Tx (void)

  {

    Ptr_Prim_Fila_Primitivas_N_DL_Tx  = NULL;
    Ptr_Prim_Fila_Primitivas_DL_N_Tx = NULL;
    Nr_Elem_Fila_Primitivas_N_DL_Tx = 0;
    Nr_Elem_Fila_Primitivas_DL_N_Tx = 0;

  } /* Inicializar_Interface_N_DL_Tx */


/*************************************************************************/
/*                                                                       */
/*    Libera a area ocupada pelas filas de primitivas Rede-Gestao        */
/*                                                                       */
/*************************************************************************/

void Finalizar_Interface_N_DL_Tx (void)

  {
    Ptr_Estrutura_Primitiva_N_DL_Tx        Ptr_Primitiva_N_DL_Tx;
    Ptr_Estrutura_Primitiva_DL_N_Tx        Ptr_Primitiva_DL_N_Tx;

    while (Ptr_Prim_Fila_Primitivas_N_DL_Tx)
      {
       Ptr_Primitiva_N_DL_Tx = Ptr_Prim_Fila_Primitivas_N_DL_Tx;
       Ptr_Prim_Fila_Primitivas_N_DL_Tx = Ptr_Prim_Fila_Primitivas_N_DL_Tx->Ptr_Proximo;
       Liberar_Estrutura_Parametros_Tx (Ptr_Primitiva_N_DL_Tx->Ptr_Parametros_Primitiva);
       Liberar_Estrutura_Primitiva_Tx ((unsigned char *) (Ptr_Primitiva_N_DL_Tx));
      } /* while */

    while (Ptr_Prim_Fila_Primitivas_DL_N_Tx)
      {
       Ptr_Primitiva_DL_N_Tx = Ptr_Prim_Fila_Primitivas_DL_N_Tx;
       Ptr_Prim_Fila_Primitivas_DL_N_Tx = Ptr_Prim_Fila_Primitivas_DL_N_Tx->Ptr_Proximo;
       Liberar_Estrutura_Parametros_Rx (Ptr_Primitiva_DL_N_Tx->Ptr_Parametros_Primitiva);
       Liberar_Estrutura_Primitiva_Rx ((unsigned char *) (Ptr_Primitiva_DL_N_Tx));
      } /* while */


  } /* Finalizar_Interface_N_DL_Tx */


/*************************************************************************/
/*                                                                       */
/*      Devolve veradadeiro se a fila Rede-Enlace esta cheia             */
/*                                                                       */
/*************************************************************************/

Boolean Fila_Primitivas_N_DL_Tx_Cheia (void)

  {

    if (Nr_Elem_Fila_Primitivas_N_DL_Tx == Nr_Max_Elem_Fila_Primitivas_N_DL_Tx)
      return (True);
    else
      return (False);

  } /* Fila_Primitivas_N_DL_Tx_Cheia */


/*************************************************************************/
/*                                                                       */
/*      Devolve veradadeiro se a fila Enlace-Rede esta cheia             */
/*                                                                       */
/*************************************************************************/

Boolean Fila_Primitivas_DL_N_Tx_Cheia (void)

  {

    if (Nr_Elem_Fila_Primitivas_DL_N_Tx == Nr_Max_Elem_Fila_Primitivas_DL_N_Tx)
      return (True);
    else
      return (False);

  } /* Fila_Primitivas_DL_N_Tx_Cheia */


/*************************************************************************/
/*                                                                       */
/*      Devolve veradadeiro se a fila Rede-Enlace esta nao vazia         */
/*                                                                       */
/*************************************************************************/

Boolean Fila_Primitivas_N_DL_Tx_Nao_Vazia (void)

  {

    if (Ptr_Prim_Fila_Primitivas_N_DL_Tx)
      return (True);
    else
      return (False);

  } /* Fila_Primitivas_N_DL_Tx_Nao_Vazia */


/*************************************************************************/
/*                                                                       */
/*      Devolve veradadeiro se a fila Enlace-Rede esta nao vazia         */
/*                                                                       */
/*************************************************************************/

Boolean Fila_Primitivas_DL_N_Tx_Nao_Vazia (void)

  {

    if (Ptr_Prim_Fila_Primitivas_DL_N_Tx)
      return (True);
    else
      return (False);

  } /* Fila_Primitivas_DL_N_Tx_Nao_Vazia */


/*************************************************************************/
/*                                                                       */
/*             Envia Primitiva da Camada Rede para a Enlace              */
/*                                                                       */
/*************************************************************************/

void Enviar_Primitiva_N_DL_Tx (Ptr_Estrutura_Primitiva_N_DL_Tx Ptr_Primitiva)

  {

    if (!Ptr_Prim_Fila_Primitivas_N_DL_Tx)
      Ptr_Prim_Fila_Primitivas_N_DL_Tx = Ptr_Primitiva;
    else
      Ptr_Ult_Fila_Primitivas_N_DL_Tx->Ptr_Proximo = Ptr_Primitiva;
    Ptr_Ult_Fila_Primitivas_N_DL_Tx = Ptr_Primitiva;
    Ptr_Ult_Fila_Primitivas_N_DL_Tx ->Ptr_Proximo = NULL;
    Nr_Elem_Fila_Primitivas_N_DL_Tx++;
    Enviar_Rotina_Fila_Gerente_RMOSI (Tratar_Pedido_Servico_NDL_Tx,0);

  }  /* Enviar_Primitiva_N_DL_Tx */


/*************************************************************************/
/*                                                                       */
/*             Envia Primitiva da Camada Enlace para a Rede              */
/*                                                                       */
/*************************************************************************/

void Enviar_Primitiva_DL_N_Tx (Ptr_Estrutura_Primitiva_DL_N_Tx Ptr_Primitiva)

  {

    if (!Ptr_Prim_Fila_Primitivas_DL_N_Tx)
      Ptr_Prim_Fila_Primitivas_DL_N_Tx = Ptr_Primitiva;
    else
      Ptr_Ult_Fila_Primitivas_DL_N_Tx->Ptr_Proximo = Ptr_Primitiva;
    Ptr_Ult_Fila_Primitivas_DL_N_Tx = Ptr_Primitiva;
    Ptr_Ult_Fila_Primitivas_DL_N_Tx->Ptr_Proximo = NULL;
    Nr_Elem_Fila_Primitivas_DL_N_Tx++;
    Enviar_Rotina_Fila_Gerente_RMOSI (Tratar_Pedido_Servico_DLN_Tx,0);

  } /* Enviar_Primitiva_DL_N_Tx */


/*************************************************************************/
/*                                                                       */
/*               Recebe a Primitiva enviada pela Camada Rede             */
/*                                                                       */
/*************************************************************************/

Ptr_Estrutura_Primitiva_N_DL_Tx Receber_Primitiva_N_DL_Tx (void)

  {

    return (Ptr_Prim_Fila_Primitivas_N_DL_Tx);

  } /* Receber_Primitiva_N_DL_Tx */


/*************************************************************************/
/*                                                                       */
/*               Recebe a Primitiva enviada pela Camada Enlace           */
/*                                                                       */
/*************************************************************************/

Ptr_Estrutura_Primitiva_DL_N_Tx Receber_Primitiva_DL_N_Tx (void)

  {

    return (Ptr_Prim_Fila_Primitivas_DL_N_Tx);

  } /* Receber_Primitiva_DL_N_Tx */


/*************************************************************************/
/*                                                                       */
/*    Libera a area ocupada pela primitiva enviada pela Camada Rede      */
/*                                                                       */
/*************************************************************************/

void Retirar_Primitiva_Fila_N_DL_Tx (void)

  {

    Ptr_Estrutura_Primitiva_N_DL_Tx        Ptr_Primitiva_N_DL_Tx;

    if (Ptr_Prim_Fila_Primitivas_N_DL_Tx)
      {
        Ptr_Primitiva_N_DL_Tx = Ptr_Prim_Fila_Primitivas_N_DL_Tx;
        Ptr_Prim_Fila_Primitivas_N_DL_Tx = Ptr_Prim_Fila_Primitivas_N_DL_Tx->Ptr_Proximo;
        Liberar_Estrutura_Primitiva_Tx ((unsigned char *) (Ptr_Primitiva_N_DL_Tx));
        Nr_Elem_Fila_Primitivas_N_DL_Tx--;
      }


  } /* Retirar_Primitiva_Fila_N_DL_Tx */


/*************************************************************************/
/*                                                                       */
/*    Libera a area ocupada pela primitiva enviada pela Camada Enlace    */
/*                                                                       */
/*************************************************************************/

void Retirar_Primitiva_Fila_DL_N_Tx (void)

  {

    Ptr_Estrutura_Primitiva_DL_N_Tx        Ptr_Primitiva_DL_N_Tx;

    if (Ptr_Prim_Fila_Primitivas_DL_N_Tx)
      {
        Ptr_Primitiva_DL_N_Tx = Ptr_Prim_Fila_Primitivas_DL_N_Tx;
        Ptr_Prim_Fila_Primitivas_DL_N_Tx = Ptr_Prim_Fila_Primitivas_DL_N_Tx->Ptr_Proximo;
        Liberar_Estrutura_Primitiva_Rx ((unsigned char *) (Ptr_Primitiva_DL_N_Tx));
        Nr_Elem_Fila_Primitivas_DL_N_Tx--;
      }


  } /* Retirar_Primitiva_Fila_DL_N_Tx */


#endif
