/* Arquivo             : FncNMPDL.C                    */
/* Autor               : Lanza                         */
/* Modificacoes        : Marcos Tadeu von Lutzow Vidal */
/* Data Inicio         : 05-12-89                      */
/* Versao incluindo Escalonador                        */
/* Inicio modif.23/10/93                               */
/* Ult. Modif. :27/10/93                               */

/*************************************************************************/
/*                                                                       */
/* Definicao das funcoes para a Interface entre as Camadas Rede e Enlace */
/*                                                                       */
/*************************************************************************/

#ifndef FUNCOESINTERFACENMPDL_C
#define FUNCOESINTERFACENMPDL_C

#include <conio.h>

#include <CntGlob.H>
#include <TipGlob.H>
#include <MemTx.H>
#include <MemRx.H>
#include <FncEsc.H>
#include <CntNMPDL.H>
#include <TipNMPDL.H>
#include <VarNMPDL.H>

/*************************************************************************/
/*                                                                       */
/* Cabecalho dos pontos de entrada nas Camadas Rede e Enlace             */
/*                                                                       */
/*************************************************************************/

void  Tratar_Pedido_Servico_NMPDL (void);

void  Tratar_Pedido_Servico_MPDLN (void);

/*************************************************************************/
/*                                                                       */
/* Cabecalho das funcoes para a Interface entre as Camadas Rede e Enlace */
/*                                                                       */
/*************************************************************************/

void Inicializar_Interface_N_MPDL (void);

void Finalizar_Interface_N_MPDL (void);

Boolean Fila_Primitivas_N_MPDL_Cheia (void);

Boolean Fila_Primitivas_MPDL_N_Cheia (void);

Boolean Fila_Primitivas_N_MPDL_Nao_Vazia (void);

Boolean Fila_Primitivas_MPDL_N_Nao_Vazia (void);

void Enviar_Primitiva_N_MPDL (Ptr_Estrutura_Primitiva_N_MPDL);

void Enviar_Primitiva_MPDL_N (Ptr_Estrutura_Primitiva_MPDL_N);

Ptr_Estrutura_Primitiva_N_MPDL Receber_Primitiva_N_MPDL (void);

Ptr_Estrutura_Primitiva_MPDL_N Receber_Primitiva_MPDL_N (void);

void Retirar_Primitiva_Fila_N_MPDL (void);

void Retirar_Primitiva_Fila_MPDL_N (void);


/*************************************************************************/
/*                                                                       */
/*     Inicializa as variaveis de controle da interface Rede - Enlace    */
/*                                                                       */
/*************************************************************************/

void Inicializar_Interface_N_MPDL (void)

  {

    Ptr_Prim_Fila_Primitivas_N_MPDL  = NULL;
    Ptr_Prim_Fila_Primitivas_MPDL_N = NULL;
    Nr_Elem_Fila_Primitivas_N_MPDL = 0;
    Nr_Elem_Fila_Primitivas_MPDL_N = 0;

  } /* Inicializar_Interface_N_MPDL */


/*************************************************************************/
/*                                                                       */
/*    Libera a area ocupada pelas filas de primitivas Rede-Gestao        */
/*                                                                       */
/*************************************************************************/

void Finalizar_Interface_N_MPDL (void)

  {
    Ptr_Estrutura_Primitiva_N_MPDL        Ptr_Primitiva_N_MPDL;
    Ptr_Estrutura_Primitiva_MPDL_N        Ptr_Primitiva_MPDL_N;

    while (Ptr_Prim_Fila_Primitivas_N_MPDL)
      {
       Ptr_Primitiva_N_MPDL = Ptr_Prim_Fila_Primitivas_N_MPDL;
       Ptr_Prim_Fila_Primitivas_N_MPDL = Ptr_Prim_Fila_Primitivas_N_MPDL->Ptr_Proximo;
       Liberar_Estrutura_Parametros_Tx (Ptr_Primitiva_N_MPDL->Ptr_Parametros_Primitiva);
       Liberar_Estrutura_Primitiva_Tx ((unsigned char *) (Ptr_Primitiva_N_MPDL));
      } /* while */

    while (Ptr_Prim_Fila_Primitivas_MPDL_N)
      {
       Ptr_Primitiva_MPDL_N = Ptr_Prim_Fila_Primitivas_MPDL_N;
       Ptr_Prim_Fila_Primitivas_MPDL_N = Ptr_Prim_Fila_Primitivas_MPDL_N->Ptr_Proximo;
       Liberar_Estrutura_Parametros_Rx (Ptr_Primitiva_MPDL_N->Ptr_Parametros_Primitiva);
       Liberar_Estrutura_Primitiva_Rx ((unsigned char *) (Ptr_Primitiva_MPDL_N));
      } /* while */


  } /* Finalizar_Interface_N_MPDL */


/*************************************************************************/
/*                                                                       */
/*      Devolve veradadeiro se a fila Rede-Enlace esta cheia             */
/*                                                                       */
/*************************************************************************/

Boolean Fila_Primitivas_N_MPDL_Cheia (void)

  {

    if (Nr_Elem_Fila_Primitivas_N_MPDL == Nr_Max_Elem_Fila_Primitivas_N_MPDL)
      return (True);
    else
      return (False);

  } /* Fila_Primitivas_N_MPDL_Cheia */


/*************************************************************************/
/*                                                                       */
/*      Devolve veradadeiro se a fila Enlace-Rede esta cheia             */
/*                                                                       */
/*************************************************************************/

Boolean Fila_Primitivas_MPDL_N_Cheia (void)

  {

    if (Nr_Elem_Fila_Primitivas_MPDL_N == Nr_Max_Elem_Fila_Primitivas_MPDL_N)
      return (True);
    else
      return (False);

  } /* Fila_Primitivas_MPDL_N_Cheia */


/*************************************************************************/
/*                                                                       */
/*      Devolve veradadeiro se a fila Rede-Enlace esta nao vazia         */
/*                                                                       */
/*************************************************************************/

Boolean Fila_Primitivas_N_MPDL_Nao_Vazia (void)

  {

    if (Ptr_Prim_Fila_Primitivas_N_MPDL)
      return (True);
    else
      return (False);

  } /* Fila_Primitivas_N_MPDL_Nao_Vazia */


/*************************************************************************/
/*                                                                       */
/*      Devolve veradadeiro se a fila Enlace-Rede esta nao vazia         */
/*                                                                       */
/*************************************************************************/

Boolean Fila_Primitivas_MPDL_N_Nao_Vazia (void)

  {

    if (Ptr_Prim_Fila_Primitivas_MPDL_N)
      return (True);
    else
      return (False);

  } /* Fila_Primitivas_MPDL_N_Nao_Vazia */


/*************************************************************************/
/*                                                                       */
/*             Envia Primitiva da Camada Rede para a Enlace              */
/*                                                                       */
/*************************************************************************/

void Enviar_Primitiva_N_MPDL (Ptr_Estrutura_Primitiva_N_MPDL Ptr_Primitiva)

  {

    if (!Ptr_Prim_Fila_Primitivas_N_MPDL)
      Ptr_Prim_Fila_Primitivas_N_MPDL = Ptr_Primitiva;
    else
      Ptr_Ult_Fila_Primitivas_N_MPDL->Ptr_Proximo = Ptr_Primitiva;
    Ptr_Ult_Fila_Primitivas_N_MPDL = Ptr_Primitiva;
    Ptr_Ult_Fila_Primitivas_N_MPDL ->Ptr_Proximo = NULL;
    Nr_Elem_Fila_Primitivas_N_MPDL++;
    Enviar_Rotina_Fila_Gerente_RMOSI (Tratar_Pedido_Servico_NMPDL,0);

  }  /* Enviar_Primitiva_N_MPDL */


/*************************************************************************/
/*                                                                       */
/*             Envia Primitiva da Camada Enlace para a Rede              */
/*                                                                       */
/*************************************************************************/

void Enviar_Primitiva_MPDL_N (Ptr_Estrutura_Primitiva_MPDL_N Ptr_Primitiva)

  {

    if (!Ptr_Prim_Fila_Primitivas_MPDL_N)
      Ptr_Prim_Fila_Primitivas_MPDL_N = Ptr_Primitiva;
    else
      Ptr_Ult_Fila_Primitivas_MPDL_N->Ptr_Proximo = Ptr_Primitiva;
    Ptr_Ult_Fila_Primitivas_MPDL_N = Ptr_Primitiva;
    Ptr_Ult_Fila_Primitivas_MPDL_N->Ptr_Proximo = NULL;
    Nr_Elem_Fila_Primitivas_MPDL_N++;
    Enviar_Rotina_Fila_Gerente_RMOSI (Tratar_Pedido_Servico_MPDLN,0);

  } /* Enviar_Primitiva_MPDL_N */


/*************************************************************************/
/*                                                                       */
/*               Recebe a Primitiva enviada pela Camada Rede             */
/*                                                                       */
/*************************************************************************/

Ptr_Estrutura_Primitiva_N_MPDL Receber_Primitiva_N_MPDL (void)

  {

    return (Ptr_Prim_Fila_Primitivas_N_MPDL);

  } /* Receber_Primitiva_N_MPDL */


/*************************************************************************/
/*                                                                       */
/*               Recebe a Primitiva enviada pela Camada Enlace           */
/*                                                                       */
/*************************************************************************/

Ptr_Estrutura_Primitiva_MPDL_N Receber_Primitiva_MPDL_N (void)

  {

    return (Ptr_Prim_Fila_Primitivas_MPDL_N);

  } /* Receber_Primitiva_MPDL_N */


/*************************************************************************/
/*                                                                       */
/*    Libera a area ocupada pela primitiva enviada pela Camada Rede      */
/*                                                                       */
/*************************************************************************/

void Retirar_Primitiva_Fila_N_MPDL (void)

  {

    Ptr_Estrutura_Primitiva_N_MPDL        Ptr_Primitiva_N_MPDL;

    if (Ptr_Prim_Fila_Primitivas_N_MPDL)
      {
        Ptr_Primitiva_N_MPDL = Ptr_Prim_Fila_Primitivas_N_MPDL;
        Ptr_Prim_Fila_Primitivas_N_MPDL = Ptr_Prim_Fila_Primitivas_N_MPDL->Ptr_Proximo;
        Liberar_Estrutura_Primitiva_Tx ((unsigned char *) (Ptr_Primitiva_N_MPDL));
        Nr_Elem_Fila_Primitivas_N_MPDL--;
      }


  } /* Retirar_Primitiva_Fila_N_MPDL */


/*************************************************************************/
/*                                                                       */
/*    Libera a area ocupada pela primitiva enviada pela Camada Enlace    */
/*                                                                       */
/*************************************************************************/

void Retirar_Primitiva_Fila_MPDL_N (void)

  {

    Ptr_Estrutura_Primitiva_MPDL_N        Ptr_Primitiva_MPDL_N;

    if (Ptr_Prim_Fila_Primitivas_MPDL_N)
      {
        Ptr_Primitiva_MPDL_N = Ptr_Prim_Fila_Primitivas_MPDL_N;
        Ptr_Prim_Fila_Primitivas_MPDL_N = Ptr_Prim_Fila_Primitivas_MPDL_N->Ptr_Proximo;
        Liberar_Estrutura_Primitiva_Rx ((unsigned char *) (Ptr_Primitiva_MPDL_N));
        Nr_Elem_Fila_Primitivas_MPDL_N--;
      }


  } /* Retirar_Primitiva_Fila_MPDL_N */

void Recolocar_Primitiva_Fila_N_MPDL (void)
  {
  Ptr_Estrutura_Primitiva_N_MPDL        Ptr_Primitiva_N_MPDL;

  if (Ptr_Prim_Fila_Primitivas_N_MPDL)
    {
    Ptr_Primitiva_N_MPDL = Ptr_Prim_Fila_Primitivas_N_MPDL;
    Ptr_Prim_Fila_Primitivas_N_MPDL = Ptr_Prim_Fila_Primitivas_N_MPDL->Ptr_Proximo;

    if (!Ptr_Prim_Fila_Primitivas_N_MPDL)
      Ptr_Prim_Fila_Primitivas_N_MPDL = Ptr_Primitiva_N_MPDL;
    else
      Ptr_Ult_Fila_Primitivas_N_MPDL->Ptr_Proximo = Ptr_Primitiva_N_MPDL;
    Ptr_Ult_Fila_Primitivas_N_MPDL = Ptr_Primitiva_N_MPDL;
    Ptr_Ult_Fila_Primitivas_N_MPDL ->Ptr_Proximo = NULL;
    Enviar_Rotina_Fila_Gerente_RMOSI (Tratar_Pedido_Servico_NMPDL,0);
    }
  else
    cprintf("Recolocar_Primitiva_Fila_N_MPDL com prim_fila NULO!!!");
  }

#endif
