/*                                                                    */
/* Arquivo: AplMPMP.c     Aplicacao para a interface com o usuario    */
/*                        Protocolo multiponto-a-multiponto           */
/*                        com canal de retorno                        */
/*                                                                    */
/* Autores: Hermes Alexandre A. S. Costa                              */
/*          Luiz Mauricio Q. Portela                                  */
/*          Marcos Tadeu                                              */
/*                                                                    */
/* Data Inicio: 07 - 11 - 93                                          */
/* Ultima modificacao: 14-01-94                                       */

#include <conio.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <bios.h>
#include <time.h>
#include <dos.h>
#include <math.h>

#include <cntglob.h>
#include <tipglob.h>
#include <memtx.h>
#include <memrx.h>

#include <tipnmpdl.h>
#include <fncnmpdl.h>
#include <modivar.h>
#include <varmpdl.h>

#include <cntmpdl.h> /* Definicao de Num_Estacoes */

#include <janelahl.h>
#include <janelas.h>

/*#include <varph.h>  */  /* Definicao das porcentagens de perda */

/*#define  placa*/

typedef enum
  {
  APL_CLOSED,
  TX,
  RX
  } Tipo_Estado_Apl;

typedef enum
  {
  NENHUMA,
  FIM_MEDIDA,
  MED_TX,
  MED_RX,
  MED_TX0
  } Tipo_Estado_Med;

/* Definicao de variaveis */

Tipo_Estado_Apl  Estado_Apl=APL_CLOSED;
Tipo_Estado_Med  Estado_Medida=NENHUMA;


extern unsigned char id_est;

extern char far *video;
unsigned long int  Cont_Tx = 0,cont_rx[5]={0,0,0,0,0};

float              T0;

float              T1;

Boolean            Apl_Pediu_Ficha = False,
                   help_ativo=false;

int                Num_Jan=1,//ccc=5,
                   Tamanho_Dt_Apl=0,cont_med=0;

char               *Ptr_Buffer_Dados_Apl,*Ptr_Ini_Buf;

unsigned char cont_apg_msg=0;

extern unsigned int estacao_local,errforc;

Ptr_Estrutura_Parametros     Ptr_Est_Param;

#ifdef placa
extern boolean  prim_quadro;
#else
boolean  prim_quadro;
#endif

void Retransmite_Todos_os_Quadros(void); //teste

/* Rotina de alteracao de variaveis - arquivo medvar.c */

void menu_var (void);

/* Rotina de Inicializacao */

void  Incializar_Aplicacao (void);


/* Rotina de Finalizacao */

void Finalizar_Aplicacao (void);



/* Pontos de entrada do escalonador */

void Tratar_Pedido_Servico_MPDLN (void);


/* Rotina de tratamento dos comandos do usuario */

Boolean  Executar_Aplicacao (void);


/* Rotinas de montagem e envio de primitivas */

void Enviar_MPDL_ESTABLISH_Req (void);
void Enviar_MPDL_ABORT_Req (void);
void Enviar_MPDL_TOKEN_PLEASE_Req (void);
void Enviar_MPDL_TOKEN_GIVE_Req (void);
void Enviar_MPDL_DATA_Req (unsigned char *, unsigned int);
void Enviar_MPDL_STOP_TRANSMISSION_Resp(void);


/* Rotinas de manipulacao de tela */

void inicia_tela (void);
void Help_Jan (void);

void Recebe_Dados (Ptr_Estrutura_Primitiva_MPDL_N);
void Transmite_Buffer (void);

void Msg_Status (char [80]);
void Msg_Status_Id (char [80],unsigned char);
void Msg_Status_Apl(char msg[80]);

/****************************************************************************/
/*                                                                          */
/*              Inicializacao                                               */
/*                                                                          */
/****************************************************************************/

void  Inicializar_Aplicacao (void)
  {
   int i;

   #ifdef WR_STAT
   Abre_Status();
   #endif
   directvideo=true;
   Ptr_Buffer_Dados_Apl = malloc(1024);
   Ptr_Ini_Buf=Ptr_Buffer_Dados_Apl;
   Cont_Tx = 0;
   T0 = biostime (0,0L) / CLK_TCK;
   prim_quadro=true;
   Apl_Pediu_Ficha=false;
   moldura();
   for (i=1;i<=4;i++)
     Cor_Titulo(DARKGRAY,YELLOW,i);
   Cor_Titulo(BLUE,YELLOW,id_est);
   menu_var(); /* mostrar e modificar variaveis do sistema */
  } /* fim Inicializar_Aplicacao */



/****************************************************************************/
/*                                                                          */
/*              Finalizacao                                                 */
/*                                                                          */
/****************************************************************************/

void  Finalizar_Aplicacao (void)
  {
  free (Ptr_Buffer_Dados_Apl);
  #ifdef WR_STAT
  Fecha_Status();
  #endif
  } /* fim Finalizar_Aplicacao */


/****************************************************************************/
/*                                                                          */
/*              Pontos de entrada do escalonador                            */
/*                                                                          */
/****************************************************************************/

void  Tratar_Pedido_Servico_MPDLN (void)
  {

  /* Esta rotina recebera' e tratara' as primitivas enviadas para a aplicacao */
  /* pela maquina de estados                  */

  int   cont = 1;
  Ptr_Estrutura_Primitiva_MPDL_N  Ptr_Primitiva;
  unsigned char                   *Ptr_Param;
  unsigned char i,j;

  Ptr_Primitiva = Receber_Primitiva_MPDL_N ();
  if (help_ativo)
    {
    Fechar_Janela();
    help_ativo=false;
    }
  switch (Ptr_Primitiva->Nome_Primitiva)
    {
    case MPDL_DATA_Indication:

      i=(unsigned char) *Ptr_Primitiva->Ptr_Parametros_Primitiva->Ptr_Parametros;
      if ((Estado_Medida==MED_RX) || (Estado_Medida==MED_TX) || (Estado_Medida==MED_TX0))
	{
	cont_rx[i]++;
//        cprintf("%c",*Ptr_Primitiva->Ptr_Parametros_Primitiva->Ptr_Dados_Usuario);
	if (cont_rx[i]>=Num_Quadros)
	  {
	  j=1;
	  while ((j<=Num_Estacoes) && ((cont_rx[j]>=Num_Quadros) || (cont_rx[j]==0)))
	    j++;
	  if ((j>Num_Estacoes) && ((Cont_Tx>=Num_Quadros) || (Cont_Tx==0)))
            Estado_Medida=FIM_MEDIDA;
          }
	}
      else
        if ((Ptr_Primitiva->Ptr_Parametros_Primitiva->Tam_Dados_Usuario==6) &&
           (!memcmp(Ptr_Primitiva->Ptr_Parametros_Primitiva->Ptr_Dados_Usuario, &"MED_TX",6)))
          {
          T0 = biostime (0,0L) / CLK_TCK;
          Estado_Medida=MED_RX;
          for (j=1;j<=Num_Estacoes;j++)
            cont_rx[j]=0;
          cont_rx[i]=1;
          cont_med++;
          if (Num_Jan!=i)
	    Ativa(i);
          cprintf ("%2u:%u de %u.J=%u,Tack=%u,TMT=%u\r\n",cont_med,Num_Quadros,Tamanho,Janela,Tempo_TACK,Tempo_TMT);
          }
        else
          if (Estado_Medida==NENHUMA)
            Recebe_Dados(Ptr_Primitiva);
      Liberar_Memoria_Rx(Ptr_Primitiva->Ptr_Parametros_Primitiva->Ptr_Parametros,1);
      Liberar_Estrutura_Parametros_Rx (Ptr_Primitiva->Ptr_Parametros_Primitiva);
      break;

    case MPDL_STOP_TRANSMISSION_Indication:
      #ifdef MSG_APL
      Msg_Status_Apl("Recebi MPDL_STOP_TRANSMISSION_Indication:");
      #endif
      Cor_Titulo(RED,YELLOW,id_est);
      Estado_Apl=RX;
      Enviar_MPDL_STOP_TRANSMISSION_Resp();
      break;

    case MPDL_ESTABLISH_Confirm:
      Ptr_Param=Ptr_Primitiva->Ptr_Parametros_Primitiva->Ptr_Parametros;
      #ifdef MSG_APL
      Msg_Status_Apl("Recebi MPDL_ESTABLISH_Confirm:");
      #endif
      if (!*Ptr_Param)
	Estado_Apl=TX; // conexao nova
      for (cont=1;cont<=Num_Estacoes;cont++)
	{
	Ptr_Param++;
	if (*Ptr_Param)
	  Cor_Titulo(RED,YELLOW,cont);
	}
      if (Estado_Apl==TX)
        Cor_Titulo(GREEN,BLACK,id_est);
      Liberar_Memoria_Rx(Ptr_Primitiva->Ptr_Parametros_Primitiva->Ptr_Parametros,Num_Estacoes+1);
      Liberar_Estrutura_Parametros_Rx (Ptr_Primitiva->Ptr_Parametros_Primitiva);
      Transmite_Buffer();
      break;

    case MPDL_TOKEN_GIVE_Indication:
      #ifdef MSG_APL
      Msg_Status_Apl("Recebi MPDL_TOKEN_GIVE_Indication");
      #endif
      Estado_Apl=TX;
      Apl_Pediu_Ficha = False;
      Cor_Titulo(GREEN,BLACK,id_est);
      Transmite_Buffer();
      break;

    case MPDL_INDIVIDUAL_ABORT_Indication:
    case MPDL_INDIVIDUAL_ABORT_Confirm:
      #ifdef MSG_APL
      Msg_Status_Apl("Recebi MPDL_INDIVIDUAL_ABORT_Indication");
      #endif
      if (id_est==*Ptr_Primitiva->Ptr_Parametros_Primitiva->Ptr_Parametros)
        {
        Estado_Apl=APL_CLOSED;
        Estado_Medida=NENHUMA;
        Apl_Pediu_Ficha=false;
        for (i=1;i<=Num_Estacoes;Cor_Titulo(DARKGRAY,LIGHTGRAY,i++));
        Cor_Titulo(BLUE,YELLOW,id_est);
        }
      else
        Cor_Titulo(DARKGRAY,LIGHTGRAY,*Ptr_Primitiva->Ptr_Parametros_Primitiva->Ptr_Parametros);
      Liberar_Memoria_Rx(Ptr_Primitiva->Ptr_Parametros_Primitiva->Ptr_Parametros,1);
      Liberar_Estrutura_Parametros_Rx (Ptr_Primitiva->Ptr_Parametros_Primitiva);
      break;

    case MPDL_ABORT_Indication:
      #ifdef MSG_APL
      Msg_Status_Apl("Recebi MPDL_ABORT_Indication");
      #endif
      Liberar_Memoria_Rx(Ptr_Primitiva->Ptr_Parametros_Primitiva->Ptr_Parametros,1);
      Liberar_Estrutura_Parametros_Rx (Ptr_Primitiva->Ptr_Parametros_Primitiva);
      for (cont=1;cont<=4;cont++)
	      Cor_Titulo(DARKGRAY,LIGHTGRAY,cont);
      Cor_Titulo(BLUE,YELLOW,id_est);
      Ptr_Buffer_Dados_Apl=Ptr_Ini_Buf;
      Tamanho_Dt_Apl=0;
      Apl_Pediu_Ficha=false;
      Estado_Apl=APL_CLOSED;
      Estado_Medida=NENHUMA;
      break;

    case MPDL_ABORT_Confirm:
      #ifdef MSG_APL
      Msg_Status_Apl("Recebi MPDL_ABORT_Confirm:");
      #endif
      Estado_Apl=APL_CLOSED;
      Estado_Medida=NENHUMA;
      for (cont=1;cont<=4;cont++)
        Cor_Titulo(DARKGRAY,LIGHTGRAY,cont);
      Cor_Titulo(BLUE,YELLOW,id_est);
      Ptr_Buffer_Dados_Apl=Ptr_Ini_Buf;
      Apl_Pediu_Ficha=false;
      Tamanho_Dt_Apl=0;
      break;

    case MPDL_ESTABLISH_Indication:
      Cor_Titulo(RED,YELLOW,*Ptr_Primitiva->Ptr_Parametros_Primitiva->Ptr_Parametros);
      if (Estado_Apl==APL_CLOSED)
        {
        Estado_Apl=RX;
        Cor_Titulo(RED,YELLOW,id_est);
        }
      #ifdef MSG_APL
      Msg_Status_Id("Recebi MPDL_ESTABLISH_Indication:",*Ptr_Primitiva->Ptr_Parametros_Primitiva->Ptr_Parametros);
      #endif
      Liberar_Memoria_Rx(Ptr_Primitiva->Ptr_Parametros_Primitiva->Ptr_Parametros,1);
      Liberar_Estrutura_Parametros_Rx (Ptr_Primitiva->Ptr_Parametros_Primitiva);
      break;

    case MPDL_TOKEN_PLEASE_Indication:
//      sound(5000);
      #ifdef MSG_APL
      Msg_Status_Id("Recebi MPDL_TOKEN_PLEASE_Indication da ",*Ptr_Primitiva->Ptr_Parametros_Primitiva->Ptr_Parametros);
      #endif
      Liberar_Memoria_Rx(Ptr_Primitiva->Ptr_Parametros_Primitiva->Ptr_Parametros,1);
      Liberar_Estrutura_Parametros_Rx (Ptr_Primitiva->Ptr_Parametros_Primitiva);
//      nosound();
      break;


    } /* fim switch */
  Retirar_Primitiva_Fila_MPDL_N ();
  } /* fim Tratar_Pedido_Servico_DLN_Tx */

/****************************************************************************/
/*                                                                          */
/*              Rotina para escrever os dados recebidos                     */
/*                                                                          */
/****************************************************************************/

void Recebe_Dados (Ptr_Estrutura_Primitiva_MPDL_N  Ptr_Primitiva)
  {
  int conta_dados = 0;
  Ptr_Estrutura_Parametros Ptr_Est_Param;
  unsigned char            *Ptr_Dados;

  Ptr_Est_Param = Ptr_Primitiva->Ptr_Parametros_Primitiva;
  if (*Ptr_Est_Param->Ptr_Parametros!=Num_Jan)
    Ativa(*Ptr_Est_Param->Ptr_Parametros);
  Ptr_Dados=Ptr_Est_Param->Ptr_Dados_Usuario;
  for (conta_dados=1;conta_dados<=Ptr_Est_Param->Tam_Dados_Usuario;conta_dados++)
    Imprime (*Ptr_Dados++);
  }

void Transmite_Buffer(void)
  {
  Ptr_Estrutura_Primitiva_N_MPDL  Ptr_Primitiva_Tx;

  if (Tamanho_Dt_Apl>0)
    {
    Ptr_Buffer_Dados_Apl = Ptr_Buffer_Dados_Apl - Tamanho_Dt_Apl;
    Ptr_Est_Param = Alocar_Estrutura_Parametros_Tx ();
    Ptr_Est_Param->Ptr_Proximo = NULL;
    Ptr_Est_Param->Ptr_Parametros = NULL;
    Ptr_Est_Param->Tam_Dados_Usuario = Tamanho_Dt_Apl;
    Ptr_Est_Param->Ptr_Dados_Usuario = Alocar_Memoria_Tx (Tamanho_Dt_Apl);
    memcpy(Ptr_Est_Param->Ptr_Dados_Usuario,Ptr_Buffer_Dados_Apl,Tamanho_Dt_Apl);
    Ptr_Primitiva_Tx = (Ptr_Estrutura_Primitiva_N_MPDL) Alocar_Estrutura_Primitiva_Tx ();
    Ptr_Primitiva_Tx->Nome_Primitiva = MPDL_DATA_Request;
    Ptr_Primitiva_Tx->Ptr_Parametros_Primitiva = Ptr_Est_Param;
    Enviar_Primitiva_N_MPDL(Ptr_Primitiva_Tx);
    Tamanho_Dt_Apl = 0;
    }
  }

/***************************************************************************/
/*                                                                         */
/*             Rotina de tratamento dos comandos do usuario                */
/*                                                                         */
/***************************************************************************/

Boolean  Executar_Aplicacao (void)
  {
  /* Esta rotina recebe, trata e envia a primitiva correspondente para a */
  /* respectiva maquina de estados                                       */
  /* Retorna TRUE se o usuario desejar encerrar o programa  e  FALSE  em */
  /* caso contrario                                                      */

  Boolean                           Fim = False;
  unsigned char                     Tecla,i;
  Ptr_Estrutura_Primitiva_N_MPDL    Ptr_Primitiva_Tx;

  if (kbhit ())
    {
    Tecla = (unsigned char) getch ();
    if (cont_apg_msg>0)
      if (--cont_apg_msg==0)
        Msg_Status("");
    if (Tecla==0)
      {
      Tecla = (unsigned char) getch ();
      if ((help_ativo)&&(Tecla!=F1))
        {
        Fechar_Janela();
        help_ativo=false;
        }
      switch (Tecla)
	{
        case F1:
          if (help_ativo)
            Fechar_Janela();
          else
            Help_Jan();
          help_ativo=!help_ativo;
          break;

        case F2:
          #ifdef MSG_APL
          Msg_Status_Apl("Enviei pedido de conexo");
          #endif
	  Enviar_MPDL_ESTABLISH_Req ();
	  break;

	case F3:
          if (Estado_Apl==TX)
            {
            #ifdef MSG_APL
            Msg_Status_Apl("Enviei pedido de desconexo");
            #endif
	    Enviar_MPDL_ABORT_Req ();
            }
          else
            Msg_Status_Apl("Pedido de desconexo s quando em transmisso");
          break;

	case F4:
          if (Estado_Apl==RX)
            Enviar_MPDL_TOKEN_PLEASE_Req ();
          break;

	case F5:
          if (Estado_Apl==TX)
            {
            Estado_Apl=RX;
            Enviar_MPDL_TOKEN_GIVE_Req ();
            }
          break;

        case F6:
          cont_med=0;
          break;

        case F7:
          if (Estado_Medida==NENHUMA)
            for (i=1;i<=Num_Estacoes;i++)
              cont_rx[i]=0;
          if (Estado_Medida!=MED_TX)
           {
           cont_med++;
           switch (Estado_Apl)
            {
            case TX:
              errforc=0;
              if (Num_Jan!=id_est)
	        Ativa(id_est);
              cprintf ("%2u:%u de %u.J=%u,Tack=%u,TMT=%u\r\n",cont_med,Num_Quadros,Tamanho,Janela,Tempo_TACK,Tempo_TMT);
              estourou_janela = False;
              faltou_memo = False;
              faltou_primit = False;
              Cont_Tx = 0;
              num_srej=0;
              if (Estado_Medida==NENHUMA)
                T0 = biostime (0,0L) / CLK_TCK;
              Estado_Medida = MED_TX;
              prim_quadro=false;
              Ptr_Est_Param = Alocar_Estrutura_Parametros_Tx ();
              Ptr_Est_Param->Ptr_Proximo = NULL;
              Ptr_Est_Param->Ptr_Parametros = NULL;
              Ptr_Est_Param->Tam_Dados_Usuario = 6;
              Ptr_Est_Param->Ptr_Dados_Usuario = Alocar_Memoria_Tx (6);
              memcpy(Ptr_Est_Param->Ptr_Dados_Usuario,&"MED_TX",6);
              Ptr_Primitiva_Tx = (Ptr_Estrutura_Primitiva_N_MPDL) Alocar_Estrutura_Primitiva_Tx ();
              Ptr_Primitiva_Tx->Nome_Primitiva = MPDL_DATA_Request;
              Ptr_Primitiva_Tx->Ptr_Parametros_Primitiva = Ptr_Est_Param;
              Enviar_Primitiva_N_MPDL (Ptr_Primitiva_Tx);
              Cont_Tx++;
              break;

            case RX:
              Enviar_MPDL_TOKEN_PLEASE_Req ();
              Apl_Pediu_Ficha = True;
              errforc=0;
              if (Num_Jan!=id_est)
	        Ativa(id_est);
              cprintf ("%2u:%u de %u.J=%u,Tack=%u,TMT=%u\r\n",cont_med,Num_Quadros,Tamanho,Janela,Tempo_TACK,Tempo_TMT);
              estourou_janela = False;
              faltou_memo = False;
              faltou_primit = False;
              Cont_Tx = 0;
              num_srej=0;
              if (Estado_Medida==NENHUMA)
                T0 = biostime (0,0L) / CLK_TCK;
              Estado_Medida = MED_TX0;
	      break;

            default:
              Msg_Status_Apl("Abra a conexao antes de efetuar medidas!");
            }
           }
          break;


        case F9:
          if (Estado_Apl==APL_CLOSED)
            menu_var();
          else
            Msg_Status_Apl("Modificao nas variveis do sistema s com a conexo FECHADA");

        }
      }
    else
      {
      if (help_ativo)
        {
        Fechar_Janela();
        help_ativo=false;
        }
      switch (Tecla)
	{
	case Escape:
	  Fim = True;
          window(1,1,80,25);
          clrscr();
	  printf ("\nCont_Tx = %ld\n", Cont_Tx);
	  break;

        default:
          if (Estado_Apl==APL_CLOSED)
            {
            #ifdef MSG_APL
            Msg_Status_Apl("Enviei pedido de conexo");
            #endif
	    Enviar_MPDL_ESTABLISH_Req ();
            }
          if ((!Apl_Pediu_Ficha) && (Estado_Apl==RX))
            {
            Apl_Pediu_Ficha = True;
            Enviar_MPDL_TOKEN_PLEASE_Req ();
            }
          if (Num_Jan!=id_est)
	    Ativa(id_est);
	  Imprime(Tecla);
	  if (Estado_Apl==TX)
	    {
            if ((Ptr_Est_Param = Alocar_Estrutura_Parametros_Tx ())!=NULL)
              {
              if ((Ptr_Est_Param->Ptr_Dados_Usuario = Alocar_Memoria_Tx (1))!=NULL)
                {
		if ((Ptr_Primitiva_Tx = (Ptr_Estrutura_Primitiva_N_MPDL) Alocar_Estrutura_Primitiva_Tx ())!=NULL)
                  {
		  Ptr_Est_Param->Ptr_Proximo = NULL;
		  Ptr_Est_Param->Ptr_Parametros = NULL;
		  Ptr_Est_Param->Tam_Dados_Usuario = 1;
		  *Ptr_Est_Param->Ptr_Dados_Usuario = Tecla;
		  Ptr_Primitiva_Tx->Nome_Primitiva = MPDL_DATA_Request;
		  Ptr_Primitiva_Tx->Ptr_Parametros_Primitiva = Ptr_Est_Param;
		  Enviar_Primitiva_N_MPDL(Ptr_Primitiva_Tx);
                  }
                else
                  {
                  Liberar_Memoria_Tx(Ptr_Est_Param->Ptr_Dados_Usuario,1);
                  Liberar_Estrutura_Parametros_Tx (Ptr_Est_Param);
                  #ifdef MSG_ERR
                  Msg_Status_Apl("Nao deu para TX: Estru Primitiva C");
                  #endif
                  }
                }
              else
                {
                Liberar_Estrutura_Parametros_Tx (Ptr_Est_Param);
                #ifdef MSG_ERR
                Msg_Status_Apl("Nao deu para TX: Memoria Tx C");
                #endif
                }
              }
            #ifdef MSG_ERR
            else
              Msg_Status_Apl("Nao deu para TX: Estru Parametros Tx C");
            #endif
	  }
	else
	  {
	  *Ptr_Buffer_Dados_Apl = Tecla;
	  Ptr_Buffer_Dados_Apl++;
	  Tamanho_Dt_Apl++;
	  }
        } /* fim switch (Tecla) */
      }
    } /* if kbhit */
  else
    switch (Estado_Medida)
      {
      case MED_TX:
//        if (ccc>0) ccc--;
        if (Estado_Apl==TX)//  && (ccc==0))
          {
//          ccc=49;
          Ptr_Est_Param = Alocar_Estrutura_Parametros_Tx ();
          if (Ptr_Est_Param!=NULL)
            {
            Ptr_Est_Param->Ptr_Dados_Usuario = Alocar_Memoria_Tx (Tamanho);
            if (Ptr_Est_Param->Ptr_Dados_Usuario!=NULL)
              {
              Ptr_Primitiva_Tx = (Ptr_Estrutura_Primitiva_N_MPDL) Alocar_Estrutura_Primitiva_Tx ();
              if (Ptr_Primitiva_Tx!=NULL)
                {
                Ptr_Est_Param->Ptr_Proximo = NULL;
                Ptr_Est_Param->Ptr_Parametros = NULL;
                Ptr_Est_Param->Tam_Dados_Usuario = Tamanho;
//                *Ptr_Est_Param->Ptr_Dados_Usuario = ccc++%10 + 0x30;
                Ptr_Primitiva_Tx->Nome_Primitiva = MPDL_DATA_Request;
                Ptr_Primitiva_Tx->Ptr_Parametros_Primitiva = Ptr_Est_Param;
                Enviar_Primitiva_N_MPDL (Ptr_Primitiva_Tx);
                Cont_Tx++;
                if (Cont_Tx == Num_Quadros)
                  {
                  i=1;
	          while ((i<=Num_Estacoes) && ((cont_rx[i]>=Num_Quadros) || (cont_rx[i]==0)))
	            i++;
	          if (i>Num_Estacoes)
                    Estado_Medida=FIM_MEDIDA;
                  else
                    {
                    Estado_Medida = MED_RX;
                    Estado_Apl=RX;
                    Enviar_MPDL_TOKEN_GIVE_Req ();
                    }
                  }
                }
              else
                {
                Liberar_Memoria_Tx(Ptr_Est_Param->Ptr_Dados_Usuario,Tamanho);
                Liberar_Estrutura_Parametros_Tx (Ptr_Est_Param);
                #ifdef MSG_ERR
                Msg_Status_Apl("Nao deu para TX: Estru Primitiva");
                cprintf("%u",Cont_Tx);
                #endif
                }
              }
            else
              {
              Liberar_Estrutura_Parametros_Tx (Ptr_Est_Param);
              #ifdef MSG_ERR
              Msg_Status_Apl("Nao deu para TX: Memoria Tx");
              cprintf("%u",Cont_Tx);
              #endif
              }
            }
          #ifdef MSG_ERR
          else
            {
            Msg_Status_Apl("Nao deu para TX: Estru Parametros Tx");
            cprintf("%u",Cont_Tx);
            }
          #endif
          }
        else
          if ((!Apl_Pediu_Ficha) && (Estado_Apl==RX))
            {
            Apl_Pediu_Ficha = True;
            Enviar_MPDL_TOKEN_PLEASE_Req ();
            if (Cont_Tx==0)
              Estado_Medida=MED_TX0;
            }
        break;

      case FIM_MEDIDA:
        T1 = biostime (0, 0L) / CLK_TCK;
        if (Num_Jan!=id_est)
	  Ativa(id_est);
        gotoxy(1,wherey());
        T0=floor((T1-T0)*10+.5)/10;
        cprintf("%2u:t=%.1f,ES=%u",cont_med, T0, errforc);
        if (estourou_janela)
          cprintf(" J");
        if (faltou_memo)
          cprintf(" FM");
        if (faltou_primit)
          cprintf(" FP");
        T1=Num_Quadros/T0*Tamanho*8;
        cprintf(" Srej=%u,V=%.1f\r\n",num_srej,T1);
        errforc=0;
        Estado_Medida=NENHUMA;
        break;

      case MED_TX0:
        if (Estado_Apl==TX)
          {
          Ptr_Est_Param = Alocar_Estrutura_Parametros_Tx ();
          if (Ptr_Est_Param)
            {
            Ptr_Est_Param->Ptr_Dados_Usuario = Alocar_Memoria_Tx (6);
            if (Ptr_Est_Param->Ptr_Dados_Usuario)
              {
              Ptr_Primitiva_Tx = (Ptr_Estrutura_Primitiva_N_MPDL) Alocar_Estrutura_Primitiva_Tx ();
              if (Ptr_Primitiva_Tx)
                {
                Ptr_Est_Param->Ptr_Proximo = NULL;
                Ptr_Est_Param->Ptr_Parametros = NULL;
                Ptr_Est_Param->Tam_Dados_Usuario = 6;
                memcpy(Ptr_Est_Param->Ptr_Dados_Usuario,&"MED_TX",6);
                Ptr_Primitiva_Tx->Nome_Primitiva = MPDL_DATA_Request;
                Ptr_Primitiva_Tx->Ptr_Parametros_Primitiva = Ptr_Est_Param;
                Enviar_Primitiva_N_MPDL (Ptr_Primitiva_Tx);
                Cont_Tx++;
                Estado_Medida=MED_TX;
                }
              else
                {
                Liberar_Memoria_Tx(Ptr_Est_Param->Ptr_Dados_Usuario,6);
                #ifdef MSG_ERR
                Msg_Status_Apl("Nao deu para TX0: Estru Primitiva");
                cprintf("%u",Cont_Tx);
                #endif
                Liberar_Estrutura_Parametros_Tx (Ptr_Est_Param);
                }
              }
            else
              {
              #ifdef MSG_ERR
              Msg_Status_Apl("Nao deu para TX0: Memoria Tx");
              cprintf("%u",Cont_Tx);
              #endif
              Liberar_Estrutura_Parametros_Tx (Ptr_Est_Param);
              }
            }
          #ifdef MSG_ERR
          else
            {
            Msg_Status_Apl("Nao deu para TX0: Estru Parametros Tx");
            cprintf("%u",Cont_Tx);
            }
          #endif
          }
        break;

    } // switch

  return (Fim);

  }/* fim Executar_Aplicacao */



/*********************************************2*******************************/
/*                                                                          */
/*              Rotinas de montagem e envio de primitivas                   */
/*                                                                          */
/****************************************************************************/

void  Enviar_MPDL_ESTABLISH_Req (void)
  {
  Ptr_Estrutura_Primitiva_N_MPDL    Ptr_Primitiva;

  Ptr_Primitiva = (Ptr_Estrutura_Primitiva_N_MPDL) Alocar_Estrutura_Primitiva_Tx ();
  Ptr_Primitiva->Nome_Primitiva = MPDL_ESTABLISH_Request;
  Ptr_Primitiva->Ptr_Parametros_Primitiva = NULL;
  Enviar_Primitiva_N_MPDL (Ptr_Primitiva);
  } /* fim Enviar_MPDL_ESTABLISH_Req */



void  Enviar_MPDL_ABORT_Req (void)
  {
  Ptr_Estrutura_Primitiva_N_MPDL    Ptr_Primitiva;

  Ptr_Primitiva = (Ptr_Estrutura_Primitiva_N_MPDL) Alocar_Estrutura_Primitiva_Tx ();
  Ptr_Primitiva->Nome_Primitiva = MPDL_ABORT_Request;
  Ptr_Primitiva->Ptr_Parametros_Primitiva = NULL;
  Enviar_Primitiva_N_MPDL (Ptr_Primitiva);
  } /* fim Enviar_MPDL_ABORT_Req */


void  Enviar_MPDL_TOKEN_PLEASE_Req (void)
  {
  Ptr_Estrutura_Primitiva_N_MPDL    Ptr_Primitiva;

  #ifdef MSG_APL
  Msg_Status_Apl("Enviei pedido de FICHA");
  #endif
  Ptr_Primitiva = (Ptr_Estrutura_Primitiva_N_MPDL) Alocar_Estrutura_Primitiva_Tx ();
  Ptr_Primitiva->Nome_Primitiva = MPDL_TOKEN_PLEASE_Request;
  Ptr_Primitiva->Ptr_Parametros_Primitiva = NULL;
  Enviar_Primitiva_N_MPDL (Ptr_Primitiva);

  }


void  Enviar_MPDL_TOKEN_GIVE_Req (void)
  {
  Ptr_Estrutura_Primitiva_N_MPDL    Ptr_Primitiva;

  #ifdef MSG_APL
  Msg_Status_Apl("Enviei a FICHA");
  #endif
  Ptr_Primitiva = (Ptr_Estrutura_Primitiva_N_MPDL) Alocar_Estrutura_Primitiva_Tx ();
  Ptr_Primitiva->Nome_Primitiva = MPDL_TOKEN_GIVE_Request;
  Ptr_Primitiva->Ptr_Parametros_Primitiva = NULL;
  Enviar_Primitiva_N_MPDL (Ptr_Primitiva);

  }

void  Enviar_MPDL_STOP_TRANSMISSION_Resp(void)
  {
  Ptr_Estrutura_Primitiva_N_MPDL    Ptr_Primitiva;

  Ptr_Primitiva = (Ptr_Estrutura_Primitiva_N_MPDL) Alocar_Estrutura_Primitiva_Tx ();
  Ptr_Primitiva->Nome_Primitiva = MPDL_STOP_TRANSMISSION_Response;
  Ptr_Primitiva->Ptr_Parametros_Primitiva = NULL;
  Enviar_Primitiva_N_MPDL (Ptr_Primitiva);
  } /* fim Enviar_MPDL_ESTABLISH_Req */


/****************************************************************************/
/*                                                                          */
/*              Rotinas de manipulacao de tela                              */
/*                                                                          */
/****************************************************************************/


void Help_Jan (void)
 {
 Abrir_Janela(6,8,74,18,BLACK,LIGHTGREEN," TECLAS DE FUNCAO: Aplicacao Multi-ponto a Multi-ponto ");
 cprintf("F2 - Envia pedido de conexao\r\n");
 cprintf("F3 - Envia pedido de desconexao\r\n");
 cprintf("F4 - Envia pedido para transmitir (automatico ao se digitar algo)\r\n");
 cprintf("F5 - Cede o direito de transmissao (envia a ficha)\r\n");
 cprintf("F6 - Zera o contador de \"nmero de medidas\"\r\n");
 cprintf("F7 - Ativa transmissao para medida de vazao\r\n");
 cprintf("F9 - Entra no menu de modificacoes de parametros do protocolo\r\n\n");
 cprintf("TAB- Apaga a tela da estacao e as correspondentes nos receptores");
 }