//
// Arquivo: FncMPDL.c      Maquina de estados para o
//                          protocolo multiponto-a-multiponto
//
//                Versao para A REDE
//
// Autor: Marcos Tadeu

// Data inicio: 22/10/93
// Ultima atual.14/01/94

#include <conio.h>
#include <stdio.h>
#include <dos.h>
#include <string.h>

#include <cntglob.h>
#include <tipglob.h>
#include <fncglob.h>
#include <memtx.h>
#include <memrx.h>
#include <timermt.h>
//#include <timer_in.h>
#include <fncesc.h>

#include <tipnmpdl.h>
#include <fncnmpdl.h>
/*
#include <cntmpdl.h>
#include <tipmpdl.h>
*/
#include <varmpdl.h>
#include <tiplm.h>
#include <fnclm.h>
#include <modivar.h>
#include <janelahl.h>

extern unsigned char cont_apg_msg;
extern void interrupt          (*Interrupcao_Original)();
void interrupt Interrupcao_Timer (void);
extern char far *video;

FILE *arq_timer;

void  Inicializar_Camada_MPDL (void);

// ponto de entrada do escalonador
void Tratar_Pedido_Servico_NMPDL  (void);

// rotinas que tratam o recebimento das primitivas NMPDL
void Tratar_Closed_NMPDL (void);
void Tratar_Establish_NMPDL (void);
void Tratar_Establish_Rec_NMPDL (void);
void Tratar_Open_Master_NMPDL (void);
void Tratar_Open_Rec_NMPDL (void);
void Tratar_Aw_Un_Rel_NMPDL (void);
void Tratar_Aw_Tk_Rec_NMPDL (void);
void Tratar_Await_Rel_NMPDL (void);

// ponto de entrada do escalonador
//void Tratar_Pedido_Servico_PHMPDL (void);
void Maquina_Estados_MAC_LLC(void);

// rotinas que tratam o recebimento das primitivas PHMPDL
void Tratar_Closed_MACMPDL (void);
void Tratar_Establish_MACMPDL (void);
void Tratar_Establish_Rec_MACMPDL (void);
void Tratar_Open_Master_MACMPDL (void);
void Tratar_Open_Rec_MACMPDL (void);
void Tratar_Aw_Un_Rel_MACMPDL (void);
void Tratar_Aw_Tk_Rec_MACMPDL (void);
void Tratar_Await_Rel_MACMPDL (void);


// rotinas de montagem e envio de quadros
void    Enviar_SMPARM (unsigned char);
void    Enviar_MPDISC (void);
void    Enviar_DISC (unsigned char);
Boolean Enviar_Quadro_I (Ptr_Estrutura_Parametros, Long);
void    Enviar_MPARMAC  (unsigned char);
void    Enviar_MPDISCAC (unsigned char);
void    Enviar_RR   (Long);
void    Enviar_SREJ (Long, unsigned char);
void    Enviar_MPRP (void);
void    Enviar_DISCAC (unsigned char);
void    Enviar_RP (void);
void    Enviar_TP (void);
void    Enviar_TG (unsigned char);
void    Enviar_BM (void);
void    Enviar_CM (unsigned char);
Boolean Enviar_PLIST (Long);


void Enviar_MPDL_ESTABLISH_Ind  (unsigned char);
void Enviar_MPDL_ESTABLISH_Conf (Boolean);
void Enviar_MPDL_ABORT_Ind  (unsigned char);
void Enviar_MPDL_ABORT_Conf (void);
void Enviar_MPDL_RELEASE_PLEASE_Ind   (unsigned char);
void Enviar_MPDL_DATA_Ind (Ptr_Estrutura_Parametros, unsigned char);
void Enviar_MPDL_INDIVIDUAL_ABORT_Ind  (unsigned char);
void Enviar_MPDL_INDIVIDUAL_ABORT_Conf  (unsigned char);
void Enviar_MPDL_IND_RELEASE_PLEASE_Ind  (unsigned char);
void Enviar_MPDL_TOKEN_PLEASE_Ind (unsigned char);
void Enviar_MPDL_TOKEN_GIVE_Ind (void);
void Enviar_MPDL_STOP_TRANSMISSION_Ind (void);

// rotinas de manipulacao da Lista de Quadros Armazenados
Boolean Inserir_na_Lista_de_Quadros_Armazenados (Ptr_Estrutura_Parametros, Long);
Ptr_Elemento_Lista_Quadros_Armazenados
   Retirar_da_Lista_de_Quadros_Armazenados
     (Ptr_Elemento_Lista_Quadros_Armazenados);

void Descartar_Lista_de_Quadros_Armazenados (void);

// rotinas de manipulacao da Lista de Quadros Esperados
void Inserir_Lista_Quadros_Esperados (Long, unsigned char);
Ptr_Elemento_Lista_Quadros_Esperados Retirar_Lista_Quadros_Esperados (Ptr_Elemento_Lista_Quadros_Esperados, unsigned char);
void Descartar_Lista_Quadros_Esperados (unsigned char);

// rotinas de manipulacao da Lista de Quadros Recebidos Fora de Ordem
void Inserir_Lista_Quadros_Rec_Fora_Ordem (Long, Ptr_Estrutura_Parametros, unsigned char);
// a retirada dessa lista e' feita em Verificar_Possibilidade_Enviar_MPDL_DATA_Ind
void Descartar_Lista_Quadros_Rec_Fora_Ordem (unsigned char);


// rotinas gerais
void           Coloca_na_Fila(unsigned char);
Boolean        Esta_na_Fila_de_Espera(unsigned char);
void           Retirar_da_Fila_de_Espera (unsigned char);
unsigned char  Decodificar_PDU (Ptr_Elem_Buffer_Rx);
Boolean        Quadro_Esta_Lista_de_Armazenados (Long);
void           Retransmitir_Quadro (Long);
void           Retransmite_Todos_os_Quadros(void);
void           Verificar_Sequenciamento (Ptr_Estrutura_Parametros, unsigned char);
void           Verificar_Possibilidade_Enviar_MPDL_Data_Ind (unsigned char);
void           Verificar_Descarte_Quadros (unsigned char, Long);
void           Faltou_Mem_Rx(void);

// rotinas de tratamento de timeout
void Tratar_Estouro_Temp_TR (void);
void Tratar_Estouro_Temp_TACK (void);
void Tratar_Estouro_Temp_TIM (void);
void Tratar_Estouro_Temp_TRQ (void);
void Tratar_Estouro_Temp_TIP (void);
void Tratar_Estouro_Temp_TKPR (void);
void Tratar_Estouro_Temp_TI (unsigned char);
void Tratar_Estouro_Temp_TMT (void);

/***************************************************************************/
/*                                                                         */
/*       Inicializacao da camada                                           */
/*                                                                         */
/***************************************************************************/


void Iniciar_Camada_MPDL (void) // ok 1
  {
  unsigned char   i;
/*
  if ((arq_timer = fopen("TIMER.TXT", "a")) == NULL)
    cprintf("Nao abriu arq_timer");
  else
    fprintf(arq_timer,"\nTTT  TR   TACK TIM  TRQ  TIP  TKPR TMT  TIs");
*/
  for (i = 1; i <= Num_Estacoes; i++)
    {
    Mandou_Conf [i] = False;
    lista_part[i] = false;
    fila_esp[i] = 0;
    Vr [i] = 0;
    nao_rec_cm[i]=true;
    prim_quadro_rec[i]=true;
    num_cm_rec=0;

    Prim_Lista_Quadros_Esperados [i] = NULL;
    Ult_Lista_Quadros_Esperados [i] = NULL;

    Prim_Lista_Quadros_Rec_Fora_Ordem [i] = NULL;
    Ult_Lista_Quadros_Rec_Fora_Ordem [i] = NULL;
    }
  prim_fila=1;
  ult_fila=1;
  falta_mandar_conf=Num_Estacoes-1;
  Prim_Lista_Quadros_Armazenados = NULL;
  Ult_Lista_Quadros_Armazenados = NULL;
  Num_Elem_Lista_Quadros_Armazenados = 0;
  prim_q_env=true;
  canal_p_ocupado=false;
  pediu_ficha=false;
  mestra=false;
  esperando_STOP_Resp=false;  // A76
  num_part=0;
  id_mestra=0;
  Vs=0;
  esperando_discac=0;
  Num_Tentativas=1;
  num_tent_TIP=1;
  #ifdef MSG
  if (Estado!=CLOSED)
    Msg_Maq(">CLOSED");
  #endif
  Estado = CLOSED;

  } // fim Iniciar_Camada_MPDL

void Reiniciar_Camada_MPDL(void)  // A42 A43 A8 A28 A66 A70 A12 A76
  {
  unsigned char i;

//  fclose(arq_timer);
  for (i = 1; i <= Num_Estacoes; i++)
    {
    Descartar_Lista_Quadros_Esperados (i);       // A42
    Descartar_Lista_Quadros_Rec_Fora_Ordem (i);  // A43
    Finalizar_Timer (&Cod_Temp_TI [i]);       // A8
    }
  Finalizar_Timer (&Cod_Temp_TMT);            // A28
  Finalizar_Timer (&Cod_Temp_TIM);            // A66
  Finalizar_Timer (&Cod_Temp_TRQ);            // A70
  Finalizar_Timer (&Cod_Temp_TACK);
  Descartar_Lista_de_Quadros_Armazenados (); // A12
  Iniciar_Camada_MPDL();
  }

/***************************************************************************/
/*                                                                         */
/*       Ponto de Entrada do escalonador (Fila NMPDL)                      */
/*                                                                         */
/***************************************************************************/

void  Tratar_Pedido_Servico_NMPDL (void)
  {
  switch (Estado)
    {
    case OPEN_REC        : Tratar_Open_Rec_NMPDL ();      break; // ok 2
    case OPEN_MASTER     : Tratar_Open_Master_NMPDL ();   break; // ok 2
    case AW_TK_REC       : Tratar_Aw_Tk_Rec_NMPDL ();     break; // ok 2
    case AW_UN_REL       : Tratar_Aw_Un_Rel_NMPDL ();     break; // ok 2
    case CLOSED          : Tratar_Closed_NMPDL ();        break; // ok 2
    case ESTABLISH       : Tratar_Establish_NMPDL ();     break; // ok 2
    case ESTABLISH_REC   : Tratar_Establish_Rec_NMPDL (); break; // ok 2
    case AWAIT_REL       : Tratar_Await_Rel_NMPDL ();     break;
    default: printf ("??? Estado nao esperado em Tratar_Pedido_Servico_NMPDL: %2d",Estado);
    } // fim do switch

  } // fim Tratar_Pedido_Servico_NMPDL



/***************************************************************************/
/*                                                                         */
/*   Rotinas que tratam o recebimento das primitivas NMPDL                 */
/*                                                                         */
/***************************************************************************/

void Tratar_Open_Rec_NMPDL (void)  // ok 2
  {
  Ptr_Estrutura_Primitiva_N_MPDL   Ptr_Primitiva;

  Ptr_Primitiva = Receber_Primitiva_N_MPDL ();
  #ifdef MSG
  Msg_Maq("Open_Rec_N");
  #endif
  switch (Ptr_Primitiva->Nome_Primitiva)
    {
    case MPDL_TOKEN_PLEASE_Request:
      Enviar_TP();
      if (!Reiniciar_Timer (Cod_Temp_TKPR,Tempo_TKPR)) // A23
        Criar_Timer (0,Tempo_TKPR,&Cod_Temp_TKPR);
      break;

    case MPDL_IND_RELEASE_PLEASE_Request:
      Enviar_RP();
      break;

    case MPDL_DATA_Request:
      if (Inserir_na_Lista_de_Quadros_Armazenados(Ptr_Primitiva->Ptr_Parametros_Primitiva,Vs))
        Vs++;
      else
        {
        Msg_Status("MPDL(OP_REC) Dados perdidos"); //na tentativa de transmissao sem permissao");
        cont_apg_msg=5;
        }
      Enviar_MPDL_STOP_TRANSMISSION_Ind (); // A59
      break;

    case MPDL_ABORT_Request:
      Enviar_MPDL_STOP_TRANSMISSION_Ind (); // A59
      break;

    case MPDL_RELEASE_PLEASE_Request:
      Enviar_MPRP ();
      break;

    case MPDL_INDIVIDUAL_ABORT_Request:  // Open_Rec
      Liberar_Memoria_Tx(Ptr_Primitiva->Ptr_Parametros_Primitiva->Ptr_Parametros,sizeof(unsigned char));
      Liberar_Estrutura_Parametros_Tx (Ptr_Primitiva->Ptr_Parametros_Primitiva);
      Enviar_MPDL_STOP_TRANSMISSION_Ind (); // A59
      break;

    case MPDL_TOKEN_GIVE_Request:
      Enviar_MPDL_STOP_TRANSMISSION_Ind (); // A59
      break;

    case MPDL_REPLAY_Request:            // Open_Rec
      Liberar_Memoria_Tx(Ptr_Primitiva->Ptr_Parametros_Primitiva->Ptr_Parametros,sizeof(unsigned char));
      Liberar_Estrutura_Parametros_Tx (Ptr_Primitiva->Ptr_Parametros_Primitiva);
      Enviar_MPDL_STOP_TRANSMISSION_Ind (); // A59
      break;

    } // fim do switch
  Retirar_Primitiva_Fila_N_MPDL ();
  }


void Tratar_Open_Master_NMPDL (void)
  {
  Ptr_Estrutura_Primitiva_N_MPDL   Ptr_Primitiva;
  Ptr_Estrutura_Parametros         Ptr_Estrutura_PLIST;
  unsigned char                  i;
  Long                           Ns;
/*
  Boolean                        Conseguiu_Tratar_Primitiva = True;
  Boolean                        Conseguiu_Alocar = True;
  Boolean                        Conseguiu_Enviar = True;
*/

  Ptr_Primitiva = Receber_Primitiva_N_MPDL ();
  #ifdef MSG
  Msg_Maq("Op_Mas_N");
  #endif
  switch (Ptr_Primitiva->Nome_Primitiva)
    {
    case MPDL_DATA_Request:
      if (Num_Elem_Lista_Quadros_Armazenados < Janela) // P6
        {
        Ns = Vs;  //A9
        if ((Inserir_na_Lista_de_Quadros_Armazenados(Ptr_Primitiva->Ptr_Parametros_Primitiva,Ns))
           && (Enviar_Quadro_I(Ptr_Primitiva->Ptr_Parametros_Primitiva,Ns)))
          {
          Vs++;
          Retirar_Primitiva_Fila_N_MPDL ();
          // Deveria reiniciar o Temp_TRQ aqui, mas iria diminuir a vazao.
          // A solucao foi faze-lo ao receber RR, verificando a variavel abaixo.
          quadro_transmitido = true;
          }
        else
          {
          Retirar_Primitiva_Fila_N_MPDL ();
          Enviar_Primitiva_N_MPDL (Ptr_Primitiva);
          }
          //Enviar_Rotina_Fila_Gerente_RMOSI (Tratar_Pedido_Servico_NMPDL, 0);

        // se for o primeiro quadro cria temp. de retransmissao
        if (prim_q_env)  // P3
          {
          if (!Reiniciar_Timer (Cod_Temp_TRQ,Tempo_TRQ))
            Criar_Timer (0,Tempo_TRQ,&Cod_Temp_TRQ);  // A68
          prim_q_env = false;
          }
       }
      else
        {
        estourou_janela=true;
//        Recolocar_Primitiva_Fila_N_MPDL ();
        Enviar_Rotina_Fila_Gerente_RMOSI (Tratar_Pedido_Servico_NMPDL, 0);
        }
      return;

    case MPDL_TOKEN_GIVE_Request: // Open_Master
      #ifdef MSG
      Msg_Status("MPDL: MPDL_TOKEN_GIVE_Request");
      #endif
      if (prim_fila == ult_fila) // P13
        {
        if (!Reiniciar_Timer (Cod_Temp_TMT,Tempo_TMT)) // A27
          Criar_Timer (0,Tempo_TMT,&Cod_Temp_TMT);
        Enviar_MPDL_TOKEN_GIVE_Ind (); // A58
        }
      else
        {
        for (i=1;i<=Num_Estacoes;i++)
          if (lista_part[i])
            Finalizar_Timer (&Cod_Temp_TI[i]); // A8

        Finalizar_Timer (&Cod_Temp_TMT);       // A28
        Finalizar_Timer (&Cod_Temp_TRQ);       // A70
        Enviar_MPDL_STOP_TRANSMISSION_Ind (); // A59
        id_nova_mestra=fila_esp[prim_fila];
        prim_fila=(prim_fila % Num_Estacoes)+1; // A24
        Num_Tentativas = 1;
        if (!Reiniciar_Timer (Cod_Temp_TR,Tempo_TR)) // A0
          Criar_Timer (0,Tempo_TR,&Cod_Temp_TR);
        Ns = Vs;
        if ((Ptr_Estrutura_PLIST=Alocar_Estrutura_Parametros_Tx())!=NULL)
          {
          if ((Ptr_Estrutura_PLIST->Ptr_Dados_Usuario=Alocar_Memoria_Tx (Num_Estacoes))!=NULL)
            {
            Ptr_Estrutura_PLIST->Ptr_Proximo=NULL;
            Ptr_Estrutura_PLIST->Ptr_Parametros=(unsigned char*) &Var_Cod_PLIST;
            memcpy(Ptr_Estrutura_PLIST->Ptr_Dados_Usuario,&lista_part[1],Num_Estacoes);
            Ptr_Estrutura_PLIST->Tam_Dados_Usuario=Num_Estacoes;

            if ((Inserir_na_Lista_de_Quadros_Armazenados(Ptr_Estrutura_PLIST, Ns))
               && (Enviar_PLIST(Ns)))
              Vs++;
            }
          else
            Liberar_Estrutura_Parametros_Tx(Ptr_Estrutura_PLIST);
          }
        for (i=1;i<=Num_Estacoes;i++)
          if (!lista_part[i]) prim_quadro_rec[i]=true;  //A71

        Enviar_TG(id_nova_mestra);
        Estado = AW_TK_REC;
        #ifdef MSG
        Msg_Maq(">AW_TK_REC");
        #endif
        }
      break;

    case MPDL_REPLAY_Request:        // Open_Master
      id_nova_mestra=*Ptr_Primitiva->Ptr_Parametros_Primitiva->Ptr_Parametros;
      Liberar_Memoria_Tx(Ptr_Primitiva->Ptr_Parametros_Primitiva->Ptr_Parametros,sizeof(unsigned char));
      Liberar_Estrutura_Parametros_Tx (Ptr_Primitiva->Ptr_Parametros_Primitiva);
      //memcpy(&id_nova_mestra,Ptr_Primitiva->Ptr_Parametros_Primitiva->Ptr_Parametros,sizeof(id_nova_mestra));

      if (!lista_part[id_nova_mestra]) // a estacao esta na lista de participantes?
        break;

      for (i=1;i<=Num_Estacoes;i++)
        if (lista_part[i])
          {
          Finalizar_Timer (&Cod_Temp_TI[i]);       // A8
          }
      Finalizar_Timer (&Cod_Temp_TMT);       // A28
      Finalizar_Timer (&Cod_Temp_TRQ);       // A70
      Retirar_da_Fila_de_Espera(id_nova_mestra);  // P12: A22
      Enviar_MPDL_STOP_TRANSMISSION_Ind();   // A59
      Num_Tentativas = 1;
      if (!Reiniciar_Timer (Cod_Temp_TR,Tempo_TR)) // A0
        Criar_Timer (0,Tempo_TR,&Cod_Temp_TR);

      Ns = Vs;
      if ((Ptr_Estrutura_PLIST=Alocar_Estrutura_Parametros_Tx())!=NULL)
        {
        if ((Ptr_Estrutura_PLIST->Ptr_Dados_Usuario=Alocar_Memoria_Tx (Num_Estacoes))!=NULL)
          {
          Ptr_Estrutura_PLIST->Ptr_Proximo=NULL;
          Ptr_Estrutura_PLIST->Ptr_Parametros=(unsigned char*) &Var_Cod_PLIST;
          memcpy(Ptr_Estrutura_PLIST->Ptr_Dados_Usuario,&lista_part[1],Num_Estacoes);
          Ptr_Estrutura_PLIST->Tam_Dados_Usuario=Num_Estacoes;

          if ((Inserir_na_Lista_de_Quadros_Armazenados(Ptr_Estrutura_PLIST, Ns))
             && (Enviar_PLIST(Ns)))
            Vs++;
          }
        else
          Liberar_Estrutura_Parametros_Tx(Ptr_Estrutura_PLIST);
        }
      for (i=1;i<=Num_Estacoes;i++)
        if (!lista_part[i]) prim_quadro_rec[i]=true;  //A71
      Enviar_TG(id_nova_mestra);
      break;

    case MPDL_ABORT_Request:         // Open_Master
      Finalizar_Timer (&Cod_Temp_TMT);            // A28
      Finalizar_Timer (&Cod_Temp_TIM);            // A66
      Finalizar_Timer (&Cod_Temp_TRQ);            // A70
      Descartar_Lista_de_Quadros_Armazenados ();    // A12

      // reinic. Mandou_Conf e finaliza temps. TI
      for (i = 1; (i <= Num_Estacoes); i++)
        {
        Descartar_Lista_Quadros_Esperados (i);       // A42
        Descartar_Lista_Quadros_Rec_Fora_Ordem (i);  // A43
        Finalizar_Timer (&Cod_Temp_TI [i]);       // A8
        }
      Enviar_MPDISC ();
      Num_Tentativas = 1;
      if (!Reiniciar_Timer (Cod_Temp_TR,Tempo_TR)) // A0
        Criar_Timer (0,Tempo_TR,&Cod_Temp_TR);

      #ifdef MSG
      Msg_Maq(">Aw_Rel_N");
      #endif
      Estado = AWAIT_REL;
      break;

    case MPDL_TOKEN_PLEASE_Request:  // Open_Master
      Enviar_MPDL_TOKEN_GIVE_Ind (); // A58
      break;

    case MPDL_ESTABLISH_Request:
      Enviar_MPDL_ESTABLISH_Conf (conferencia_nova);
      break;                   // A49    // => aplicacao mestra
                                         // => pode transmitir
    case MPDL_INDIVIDUAL_ABORT_Request:
      esperando_discac=*Ptr_Primitiva->Ptr_Parametros_Primitiva->Ptr_Parametros; // A72
      Liberar_Memoria_Tx(Ptr_Primitiva->Ptr_Parametros_Primitiva->Ptr_Parametros,sizeof(unsigned char));
      Liberar_Estrutura_Parametros_Tx (Ptr_Primitiva->Ptr_Parametros_Primitiva);
      Enviar_DISC (esperando_discac);
      Num_Tentativas = 1;
      if (!Reiniciar_Timer (Cod_Temp_TR,Tempo_TR)) // A0
        Criar_Timer (0,Tempo_TR,&Cod_Temp_TR);
      #ifdef MSG
      Msg_Maq(">Aw_U_R_N");
      #endif
      Estado = AW_UN_REL;
      break;


    } // fim do switch

  /* colocado dentro do case MPDL_DATA_Request => mais rapido
  if ((Conseguiu_Tratar_Primitiva) && (Conseguiu_Alocar) && (Conseguiu_Enviar))
  */
    Retirar_Primitiva_Fila_N_MPDL ();
  /*
  else
    Enviar_Rotina_Fila_Gerente_RMOSI (Tratar_Pedido_Servico_NMPDL, 0);
  */

 } // fim Tratar_OPEN_MASTER_NMPDL


void Tratar_Aw_Tk_Rec_NMPDL (void)
  {
  Ptr_Estrutura_Primitiva_N_MPDL   Ptr_Primitiva;
  Long     Ns;

  Ptr_Primitiva = Receber_Primitiva_N_MPDL ();
  #ifdef MSG
  Msg_Maq("Aw_Tk_R_N");
  #endif
  switch (Ptr_Primitiva->Nome_Primitiva)
    {
    case MPDL_DATA_Request:
      if (esperando_STOP_Resp)
        {
        if (Num_Elem_Lista_Quadros_Armazenados < Janela) // P6
          {
          Ns = Vs;
          if ((Inserir_na_Lista_de_Quadros_Armazenados(Ptr_Primitiva->Ptr_Parametros_Primitiva,Ns))
             && (Enviar_Quadro_I(Ptr_Primitiva->Ptr_Parametros_Primitiva,Ns)))
            {
            Vs++;
            Retirar_Primitiva_Fila_N_MPDL ();
            // Deveria reiniciar o Temp_TRQ aqui, mas iria diminuir a vazao.
            // A solucao foi faze-lo ao receber RR, verificando a variavel abaixo.
            quadro_transmitido = true;
            }
          else
            Enviar_Rotina_Fila_Gerente_RMOSI (Tratar_Pedido_Servico_NMPDL, 0);

          // se for o primeiro quadro cria temp. de retransmissao
          if (prim_q_env)  // P3
            {
            if (!Reiniciar_Timer (Cod_Temp_TRQ,Tempo_TRQ))
              Criar_Timer (0,Tempo_TRQ,&Cod_Temp_TRQ);  // A68
            prim_q_env = false;
            }
         }
        else
          {
          estourou_janela=true;
  //        Recolocar_Primitiva_Fila_N_MPDL ();
          Enviar_Rotina_Fila_Gerente_RMOSI (Tratar_Pedido_Servico_NMPDL, 0);
          }
        return;
        }

    case MPDL_STOP_TRANSMISSION_Response:
      Enviar_TG(id_nova_mestra);
      esperando_STOP_Resp=false;
      break;

    case MPDL_TOKEN_PLEASE_Request:   // Aw_Tk_Rec
      if (!Reiniciar_Timer (Cod_Temp_TKPR,Tempo_TKPR)) // A23
        Criar_Timer (0,Tempo_TKPR,&Cod_Temp_TKPR);
      pediu_ficha=true;
      break;

    case MPDL_ABORT_Request:            // Aw_Tk_Rec
      Enviar_MPDL_STOP_TRANSMISSION_Ind (); // A59
      break;

    case MPDL_IND_RELEASE_PLEASE_Request: // Aw_Tk_Rec
    case MPDL_RELEASE_PLEASE_Request:   // Aw_Tk_Rec
    case MPDL_TOKEN_GIVE_Request: // Aw_Tk_Rec
      // a ficha ja foi enviada: nada a fazer.
      break;

    case MPDL_INDIVIDUAL_ABORT_Request: // Aw_Tk_Rec
    case MPDL_REPLAY_Request:  // Aw_Tk_Rec
      Liberar_Memoria_Tx(Ptr_Primitiva->Ptr_Parametros_Primitiva->Ptr_Parametros,sizeof(unsigned char));
      Liberar_Estrutura_Parametros_Tx (Ptr_Primitiva->Ptr_Parametros_Primitiva);
      Enviar_MPDL_STOP_TRANSMISSION_Ind (); // A59
      break;
    }
  Retirar_Primitiva_Fila_N_MPDL ();
  }  // Tratar_Aw_Tk_Rec_NMPDL


void Tratar_Closed_NMPDL (void)  // ok 2
  {
  Ptr_Estrutura_Primitiva_N_MPDL   Ptr_Primitiva;
  unsigned char                     i;

  Ptr_Primitiva = Receber_Primitiva_N_MPDL ();
  #ifdef MSG
  Msg_Maq("Closed_N");
  #endif
  switch (Ptr_Primitiva->Nome_Primitiva)
    {
    case MPDL_ESTABLISH_Request:
       if (canal_p_ocupado)  // P21
         {
         Enviar_SMPARM (id_mestra);
         #ifdef MSG
         Msg_Status("MPDL_ESTABLISH_Request: CLOSED => ESTABLISH_REC");
         Msg_Maq(">Est_R_N");
         #endif
         Estado = ESTABLISH_REC;
         }
       else
         {
         for (i = 1; i <= Num_Estacoes; i++)
           {
           Mandou_Conf [i] = false;
           lista_part[i] = false;
           fila_esp[i] = 0;
           }
         num_part=0;
         prim_fila=1;
         ult_fila=1;
         falta_mandar_conf=Num_Estacoes-1;
         Enviar_SMPARM (0xFF); // para todas
         #ifdef MSG
         Msg_Status("MPDL_ESTABLISH_Request: CLOSED => ESTABLISH");
         Msg_Maq(">Estab_N");
         #endif
         Estado = ESTABLISH;
         }
       if (!Reiniciar_Timer (Cod_Temp_TR, Tempo_TR))
         Criar_Timer (0,Tempo_TR,&Cod_Temp_TR);
       Num_Tentativas = 1;
       break;

    case MPDL_ABORT_Request:
       Enviar_MPDL_ABORT_Conf ();
       break;

    case MPDL_DATA_Request:
      Msg_Status("MPDL(CLOSED): Dados perdidos"); // na tentativa de transmissao sem permissao");
       // Nada a fazer
       Liberar_Estrutura_Parametros_Tx (Ptr_Primitiva->Ptr_Parametros_Primitiva);
       break;

    } // fim do switch
  Retirar_Primitiva_Fila_N_MPDL ();

  } // fim Tratar_Closed_NMPDL


void Tratar_Establish_NMPDL (void)  // ok 2
  {
  Ptr_Estrutura_Primitiva_N_MPDL   Ptr_Primitiva;
  unsigned char                  i;

  Ptr_Primitiva = Receber_Primitiva_N_MPDL ();
  #ifdef MSG
  Msg_Maq("Estab_N");
  #endif
  switch (Ptr_Primitiva->Nome_Primitiva)
    {
    case MPDL_ESTABLISH_Request:
      // nada a fazer
      break;

    case MPDL_ABORT_Request:
      // reinicializa Mandou_Conf
      for (i = 1; (i <= Num_Estacoes); i++)
        Mandou_Conf [i] = False;            // A5
      if (num_part > 1)
        falta_mandar_conf=num_part;
      else
        falta_mandar_conf=Num_Estacoes-1;

      Enviar_MPDISC ();

      Num_Tentativas = 1;                          // A4
      if (!Reiniciar_Timer (Cod_Temp_TR,Tempo_TR)) // existe tempo_TR?
        Criar_Timer (0,Tempo_TR,&Cod_Temp_TR);    // se nao
      #ifdef MSG
      Msg_Maq(">Aw_Rel_N");
      #endif
      Estado = AWAIT_REL;
      break;

    case MPDL_DATA_Request:
      Msg_Status("MPDL(Establish): Dados perdidos"); // na tentativa de transmissao sem permissao");
      // Nada a fazer
      Liberar_Estrutura_Parametros_Tx (Ptr_Primitiva->Ptr_Parametros_Primitiva);
      break;

    } // fim do switch
  Retirar_Primitiva_Fila_N_MPDL ();

  } // fim Tratar_Establish_NMPDL


void Tratar_Establish_Rec_NMPDL (void) // ok 2
  {
  Ptr_Estrutura_Primitiva_N_MPDL   Ptr_Primitiva;

  Ptr_Primitiva = Receber_Primitiva_N_MPDL ();
  #ifdef MSG
  Msg_Maq("EstabRec_N");
  #endif
  switch (Ptr_Primitiva->Nome_Primitiva)
    {
    case MPDL_TOKEN_PLEASE_Request:  // Establish_Rec
      pediu_ficha=true;
      if (!Reiniciar_Timer (Cod_Temp_TKPR,Tempo_TKPR)) // A23
        Criar_Timer (0,Tempo_TKPR,&Cod_Temp_TKPR);
      break;

    case MPDL_IND_RELEASE_PLEASE_Request: // Establish_Rec
      Enviar_RP();
      break;

    case MPDL_DATA_Request:               // Establish_Rec
      Msg_Status("MPDL(Estab_Rec): Dados perdidos"); // na tentativa de transmissao sem permissao");
      Liberar_Estrutura_Parametros_Tx (Ptr_Primitiva->Ptr_Parametros_Primitiva);
      Enviar_MPDL_STOP_TRANSMISSION_Ind (); // A59
//      Enviar_TP();
//      if (!Reiniciar_Timer (Cod_Temp_TKPR,Tempo_TKPR)) // A23
//        Criar_Timer (0,Tempo_TKPR,&Cod_Temp_TKPR);
//      Enviar_Rotina_Fila_Gerente_RMOSI (Tratar_Pedido_Servico_NMPDL, 0);
      break;       // A14

    case MPDL_ABORT_Request:              // Establish_Rec
      Enviar_MPDL_STOP_TRANSMISSION_Ind (); // A59
      break;

    case MPDL_RELEASE_PLEASE_Request:
      Enviar_MPRP ();
      break;

    case MPDL_INDIVIDUAL_ABORT_Request:
      Liberar_Memoria_Tx(Ptr_Primitiva->Ptr_Parametros_Primitiva->Ptr_Parametros,sizeof(unsigned char));
      Liberar_Estrutura_Parametros_Tx (Ptr_Primitiva->Ptr_Parametros_Primitiva);
      Enviar_MPDL_STOP_TRANSMISSION_Ind (); // A59
      break;

    case MPDL_TOKEN_GIVE_Request:         // Establish_Rec
      Enviar_MPDL_STOP_TRANSMISSION_Ind (); // A59
      break;

    case MPDL_REPLAY_Request:             // Establish_Rec
      Liberar_Memoria_Tx(Ptr_Primitiva->Ptr_Parametros_Primitiva->Ptr_Parametros,sizeof(unsigned char));
      Liberar_Estrutura_Parametros_Tx (Ptr_Primitiva->Ptr_Parametros_Primitiva);
      Enviar_MPDL_STOP_TRANSMISSION_Ind (); // A59
      break;

    } // fim do switch
  Retirar_Primitiva_Fila_N_MPDL ();

  } // fim Tratar_Establish_Rec_NMPDL


void Tratar_Aw_Un_Rel_NMPDL (void)
  {
  Ptr_Estrutura_Primitiva_N_MPDL   Ptr_Primitiva;
  Ptr_Estrutura_Parametros         Ptr_Estrutura_PLIST;
  unsigned char                  i;
  Long                           Ns;

  Ptr_Primitiva = Receber_Primitiva_N_MPDL ();
  #ifdef MSG
  Msg_Maq("Aw_Un_Re_N");
  #endif
  switch (Ptr_Primitiva->Nome_Primitiva)
    {
    case MPDL_DATA_Request:
      if (Num_Elem_Lista_Quadros_Armazenados < Janela) // P6
        {
        Ns = Vs;
        if ((Inserir_na_Lista_de_Quadros_Armazenados(Ptr_Primitiva->Ptr_Parametros_Primitiva,Ns))
           && (Enviar_Quadro_I(Ptr_Primitiva->Ptr_Parametros_Primitiva,Ns)))
          {
          Vs++;
          Retirar_Primitiva_Fila_N_MPDL ();
          // Deveria reiniciar o Temp_TRQ aqui, mas iria diminuir a vazao.
          // A solucao foi faze-lo ao receber RR, verificando a variavel abaixo.
          quadro_transmitido = true;
          }
        else
          Enviar_Rotina_Fila_Gerente_RMOSI (Tratar_Pedido_Servico_NMPDL, 0);

        // se for o primeiro quadro cria temp. de retransmissao
        if (prim_q_env)  // P3
          {
          if (!Reiniciar_Timer (Cod_Temp_TRQ,Tempo_TRQ))
            Criar_Timer (0,Tempo_TRQ,&Cod_Temp_TRQ);  // A68
          prim_q_env = false;
          }
       }
      else
        {
        estourou_janela=true;
//        Recolocar_Primitiva_Fila_N_MPDL ();
        Enviar_Rotina_Fila_Gerente_RMOSI (Tratar_Pedido_Servico_NMPDL, 0);
        }

      return;

    case MPDL_TOKEN_GIVE_Request: // Await_Unique_Rel
      if (prim_fila == ult_fila) // P13
        {
        if (!Reiniciar_Timer (Cod_Temp_TMT,Tempo_TMT)) // A27
          Criar_Timer (0,Tempo_TMT,&Cod_Temp_TMT);
        Enviar_MPDL_TOKEN_GIVE_Ind (); // A58
        }
      else
        {
        Finalizar_Timer (&Cod_Temp_TMT);       // A28
        Finalizar_Timer (&Cod_Temp_TRQ);       // A70
        Enviar_MPDL_STOP_TRANSMISSION_Ind (); // A59
        if (esperando_discac==fila_esp[prim_fila]) // P12: A22
          prim_fila=(prim_fila % Num_Estacoes)+1;
        id_nova_mestra=fila_esp[prim_fila];
        prim_fila=(prim_fila % Num_Estacoes)+1; // A24
        Num_Tentativas = 1;
        if (lista_part[esperando_discac])
          {
          lista_part[esperando_discac]=false;
          num_part--;
          esperando_discac=0;
          }
        if (num_part<2)
          {
          Enviar_MPDISC();
          Enviar_MPDL_ABORT_Ind(LVZ);
          Reiniciar_Camada_MPDL();  // A42 A43 A8 A28 A66 A70 A12 A76 => CLOSED
          break;
          }
        if (!Reiniciar_Timer (Cod_Temp_TR,Tempo_TR)) // A0
          Criar_Timer (0,Tempo_TR,&Cod_Temp_TR);
        Ns = Vs;
        if ((Ptr_Estrutura_PLIST=Alocar_Estrutura_Parametros_Tx())!=NULL)
          {
          if ((Ptr_Estrutura_PLIST->Ptr_Dados_Usuario=Alocar_Memoria_Tx (Num_Estacoes))!=NULL)
            {
            Ptr_Estrutura_PLIST->Ptr_Proximo=NULL;
            Ptr_Estrutura_PLIST->Ptr_Parametros=(unsigned char*) &Var_Cod_PLIST;
            memcpy(Ptr_Estrutura_PLIST->Ptr_Dados_Usuario,&lista_part[1],Num_Estacoes);
            Ptr_Estrutura_PLIST->Tam_Dados_Usuario=Num_Estacoes;

            if ((Inserir_na_Lista_de_Quadros_Armazenados(Ptr_Estrutura_PLIST, Ns))
               && (Enviar_PLIST(Ns)))
              Vs++;
            }
          else
            Liberar_Estrutura_Parametros_Tx(Ptr_Estrutura_PLIST);
          }
        for (i=1;i<=Num_Estacoes;i++)
          if (lista_part[i])
            Finalizar_Timer (&Cod_Temp_TI [i]); // A8
          else
            prim_quadro_rec[i]=true;  //A71
        Enviar_TG(id_nova_mestra);
        #ifdef MSG
        Msg_Maq(">Aw_Tk_R_N");
        #endif
        Estado = AW_TK_REC;
        }
      break;

    case MPDL_REPLAY_Request:        // Await_Unique_Rel
      i=*Ptr_Primitiva->Ptr_Parametros_Primitiva->Ptr_Parametros;
      Liberar_Memoria_Tx(Ptr_Primitiva->Ptr_Parametros_Primitiva->Ptr_Parametros,sizeof(unsigned char));
      Liberar_Estrutura_Parametros_Tx (Ptr_Primitiva->Ptr_Parametros_Primitiva);
      if ((esperando_discac==i)||(!lista_part[i])) //N(NP27: P10)
        break;
      id_nova_mestra=i;

      // Retira a estacao da fila de espera  P16: A22
      if (prim_fila != ult_fila)
        {
        for (i=prim_fila;(i!=ult_fila)&&(fila_esp[i]!=id_nova_mestra);)
          i=i++%Num_Estacoes;
        if (fila_esp[i]==id_nova_mestra)
          {
          for (;i!=ult_fila;)
            {
            fila_esp[i]=fila_esp[i%Num_Estacoes+1];
            i=i++%Num_Estacoes;
            }
          ult_fila--;
          if (ult_fila==0)
            ult_fila=Num_Estacoes;
          } // (fila_esp[i]==id_nova_mestra)
        } // (prim_fila != ult_fila)

      Finalizar_Timer (&Cod_Temp_TMT);      // A28
      Finalizar_Timer (&Cod_Temp_TRQ);      // A70
      for (i = 1; (i <= Num_Estacoes); i++)
        Finalizar_Timer (&Cod_Temp_TI [i]); // A8
      Enviar_MPDL_STOP_TRANSMISSION_Ind (); // A59
      Num_Tentativas = 1;
      if (!Reiniciar_Timer (Cod_Temp_TR,Tempo_TR)) // A0
        Criar_Timer (0,Tempo_TR,&Cod_Temp_TR);
      Ns = Vs;
      if ((Ptr_Estrutura_PLIST=Alocar_Estrutura_Parametros_Tx())!=NULL)
        {
        if ((Ptr_Estrutura_PLIST->Ptr_Dados_Usuario=Alocar_Memoria_Tx (Num_Estacoes))!=NULL)
          {
          Ptr_Estrutura_PLIST->Ptr_Proximo=NULL;
          Ptr_Estrutura_PLIST->Ptr_Parametros=(unsigned char*) &Var_Cod_PLIST;
          memcpy(Ptr_Estrutura_PLIST->Ptr_Dados_Usuario,&lista_part[1],Num_Estacoes);
          Ptr_Estrutura_PLIST->Tam_Dados_Usuario=Num_Estacoes;

          if ((Inserir_na_Lista_de_Quadros_Armazenados(Ptr_Estrutura_PLIST, Ns))
             && (Enviar_PLIST(Ns)))
            Vs++;
          }
        else
          Liberar_Estrutura_Parametros_Tx(Ptr_Estrutura_PLIST);
        }
      for (i=1;i<=Num_Estacoes;i++)
        if (!lista_part[i]) prim_quadro_rec[i]=true;  //A71
      Enviar_TG(id_nova_mestra);
      Estado = AW_TK_REC;
      break;

    case MPDL_ABORT_Request:         // Await_Unique_Rel
      Finalizar_Timer (&Cod_Temp_TMT);            // A28
      Finalizar_Timer (&Cod_Temp_TIM);            // A66
      Finalizar_Timer (&Cod_Temp_TRQ);            // A70
      Descartar_Lista_de_Quadros_Armazenados ();    // A12

      // reinic. Mandou_Conf e finaliza temps. TI
      for (i = 1; (i <= Num_Estacoes); i++)
        {
        Descartar_Lista_Quadros_Esperados (i);       // A42
        Descartar_Lista_Quadros_Rec_Fora_Ordem (i);  // A43
        Mandou_Conf [i] = False;
        Finalizar_Timer (&Cod_Temp_TI [i]);       // A8
        }
      falta_mandar_conf = num_part-1;
      Enviar_MPDISC ();
      Num_Tentativas = 1;
      if (!Reiniciar_Timer (Cod_Temp_TR,Tempo_TR)) // A0
        Criar_Timer (0,Tempo_TR,&Cod_Temp_TR);

      Estado = AWAIT_REL;
      #ifdef MSG
      Msg_Maq(">Aw_Rel_N");
      #endif
      break;

    case MPDL_TOKEN_PLEASE_Request:  // Await_Unique_Rel
      Enviar_MPDL_TOKEN_GIVE_Ind (); // A58
      break;

    case MPDL_ESTABLISH_Request:
      Enviar_MPDL_ESTABLISH_Conf (conferencia_nova);
      break;                   // A49    // => aplicacao mestra
                                         // => pode transmitir
    case MPDL_INDIVIDUAL_ABORT_Request:
      Liberar_Memoria_Tx(Ptr_Primitiva->Ptr_Parametros_Primitiva->Ptr_Parametros,sizeof(unsigned char));
      Liberar_Estrutura_Parametros_Tx (Ptr_Primitiva->Ptr_Parametros_Primitiva);
      break;

    } // fim do switch

    Retirar_Primitiva_Fila_N_MPDL ();

 } // fim Tratar_Aw_Un_Rel_NMPDL


void Tratar_Await_Rel_NMPDL (void)
  {
  Ptr_Estrutura_Primitiva_N_MPDL   Ptr_Primitiva;

  Ptr_Primitiva = Receber_Primitiva_N_MPDL ();
  #ifdef MSG
  Msg_Maq("Aw_Rele_N");
  #endif
  switch (Ptr_Primitiva->Nome_Primitiva)
    {
    case MPDL_TOKEN_PLEASE_Request:
    case MPDL_IND_RELEASE_PLEASE_Request:
    case MPDL_RELEASE_PLEASE_Request:
    case MPDL_TOKEN_GIVE_Request:
      Enviar_MPDL_STOP_TRANSMISSION_Ind (); // A59
      break;

    case MPDL_DATA_Request:
      Msg_Status("MPDL(Aw_Un_Rel): Dados perdidos"); // na tentativa de transmissao sem permissao");
      Liberar_Estrutura_Parametros_Tx (Ptr_Primitiva->Ptr_Parametros_Primitiva);
      Enviar_MPDL_STOP_TRANSMISSION_Ind (); // A59
      break;

    case MPDL_INDIVIDUAL_ABORT_Request:
    case MPDL_REPLAY_Request:
      Liberar_Memoria_Tx(Ptr_Primitiva->Ptr_Parametros_Primitiva->Ptr_Parametros,sizeof(unsigned char));
      Liberar_Estrutura_Parametros_Tx (Ptr_Primitiva->Ptr_Parametros_Primitiva);
      Enviar_MPDL_STOP_TRANSMISSION_Ind (); // A59
      break;

    case MPDL_ABORT_Request:
      Enviar_MPDISC ();
      break;

    } // fim do switch
  Retirar_Primitiva_Fila_N_MPDL ();

  } // fim Tratar_Await_Rel_NMPDL

/***************************************************************************/
/*                                                                         */
/*    Ponto de entrada do escalonador  (Fila MACMPDL)                      */
/*                                                                         */
/***************************************************************************/

void Maquina_Estados_MAC_LLC(void)
  {
  switch (Estado)
    {
    case OPEN_REC      : Tratar_Open_Rec_MACMPDL ();      break;
    case OPEN_MASTER   : Tratar_Open_Master_MACMPDL ();   break;
    case AW_TK_REC     : Tratar_Aw_Tk_Rec_MACMPDL ();     break;
    case AW_UN_REL     : Tratar_Aw_Un_Rel_MACMPDL ();     break;
    case CLOSED        : Tratar_Closed_MACMPDL ();        break;
    case ESTABLISH     : Tratar_Establish_MACMPDL ();     break; //ok 2
    case ESTABLISH_REC : Tratar_Establish_Rec_MACMPDL (); break;
    case AWAIT_REL     : Tratar_Await_Rel_MACMPDL ();     break;
    default: printf ("??? Estado nao esperado em Maquina_Estados_MAC_LLC: %2d",Estado);
    } // fim do switch

  } // fim Maquina_Estados_MAC_LLC


/***************************************************************************/
/*                                                                         */
/*    Rotinas que tratam o recebimento das primitivas MACMPDL (PDU's)      */
/*                                                                         */
/***************************************************************************/

void Tratar_Closed_MACMPDL (void)
  {
  Ptr_Estrutura_Primitiva_M_L    Ptr_Primitiva;
  unsigned char                  id_fonte;

  Ptr_Primitiva = Receber_Primitiva_M_L ();
  #ifdef MSG
  Msg_Maq("Closed");
  #endif
  if (Ptr_Primitiva->Nome_Primitiva == MA_DATA_Indication)
    {
    id_fonte=Ptr_Primitiva->Ptr_Parametros_Primitiva->Info[0];
    switch (Decodificar_PDU (Ptr_Primitiva->Ptr_Parametros_Primitiva))
      {
      case Cod_SMPARM:    // CLOSED
        Enviar_MPDL_ESTABLISH_Ind(id_fonte); // A48
        mestra=false;                        // A16
        id_mestra=id_fonte;                  // A63
        if (!Reiniciar_Timer (Cod_Temp_TACK,Tempo_TACK))
          Criar_Timer(0,Tempo_TACK,&Cod_Temp_TACK); // A38
        Criar_Timer(0,Tempo_TIP,&Cod_Temp_TIP); // A17
        num_tent_TIP = 1;
        Enviar_MPARMAC(id_fonte);
        lista_part[id_est]=true;
        lista_part[id_fonte]=true;  // A15
        num_part=2;
        #ifdef MSG
        Msg_Status("SMPARM: CLOSED => OPEN_REC");
        #endif
        Estado=OPEN_REC;
        break;

      case Cod_DISC:    // CLOSED
        Enviar_DISCAC(id_fonte);
        break;

      case Cod_MPDISC:
        Enviar_MPDISCAC(id_fonte);
        canal_p_ocupado=false;  // A62

      } // fim switch
    } // fim if primitiva

  if (Ptr_Primitiva->Nome_Primitiva == MA_DATA_Indication)
    {
    Dealocar_Fila_Primitivas_M_L ();
    Dealocar_Quadro_Buffer_Rx ();
    }
  else
    Dealocar_Fila_Primitivas_M_L ();
  }



void Tratar_Await_Rel_MACMPDL (void)
  {
  Ptr_Estrutura_Primitiva_M_L    Ptr_Primitiva;
  Long                           Nr;
  unsigned char                  id_fonte;

  Ptr_Primitiva = Receber_Primitiva_M_L ();
  #ifdef MSG
  Msg_Maq("Aw_Rel");
  #endif
  if (Ptr_Primitiva->Nome_Primitiva == MA_DATA_Indication)
    {
    id_fonte=Ptr_Primitiva->Ptr_Parametros_Primitiva->Info[0];
    switch (Decodificar_PDU (Ptr_Primitiva->Ptr_Parametros_Primitiva))
      {
      case Cod_MPDISCAC:    // Await_Rel
        if (lista_part[id_fonte]) // P10
          {
          lista_part[id_fonte]=false; // A18
          num_part--;
          if (num_part<2)  // P11
            {
            Enviar_MPDL_ABORT_Conf();       // A51
            Finalizar_Timer (&Cod_Temp_TR); // A6
            Reiniciar_Camada_MPDL();  // A42 A43 A8 A28 A66 A70 A12 A76 => CLOSED
            }
          }
        break;

      case Cod_SREJ:   // Await_Rel
        if (!Reiniciar_Timer (Cod_Temp_TI [id_fonte],Tempo_TI))
           Criar_Timer (0,Tempo_TI,&Cod_Temp_TI[id_fonte]);
        if (quadro_transmitido)  // P28
          {
          quadro_transmitido=false;
          if (!Reiniciar_Timer (Cod_Temp_TRQ,Tempo_TRQ))    // A69
            Criar_Timer (0,Tempo_TRQ,&Cod_Temp_TRQ);
          if (!Reiniciar_Timer (Cod_Temp_TIM, Tempo_TIM))  // A65
            Criar_Timer (0,Tempo_TIM,&Cod_Temp_TIM);
          }
        Nr = Ler_Long (&(Ptr_Primitiva->Ptr_Parametros_Primitiva->Info[3]));
        Retransmitir_Quadro (Nr);
        num_srej++;
        break;

      case Cod_SMPARM:
      case Cod_RP:
      case Cod_TP:
      case Cod_CM:
      case Cod_MPRP:
        Enviar_MPDISC();
/*
     case Cod_MPI:
     case Cod_RR:
     case Cod_PLIST:
     case Cod_TG:
     case Cod_BM:
     case Cod_MPARMAC:
     case Cod_MPDISC:
     case Cod_DISC:
     case Cod_DISCAC:
      break;
*/
      } // fim switch
    } // fim if primitiva

  if (Ptr_Primitiva->Nome_Primitiva == MA_DATA_Indication)
    {
    Dealocar_Fila_Primitivas_M_L ();
    Dealocar_Quadro_Buffer_Rx ();
    }
  else
    Dealocar_Fila_Primitivas_M_L ();
  }


void Tratar_Establish_Rec_MACMPDL (void)
  {
  Ptr_Estrutura_Primitiva_M_L    Ptr_Primitiva;
  unsigned char                  id_fonte;
  Tipo_Lista                     aux_lista_part;


  Ptr_Primitiva = Receber_Primitiva_M_L ();
  #ifdef MSG
  Msg_Maq("Estab_Rec");
  #endif
  if (Ptr_Primitiva->Nome_Primitiva == MA_DATA_Indication)
    {
    id_fonte=Ptr_Primitiva->Ptr_Parametros_Primitiva->Info[0];
    switch (Decodificar_PDU (Ptr_Primitiva->Ptr_Parametros_Primitiva))
      {
      case Cod_BM:  // Establish_Rec
        id_mestra=id_fonte; // A63
        break;

      case Cod_DISC:      // Establish_Rec
        Finalizar_Timer(&Cod_Temp_TACK);  // A40
        Enviar_MPDL_INDIVIDUAL_ABORT_Ind(id_est); // A54
        Enviar_DISCAC(id_fonte);
        Reiniciar_Camada_MPDL(); // A42 A43 A8 A28 A66 A70 A12 A76 => CLOSED
        break;

      case Cod_MPARMAC:  // Establish_Rec
        if (Ptr_Primitiva->Ptr_Parametros_Primitiva->Info[3]) // P21
          {
          Finalizar_Timer (&Cod_Temp_TR); // A6
          mestra=false;  // A16
          id_mestra=id_fonte; // A63
          Num_Tentativas=1;
          lista_part [id_fonte] = True; // A15
          lista_part [id_est] = true;
          num_part+=2;
          Enviar_MPDL_ESTABLISH_Conf(conferencia_em_andamento);  // A49
          num_tent_TIP=1;
          Criar_Timer (0,Tempo_TIP,&Cod_Temp_TIP); //A17
          Criar_Timer (0,Tempo_TACK,&Cod_Temp_TACK); //A38
          Estado = OPEN_REC;
          #ifdef MSG
          Msg_Maq(">Open_rec");
          #endif
          }
        break;

      case Cod_MPDISC:   // Establish_Rec
        Enviar_MPDL_ABORT_Ind(USU);  // A50
        Enviar_MPDISCAC(id_fonte);
        Reiniciar_Camada_MPDL(); // A42 A43 A8 A28 A66 A70 A12 A76 => CLOSED
        break;

      case Cod_PLIST:  // Establish_Rec
        memcpy(&aux_lista_part[1],&Ptr_Primitiva->Ptr_Parametros_Primitiva->Info[7],Num_Estacoes);
        id_mestra=id_fonte;   // A63
        if (!aux_lista_part [id_est]) // NP24
          {
          Enviar_SMPARM(id_fonte);
          if (!Reiniciar_Timer (Cod_Temp_TR,Tempo_TR)) // A0
            Criar_Timer (0,Tempo_TR,&Cod_Temp_TR);
          }
        break;
/*
      case Cod_CM:        // Establish_Rec
        break;

      case Cod_MPI:  // Establish_Rec
        break;

      case Cod_RR:   // Establish_Rec
        break;

      case Cod_SREJ:  // Establish_Rec:
        break;

      case Cod_TG:  // Establish_Rec
        break;

      case Cod_DISCAC:    // Establish_Rec
      case Cod_MPDISCAC:  // Establish_Rec
      case Cod_MPRP:      // Establish_Rec
      case Cod_SMPARM:  // Establish_Rec
      case Cod_RP:        // Establish_Rec

     case Cod_TP:        // Establish_Rec
       break;
*/
      } // fim switch
    } // fim if primitiva

  if (Ptr_Primitiva->Nome_Primitiva == MA_DATA_Indication)
    {
    Dealocar_Fila_Primitivas_M_L ();
    Dealocar_Quadro_Buffer_Rx ();
    }
  else
    Dealocar_Fila_Primitivas_M_L ();

  }  // fim Tratar_Establish_Rec_MACMPDL



void Tratar_Aw_Un_Rel_MACMPDL (void)
  {
  Ptr_Estrutura_Primitiva_M_L    Ptr_Primitiva;
  Ptr_Estrutura_Parametros       Ptr_Estrutura_PLIST;
  unsigned char                  i, id_fonte;
  Long                           Ns, Nr;

  Ptr_Primitiva = Receber_Primitiva_M_L ();
  #ifdef MSG
  Msg_Maq("Aw_Un_Rel");
  #endif
  if (Ptr_Primitiva->Nome_Primitiva == MA_DATA_Indication)
    {
    id_fonte=Ptr_Primitiva->Ptr_Parametros_Primitiva->Info[0];
    switch (Decodificar_PDU (Ptr_Primitiva->Ptr_Parametros_Primitiva))
      {
      case Cod_RR:     // Aw_Un_Rel
        if (!Reiniciar_Timer (Cod_Temp_TI [id_fonte],Tempo_TI)) // A3
           Criar_Timer (0,Tempo_TI,&Cod_Temp_TI[id_fonte]);
        if (quadro_transmitido)                            // P28
          {
          quadro_transmitido=false;
          if (!Reiniciar_Timer (Cod_Temp_TIM, Tempo_TIM))  // A65
            Criar_Timer (0,Tempo_TIM,&Cod_Temp_TIM);
          }
        Nr = Ler_Long (&(Ptr_Primitiva->Ptr_Parametros_Primitiva->Info[3]));
        Verificar_Descarte_Quadros (id_fonte,Nr);  // P4: A10 A69
        break;

      case Cod_SREJ:   // Aw_Un_Rel
        if (!Reiniciar_Timer (Cod_Temp_TI [id_fonte],Tempo_TI))  // A3
           Criar_Timer (0,Tempo_TI,&Cod_Temp_TI[id_fonte]);
        if (quadro_transmitido)  // P28
          {
          quadro_transmitido=false;
          if (!Reiniciar_Timer (Cod_Temp_TRQ,Tempo_TRQ))    // A69
            Criar_Timer (0,Tempo_TRQ,&Cod_Temp_TRQ);
          if (!Reiniciar_Timer (Cod_Temp_TIM, Tempo_TIM))  // A65
            Criar_Timer (0,Tempo_TIM,&Cod_Temp_TIM);
          }
        Nr = Ler_Long (&(Ptr_Primitiva->Ptr_Parametros_Primitiva->Info[3]));
        Retransmitir_Quadro (Nr);  //  P22
        num_srej++;
        break;

      case Cod_SMPARM:   // Aw_Un_Rel
        if (id_fonte!=esperando_discac)
          {
          if (!lista_part[id_fonte])             // NP10
            {
            lista_part[id_fonte]=true;           // A15
            num_part++;
            Enviar_MPDL_ESTABLISH_Ind(id_fonte); // A48
            }
          Ns = Vs;                          //  PLIST
          if ((Ptr_Estrutura_PLIST=Alocar_Estrutura_Parametros_Tx())!=NULL)
            {
            if ((Ptr_Estrutura_PLIST->Ptr_Dados_Usuario=Alocar_Memoria_Tx (Num_Estacoes))!=NULL)
              {
              Ptr_Estrutura_PLIST->Ptr_Proximo=NULL;
              Ptr_Estrutura_PLIST->Ptr_Parametros=(unsigned char*) &Var_Cod_PLIST;
              memcpy(Ptr_Estrutura_PLIST->Ptr_Dados_Usuario,&lista_part[1],Num_Estacoes);
              Ptr_Estrutura_PLIST->Tam_Dados_Usuario=Num_Estacoes;

              if ((Inserir_na_Lista_de_Quadros_Armazenados(Ptr_Estrutura_PLIST, Ns))
                 && (Enviar_PLIST(Ns)))
                Vs++;
              }
            else
              Liberar_Estrutura_Parametros_Tx(Ptr_Estrutura_PLIST);
            }
          Enviar_MPARMAC(id_fonte);
          Coloca_na_Fila(id_fonte); // A19
          if (!Reiniciar_Timer (Cod_Temp_TI[id_fonte],Tempo_TI))
            Criar_Timer (0,Tempo_TI,&Cod_Temp_TI [id_fonte]);  // A20
          }
        else
          Enviar_DISC(id_fonte);
        break;

      case Cod_MPDISC:   // Aw_Un_Rel
        Enviar_MPDL_ABORT_Ind(ERR);                // A50
        Enviar_MPDISCAC(id_fonte);
        Reiniciar_Camada_MPDL(); // A42 A43 A8 A28 A66 A70 A12 A76 => CLOSED
        break;

      case Cod_MPRP:   // Aw_Un_Rel
        Enviar_MPDL_RELEASE_PLEASE_Ind(id_fonte);  // A52
        break;

      case Cod_DISC:   // Aw_Un_Rel
        Enviar_MPDL_ABORT_Ind(ERR);
        Enviar_DISCAC(id_fonte);
        Reiniciar_Camada_MPDL(); // A42 A43 A8 A28 A66 A70 A12 A76 => CLOSED
        break;

      case Cod_RP:     // Aw_Un_Rel
        Enviar_MPDL_IND_RELEASE_PLEASE_Ind(id_fonte);  // A56
        break;

      case Cod_TP:     // Aw_Un_Rel
        if (lista_part[id_fonte])  // P10
          {
          Enviar_MPDL_TOKEN_PLEASE_Ind (id_fonte);
          Coloca_na_Fila(id_fonte); // NP12: A19
          }
        break;

      case Cod_TG:     // Aw_Un_Rel
        if (id_est==Ptr_Primitiva->Ptr_Parametros_Primitiva->Info[3]) // P14
          {
          Enviar_BM();
          Enviar_BM();
          if (!Reiniciar_Timer (Cod_Temp_TI[id_fonte],Tempo_TI))
             Criar_Timer (0,Tempo_TI,&Cod_Temp_TI[id_fonte]);  // A20
          }
        else
          {
          Enviar_MPDL_STOP_TRANSMISSION_Ind();  // A59
          Finalizar_Timer (&Cod_Temp_TRQ);      // A70
          if (!Prim_Lista_Quadros_Armazenados)  // P5  se vazia, ptr==NULL
            {
            Finalizar_Timer (&Cod_Temp_TR);     // A6
            }
          else
            if (!Reiniciar_Timer (Cod_Temp_TR,Tempo_TR))
              Criar_Timer (0,Tempo_TR,&Cod_Temp_TR);// A0
          for (i=1;i<=Num_Estacoes;i++)
            Finalizar_Timer (&Cod_Temp_TI[i]);      // A8
          id_mestra=id_fonte;                       // A63
          mestra=false;                             // A16
          num_tent_TIP=1;
          Criar_Timer (0,Tempo_TIP,&Cod_Temp_TIP);  // A17
          Criar_Timer (0,Tempo_TACK,&Cod_Temp_TACK);// A38
          Estado = OPEN_REC;
          #ifdef MSG
          Msg_Maq(">Open_Rec");
          #endif
          }
        break;

      case Cod_BM:     // Aw_Un_Rel
        if (id_fonte<id_est)  // P9
          {
          Enviar_MPDL_STOP_TRANSMISSION_Ind();  // A59
          Finalizar_Timer (&Cod_Temp_TRQ);       // A70
          if (!Prim_Lista_Quadros_Armazenados)   // P5
            Finalizar_Timer (&Cod_Temp_TR);      // A6
          else
            if (!Reiniciar_Timer (Cod_Temp_TR,Tempo_TR))
              Criar_Timer (0,Tempo_TR,&Cod_Temp_TR);// A0
          for (i=1;i<=Num_Estacoes;i++)
            Finalizar_Timer (&Cod_Temp_TI[i]);        // A8
          num_tent_TIP=1;
          id_mestra=id_fonte; // A63
          mestra=false;   // A16
          Criar_Timer (0,Tempo_TACK,&Cod_Temp_TACK);  // A38
          Criar_Timer (0,Tempo_TIP,&Cod_Temp_TIP);  // A17
          Estado = OPEN_REC;
          #ifdef MSG
          Msg_Maq(">Open_Rec");
          #endif
          }
        else
          {
          Enviar_BM();
          Enviar_BM();
          if (!Reiniciar_Timer (Cod_Temp_TI[id_fonte],Tempo_TI))
             Criar_Timer (0,Tempo_TI,&Cod_Temp_TI[id_fonte]);  // A20
          }
        break;

      case Cod_CM:    // Aw_Un_Rel
        if (nao_rec_cm[id_fonte]) // NP20
          {
          nao_rec_cm[id_fonte]=false;
          num_cm_rec++;               // A37
          if (num_cm_rec>=(num_part / 2))
            {    // P19
            Enviar_MPDL_ABORT_Ind(ERR);  // A50
            Reiniciar_Camada_MPDL(); // A42 A43 A8 A28 A66 A70 A12 A76 => CLOSED
            }
          }
        break;

      case Cod_DISCAC: // Aw_Un_Rel
        if (lista_part[id_fonte]) // P10
          {
          lista_part[id_fonte]=false;
          num_part--;  // A21
          Finalizar_Timer(&Cod_Temp_TI[id_fonte]); // A34
          Descartar_Lista_Quadros_Esperados (id_fonte);     // A42
          Descartar_Lista_Quadros_Rec_Fora_Ordem (id_fonte);// A43
          Retirar_da_Fila_de_Espera(id_fonte); // P12: A22
          if (num_part<2)  // P11
            {
            Enviar_MPDL_ABORT_Ind(LVZ);  // A50
            Enviar_MPDISC();
            Reiniciar_Camada_MPDL(); // A42 A43 A8 A28 A66 A70 A12 A76 => CLOSED
            }
          else   // NP11
            {
            Finalizar_Timer (&Cod_Temp_TR);           // A6

            if (id_fonte==esperando_discac)
              {
              esperando_discac=0;
              Enviar_MPDL_INDIVIDUAL_ABORT_Conf(id_fonte); // A55
              }
            else
              Enviar_MPDL_INDIVIDUAL_ABORT_Ind(id_fonte); // A54

            Ns = Vs;                          //  PLIST
            if ((Ptr_Estrutura_PLIST=Alocar_Estrutura_Parametros_Tx())!=NULL)
              {
              if ((Ptr_Estrutura_PLIST->Ptr_Dados_Usuario=Alocar_Memoria_Tx (Num_Estacoes))!=NULL)
                {
                Ptr_Estrutura_PLIST->Ptr_Proximo=NULL;
                Ptr_Estrutura_PLIST->Ptr_Parametros=(unsigned char*) &Var_Cod_PLIST;
                memcpy(Ptr_Estrutura_PLIST->Ptr_Dados_Usuario,&lista_part[1],Num_Estacoes);
                Ptr_Estrutura_PLIST->Tam_Dados_Usuario=Num_Estacoes;

                if ((Inserir_na_Lista_de_Quadros_Armazenados(Ptr_Estrutura_PLIST, Ns))
                   && (Enviar_PLIST(Ns)))
                  Vs++;
                }
              else
                Liberar_Estrutura_Parametros_Tx(Ptr_Estrutura_PLIST);
              }
            Verificar_Descarte_Quadros (id_fonte, Vs);  // A61 A10
            Estado = OPEN_MASTER;
            #ifdef MSG
            Msg_Maq(">Open_Mast");
            #endif
            }
          }// Esta_na_Lista
        break;

//      case Cod_MPI:    // Aw_Un_Rel
//     case Cod_PLIST:   // Aw_Un_Rel
//     case Cod_MPDISCAC:
//      break;

      case Cod_Erro:
        #ifdef MSG
        Msg_Maq("Erro em PDU");
        printf("%2d",Ptr_Primitiva->Ptr_Parametros_Primitiva->Info[2]);
        printf("%2d",Ptr_Primitiva->Ptr_Parametros_Primitiva->Tam_Info);
        #endif
        Enviar_MPDL_ABORT_Ind(ERR);  // A50
//        Enviar_MPDISC();
  //      Enviar_MPDISC();
        Reiniciar_Camada_MPDL(); // A42 A43 A8 A28 A66 A70 A12 A76 => CLOSED
        break;

      } // fim switch
    } // fim if primitiva

  if (Ptr_Primitiva->Nome_Primitiva == MA_DATA_Indication)
    {
    Dealocar_Fila_Primitivas_M_L ();
    Dealocar_Quadro_Buffer_Rx ();
    }
  else
    Dealocar_Fila_Primitivas_M_L ();

  }  // fim Tratar_Aw_Un_Rel_MACMPDL



void Tratar_Open_Rec_MACMPDL (void)
  {
  Ptr_Estrutura_Primitiva_M_L    Ptr_Primitiva;
  unsigned char                  i, id_fonte;
  Long                           Ns, Nr;
  Ptr_Estrutura_Parametros       Ptr_Est_Quadro;
  Ptr_Estrutura_Parametros       Ptr_Estrutura_PLIST;
  unsigned char                  *Ptr_Quadro, *Ptr_Dest;
  Tipo_Lista                     aux_lista_part;


  Ptr_Primitiva = Receber_Primitiva_M_L ();
  #ifdef MSG
  Msg_Maq("Open_Rec");
  #endif
  if (Ptr_Primitiva->Nome_Primitiva == MA_DATA_Indication)
    {
    id_fonte=Ptr_Primitiva->Ptr_Parametros_Primitiva->Info[0];
    switch (Decodificar_PDU (Ptr_Primitiva->Ptr_Parametros_Primitiva))
      {
      case Cod_MPI:  // Open_Rec
        num_tent_TIP=1;
        if (!Reiniciar_Timer (Cod_Temp_TIP, Tempo_TIP))  //  A35
          Criar_Timer (0,Tempo_TIP,&Cod_Temp_TIP);

        /* Copia quadro para uma Estrutura de Parametros */
        if ((Ptr_Est_Quadro = Alocar_Estrutura_Parametros_Rx ())!=NULL)
          {
          Ptr_Quadro = Alocar_Memoria_Rx (Ptr_Primitiva->Ptr_Parametros_Primitiva->Tam_Info);
          if (Ptr_Quadro!=NULL)
            {
            if (prim_quadro_rec[id_fonte])  //  P25
              {
              Vr [id_fonte]= Ler_Long (&(Ptr_Primitiva->Ptr_Parametros_Primitiva->Info[3])); // A60
              prim_quadro_rec[id_fonte]=false;
              }
            Ptr_Est_Quadro->Ptr_Proximo = NULL;
            Ptr_Est_Quadro->Tam_Dados_Usuario = Ptr_Primitiva->Ptr_Parametros_Primitiva->Tam_Info;
            Ptr_Est_Quadro->Ptr_Dados_Usuario = Ptr_Quadro;
            Ptr_Est_Quadro->Ptr_Parametros =(unsigned char *) &Var_Cod_MPI;
            disable();
            _fmemcpy(Ptr_Quadro,&(Ptr_Primitiva->Ptr_Parametros_Primitiva->Info[0]),
                                Ptr_Primitiva->Ptr_Parametros_Primitiva->Tam_Info);
            enable();
            Verificar_Sequenciamento (Ptr_Est_Quadro,id_fonte); // A41
            }
          else
            {
            Liberar_Estrutura_Parametros_Rx(Ptr_Est_Quadro);
            #ifdef MSG_ERR
            Msg_Status("Faltou Mem. RX");
            #endif
            }
          }
        #ifdef MSG_ERR
        else
          Msg_Status("Faltou Estru Param RX");
        #endif
        break;

      case Cod_PLIST:  // Open_Rec
        #ifdef MSG
        Msg_Status_Id("MPDL: REC PLIST",id_fonte);
        #endif
        if (prim_quadro_rec[id_fonte])  //  P25
          {
          Vr [id_fonte]= Ler_Long (&(Ptr_Primitiva->Ptr_Parametros_Primitiva->Info[3]));
          prim_quadro_rec[id_fonte]=false;
          }
        num_tent_TIP=1;
        if (!Reiniciar_Timer (Cod_Temp_TIP, Tempo_TIP))  //  A35
          Criar_Timer (0,Tempo_TIP,&Cod_Temp_TIP);
        memcpy(&aux_lista_part[1],&Ptr_Primitiva->Ptr_Parametros_Primitiva->Info[7],Num_Estacoes);
        for (i=1;i<=Num_Estacoes;i++)
          if (aux_lista_part[i] && !lista_part[i] && (i!=id_est))   // A75
            {
            Enviar_MPDL_ESTABLISH_Ind(i);
            num_part++;
            }
          else if (!aux_lista_part[i] && lista_part[i] && (i!=id_est))
                 {
                 Enviar_MPDL_INDIVIDUAL_ABORT_Ind(i);
                 num_part--;
                 }
        memcpy(&lista_part[1],&aux_lista_part[1],Num_Estacoes);  // A47

        /* Copia quadro para uma Estrutura de Parametros para fins de sequenciamento */
        if ((Ptr_Est_Quadro = Alocar_Estrutura_Parametros_Rx ())!=NULL)
          {
          Ptr_Est_Quadro->Ptr_Proximo = NULL;
          Ptr_Est_Quadro->Tam_Dados_Usuario = Tam_PLIST-Num_Estacoes;
          Ptr_Quadro = Alocar_Memoria_Rx (Tam_PLIST-Num_Estacoes);
          Ptr_Est_Quadro->Ptr_Dados_Usuario = Ptr_Quadro;
          Ptr_Est_Quadro->Ptr_Parametros =(unsigned char *) &Var_Cod_PLIST;
          memcpy(Ptr_Quadro,&(Ptr_Primitiva->Ptr_Parametros_Primitiva->Info[0]),Tam_PLIST-Num_Estacoes);

          Verificar_Sequenciamento (Ptr_Est_Quadro,id_fonte); // A41
          }
        if (!lista_part [id_est]) // NP24
          {
          Enviar_SMPARM(id_fonte);
          if (!Reiniciar_Timer (Cod_Temp_TR,Tempo_TR)) // A0
            Criar_Timer (0,Tempo_TR,&Cod_Temp_TR);
          Estado = ESTABLISH_REC;
          #ifdef MSG
          Msg_Maq(">Estab_Rec");
          #endif
          }
        break;

      case Cod_RR:   // Open_Rec
        Nr = Ler_Long (&(Ptr_Primitiva->Ptr_Parametros_Primitiva->Info[3]));
        Verificar_Descarte_Quadros (id_fonte,Nr);  // P4: A10
        break;

      case Cod_TG:  // Open_Rec
        #ifdef MSG
        Msg_Status_Id("MPDL: REC TG",id_fonte);
        #endif

        if (!Prim_Lista_Quadros_Esperados [id_mestra])  // P7
          Enviar_RR (Vr [id_mestra]);
        else
          Enviar_RR (Prim_Lista_Quadros_Esperados [id_mestra]->Num_Quadro);
        id_mestra=Ptr_Primitiva->Ptr_Parametros_Primitiva->Info[3];
        if (id_est==id_mestra) // P14
          {
          Finalizar_Timer (&Cod_Temp_TACK);       // A40
          Finalizar_Timer (&Cod_Temp_TIP);       // A67
          Finalizar_Timer (&Cod_Temp_TKPR);       // A31
          Enviar_BM();
          Enviar_BM();
          Ptr_Dest=&Ptr_Primitiva->Ptr_Parametros_Primitiva->Info[4];
          memcpy(&fila_esp[1],Ptr_Dest,Num_Estacoes); // A29
          Ptr_Dest+=Num_Estacoes;
          prim_fila=*Ptr_Dest++;
          ult_fila=*Ptr_Dest;

          pediu_ficha=false;  // A13
          mestra=true;
          Enviar_MPDL_TOKEN_GIVE_Ind (); // A58
          if (Prim_Lista_Quadros_Armazenados)   // NP5
            Retransmite_Todos_os_Quadros();     // A11
          num_cm_rec=0;
          for (i = 1; i <= Num_Estacoes; i++)
            {
            nao_rec_cm[i]=true;  //A74
            if ((lista_part[i]) && (i!=id_est))
              Criar_Timer (0,Tempo_TI,&Cod_Temp_TI [i]); // A2
            }
          Criar_Timer (0,Tempo_TIM,&Cod_Temp_TIM); // A64
          Criar_Timer (0,Tempo_TMT,&Cod_Temp_TMT); // A26
          Criar_Timer (0,Tempo_TRQ,&Cod_Temp_TRQ); // A68
          Estado = OPEN_MASTER;
          #ifdef MSG
          Msg_Maq(">Open_Mast");
          #endif
          }
        else
          {
          num_tent_TIP=1;
          if (!Reiniciar_Timer (Cod_Temp_TIP,Tempo_TIP))  // A35
            Criar_Timer (0,Tempo_TIP,&Cod_Temp_TIP);
          if (pediu_ficha)  // P15
            {
            Ptr_Dest=&Ptr_Primitiva->Ptr_Parametros_Primitiva->Info[4];
            memcpy(&fila_esp[1],Ptr_Dest,Num_Estacoes); // A29
            Ptr_Dest+=Num_Estacoes;
            prim_fila=*Ptr_Dest++;
            ult_fila=*Ptr_Dest;
            }
          }
        break;

      case Cod_BM:  // Open_Rec
        if (!Reiniciar_Timer (Cod_Temp_TACK,Tempo_TACK))  // A39
          Criar_Timer (0,Tempo_TACK,&Cod_Temp_TACK);
        id_mestra=id_fonte; // A63
        num_tent_TIP=1;
        if (!Reiniciar_Timer (Cod_Temp_TIP,Tempo_TIP))  // A35
          Criar_Timer (0,Tempo_TIP,&Cod_Temp_TIP);
        if (pediu_ficha && !Esta_na_Fila_de_Espera(id_est)) // P15:NP16
          {
          if (!Reiniciar_Timer (Cod_Temp_TKPR,Tempo_TKPR))  // A30
            Criar_Timer (0,Tempo_TKPR,&Cod_Temp_TKPR);
          Enviar_TP();
          }
        break;

      case Cod_CM:        // Open_Rec
        if (nao_rec_cm[id_fonte]) // NP20
          {
          nao_rec_cm[id_fonte]=false;
          num_cm_rec++;                 // A37
          if (num_cm_rec>=(num_part / 2))
            {    // P19
            Finalizar_Timer (&Cod_Temp_TIP);  // A67
            Finalizar_Timer (&Cod_Temp_TACK);  // A40
            Finalizar_Timer (&Cod_Temp_TKPR);  // A31
            for (i=1; i<=Num_Estacoes;i++);
               lista_part[i]=!nao_rec_cm[i];
            lista_part[id_est]=true;
            num_part=num_cm_rec+1;
            Enviar_BM();
//            Enviar_BM();
//            Enviar_BM();
            Enviar_MPDL_TOKEN_GIVE_Ind (); // A58
            pediu_ficha=false;  // A13
            mestra=true;
            id_mestra=id_est;
            Num_Tentativas=1;
            if (Prim_Lista_Quadros_Armazenados)   // NP5
              Retransmite_Todos_os_Quadros();     // A45
            prim_fila=1;  // A36
            for (i=1; i<=Num_Estacoes; nao_rec_cm[i++]=true); //A74
            num_cm_rec=0;
            ult_fila=1;

            Ns = Vs;                          //  PLIST
            if ((Ptr_Estrutura_PLIST=Alocar_Estrutura_Parametros_Tx())!=NULL)
              {
              if ((Ptr_Estrutura_PLIST->Ptr_Dados_Usuario=Alocar_Memoria_Tx (Num_Estacoes))!=NULL)
                {
                Ptr_Estrutura_PLIST->Ptr_Proximo=NULL;
                Ptr_Estrutura_PLIST->Ptr_Parametros=(unsigned char*) &Var_Cod_PLIST;
                memcpy(Ptr_Estrutura_PLIST->Ptr_Dados_Usuario,&lista_part[1],Num_Estacoes);
                Ptr_Estrutura_PLIST->Tam_Dados_Usuario=Num_Estacoes;

                if ((Inserir_na_Lista_de_Quadros_Armazenados(Ptr_Estrutura_PLIST, Ns))
                   && (Enviar_PLIST(Ns)))
                  Vs++;
                }
              else
                Liberar_Estrutura_Parametros_Tx(Ptr_Estrutura_PLIST);
              }

            Criar_Timer (0,Tempo_TIM,&Cod_Temp_TIM); // A64
            Criar_Timer (0,Tempo_TMT,&Cod_Temp_TMT); // A26
            Criar_Timer (0,Tempo_TRQ,&Cod_Temp_TRQ); // A68
            for (i = 1; i <= Num_Estacoes; i++)
              if ((lista_part[i]) && (i!=id_est))
                Criar_Timer (0,Tempo_TI,&Cod_Temp_TI [i]); // A2
            Estado = OPEN_MASTER;
            #ifdef MSG
            Msg_Maq(">Open_Mast");
            #endif
            }
          }
        break;

      case Cod_DISC:      // Open_Rec
        Finalizar_Timer (&Cod_Temp_TACK);  // A40
        Enviar_MPDL_INDIVIDUAL_ABORT_Ind(id_est); // A54
        Enviar_DISCAC(id_fonte);
        Reiniciar_Camada_MPDL(); // A42 A43 A8 A28 A66 A70 A12 A76 => CLOSED
        break;

      case Cod_MPARMAC:  // Open_Rec
        num_tent_TIP=1;
        if (!Reiniciar_Timer (Cod_Temp_TIP,Tempo_TIP))  // A35
          Criar_Timer (0,Tempo_TIP,&Cod_Temp_TIP);
        break;

      case Cod_MPDISC:   // Open_Rec
        Enviar_MPDL_ABORT_Ind(USU);  // A50
        Enviar_MPDISCAC(id_fonte);
        Reiniciar_Camada_MPDL(); // A42 A43 A8 A28 A66 A70 A12 A76 => CLOSED
        break;

      case Cod_SREJ:  // Open_Rec:
        Nr = Ler_Long (&(Ptr_Primitiva->Ptr_Parametros_Primitiva->Info[3]));
        if (Quadro_Esta_Lista_de_Armazenados(Nr)) // P22
          {
          Enviar_TP();
          if (!Reiniciar_Timer (Cod_Temp_TKPR,Tempo_TKPR))
            Criar_Timer (0,Tempo_TKPR,&Cod_Temp_TKPR);   // A23
          num_srej++;
          }
        break;

      case Cod_Erro:
        #ifdef MSG_ERR
        Msg_Maq("Erro em PDU");
        printf("%2d",Ptr_Primitiva->Ptr_Parametros_Primitiva->Info[2]);
        printf("%2d",Ptr_Primitiva->Ptr_Parametros_Primitiva->Tam_Info);
        #endif
        Enviar_MPDL_ABORT_Ind(ERR);
//        Enviar_MPDISC();
        Reiniciar_Camada_MPDL(); // A42 A43 A8 A28 A66 A70 A12 A76 => CLOSED
        break;

/*
      case Cod_DISCAC:    // Open_Rec
      case Cod_MPDISCAC:  // Open_Rec
      case Cod_MPRP:      // Open_Rec
      case Cod_SMPARM:  // Open_Rec
      case Cod_RP:        // Open_Rec

     case Cod_TP:        // Open_Rec
       break;
*/
      } // fim switch
    } // fim if primitiva

  if (Ptr_Primitiva->Nome_Primitiva == MA_DATA_Indication)
    {
    Dealocar_Fila_Primitivas_M_L ();
    Dealocar_Quadro_Buffer_Rx ();
    }
  else
    Dealocar_Fila_Primitivas_M_L ();

  }  // fim Tratar_Open_Rec_MACMPDL

void Tratar_Aw_Tk_Rec_MACMPDL (void)
  {
  Ptr_Estrutura_Primitiva_M_L    Ptr_Primitiva;
  unsigned char                  i, id_fonte;
  Long                           Nr;


  Ptr_Primitiva = Receber_Primitiva_M_L ();
  #ifdef MSG
  Msg_Maq("Aw_Tk_Rec");
  #endif
  if (Ptr_Primitiva->Nome_Primitiva == MA_DATA_Indication)
    {
    id_fonte=Ptr_Primitiva->Ptr_Parametros_Primitiva->Info[0];
    switch (Decodificar_PDU (Ptr_Primitiva->Ptr_Parametros_Primitiva))
      {
      case Cod_RR:     // Aw_Tk_Rec
        if (quadro_transmitido)                            // P28
          {
          quadro_transmitido=false;
          if (!Reiniciar_Timer (Cod_Temp_TIM, Tempo_TIM))  // A65
            Criar_Timer (0,Tempo_TIM,&Cod_Temp_TIM);
          }
        Nr = Ler_Long (&(Ptr_Primitiva->Ptr_Parametros_Primitiva->Info[3]));
        Verificar_Descarte_Quadros (id_fonte,Nr);
        break;

      case Cod_BM:     // Aw_Tk_Rec
        #ifdef MSG
        Msg_Status_Id("MPDL: Aw_Tk_Rec: BM",id_fonte);
        #endif
        Finalizar_Timer (&Cod_Temp_TIM);   // A66
        if (!Prim_Lista_Quadros_Armazenados)   // P5
          Finalizar_Timer (&Cod_Temp_TR);      // A6
        else
          if (!Reiniciar_Timer (Cod_Temp_TR,Tempo_TR))
            Criar_Timer (0,Tempo_TR,&Cod_Temp_TR);// A4
        id_mestra=id_fonte; // A63
        mestra=false;   // A16
        for (i=1; i<=Num_Estacoes; nao_rec_cm[i++]=true); //A74
        num_cm_rec=0;
        num_tent_TIP=1;
        Criar_Timer (0,Tempo_TIP,&Cod_Temp_TIP);  // A17
        Criar_Timer (0,Tempo_TACK,&Cod_Temp_TACK);  // A38
        Estado = OPEN_REC;
        #ifdef MSG
        Msg_Maq(">Open_Rec");
        #endif
        break;

      case Cod_SREJ:   // Aw_Tk_Rec
        if (quadro_transmitido)              //  P28
          {
          quadro_transmitido=false;
          if (!Reiniciar_Timer (Cod_Temp_TRQ,Tempo_TRQ))    // A69
            Criar_Timer (0,Tempo_TRQ,&Cod_Temp_TRQ);
          if (!Reiniciar_Timer (Cod_Temp_TIM, Tempo_TIM))  // A65
            Criar_Timer (0,Tempo_TIM,&Cod_Temp_TIM);
          }
        Nr = Ler_Long (&(Ptr_Primitiva->Ptr_Parametros_Primitiva->Info[3]));
        Retransmitir_Quadro (Nr);  // P22: A23 A44
        num_srej++;
        break;

      case Cod_MPDISC:   // Aw_Tk_Rec
        Enviar_MPDL_ABORT_Ind(ERR);  // A50
        Enviar_MPDISCAC(id_fonte);
        Reiniciar_Camada_MPDL(); // A42 A43 A8 A28 A66 A70 A12 A76 => CLOSED
        break;

      case Cod_DISC:   // Aw_Tk_Rec
        Enviar_MPDL_ABORT_Ind(ERR);
        Enviar_DISCAC(id_fonte);
        Reiniciar_Camada_MPDL(); // A42 A43 A8 A28 A66 A70 A12 A76 => CLOSED
        break;

/*      case Cod_MPRP:   // Aw_Tk_Rec
        break;

      case Cod_MPARMAC:
        break;

      case Cod_SMPARM:   // Aw_Tk_Rec
        break;

      case Cod_RP:     // Aw_Tk_Rec
        break;

      case Cod_TP:     // Aw_Tk_Rec
        break;

      case Cod_TG:     // Aw_Tk_Rec
        break;
*/
      case Cod_CM:     // Aw_Tk_Rec
        if (nao_rec_cm[id_fonte]) // NP20
          {
          nao_rec_cm[id_fonte]=false;
          num_cm_rec++;               // A37
          if (num_cm_rec>=(num_part / 2))
            {    // P19
            Enviar_MPDL_ABORT_Ind(ERR);  // A50
            Reiniciar_Camada_MPDL(); // A42 A43 A8 A28 A66 A70 A12 A76 => CLOSED
            }
          }
        break;

//      case Cod_MPI:    // Aw_Tk_Rec
//      case Cod_DISCAC:
//     case Cod_PLIST:   // Aw_Tk_Rec
//     case Cod_MPDISCAC:
//       break;

      case Cod_Erro:
        #ifdef MSG
        Msg_Maq("Erro em PDU");
        printf("%2d",Ptr_Primitiva->Ptr_Parametros_Primitiva->Info[2]);
        printf("%2d",Ptr_Primitiva->Ptr_Parametros_Primitiva->Tam_Info);
        #endif
        Enviar_MPDL_ABORT_Ind(ERR);
//        Enviar_MPDISC();
  //      Enviar_MPDISC();
        Reiniciar_Camada_MPDL(); // A42 A43 A8 A28 A66 A70 A12 A76 => CLOSED
        break;

      } // fim switch
    } // fim if primitiva

  if (Ptr_Primitiva->Nome_Primitiva == MA_DATA_Indication)
    {
    Dealocar_Fila_Primitivas_M_L ();
    Dealocar_Quadro_Buffer_Rx ();
    }
  else
    Dealocar_Fila_Primitivas_M_L ();

  }  // fim Tratar_Aw_Tk_Rec_MACMPDL



void Tratar_Open_Master_MACMPDL (void)  // ok 2
  {
  Ptr_Estrutura_Primitiva_M_L    Ptr_Primitiva;
  Ptr_Estrutura_Parametros       Ptr_Estrutura_PLIST;
  unsigned char                  i, id_fonte;
  Long                           Ns, Nr;


  Ptr_Primitiva = Receber_Primitiva_M_L ();
  #ifdef MSG
  Msg_Maq("Open_Mast");
  #endif
  if (Ptr_Primitiva->Nome_Primitiva == MA_DATA_Indication)
    {
    id_fonte=Ptr_Primitiva->Ptr_Parametros_Primitiva->Info[0];
    switch (Decodificar_PDU (Ptr_Primitiva->Ptr_Parametros_Primitiva))
      {
      case Cod_RR:     // Open_Master
        if (!Reiniciar_Timer (Cod_Temp_TI [id_fonte],Tempo_TI)) // A3
          Criar_Timer (0,Tempo_TI,&Cod_Temp_TI [id_fonte]);
        #ifdef MSG
        Msg_Maq_id("Op_Mas:RR",id_fonte);
        #endif

        if (quadro_transmitido)                            // P28
          {
          quadro_transmitido=false;
          if (!Reiniciar_Timer (Cod_Temp_TIM, Tempo_TIM))  // A65
            Criar_Timer (0,Tempo_TIM,&Cod_Temp_TIM);
          }
        Nr = Ler_Long (&(Ptr_Primitiva->Ptr_Parametros_Primitiva->Info[3]));
        Verificar_Descarte_Quadros (id_fonte,Nr);  // P4
        break;

      case Cod_SREJ:   // Open_Master
        if (!Reiniciar_Timer (Cod_Temp_TI [id_fonte],Tempo_TI))  // A3
          Criar_Timer (0,Tempo_TI,&Cod_Temp_TI[id_fonte]);
        if (quadro_transmitido)  // P28
          {
          quadro_transmitido=false;
          if (!Reiniciar_Timer (Cod_Temp_TRQ,Tempo_TRQ))    // A69
            Criar_Timer (0,Tempo_TRQ,&Cod_Temp_TRQ);
          if (!Reiniciar_Timer (Cod_Temp_TIM, Tempo_TIM))  // A65
            Criar_Timer (0,Tempo_TIM,&Cod_Temp_TIM);
          }
        Nr = Ler_Long (&(Ptr_Primitiva->Ptr_Parametros_Primitiva->Info[3]));
        Retransmitir_Quadro (Nr);                    // P22:...
        num_srej++;
        break;

      case Cod_MPARMAC:
        if (!lista_part[id_fonte])
          {
          lista_part[id_fonte]=true;           // A15
          num_part++;
          Enviar_MPDL_ESTABLISH_Ind(id_fonte); // A48
          Criar_Timer (0,Tempo_TI,&Cod_Temp_TI [id_fonte]);  // A20
          }
        #ifdef MSG
        Msg_Maq_id("MPARMAC",id_fonte);
        #endif
        break;

      case Cod_SMPARM:   // Open_Master
        if (!lista_part[id_fonte])             // NP10
          {
          lista_part[id_fonte]=true;           // A15
          num_part++;
          Enviar_MPDL_ESTABLISH_Ind(id_fonte); // A48
          }
        Ns = Vs;                          //  PLIST
        if ((Ptr_Estrutura_PLIST=Alocar_Estrutura_Parametros_Tx())!=NULL)
          {
          if ((Ptr_Estrutura_PLIST->Ptr_Dados_Usuario=Alocar_Memoria_Tx (Num_Estacoes))!=NULL)
            {
            Ptr_Estrutura_PLIST->Ptr_Proximo=NULL;
            Ptr_Estrutura_PLIST->Ptr_Parametros=(unsigned char*) &Var_Cod_PLIST;
            memcpy(Ptr_Estrutura_PLIST->Ptr_Dados_Usuario,&lista_part[1],Num_Estacoes);
            Ptr_Estrutura_PLIST->Tam_Dados_Usuario=Num_Estacoes;

            if ((Inserir_na_Lista_de_Quadros_Armazenados(Ptr_Estrutura_PLIST, Ns))
               && (Enviar_PLIST(Ns)))
              Vs++;
            }
          else
            Liberar_Estrutura_Parametros_Tx(Ptr_Estrutura_PLIST);
          }
        Enviar_MPARMAC(id_fonte);
        Coloca_na_Fila(id_fonte); // A19
        if (!Reiniciar_Timer (Cod_Temp_TI[id_fonte],Tempo_TI))
          Criar_Timer (0,Tempo_TI,&Cod_Temp_TI [id_fonte]);  // A20
        break;

      case Cod_MPDISC:   // Open_Master
        Enviar_MPDL_ABORT_Ind(ERR);
        Enviar_MPDISCAC(id_fonte);
        Reiniciar_Camada_MPDL(); // A42 A43 A8 A28 A66 A70 A12 A76 => CLOSED
        break;

      case Cod_MPRP:   // Open_Master
        Enviar_MPDL_RELEASE_PLEASE_Ind(id_fonte);  // A52
        break;

      case Cod_DISC:   // Open_Master
        Enviar_MPDL_ABORT_Ind(ERR);
        Enviar_DISCAC(id_fonte);
        Reiniciar_Camada_MPDL(); // A42 A43 A8 A28 A66 A70 A12 A76 => CLOSED
        break;

      case Cod_RP:     // Open_Master
        Enviar_MPDL_IND_RELEASE_PLEASE_Ind(id_fonte);// A56
        break;

      case Cod_TP:     // Open_Master
        if (lista_part[id_fonte])  // P10
          {
          Enviar_MPDL_TOKEN_PLEASE_Ind (id_fonte);  // A57
          Coloca_na_Fila(id_fonte); // NP12: A19
          }
        else // NP10
          {
          Enviar_DISC (id_fonte);
          Criar_Timer (0,Tempo_TR,&Cod_Temp_TR);  // A0
          Num_Tentativas=1;
          Estado = AW_UN_REL;
          #ifdef MSG
          Msg_Maq(">Aw_Un_Rel");
          #endif
          }
        break;

      case Cod_TG:     // Open_Master
        #ifdef MSG
        Msg_Status_Id("MPDL: Rec. TG em OP_Mast",id_fonte);
        #endif
        if (id_est==Ptr_Primitiva->Ptr_Parametros_Primitiva->Info[3]) // P14
          {
          Enviar_BM();
          Enviar_BM();
          if (!Reiniciar_Timer (Cod_Temp_TI[id_fonte],Tempo_TI))
             Criar_Timer (0,Tempo_TI,&Cod_Temp_TI[id_fonte]);  // A20
          }
        else
          {
          Enviar_MPDL_STOP_TRANSMISSION_Ind();   // A59
          Finalizar_Timer (&Cod_Temp_TRQ);       // A70
          if (!Prim_Lista_Quadros_Armazenados)   // P5
            Finalizar_Timer (&Cod_Temp_TR);      // A6
          else
            if (!Reiniciar_Timer (Cod_Temp_TR,Tempo_TR))
              Criar_Timer (0,Tempo_TR,&Cod_Temp_TR);// A0
          for (i=1;i<=Num_Estacoes;i++)
            Finalizar_Timer (&Cod_Temp_TI[i]);      // A8
          id_mestra=id_fonte;                       // A63
          num_tent_TIP=1;
          Criar_Timer (0,Tempo_TIP,&Cod_Temp_TIP);  // A17
          Criar_Timer (0,Tempo_TACK,&Cod_Temp_TACK);// A38
          mestra=false;                             // A16
          Estado = OPEN_REC;
          #ifdef MSG
          Msg_Maq(">Open_Rec");
          #endif
          }
        break;

      case Cod_BM:     // Open_Master
        #ifdef MSG
        Msg_Status_Id("MPDL: Rec. BM em OP_Mast",id_fonte);
        #endif
        if (id_fonte<id_est)  // P9
          {
          Enviar_MPDL_STOP_TRANSMISSION_Ind();  // A59
          Finalizar_Timer (&Cod_Temp_TRQ);       // A70
          if (!Prim_Lista_Quadros_Armazenados)   // P5
            Finalizar_Timer (&Cod_Temp_TR);      // A6
          else
            if (!Reiniciar_Timer (Cod_Temp_TR,Tempo_TR))
              Criar_Timer (0,Tempo_TR,&Cod_Temp_TR);// A0
          for (i=1;i<=Num_Estacoes;i++)
            Finalizar_Timer (&Cod_Temp_TI[i]);        // A8
          num_tent_TIP=1;
          id_mestra=id_fonte; // A63
          Criar_Timer (0,Tempo_TIP,&Cod_Temp_TIP);  // A17
          Criar_Timer (0,Tempo_TACK,&Cod_Temp_TACK);  // A38
          mestra=false;   // A16
          Estado = OPEN_REC;
          #ifdef MSG
          Msg_Maq(">Open_Rec");
          #endif
          }
        else
          {
          Enviar_BM();
          Enviar_BM();
          if (!Reiniciar_Timer (Cod_Temp_TI[id_fonte],Tempo_TI))
            Criar_Timer (0,Tempo_TI,&Cod_Temp_TI [id_fonte]);  // A20
          }
        break;

      case Cod_CM:    // Open_Master
        if (nao_rec_cm[id_fonte]) // NP20
          {
          nao_rec_cm[id_fonte]=false;
          num_cm_rec++;               // A37
          if (num_cm_rec>=(num_part / 2))
            {    // P19
            Enviar_MPDL_ABORT_Ind(ERR);  // A50
            Reiniciar_Camada_MPDL(); // A42 A43 A8 A28 A66 A70 A12 A76 => CLOSED
            }
          }
        break;

//      case Cod_MPI:    // Open_Master
//      case Cod_DISCAC:
//     case Cod_PLIST:   // Open_Master
//     case Cod_MPDISCAC:
//       break;

      case Cod_Erro:
        #ifdef MSG
        Msg_Maq("Erro em PDU");
        printf("%2d",Ptr_Primitiva->Ptr_Parametros_Primitiva->Info[2]);
        printf("%2d",Ptr_Primitiva->Ptr_Parametros_Primitiva->Tam_Info);
        #endif

        Enviar_MPDL_ABORT_Ind(ERR);  // A50
//        Enviar_MPDISC();
  //      Enviar_MPDISC();
        Reiniciar_Camada_MPDL(); // A42 A43 A8 A28 A66 A70 A12 A76 => CLOSED
        break;

      } // fim switch
    } // fim if primitiva

  if (Ptr_Primitiva->Nome_Primitiva == MA_DATA_Indication)
    {
    Dealocar_Fila_Primitivas_M_L ();
    Dealocar_Quadro_Buffer_Rx ();
    }
  else
    Dealocar_Fila_Primitivas_M_L ();

  }  // fim Tratar_Open_Master_MACMPDL


void Tratar_Establish_MACMPDL (void)  // ok 2
  {
  Ptr_Estrutura_Primitiva_M_L    Ptr_Primitiva;
  Ptr_Estrutura_Parametros       Ptr_Estrutura_PLIST;
  unsigned char                  i, id_fonte;
  Long                           Ns;
  Tipo_Lista                     aux_lista_part;

  Ptr_Primitiva = Receber_Primitiva_M_L ();
  #ifdef MSG
  Msg_Maq("Establish");
  #endif
  if (Ptr_Primitiva->Nome_Primitiva == MA_DATA_Indication)
    {
      // Ptr...->Info[0] e' a identificacao da estacao fonte
    id_fonte=Ptr_Primitiva->Ptr_Parametros_Primitiva->Info[0];
    switch (Decodificar_PDU (Ptr_Primitiva->Ptr_Parametros_Primitiva))
      {
      case Cod_MPARMAC:   // Establish
          // Ptr...->Info[3] indica se a estacao que enviou eh a mestra
        if (Ptr_Primitiva->Ptr_Parametros_Primitiva->Info[3]) // P21
          {
          Finalizar_Timer (&Cod_Temp_TR); // A6
          mestra=false;  // A16
          id_mestra=id_fonte; // A63
          Num_Tentativas=1;
          num_tent_TIP=1;
          Criar_Timer (0,Tempo_TIP,&Cod_Temp_TIP); //A17
          Criar_Timer (0,Tempo_TACK,&Cod_Temp_TACK); //A38
          lista_part [id_fonte] = True; // A15
          lista_part [id_est] = true;
          num_part+=2;
          Enviar_MPDL_ESTABLISH_Conf(conferencia_em_andamento);  // A49
          Estado = OPEN_REC;
          break;
          }
        else
          {
          if (!Mandou_Conf [id_fonte])
            {
            Mandou_Conf [id_fonte] = True; // A1
            lista_part [id_fonte] = True; // A15
            num_part++;
            falta_mandar_conf--;

            // teste
            //falta_mandar_conf=0;

            if (!falta_mandar_conf) // == 0  P0
              {
              Finalizar_Timer (&Cod_Temp_TR); // A6
              pediu_ficha=false;  // A13
              mestra=true;
              id_mestra=id_est;
              Num_Tentativas=1;
              lista_part [id_est] = true;
              num_part++;
              if (!Reiniciar_Timer (Cod_Temp_TIM, Tempo_TIM))  // A64
                Criar_Timer (0,Tempo_TIM,&Cod_Temp_TIM);

              Vs = 0;
              Enviar_MPDL_ESTABLISH_Conf(conferencia_nova);  // A49

              Ns = Vs;                          //  PLIST
              if ((Ptr_Estrutura_PLIST=Alocar_Estrutura_Parametros_Tx())!=NULL)
                {
                if ((Ptr_Estrutura_PLIST->Ptr_Dados_Usuario=Alocar_Memoria_Tx (Num_Estacoes))!=NULL)
                  {
                  Ptr_Estrutura_PLIST->Ptr_Proximo=NULL;
                  Ptr_Estrutura_PLIST->Ptr_Parametros=(unsigned char*) &Var_Cod_PLIST;
                  memcpy(Ptr_Estrutura_PLIST->Ptr_Dados_Usuario,&lista_part[1],Num_Estacoes);
                  Ptr_Estrutura_PLIST->Tam_Dados_Usuario=Num_Estacoes;

                  if ((Inserir_na_Lista_de_Quadros_Armazenados(Ptr_Estrutura_PLIST, Ns))
                     && (Enviar_PLIST(Ns)))
                    Vs++;
                  }
                else
                  Liberar_Estrutura_Parametros_Tx(Ptr_Estrutura_PLIST);
                }

              for (i = 1; i <= Num_Estacoes; i++)
                if ((lista_part[i]) && (i!=id_est))
                  Criar_Timer (0,Tempo_TI,&Cod_Temp_TI [i]); // A2
              Criar_Timer (0,Tempo_TMT,&Cod_Temp_TMT); // A26
              Criar_Timer (0,Tempo_TRQ,&Cod_Temp_TRQ); // A68
              Estado = OPEN_MASTER;
              } // fim do if todos aceitaram
            } // fim if ainda nao havia confirmado
          } // fim if else veio da mestra
        break;

      case Cod_MPDISC:  // Establish
        Finalizar_Timer (&Cod_Temp_TR);     // A6
        Enviar_MPDL_ABORT_Ind(USU); // A50
        Enviar_MPDISCAC (id_fonte);
        canal_p_ocupado=false; // A62
        Reiniciar_Camada_MPDL(); // A42 A43 A8 A28 A66 A70 A12 A76 => CLOSED
        break;

      case Cod_SMPARM:  // Establish
        if (id_fonte<id_est)  // P9
          {
          Finalizar_Timer (&Cod_Temp_TR);     // A6
          lista_part [id_fonte] = True; // A15
          lista_part [id_est] = true;
          num_part+=2;
          Enviar_MPDL_ESTABLISH_Conf(conferencia_em_andamento);  // A49
          mestra=false;  // A16
          Num_Tentativas = 1;
          Enviar_MPARMAC(id_fonte);
          num_tent_TIP=1;
          Criar_Timer (0,Tempo_TIP,&Cod_Temp_TIP);   // A17
          Criar_Timer (0,Tempo_TACK,&Cod_Temp_TACK); // A38
          Estado = OPEN_REC;
          }
        else
          {
          if (!Reiniciar_Timer (Cod_Temp_TR,Tempo_TR)) // A4
            Criar_Timer (0,Tempo_TR,&Cod_Temp_TR);
          Enviar_SMPARM(id_fonte);
          }
        break;

      case Cod_DISC:  // Establish
        Finalizar_Timer (&Cod_Temp_TR);     // A6
        Enviar_MPDL_INDIVIDUAL_ABORT_Ind(id_est); // A54
        Enviar_DISCAC(id_fonte);
        Reiniciar_Camada_MPDL(); // A42 A43 A8 A28 A66 A70 A12 A76 => CLOSED
        break;

      case Cod_PLIST:  // Establish
        canal_p_ocupado=true; // A46
        memcpy(&aux_lista_part[1],&Ptr_Primitiva->Ptr_Parametros_Primitiva->Info[7],Num_Estacoes);
        for (i=1;i<=Num_Estacoes;i++)                             // A75
          if (aux_lista_part[i] && !lista_part[i] && (i!=id_est))
            {
            Enviar_MPDL_ESTABLISH_Ind(i);
            num_part++;
            }
          else if (!aux_lista_part[i] && lista_part[i] && (i!=id_est))
                 {
                 Enviar_MPDL_INDIVIDUAL_ABORT_Ind(i);
                 num_part--;
                 }
        memcpy(&lista_part[1],&aux_lista_part[1],Num_Estacoes);
        if (!lista_part [id_est]) // NP24
          {
          Enviar_SMPARM(id_fonte);
          if (!Reiniciar_Timer (Cod_Temp_TR,Tempo_TR)) // A4
            Criar_Timer (0,Tempo_TR,&Cod_Temp_TR);
          Estado = ESTABLISH_REC;
          }
        break;

      case Cod_MPRP:   // Establish
      case Cod_MPDISCAC:
      case Cod_TP:
      case Cod_TG:
      case Cod_BM:
      case Cod_MPI:
      case Cod_RR:
      case Cod_SREJ:
      case Cod_RP:
        canal_p_ocupado=true; // A46
        break;

//     case Cod_DISCAC:
//     case Cod_CM:
//       break;

      case Cod_Erro:   // Establish
        #ifdef MSG
        Msg_Maq("Erro em PDU");
        printf("%2d",Ptr_Primitiva->Ptr_Parametros_Primitiva->Info[2]);
        printf("%2d",Ptr_Primitiva->Ptr_Parametros_Primitiva->Tam_Info);
        #endif
        Enviar_MPDL_ABORT_Ind(ERR);
//        Enviar_MPDISC();
  //      Enviar_MPDISC();
        Reiniciar_Camada_MPDL(); // A42 A43 A8 A28 A66 A70 A12 A76 => CLOSED
        break;

       } // fim switch
     } // fim do if

   // Retira da fila de primitivas e, em caso de primitiva de dados, libera Buffer_Rx
  if (Ptr_Primitiva->Nome_Primitiva == MA_DATA_Indication)
    {
    Dealocar_Fila_Primitivas_M_L ();
    Dealocar_Quadro_Buffer_Rx ();
    }
  else
    Dealocar_Fila_Primitivas_M_L ();


  } // fim Tratar_Establish_MACMPDL


/***************************************************************************/
/*                                                                         */
/*   Rotinas de montagem e envio de PDU's                                  */
/*                                                                         */
/***************************************************************************/

void Enviar_SMPARM (unsigned char id_dest)
  {
   Ptr_Elem_Buffer_Tx             Ptr_Buffer;
   Ptr_Estrutura_Primitiva_L_M  Ptr_Primitiva;

   Ptr_Buffer = Alocar_Quadro_Buffer_Tx ();
   if (Ptr_Buffer)   // Conseguiu alocar sem problemas
     {
      Ptr_Primitiva = Alocar_Fila_Primitivas_L_M ();
      if (Ptr_Primitiva)
        {
        /*
        num_alocacoes_Tx++;
        num_aloc_fila_LM++;
        */
        Ptr_Buffer->Tam_Info = 3;
        Ptr_Buffer->Info[0] = id_est;          // End. Fonte
        Ptr_Buffer->Info[1] = id_dest;
        Ptr_Buffer->Info[2] = Cod_SMPARM;
        Ptr_Buffer->End_Destino = id_dest;

        // Coloca na fila DL PH
        Ptr_Primitiva->Nome_Primitiva = MA_DATA_Request;
        Ptr_Primitiva->Ptr_Parametros_Primitiva = Ptr_Buffer;
        Enviar_Primitiva_L_M ();
        }
       else
        Dealocar_Quadro_Buffer_Tx_Recem_Alocado();
        //Dealocar_Quadro_Buffer_Tx();


     } // if Ptr_Buffer

  } // fim Enviar_SMPARM

void Enviar_MPARMAC (unsigned char id_dest)
  {
  Ptr_Elem_Buffer_Tx             Ptr_Buffer;
  Ptr_Estrutura_Primitiva_L_M  Ptr_Primitiva;

  Ptr_Buffer = Alocar_Quadro_Buffer_Tx ();
  if (Ptr_Buffer)
    {
    Ptr_Primitiva = Alocar_Fila_Primitivas_L_M ();
    if (Ptr_Primitiva)
      {
      /*
      num_alocacoes_Tx++;
      num_aloc_fila_LM++;
      */
      Ptr_Buffer->Tam_Info = 4;
      Ptr_Buffer->Info[0] = id_est;          // End. Fonte
      Ptr_Buffer->Info[1] = id_dest;
      Ptr_Buffer->Info[2] = Cod_MPARMAC;
      Ptr_Buffer->Info[3] = mestra;      // true ou false
      Ptr_Buffer->End_Destino = id_dest;

      // Coloca na fila DL PH
      Ptr_Primitiva->Nome_Primitiva = MA_DATA_Request;
      Ptr_Primitiva->Ptr_Parametros_Primitiva = Ptr_Buffer;
      Enviar_Primitiva_L_M ();
      }
     else
      Dealocar_Quadro_Buffer_Tx_Recem_Alocado();
      //Dealocar_Quadro_Buffer_Tx();


    } // if Ptr_Buffer

  } // fim Enviar_MPARMAC



void  Enviar_MPDISC (void)
  {
  Ptr_Elem_Buffer_Tx             Ptr_Buffer;
  Ptr_Estrutura_Primitiva_L_M  Ptr_Primitiva;

  Ptr_Buffer = Alocar_Quadro_Buffer_Tx ();
  if (Ptr_Buffer)
    {
    if ((Ptr_Primitiva = Alocar_Fila_Primitivas_L_M ()) != NULL)
      {
      /*
      num_alocacoes_Tx++;
      num_aloc_fila_LM++;
      */
      Ptr_Buffer->Tam_Info = 3;
      Ptr_Buffer->Info[0] = id_est;          // End. Fonte
      Ptr_Buffer->Info[1] = 0xFF;
      Ptr_Buffer->Info[2] = Cod_MPDISC;
      Ptr_Buffer->End_Destino = 0xFF;   // End. de difusao

      // Coloca na fila DL PH
      Ptr_Primitiva->Nome_Primitiva = MA_DATA_Request;
      Ptr_Primitiva->Ptr_Parametros_Primitiva = Ptr_Buffer;
      Enviar_Primitiva_L_M ();
      if (!Reiniciar_Timer (Cod_Temp_TIM, Tempo_TIM))  // A65
        Criar_Timer (0,Tempo_TIM,&Cod_Temp_TIM);
      }
     else
      Dealocar_Quadro_Buffer_Tx_Recem_Alocado();
      //Dealocar_Quadro_Buffer_Tx();

    } // if Ptr_Buffer

  } // fim Enviar_MPDISC


void  Enviar_MPDISCAC (unsigned char id_dest)
  {
  Ptr_Elem_Buffer_Tx             Ptr_Buffer;
  Ptr_Estrutura_Primitiva_L_M  Ptr_Primitiva;

  Ptr_Buffer = Alocar_Quadro_Buffer_Tx ();
  if (Ptr_Buffer)
    {
    if ((Ptr_Primitiva = Alocar_Fila_Primitivas_L_M ()) != NULL)
      {
      /*
      num_alocacoes_Tx++;
      num_aloc_fila_LM++;
      */
      Ptr_Buffer->Tam_Info = 3;
      Ptr_Buffer->Info[0] = id_est;          // End. Fonte
      Ptr_Buffer->Info[1] = id_dest;
      Ptr_Buffer->Info[2] = Cod_MPDISCAC;
      Ptr_Buffer->End_Destino = id_dest;

      // Coloca na fila DL PH
      Ptr_Primitiva->Nome_Primitiva = MA_DATA_Request;
      Ptr_Primitiva->Ptr_Parametros_Primitiva = Ptr_Buffer;
      Enviar_Primitiva_L_M ();
      }
     else
      Dealocar_Quadro_Buffer_Tx_Recem_Alocado();
      //Dealocar_Quadro_Buffer_Tx();

    } // if Ptr_Buffer

  } // fim Enviar_MPDISCAC


void  Enviar_DISC (unsigned char id_dest)
  {
  Ptr_Elem_Buffer_Tx           Ptr_Buffer;
  Ptr_Estrutura_Primitiva_L_M  Ptr_Primitiva;

  Ptr_Buffer = Alocar_Quadro_Buffer_Tx ();
  if (Ptr_Buffer)
    {
    if ((Ptr_Primitiva = Alocar_Fila_Primitivas_L_M ()) != NULL)
      {
      /*
      num_alocacoes_Tx++;
      num_aloc_fila_LM++;
      */
      Ptr_Buffer->Tam_Info = 3;
      Ptr_Buffer->Info[0] = id_est;          // End. Fonte
      Ptr_Buffer->Info[1] = id_dest;
      Ptr_Buffer->Info[2] = Cod_DISC;
      Ptr_Buffer->End_Destino = id_dest;   // End. destino

      // Coloca na fila DL PH
      Ptr_Primitiva->Nome_Primitiva = MA_DATA_Request;
      Ptr_Primitiva->Ptr_Parametros_Primitiva = Ptr_Buffer;
      Enviar_Primitiva_L_M ();
      if (!Reiniciar_Timer (Cod_Temp_TIM, Tempo_TIM))  // A65
        Criar_Timer (0,Tempo_TIM,&Cod_Temp_TIM);
      }
     else
      Dealocar_Quadro_Buffer_Tx_Recem_Alocado();
      //Dealocar_Quadro_Buffer_Tx();

    } // if Ptr_Buffer

  } // fim Enviar_DISC


void  Enviar_DISCAC (unsigned char id_dest)
  {
  Ptr_Elem_Buffer_Tx           Ptr_Buffer;
  Ptr_Estrutura_Primitiva_L_M  Ptr_Primitiva;

  Ptr_Buffer = Alocar_Quadro_Buffer_Tx ();
  if (Ptr_Buffer)
    {
    if ((Ptr_Primitiva = Alocar_Fila_Primitivas_L_M ()) != NULL)
      {
      /*
      num_alocacoes_Tx++;
      num_aloc_fila_LM++;
      */
      Ptr_Buffer->Tam_Info = 3;
      Ptr_Buffer->Info[0] = id_est;          // End. Fonte
      Ptr_Buffer->Info[1] = id_dest;
      Ptr_Buffer->Info[2] = Cod_DISCAC;
      Ptr_Buffer->End_Destino = id_dest;   // End. destino

      // Coloca na fila DL PH
      Ptr_Primitiva->Nome_Primitiva = MA_DATA_Request;
      Ptr_Primitiva->Ptr_Parametros_Primitiva = Ptr_Buffer;
      Enviar_Primitiva_L_M ();
      }
     else
      Dealocar_Quadro_Buffer_Tx_Recem_Alocado();
      //Dealocar_Quadro_Buffer_Tx();

    } // if Ptr_Buffer

  } // fim Enviar_DISCAC


Boolean  Enviar_Quadro_I (Ptr_Estrutura_Parametros  Ptr_Est_Quadro, Long  Ns)
  {
   // retorna True se conseguir enviar e False em caso contrario

   Ptr_Elem_Buffer_Tx                   Ptr_Buffer;
   Ptr_Estrutura_Primitiva_L_M        Ptr_Primitiva;
   unsigned int                         Tamanho;
   Ptr_Estrutura_Parametros             Ptr_Fonte;
   unsigned char                        *Ptr_Dest;

   Ptr_Buffer = Alocar_Quadro_Buffer_Tx ();
   if (Ptr_Buffer)
     {
      if ((Ptr_Primitiva = Alocar_Fila_Primitivas_L_M ()) != NULL)
        {
        /*
        num_alocacoes_Tx++;
        num_aloc_fila_LM++;
        */
        Ptr_Buffer->Info[0] = id_est;          // End. Fonte
        Ptr_Buffer->Info[1] = 0xFF;
        Ptr_Buffer->Info[2] = Cod_MPI;

        // Copia Ns para Buffer Tx
        Escrever_Long (&(Ptr_Buffer->Info[3]), Ns);

        // Copia dados para Buffer Tx
        Tamanho = 7;
        Ptr_Dest = &(Ptr_Buffer->Info[7]);
        Ptr_Fonte = Ptr_Est_Quadro;
        do
          {
          enable();
          memcpy(Ptr_Dest,Ptr_Fonte->Ptr_Dados_Usuario,Ptr_Fonte->Tam_Dados_Usuario);
          disable();
          Tamanho += Ptr_Fonte->Tam_Dados_Usuario;
          Ptr_Dest += Ptr_Fonte->Tam_Dados_Usuario;
          Ptr_Fonte = Ptr_Fonte->Ptr_Proximo;
          }
        while (Ptr_Fonte);
        Ptr_Buffer->Tam_Info = Tamanho;
        Ptr_Buffer->End_Destino = 0xFF;   // End. de difusao

        // Coloca na fila DL PH
        Ptr_Primitiva->Nome_Primitiva = MA_DATA_Request;
        Ptr_Primitiva->Ptr_Parametros_Primitiva = Ptr_Buffer;
        Enviar_Primitiva_L_M ();
        return (True);
        }
       else
        {
        Dealocar_Quadro_Buffer_Tx_Recem_Alocado();
        //Dealocar_Quadro_Buffer_Tx();
        return (False);
        }

     } // if Ptr_Buffer
   else
      return (False);

  } // fim Enviar_Quadro_I


Boolean  Enviar_PLIST (Long  Ns)
  {
   // retorna True se conseguir enviar e False em caso contrario

   Ptr_Elem_Buffer_Tx                 Ptr_Buffer;
   Ptr_Estrutura_Primitiva_L_M        Ptr_Primitiva;
//   unsigned int                         Tamanho;
//   Ptr_Estrutura_Parametros             Ptr_Fonte;
   unsigned char                        *Ptr_Dest;

   Ptr_Buffer = Alocar_Quadro_Buffer_Tx ();
   if (Ptr_Buffer)
     {
     if ((Ptr_Primitiva = Alocar_Fila_Primitivas_L_M ()) != NULL)
        {
        /*
        num_alocacoes_Tx++;
        num_aloc_fila_LM++;
        */
        Ptr_Buffer->Info[0] = id_est;          // End. Fonte
        Ptr_Buffer->Info[1] = 0xFF;
        Ptr_Buffer->Info[2] = Cod_PLIST;

        // Copia Ns para Buffer Tx
        Escrever_Long (&(Ptr_Buffer->Info[3]), Ns);

        // Copia dados para Buffer Tx
        Ptr_Dest = &(Ptr_Buffer->Info[7]);
        memcpy(Ptr_Dest,&lista_part[1],Num_Estacoes);
        Ptr_Buffer->Tam_Info = 7 + Num_Estacoes;
        Ptr_Buffer->End_Destino = 0xFF;   // End. de difusao

        // Coloca na fila DL MAC
        Ptr_Primitiva->Nome_Primitiva = MA_DATA_Request;
        Ptr_Primitiva->Ptr_Parametros_Primitiva = Ptr_Buffer;
        Enviar_Primitiva_L_M ();
        if (!Reiniciar_Timer (Cod_Temp_TIM, Tempo_TIM))  // A65
          Criar_Timer (0,Tempo_TIM,&Cod_Temp_TIM);
        return (True);
        }
       else
        {
        Dealocar_Quadro_Buffer_Tx_Recem_Alocado();
        /*Dealocar_Quadro_Buffer_Tx();  isto estava completamente furado!
                                        eh feita uma alocacao num extremo da
                                        fila e a delalocacao o eh no outro
                                        extremo */

        return (False);
        }

     } // if Ptr_Buffer
   else
      return (False);

  } // fim Enviar_Quadro_I


void  Enviar_RR (Long Nr)
  {
   Ptr_Elem_Buffer_Tx           Ptr_Buffer;
   Ptr_Estrutura_Primitiva_L_M  Ptr_Primitiva;

   Ptr_Buffer = Alocar_Quadro_Buffer_Tx ();
   if (Ptr_Buffer)
     {
     if ((Ptr_Primitiva = Alocar_Fila_Primitivas_L_M ())!=NULL)
       {
       Ptr_Buffer->Tam_Info = 7;
       Ptr_Buffer->End_Destino = id_mestra;
       Ptr_Buffer->Info[0] = id_est;
       Ptr_Buffer->Info[1] = id_mestra;
       Ptr_Buffer->Info[2] = Cod_RR;

       /* Copia Nr para Buffer Tx */
       Escrever_Long (&(Ptr_Buffer->Info[3]), Nr);

       /* Coloca na fila DL PH */
       Ptr_Primitiva->Nome_Primitiva = MA_DATA_Request;
       Ptr_Primitiva->Ptr_Parametros_Primitiva = Ptr_Buffer;
       Enviar_Primitiva_L_M ();
       }
      else
       {
       #ifdef MSG_ERR
       Msg_Status("Faltou prim LM");
       #endif
       Dealocar_Quadro_Buffer_Tx_Recem_Alocado();
       }
     } /* if Ptr_Buffer */

  } /* fim Enviar_RR */


void  Enviar_SREJ (Long Nr, unsigned char id_estacao)
  {
   Ptr_Elem_Buffer_Tx           Ptr_Buffer;
   Ptr_Estrutura_Primitiva_L_M  Ptr_Primitiva;

   Ptr_Buffer = Alocar_Quadro_Buffer_Tx ();
   if (Ptr_Buffer)
     {
     if ((Ptr_Primitiva = Alocar_Fila_Primitivas_L_M ())!=NULL)
       {
       Ptr_Buffer->Tam_Info = 7;
       Ptr_Buffer->End_Destino = id_mestra;
       Ptr_Buffer->Info[0] = id_est;
       Ptr_Buffer->Info[1] = id_estacao;
       Ptr_Buffer->Info[2] = Cod_SREJ;

       // Copia Nr para Buffer Tx
       Escrever_Long (&(Ptr_Buffer->Info[3]), Nr);

       // Coloca na fila DL PH
       Ptr_Primitiva->Nome_Primitiva = MA_DATA_Request;
       Ptr_Primitiva->Ptr_Parametros_Primitiva = Ptr_Buffer;
       Enviar_Primitiva_L_M ();
       }
      else
       Dealocar_Quadro_Buffer_Tx_Recem_Alocado();
     } // if Ptr_Buffer

  } // fim Enviar_SREJ


void  Enviar_MPRP (void)
  {
  Ptr_Elem_Buffer_Tx           Ptr_Buffer;
  Ptr_Estrutura_Primitiva_L_M  Ptr_Primitiva;

  Ptr_Buffer = Alocar_Quadro_Buffer_Tx ();
  if (Ptr_Buffer)
    {
    if ((Ptr_Primitiva = Alocar_Fila_Primitivas_L_M ()) != NULL)
      {
      /*
      num_alocacoes_Tx++;
      num_aloc_fila_LM++;
      */
      Ptr_Buffer->Tam_Info = 3;
      Ptr_Buffer->Info[0] = id_est;          // End. Fonte
      Ptr_Buffer->Info[1] = id_mestra;
      Ptr_Buffer->Info[2] = Cod_MPRP;
      Ptr_Buffer->End_Destino = id_mestra;

      // Coloca na fila DL PH
      Ptr_Primitiva->Nome_Primitiva = MA_DATA_Request;
      Ptr_Primitiva->Ptr_Parametros_Primitiva = Ptr_Buffer;
      Enviar_Primitiva_L_M ();
      }
     else
      Dealocar_Quadro_Buffer_Tx_Recem_Alocado();
      //Dealocar_Quadro_Buffer_Tx();

    } // if Ptr_Buffer

  } // fim Enviar_MPRP


void  Enviar_RP (void)
  {
  Ptr_Elem_Buffer_Tx           Ptr_Buffer;
  Ptr_Estrutura_Primitiva_L_M  Ptr_Primitiva;

  Ptr_Buffer = Alocar_Quadro_Buffer_Tx ();
  if (Ptr_Buffer)
    {
    if ((Ptr_Primitiva = Alocar_Fila_Primitivas_L_M ()) != NULL)
      {
      /*
      num_alocacoes_Tx++;
      num_aloc_fila_LM++;
      */
      Ptr_Buffer->Tam_Info = 3;
      Ptr_Buffer->Info[0] = id_est;          // End. Fonte
      Ptr_Buffer->Info[1] = id_mestra;
      Ptr_Buffer->Info[2] = Cod_RP;
      Ptr_Buffer->End_Destino = id_mestra;

      // Coloca na fila DL PH
      Ptr_Primitiva->Nome_Primitiva = MA_DATA_Request;
      Ptr_Primitiva->Ptr_Parametros_Primitiva = Ptr_Buffer;
      Enviar_Primitiva_L_M ();
      }
     else
      Dealocar_Quadro_Buffer_Tx_Recem_Alocado();
      //Dealocar_Quadro_Buffer_Tx();

    } // if Ptr_Buffer

  } // fim Enviar_RP


void  Enviar_TP (void)
  {
  Ptr_Elem_Buffer_Tx           Ptr_Buffer;
  Ptr_Estrutura_Primitiva_L_M  Ptr_Primitiva;

  Ptr_Buffer = Alocar_Quadro_Buffer_Tx ();
  if (Ptr_Buffer)
    {
    if ((Ptr_Primitiva = Alocar_Fila_Primitivas_L_M ()) != NULL)
      {
      /*
      num_alocacoes_Tx++;
      num_aloc_fila_LM++;
      */
      Ptr_Buffer->Tam_Info = 3;
      Ptr_Buffer->Info[0] = id_est;          // End. Fonte
      Ptr_Buffer->Info[1] = id_mestra;
      Ptr_Buffer->Info[2] = Cod_TP;
      Ptr_Buffer->End_Destino = id_mestra;

      // Coloca na fila DL PH
      Ptr_Primitiva->Nome_Primitiva = MA_DATA_Request;
      Ptr_Primitiva->Ptr_Parametros_Primitiva = Ptr_Buffer;
      Enviar_Primitiva_L_M ();
      }
     else
      Dealocar_Quadro_Buffer_Tx_Recem_Alocado();
      //Dealocar_Quadro_Buffer_Tx();

    } // if Ptr_Buffer

  } // fim Enviar_TP

void  Enviar_BM (void)
  {
  Ptr_Elem_Buffer_Tx           Ptr_Buffer;
  Ptr_Estrutura_Primitiva_L_M  Ptr_Primitiva;

  Ptr_Buffer = Alocar_Quadro_Buffer_Tx ();
  if (Ptr_Buffer)
    {
    if ((Ptr_Primitiva = Alocar_Fila_Primitivas_L_M ()) != NULL)
      {
      /*
      num_alocacoes_Tx++;
      num_aloc_fila_LM++;
      */
      Ptr_Buffer->Tam_Info = 3;
      Ptr_Buffer->Info[0] = id_est;          // End. Fonte
      Ptr_Buffer->Info[1] = 0xFF;
      Ptr_Buffer->Info[2] = Cod_BM;
      Ptr_Buffer->End_Destino = 0xFF;

      // Coloca na fila DL PH
      Ptr_Primitiva->Nome_Primitiva = MA_DATA_Request;
      Ptr_Primitiva->Ptr_Parametros_Primitiva = Ptr_Buffer;
      Enviar_Primitiva_L_M ();
      }
     else
      Dealocar_Quadro_Buffer_Tx_Recem_Alocado();
      //Dealocar_Quadro_Buffer_Tx();

    } // if Ptr_Buffer

  } // fim Enviar_TP

void  Enviar_CM (unsigned char id_estacao)
  {
  Ptr_Elem_Buffer_Tx           Ptr_Buffer;
  Ptr_Estrutura_Primitiva_L_M  Ptr_Primitiva;

  Ptr_Buffer = Alocar_Quadro_Buffer_Tx ();
  if (Ptr_Buffer)
    {
    if ((Ptr_Primitiva = Alocar_Fila_Primitivas_L_M ()) != NULL)
      {
      /*
      num_alocacoes_Tx++;
      num_aloc_fila_LM++;
      */
      Ptr_Buffer->Tam_Info = 3;
      Ptr_Buffer->Info[0] = id_est;          // End. Fonte
      Ptr_Buffer->Info[1] = id_estacao;
      Ptr_Buffer->Info[2] = Cod_CM;
      Ptr_Buffer->End_Destino = id_estacao;

      // Coloca na fila DL PH
      Ptr_Primitiva->Nome_Primitiva = MA_DATA_Request;
      Ptr_Primitiva->Ptr_Parametros_Primitiva = Ptr_Buffer;
      Enviar_Primitiva_L_M ();
      }
     else
      Dealocar_Quadro_Buffer_Tx_Recem_Alocado();
      //Dealocar_Quadro_Buffer_Tx();

    } // if Ptr_Buffer

  } // fim Enviar_TP



void  Enviar_TG (unsigned char id_nova_mestra)
  {
  Ptr_Elem_Buffer_Tx           Ptr_Buffer;
  Ptr_Estrutura_Primitiva_L_M  Ptr_Primitiva;
  unsigned char                *Ptr_Dest;

  Ptr_Buffer = Alocar_Quadro_Buffer_Tx ();
  if (Ptr_Buffer)
    {
    if ((Ptr_Primitiva = Alocar_Fila_Primitivas_L_M ()) != NULL)
      {
      /*
      num_alocacoes_Tx++;
      num_aloc_fila_LM++;
      */
      Ptr_Buffer->Tam_Info = 6+Num_Estacoes;
      Ptr_Buffer->Info[0] = id_est;          // End. Fonte
      Ptr_Buffer->Info[1] = 0xFF;
      Ptr_Buffer->Info[2] = Cod_TG;
      //Escrever_Long (&(Ptr_Buffer->Info[3]), Nr); passou a ser nao numerado
      Ptr_Buffer->Info[3] = id_nova_mestra;
      Ptr_Dest=&Ptr_Buffer->Info[4];
      memcpy(Ptr_Dest,&fila_esp[1],Num_Estacoes);
      Ptr_Dest+=Num_Estacoes;
      *Ptr_Dest++=prim_fila;
      *Ptr_Dest=ult_fila;

      Ptr_Buffer->End_Destino = 0xFF;

      // Coloca na fila DL PH
      Ptr_Primitiva->Nome_Primitiva = MA_DATA_Request;
      Ptr_Primitiva->Ptr_Parametros_Primitiva = Ptr_Buffer;
      Enviar_Primitiva_L_M ();
      }
     else
      Dealocar_Quadro_Buffer_Tx_Recem_Alocado();
      //Dealocar_Quadro_Buffer_Tx();

    } // if Ptr_Buffer

  } // fim Enviar_TG



/***************************************************************************/
/*                                                                         */
/*   Rotinas de montagem e envio de primitivas MPDLN                       */
/*                                                                         */
/***************************************************************************/

void Enviar_MPDL_ESTABLISH_Ind(unsigned char id_estacao)
  {
  Ptr_Estrutura_Primitiva_MPDL_N    Ptr_Primitiva;

  Ptr_Primitiva = (Ptr_Estrutura_Primitiva_MPDL_N) Alocar_Estrutura_Primitiva_Rx ();
  Ptr_Primitiva->Nome_Primitiva = MPDL_ESTABLISH_Indication;
  if (((Ptr_Primitiva->Ptr_Parametros_Primitiva =Alocar_Estrutura_Parametros_Rx ())!=NULL) &&
     ((Ptr_Primitiva->Ptr_Parametros_Primitiva->Ptr_Parametros = Alocar_Memoria_Rx(1))!=NULL))
    {
    *Ptr_Primitiva->Ptr_Parametros_Primitiva->Ptr_Parametros = id_estacao;
    Enviar_Primitiva_MPDL_N (Ptr_Primitiva);
    }
  else
    Faltou_Mem_Rx();
  }


void Enviar_MPDL_ESTABLISH_Conf (Boolean conexao)
  {
  Ptr_Estrutura_Primitiva_MPDL_N    Ptr_Primitiva;
  unsigned char                     *Ptr_Param;

  Ptr_Primitiva = (Ptr_Estrutura_Primitiva_MPDL_N) Alocar_Estrutura_Primitiva_Rx ();
  Ptr_Primitiva->Nome_Primitiva = MPDL_ESTABLISH_Confirm;
  if (((Ptr_Primitiva->Ptr_Parametros_Primitiva =Alocar_Estrutura_Parametros_Rx ())!=NULL) &&
     ((Ptr_Primitiva->Ptr_Parametros_Primitiva->Ptr_Parametros = Alocar_Memoria_Rx(1+Num_Estacoes))!=NULL))
    {
    Ptr_Param=Ptr_Primitiva->Ptr_Parametros_Primitiva->Ptr_Parametros;
    *Ptr_Param = conexao;
    Ptr_Param++;
    memcpy(Ptr_Param,&lista_part[1],Num_Estacoes);
    Enviar_Primitiva_MPDL_N (Ptr_Primitiva);
    }
  else
    Faltou_Mem_Rx();
  }


void Enviar_MPDL_ABORT_Ind  (unsigned char id_estacao)
  {
  Ptr_Estrutura_Primitiva_MPDL_N    Ptr_Primitiva;

  Ptr_Primitiva = (Ptr_Estrutura_Primitiva_MPDL_N) Alocar_Estrutura_Primitiva_Rx ();
  Ptr_Primitiva->Nome_Primitiva = MPDL_ABORT_Indication;
  if (((Ptr_Primitiva->Ptr_Parametros_Primitiva =Alocar_Estrutura_Parametros_Rx ())!=NULL) &&
     ((Ptr_Primitiva->Ptr_Parametros_Primitiva->Ptr_Parametros = Alocar_Memoria_Rx(1))!=NULL))
    {
    *Ptr_Primitiva->Ptr_Parametros_Primitiva->Ptr_Parametros = id_estacao;
    Enviar_Primitiva_MPDL_N (Ptr_Primitiva);
    }
  else
    Faltou_Mem_Rx();
  }

void Enviar_MPDL_RELEASE_PLEASE_Ind  (unsigned char id_estacao)
  {
  Ptr_Estrutura_Primitiva_MPDL_N    Ptr_Primitiva;

  Ptr_Primitiva = (Ptr_Estrutura_Primitiva_MPDL_N) Alocar_Estrutura_Primitiva_Rx ();
  Ptr_Primitiva->Nome_Primitiva = MPDL_RELEASE_PLEASE_Indication;
  if (((Ptr_Primitiva->Ptr_Parametros_Primitiva =Alocar_Estrutura_Parametros_Rx ())!=NULL) &&
     ((Ptr_Primitiva->Ptr_Parametros_Primitiva->Ptr_Parametros = Alocar_Memoria_Rx(1))!=NULL))
    {
    *Ptr_Primitiva->Ptr_Parametros_Primitiva->Ptr_Parametros = id_estacao;
    Enviar_Primitiva_MPDL_N (Ptr_Primitiva);
    }
  else
    Faltou_Mem_Rx();
  }


void Enviar_MPDL_ABORT_Conf (void)
  {
  Ptr_Estrutura_Primitiva_MPDL_N    Ptr_Primitiva;

  Ptr_Primitiva = (Ptr_Estrutura_Primitiva_MPDL_N) Alocar_Estrutura_Primitiva_Rx ();
  Ptr_Primitiva->Nome_Primitiva = MPDL_ABORT_Confirm;
  Ptr_Primitiva->Ptr_Parametros_Primitiva = NULL;
  Enviar_Primitiva_MPDL_N (Ptr_Primitiva);
  }


void Enviar_MPDL_INDIVIDUAL_ABORT_Ind   (unsigned char id_estacao)
  {
  Ptr_Estrutura_Primitiva_MPDL_N    Ptr_Primitiva;

  Ptr_Primitiva = (Ptr_Estrutura_Primitiva_MPDL_N) Alocar_Estrutura_Primitiva_Rx ();
  Ptr_Primitiva->Nome_Primitiva = MPDL_INDIVIDUAL_ABORT_Indication;
  if (((Ptr_Primitiva->Ptr_Parametros_Primitiva =Alocar_Estrutura_Parametros_Rx ())!=NULL) &&
     ((Ptr_Primitiva->Ptr_Parametros_Primitiva->Ptr_Parametros = Alocar_Memoria_Rx(1))!=NULL))
    {
    *Ptr_Primitiva->Ptr_Parametros_Primitiva->Ptr_Parametros = id_estacao;
    Enviar_Primitiva_MPDL_N (Ptr_Primitiva);
    }
  else
    Faltou_Mem_Rx();
  }

void Enviar_MPDL_INDIVIDUAL_ABORT_Conf (unsigned char id_estacao)
  {
  Ptr_Estrutura_Primitiva_MPDL_N    Ptr_Primitiva;

  Ptr_Primitiva = (Ptr_Estrutura_Primitiva_MPDL_N) Alocar_Estrutura_Primitiva_Rx ();
  Ptr_Primitiva->Nome_Primitiva = MPDL_INDIVIDUAL_ABORT_Confirm;
  if (((Ptr_Primitiva->Ptr_Parametros_Primitiva =Alocar_Estrutura_Parametros_Rx ())!=NULL) &&
     ((Ptr_Primitiva->Ptr_Parametros_Primitiva->Ptr_Parametros = Alocar_Memoria_Rx(1))!=NULL))
    {
    *Ptr_Primitiva->Ptr_Parametros_Primitiva->Ptr_Parametros = id_estacao;
    Enviar_Primitiva_MPDL_N (Ptr_Primitiva);
    }
  else
    Faltou_Mem_Rx();
  }


void Enviar_MPDL_TOKEN_PLEASE_Ind   (unsigned char id_estacao)
  {
  Ptr_Estrutura_Primitiva_MPDL_N    Ptr_Primitiva;

  Ptr_Primitiva = (Ptr_Estrutura_Primitiva_MPDL_N) Alocar_Estrutura_Primitiva_Rx ();
  Ptr_Primitiva->Nome_Primitiva = MPDL_TOKEN_PLEASE_Indication;
  if (((Ptr_Primitiva->Ptr_Parametros_Primitiva =Alocar_Estrutura_Parametros_Rx ())!=NULL) &&
     ((Ptr_Primitiva->Ptr_Parametros_Primitiva->Ptr_Parametros = Alocar_Memoria_Rx(1))!=NULL))
    {
    *Ptr_Primitiva->Ptr_Parametros_Primitiva->Ptr_Parametros = id_estacao;
    Enviar_Primitiva_MPDL_N (Ptr_Primitiva);
    }
  else
    Faltou_Mem_Rx();
  }

void Enviar_MPDL_IND_RELEASE_PLEASE_Ind   (unsigned char id_estacao)
  {
  Ptr_Estrutura_Primitiva_MPDL_N    Ptr_Primitiva;

  Ptr_Primitiva = (Ptr_Estrutura_Primitiva_MPDL_N) Alocar_Estrutura_Primitiva_Rx ();
  Ptr_Primitiva->Nome_Primitiva = MPDL_IND_RELEASE_PLEASE_Indication;
  if (((Ptr_Primitiva->Ptr_Parametros_Primitiva =Alocar_Estrutura_Parametros_Rx ())!=NULL) &&
     ((Ptr_Primitiva->Ptr_Parametros_Primitiva->Ptr_Parametros = Alocar_Memoria_Rx(1))!=NULL))
    {
    *Ptr_Primitiva->Ptr_Parametros_Primitiva->Ptr_Parametros = id_estacao;
    Enviar_Primitiva_MPDL_N (Ptr_Primitiva);
    }
  else
    Faltou_Mem_Rx();
  }

void Enviar_MPDL_TOKEN_GIVE_Ind (void)
  {
  Ptr_Estrutura_Primitiva_MPDL_N    Ptr_Primitiva;

  Ptr_Primitiva = (Ptr_Estrutura_Primitiva_MPDL_N) Alocar_Estrutura_Primitiva_Rx ();
  Ptr_Primitiva->Nome_Primitiva = MPDL_TOKEN_GIVE_Indication;
  Ptr_Primitiva->Ptr_Parametros_Primitiva = NULL;
  Enviar_Primitiva_MPDL_N (Ptr_Primitiva);
  }


void Enviar_MPDL_STOP_TRANSMISSION_Ind (void)
  {
  Ptr_Estrutura_Primitiva_MPDL_N    Ptr_Primitiva;

  Ptr_Primitiva = (Ptr_Estrutura_Primitiva_MPDL_N) Alocar_Estrutura_Primitiva_Rx ();
  Ptr_Primitiva->Nome_Primitiva = MPDL_STOP_TRANSMISSION_Indication;
  Ptr_Primitiva->Ptr_Parametros_Primitiva = NULL;
  Enviar_Primitiva_MPDL_N (Ptr_Primitiva);
  }


void Enviar_MPDL_DATA_Ind (Ptr_Estrutura_Parametros  Ptr_Parametros_Prim,
                           unsigned char             Id_Receptor)
  {
  Ptr_Estrutura_Primitiva_MPDL_N    Ptr_Primitiva;

  Ptr_Primitiva = (Ptr_Estrutura_Primitiva_MPDL_N) Alocar_Estrutura_Primitiva_Rx ();
  Ptr_Primitiva->Nome_Primitiva = MPDL_DATA_Indication;
  Ptr_Primitiva->Ptr_Parametros_Primitiva = Ptr_Parametros_Prim;
  if ((Ptr_Primitiva->Ptr_Parametros_Primitiva->Ptr_Parametros=Alocar_Memoria_Rx(1))!=NULL)
    {
    *Ptr_Primitiva->Ptr_Parametros_Primitiva->Ptr_Parametros=Id_Receptor;
    Enviar_Primitiva_MPDL_N (Ptr_Primitiva);
    }
  else
    Faltou_Mem_Rx();
  }

/***************************************************************************/
/*                                                                         */
/*    Rotinas de manipulacao da Lista de Quadros Armazenados               */
/*                                                                         */
/***************************************************************************/


Boolean Inserir_na_Lista_de_Quadros_Armazenados
           (Ptr_Estrutura_Parametros Ptr_Dados_Quadro,
            Long                     Ns)
  {
   // Retorna True se conseguiu inserir na lista

  Ptr_Elemento_Lista_Quadros_Armazenados  Ptr_Aux;
  unsigned char                           i;

  //video[6]=0x30;
  Ptr_Aux = (Ptr_Elemento_Lista_Quadros_Armazenados) Alocar_Memoria_Tx(sizeof(Tipo_Lista_Quadros_Armazenados));
  if (Ptr_Aux)
    {
    //video[6]=0x31;
    Ptr_Aux->Num_Quadro = Ns;
    Ptr_Aux->Ptr_Quadro = Ptr_Dados_Quadro;
    Ptr_Aux->num_conf_pendentes=num_part-1;
    for (i = 1; i <= Num_Estacoes; i++)
      Ptr_Aux->Quadro_Confirmado [i] = False;
    if (!Prim_Lista_Quadros_Armazenados)  // Lista vazia
      Prim_Lista_Quadros_Armazenados = Ptr_Aux;
    else
      Ult_Lista_Quadros_Armazenados->Ptr_Proximo = Ptr_Aux;
    Ult_Lista_Quadros_Armazenados = Ptr_Aux;
    Ult_Lista_Quadros_Armazenados->Ptr_Proximo = NULL;
    Num_Elem_Lista_Quadros_Armazenados++;
    //video[6]=0x32;
    return (True);
    }
  else   // Nao conseguiu alocar
    return (False);
  } // fim Inserir_na_Lista_de_Quadros_Armazenados


Ptr_Elemento_Lista_Quadros_Armazenados
   Retirar_da_Lista_de_Quadros_Armazenados
     (Ptr_Elemento_Lista_Quadros_Armazenados Ptr_Lista)

  {
  Ptr_Elemento_Lista_Quadros_Armazenados  Ptr_Retorno,
                                          Ptr_Aux;

  if (Ptr_Lista == Prim_Lista_Quadros_Armazenados)
    {
    Prim_Lista_Quadros_Armazenados = Prim_Lista_Quadros_Armazenados->Ptr_Proximo;
    Ptr_Retorno = Prim_Lista_Quadros_Armazenados;
    Liberar_Estrutura_Parametros_Tx (Ptr_Lista->Ptr_Quadro);
    Liberar_Memoria_Tx ((unsigned char *) Ptr_Lista, sizeof (Tipo_Lista_Quadros_Armazenados));
    } // if Ptr_Lista == Prim
  else
    {
    Ptr_Aux = Prim_Lista_Quadros_Armazenados;
    while (Ptr_Aux->Ptr_Proximo != Ptr_Lista)
      Ptr_Aux = Ptr_Aux->Ptr_Proximo;
    // Sai do loop com Ptr_Aux apontando para o anterior de Ptr_Lista
    // (que e' o elemento a ser retirado)
    Ptr_Aux->Ptr_Proximo = Ptr_Lista->Ptr_Proximo;
    Ptr_Retorno = Ptr_Lista->Ptr_Proximo;
    if (Ptr_Lista == Ult_Lista_Quadros_Armazenados)
      Ult_Lista_Quadros_Armazenados = Ptr_Aux;
    Liberar_Estrutura_Parametros_Tx (Ptr_Lista->Ptr_Quadro);
    Liberar_Memoria_Tx ((unsigned char *) Ptr_Lista, sizeof (Tipo_Lista_Quadros_Armazenados));
    } // else do if Ptr_Lista == Prim
  Num_Elem_Lista_Quadros_Armazenados--;
  return (Ptr_Retorno);

  } // fim Retirar_da_Lista_de_Quadros_Armazenados


void Descartar_Lista_de_Quadros_Armazenados (void)
  {
  Ptr_Elemento_Lista_Quadros_Armazenados  Ptr_Lista;

  while (Prim_Lista_Quadros_Armazenados)
    {
    Ptr_Lista = Prim_Lista_Quadros_Armazenados;
    Prim_Lista_Quadros_Armazenados = Prim_Lista_Quadros_Armazenados->Ptr_Proximo;
    Liberar_Memoria_Rx ((unsigned char *) Ptr_Lista, sizeof (Tipo_Lista_Quadros_Armazenados));
    } // fim while
  Num_Elem_Lista_Quadros_Armazenados = 0;

  } // fim Descartar_Lista_de_Quadros_Armazenados



/***************************************************************************/
/*                                                                         */
/*       Rotinas  Gerais                                                   */
/*                                                                         */
/***************************************************************************/

void Coloca_na_Fila(unsigned char id_estacao)
  {
  if (!Esta_na_Fila_de_Espera(id_estacao))
    {
    if (((ult_fila % Num_Estacoes) +1) == prim_fila)
      printf(" MELDA: ENCHEU A FILA DE ESPERA ");
    else
      {
      fila_esp[ult_fila]=id_estacao;
      ult_fila=(ult_fila % Num_Estacoes)+1;
      }
    }
  }

Boolean Esta_na_Fila_de_Espera(unsigned char id)
  {
  unsigned char i;
  Boolean n_achou;

  i=prim_fila;
  n_achou=true;
  while ((i!=ult_fila) && n_achou)
    if (id==fila_esp[i])
      n_achou=false;
    else
      i=(i % Num_Estacoes)+1;
  return(!n_achou);
  } // esta_na_fila


void Retirar_da_Fila_de_Espera (unsigned char id_estacao)
  {
  unsigned char i;

  if (prim_fila != ult_fila)
    {
    for (i=prim_fila;(i!=ult_fila)&&(fila_esp[i]!=id_estacao);)
      i=i++%Num_Estacoes;
    if (fila_esp[i]==id_estacao)
      {
      while (i!=ult_fila)
        {
        fila_esp[i]=fila_esp[i%Num_Estacoes+1];
        i=i++%Num_Estacoes;
        }
      ult_fila--;
      if (ult_fila==0)
        ult_fila=Num_Estacoes;
      } // (fila_esp[i]==id_estacao)
    } // (prim_fila != ult_fila)

  }


unsigned char  Decodificar_PDU (Ptr_Elem_Buffer_Rx  Ptr_Quadro)
  {
  switch (Ptr_Quadro->Info [2])
    {
    case Cod_MPI:
      if (Ptr_Quadro->Tam_Info < Tam_min_MPI)
        return(Cod_Erro);
      else
        return(Cod_MPI);

    case Cod_RR:
      if (Ptr_Quadro->Tam_Info != Tam_RR)
        return(Cod_Erro);
      else
        return(Cod_RR);

    case Cod_SREJ:
      if (Ptr_Quadro->Tam_Info != Tam_SREJ)
        return(Cod_Erro);
      else
        return(Cod_SREJ);

    case Cod_PLIST:
      if (Ptr_Quadro->Tam_Info != Tam_PLIST)
        return(Cod_Erro);
      else
        return(Cod_PLIST);

    case Cod_TG:
      if (Ptr_Quadro->Tam_Info != Tam_TG)
        return(Cod_Erro);
      else
        return(Cod_TG);

    case Cod_BM:
      if (Ptr_Quadro->Tam_Info != Tam_BM)
        return(Cod_Erro);
      else
        return(Cod_BM);

    case Cod_SMPARM:
      if (Ptr_Quadro->Tam_Info != Tam_SMPARM)
        return(Cod_Erro);
      else
        return(Cod_SMPARM);

    case Cod_MPARMAC:
      if (Ptr_Quadro->Tam_Info != Tam_MPARMAC)
        return(Cod_Erro);
      else
        return(Cod_MPARMAC);

    case Cod_MPDISC:
      if (Ptr_Quadro->Tam_Info != Tam_MPDISC)
        return(Cod_Erro);
      else
        return(Cod_MPDISC);

    case Cod_MPDISCAC:
      if (Ptr_Quadro->Tam_Info != Tam_MPDISCAC)
        return(Cod_Erro);
      else
        return(Cod_MPDISCAC);

    case Cod_MPRP:
      if (Ptr_Quadro->Tam_Info != Tam_MPRP)
        return(Cod_Erro);
      else
        return(Cod_MPRP);

    case Cod_DISC:
      if (Ptr_Quadro->Tam_Info != Tam_DISC)
        return(Cod_Erro);
      else
        return(Cod_DISC);

    case Cod_DISCAC:
      if (Ptr_Quadro->Tam_Info != Tam_DISCAC)
        return(Cod_Erro);
      else
        return(Cod_DISCAC);

    case Cod_RP:
      if (Ptr_Quadro->Tam_Info != Tam_RP)
        return(Cod_Erro);
      else
        return(Cod_RP);

    case Cod_TP:
      if (Ptr_Quadro->Tam_Info != Tam_TP)
        return(Cod_Erro);
      else
        return(Cod_TP);

    case Cod_CM:
      if (Ptr_Quadro->Tam_Info != Tam_CM)
        return(Cod_Erro);
      else
        return(Cod_CM);

    default:
      printf ("codigo de PDU nao esperado: %d",Ptr_Quadro->Info [2]);
      return(Cod_Erro);

    } // fim do switch

  } // fim Decodificar_PDU


void Verificar_Descarte_Quadros (unsigned char  Id_Fonte, Long  Nr)
  {
  Ptr_Elemento_Lista_Quadros_Armazenados   Ptr_Lista;
  Boolean                                  houve_descarte=false;

  Ptr_Lista = Prim_Lista_Quadros_Armazenados;
  while ((Ptr_Lista->Num_Quadro < Nr) && (Ptr_Lista))
    {
    if (!Ptr_Lista->Quadro_Confirmado [Id_Fonte])
      {
      if ((--Ptr_Lista->num_conf_pendentes)!=0)
        {  // Nem todos confirmaram
        Ptr_Lista->Quadro_Confirmado [Id_Fonte] = True;
        Ptr_Lista = Ptr_Lista->Ptr_Proximo;
        }
      else // reconhecido por todos
        {
        Ptr_Lista = Retirar_da_Lista_de_Quadros_Armazenados (Ptr_Lista);
        houve_descarte=true;
        }
      }
    else // ja havia sido confirmado pela estacao fonte
      Ptr_Lista = Ptr_Lista->Ptr_Proximo;
    } // fim do while
  if (houve_descarte && mestra)
    if (!Reiniciar_Timer (Cod_Temp_TRQ,Tempo_TRQ)) // A69
      Criar_Timer (0,Tempo_TRQ,&Cod_Temp_TRQ);

  } // fim Verificar_Descarte_Quadros

/*
void   Verificar_Descarte_Quadros (unsigned int  Id_Fonte, Long  Nr)
  {
   Ptr_Elemento_Lista_Quadros_Armazenados   Ptr_Lista;
   unsigned char                            i;

   Ptr_Lista = Prim_Lista_Quadros_Armazenados;
   while ((Ptr_Lista->Num_Quadro < Nr) && (Ptr_Lista))
     {
      Ptr_Lista->Quadro_Confirmado [Id_Fonte] = True;

      for (i = 1; (i <= Num_Receptores) && (Ptr_Lista->Quadro_Confirmado [i]); i++);

      if (i > Num_Receptores) // Quadro apontado por Ptr_Lista foi
                              // reconhecido por todos
        {
         Ptr_Lista = Retirar_da_Lista_de_Quadros_Armazenados (Ptr_Lista);
         if (!Reiniciar_Timer (Cod_Temp_TR,Tempo_TR))
           Criar_Timer (0,Tempo_TR,&Cod_Temp_TR);
        }
      else  // Nem todos confirmaram
        Ptr_Lista = Ptr_Lista->Ptr_Proximo;

     } // fim do while

  } // fim Verificar_Descarte_Quadros
*/

Boolean Quadro_Esta_Lista_de_Armazenados (Long Nr) // Implementa P22
  {
  Ptr_Elemento_Lista_Quadros_Armazenados    Ptr_Lista;

  // Procura quadro de numero Nr na Lista
  Ptr_Lista = Prim_Lista_Quadros_Armazenados;
  while ((Ptr_Lista->Num_Quadro != Nr) && (Ptr_Lista))
    Ptr_Lista = Ptr_Lista->Ptr_Proximo;

  if (Ptr_Lista)
    return(true);
  else
    return(false);
  }

void   Retransmitir_Quadro (Long Nr)
  {
  Ptr_Elemento_Lista_Quadros_Armazenados    Ptr_Lista;

  // Procura quadro de numero Nr na Lista
  Ptr_Lista = Prim_Lista_Quadros_Armazenados;
  while ((Ptr_Lista->Num_Quadro != Nr) && (Ptr_Lista))
    Ptr_Lista = Ptr_Lista->Ptr_Proximo;

  if (Ptr_Lista)  // Achou
    if (!Enviar_Quadro_I (Ptr_Lista->Ptr_Quadro, Ptr_Lista->Num_Quadro))
      Enviar_Rotina_Fila_Gerente_RMOSI (Retransmitir_Quadro, 0);

  } // fim Retransmitir_Quadro

void Verificar_Sequenciamento (Ptr_Estrutura_Parametros  Ptr_Quadro,
                               unsigned char             Id_Receptor)
  {
  Long                                   Ns;
  Boolean                                Nao_Achou;
  Ptr_Elemento_Lista_Quadros_Esperados   Ptr_Lista;


  //video[4]=0x30;
  Ns = Ler_Long (&(Ptr_Quadro->Ptr_Dados_Usuario[3]));
  Ptr_Quadro = Liberar_Parte_Cadeia_Rx (Ptr_Quadro,7);
  if (Ns == Vr [Id_Receptor])
    {
    if (!Prim_Lista_Quadros_Esperados [Id_Receptor]) /* Lista vazia */
      {
      if (*Ptr_Quadro->Ptr_Parametros==Cod_MPI)
        Enviar_MPDL_DATA_Ind (Ptr_Quadro, Id_Receptor);
      //video[4]=0x31;
      }
    else
      Inserir_Lista_Quadros_Rec_Fora_Ordem (Ns, Ptr_Quadro, Id_Receptor);
    Vr [Id_Receptor]++;
    }
  else
    if (Ns > Vr [Id_Receptor])
      {
      //video[4]=0x32;
      Inserir_Lista_Quadros_Rec_Fora_Ordem (Ns, Ptr_Quadro, Id_Receptor);
      while (Ns > Vr [Id_Receptor])
        {
        Enviar_SREJ (Vr [Id_Receptor], Id_Receptor);
        Inserir_Lista_Quadros_Esperados (Vr [Id_Receptor], Id_Receptor);
        Vr [Id_Receptor]++;
        }
       Vr [Id_Receptor]++;  /* Sai do loop com Vr = Ns, porem prox quadro esperado e' (Ns + 1) */
      }
    else
      {
      //video[4]=0x33;
      Nao_Achou = True;
      Ptr_Lista = Prim_Lista_Quadros_Esperados [Id_Receptor];
      while ((Ptr_Lista) && (Nao_Achou))
        {
        if (Ns == Ptr_Lista->Num_Quadro)
          {
          Inserir_Lista_Quadros_Rec_Fora_Ordem (Ptr_Lista->Num_Quadro,Ptr_Quadro, Id_Receptor);
          Ptr_Lista = Retirar_Lista_Quadros_Esperados (Ptr_Lista, Id_Receptor);
          Verificar_Possibilidade_Enviar_MPDL_Data_Ind (Id_Receptor);
          Nao_Achou = False;
          }
        else
          Ptr_Lista = Ptr_Lista->Ptr_Proximo;
        } /* fim while */

      if ((!Ptr_Lista) && (Nao_Achou))                 /* Percorreu toda a lista e nao achou, logo */
        {
        Liberar_Estrutura_Parametros_Rx (Ptr_Quadro);  /* nao entrou em nenhuma condicao o que in- */
        //video[4]=0x34;
        }
                                                       /* dica que o quadro ja' foi recebido  cor- */
                                                       /* retamente antes                          */

      } /* else */

  } /* fim Verificar_Sequenciamento */


void Verificar_Possibilidade_Enviar_MPDL_Data_Ind (unsigned char Id_Receptor)
  {
   Ptr_Elemento_Lista_Quadros_Rec_Fora_Ordem  Ptr_Aux;

   //video[2]=0x30;

   while (((Prim_Lista_Quadros_Rec_Fora_Ordem [Id_Receptor]) && (Prim_Lista_Quadros_Esperados [Id_Receptor])
             /* as 2 listas nao vazias */
         && (Prim_Lista_Quadros_Esperados [Id_Receptor]->Num_Quadro >
               Prim_Lista_Quadros_Rec_Fora_Ordem [Id_Receptor]->Num_Quadro))
         || ((!Prim_Lista_Quadros_Esperados [Id_Receptor])  /* lista vazia */
         && (Prim_Lista_Quadros_Rec_Fora_Ordem [Id_Receptor] /* lista nao vazia */)))
     {
     Ptr_Aux = Prim_Lista_Quadros_Rec_Fora_Ordem [Id_Receptor];
     if (*Ptr_Aux->Ptr_Quadro->Ptr_Parametros==Cod_MPI)
       Enviar_MPDL_DATA_Ind (Ptr_Aux->Ptr_Quadro, Id_Receptor);
     //video[2]=0x31;
     /* Retira da Lista de Quadros Rec Fora Ordem */
     Prim_Lista_Quadros_Rec_Fora_Ordem [Id_Receptor] = Prim_Lista_Quadros_Rec_Fora_Ordem [Id_Receptor]->Ptr_Proximo;
     if (Prim_Lista_Quadros_Rec_Fora_Ordem [Id_Receptor])
       Prim_Lista_Quadros_Rec_Fora_Ordem [Id_Receptor]->Ptr_Anterior = NULL;
     Liberar_Memoria_Rx ((unsigned char *) Ptr_Aux, sizeof (Tipo_Lista_Quadros_Rec_Fora_Ordem));
     } /* fim while */

  } /* fim Verificar_Possibilidade_Enviar_MPDL_Data_Ind */


void Faltou_Mem_Rx(void)
  {
  cprintf("Nao conseguiu alocar MEMORIA Rx\r\n");
  }

void Retransmite_Todos_os_Quadros(void)
 {
 Ptr_Elemento_Lista_Quadros_Armazenados Ptr_Lista;

 Ptr_Lista = Prim_Lista_Quadros_Armazenados;
 while (Ptr_Lista)
   {
   Enviar_Quadro_I (Ptr_Lista->Ptr_Quadro,Ptr_Lista->Num_Quadro);
   Ptr_Lista = Ptr_Lista->Ptr_Proximo;
   } // fim do while
 }

/***************************************************************************/
/*                                                                         */
/*    Rotinas de manipulacao da Lista de Quadros Recebidos Fora de Ordem   */
/*                                                                         */
/***************************************************************************/


void Inserir_Lista_Quadros_Rec_Fora_Ordem (Long                     Ns,
                                           Ptr_Estrutura_Parametros Ptr_Dados_Quadro,
                                           unsigned char            Id_Receptor)
  {
  Ptr_Elemento_Lista_Quadros_Rec_Fora_Ordem  Ptr_Novo_Elemento;
  Ptr_Elemento_Lista_Quadros_Rec_Fora_Ordem  Ptr_Aux;

  //video[0]=0x30;
  Ptr_Novo_Elemento = (Ptr_Elemento_Lista_Quadros_Rec_Fora_Ordem)
                         Alocar_Memoria_Rx (sizeof(Tipo_Lista_Quadros_Rec_Fora_Ordem));
  if (Ptr_Novo_Elemento)
    {
    //video[0]=0x31;
    Ptr_Novo_Elemento->Num_Quadro = Ns;
    Ptr_Novo_Elemento->Ptr_Quadro = Ptr_Dados_Quadro;
    if (!Prim_Lista_Quadros_Rec_Fora_Ordem[Id_Receptor])  /* Lista vazia */
      {
      //video[0]=0x32;
      Prim_Lista_Quadros_Rec_Fora_Ordem[Id_Receptor]= Ptr_Novo_Elemento;
      Ult_Lista_Quadros_Rec_Fora_Ordem[Id_Receptor] = Ptr_Novo_Elemento;
      Ptr_Novo_Elemento->Ptr_Proximo = NULL;
      Ptr_Novo_Elemento->Ptr_Anterior = NULL;
      } /* if lista vazia */
    else /* lista nao vazia, deve-se inserrir em ordem nao crescente */
      if (Ult_Lista_Quadros_Rec_Fora_Ordem[Id_Receptor]->Num_Quadro < Ns)
        {
        //video[0]=0x33;
        Ult_Lista_Quadros_Rec_Fora_Ordem[Id_Receptor]->Ptr_Proximo = Ptr_Novo_Elemento;
        Ptr_Novo_Elemento->Ptr_Anterior = Ult_Lista_Quadros_Rec_Fora_Ordem[Id_Receptor];
        Ult_Lista_Quadros_Rec_Fora_Ordem[Id_Receptor] = Ptr_Novo_Elemento;
        Ptr_Novo_Elemento->Ptr_Proximo = NULL;
        } /* if Num ultimo quadro > Ns */
      else
        {
        //video[0]=0x34;
        Ptr_Aux = Prim_Lista_Quadros_Rec_Fora_Ordem[Id_Receptor];
        while (Ptr_Aux->Num_Quadro < Ns)
          Ptr_Aux = Ptr_Aux->Ptr_Proximo;
        Ptr_Novo_Elemento->Ptr_Proximo = Ptr_Aux;
        Ptr_Novo_Elemento->Ptr_Anterior = Ptr_Aux->Ptr_Anterior;
        if (Ptr_Aux != Prim_Lista_Quadros_Rec_Fora_Ordem[Id_Receptor])
          Ptr_Aux->Ptr_Anterior->Ptr_Proximo = Ptr_Novo_Elemento;
        else
          Prim_Lista_Quadros_Rec_Fora_Ordem[Id_Receptor] = Ptr_Novo_Elemento;
        Ptr_Aux->Ptr_Anterior = Ptr_Novo_Elemento;
        } /* else do if numero ultimo quadro > Ns */
    }
  else
    Faltou_Mem_Rx();
  //video[0]=0x35;
  } /* fim Inserir_Lista_Quadros_Rec_Fora_Ordem */


void Descartar_Lista_Quadros_Rec_Fora_Ordem (unsigned char Id_Receptor)
  {
  Ptr_Elemento_Lista_Quadros_Rec_Fora_Ordem  Ptr_Lista;

  while (Prim_Lista_Quadros_Rec_Fora_Ordem[Id_Receptor])
    {
    Ptr_Lista = Prim_Lista_Quadros_Rec_Fora_Ordem[Id_Receptor];
    Prim_Lista_Quadros_Rec_Fora_Ordem[Id_Receptor] = Prim_Lista_Quadros_Rec_Fora_Ordem[Id_Receptor]->Ptr_Proximo;
    Liberar_Memoria_Rx ((unsigned char *) Ptr_Lista, sizeof (Tipo_Lista_Quadros_Rec_Fora_Ordem));
    } /* fim while */

  } /* fim Descartar_Lista_Quadros_Rec_Fora_Ordem */


/***************************************************************************/
/*                                                                         */
/*    Rotinas de manipulacao da Lista de Quadros Esperados                 */
/*                                                                         */
/***************************************************************************/


void Inserir_Lista_Quadros_Esperados (Long   Nr_Quadro, unsigned char Id_Receptor)
  {
   Ptr_Elemento_Lista_Quadros_Esperados  Ptr_Novo;

   //video[8]=0x30;
   if ((Ptr_Novo = (Ptr_Elemento_Lista_Quadros_Esperados) Alocar_Memoria_Rx (sizeof(Tipo_Lista_Quadros_Esperados)))!=NULL)
     {
     //video[8]=0x31;
     Ptr_Novo->Num_Quadro = Nr_Quadro;
     if (!Prim_Lista_Quadros_Esperados [Id_Receptor])  /* lista vazia */
       Prim_Lista_Quadros_Esperados [Id_Receptor] = Ptr_Novo;
     else
       Ult_Lista_Quadros_Esperados [Id_Receptor]->Ptr_Proximo = Ptr_Novo;
     Ult_Lista_Quadros_Esperados [Id_Receptor] = Ptr_Novo;
     Ptr_Novo->Ptr_Proximo = NULL;
     //video[8]=0x32;
     }
   else
     Faltou_Mem_Rx();

  } /* fim Inserir_Lista_Quadros_Esperados */


Ptr_Elemento_Lista_Quadros_Esperados
     Retirar_Lista_Quadros_Esperados (Ptr_Elemento_Lista_Quadros_Esperados  Ptr_Lista,
                                      unsigned char     Id_Receptor)
  {
   Ptr_Elemento_Lista_Quadros_Esperados  Ptr_Aux;
   Ptr_Elemento_Lista_Quadros_Esperados  Ptr_Retorno;

   if (Ptr_Lista == Prim_Lista_Quadros_Esperados [Id_Receptor])
     {
      Prim_Lista_Quadros_Esperados [Id_Receptor] = Prim_Lista_Quadros_Esperados [Id_Receptor]->Ptr_Proximo;
      Ptr_Retorno = Prim_Lista_Quadros_Esperados [Id_Receptor];
      Liberar_Memoria_Rx ((unsigned char *) Ptr_Lista, sizeof (Tipo_Lista_Quadros_Esperados));
     } /* if Ptr_Lista == Prim */
   else
     {
      Ptr_Aux = Prim_Lista_Quadros_Esperados [Id_Receptor];
      while (Ptr_Aux->Ptr_Proximo != Ptr_Lista)
        Ptr_Aux = Ptr_Aux->Ptr_Proximo;
      /* Sai do loop com Ptr_Aux apontando para o anterior de Ptr_Lista */
      /* (que e' o elemento a ser retirado) */
      Ptr_Aux->Ptr_Proximo = Ptr_Lista->Ptr_Proximo;
      Ptr_Retorno = Ptr_Lista->Ptr_Proximo;
      if (Ptr_Lista == Ult_Lista_Quadros_Esperados [Id_Receptor])
        Ult_Lista_Quadros_Esperados [Id_Receptor] = Ptr_Aux;
      Liberar_Memoria_Rx ((unsigned char *) Ptr_Lista, sizeof (Tipo_Lista_Quadros_Esperados));
     } /* else do if Ptr_Lista == Prim */
   return (Ptr_Retorno);

  }  /* fim Retirar_Lista_Quadros_Esperados */


void   Descartar_Lista_Quadros_Esperados (unsigned char Id_Receptor)
  {
   Ptr_Elemento_Lista_Quadros_Esperados  Ptr_Lista;

   while (Prim_Lista_Quadros_Esperados [Id_Receptor])
     {
      Ptr_Lista = Prim_Lista_Quadros_Esperados [Id_Receptor];
      Prim_Lista_Quadros_Esperados[Id_Receptor] = Prim_Lista_Quadros_Esperados[Id_Receptor]->Ptr_Proximo;
      Liberar_Memoria_Rx ((unsigned char *) Ptr_Lista, sizeof (Tipo_Lista_Quadros_Esperados));
     } /* fim while */

  } /* fim Descartar_Lista_Quadros_Esperados */


/***************************************************************************/
/*                                                                         */
/*       Rotinas  de tratamento de timeout                                 */
/*                                                                         */
/***************************************************************************/

void  Tratar_Temp_Estourado (void)     // Rotina chamada em Timer.c
  {
  unsigned int   Temp_Estourado;
  unsigned char  i;

  do
    {
    Temp_Estourado = Obter_Timer_Estourado (0);
/*
    fprintf(arq_timer,"\n%4u %4u %4u %4u %4u %4u %4u %4u %4u",Temp_Estourado,
    Cod_Temp_TR ,Cod_Temp_TACK ,Cod_Temp_TIM, Cod_Temp_TRQ ,Cod_Temp_TIP ,Cod_Temp_TKPR ,Cod_Temp_TMT);
    for (i=1;i<=Num_Estacoes; fprintf(arq_timer," %u",Cod_Temp_TI[i++]));
*/
    if (Temp_Estourado==0)
      break;
    if (Temp_Estourado == Cod_Temp_TACK)
      {
      Tratar_Estouro_Temp_TACK ();
      return;
      }
    if (Temp_Estourado == Cod_Temp_TMT)
      {
      Tratar_Estouro_Temp_TMT ();
      return;
      }
    if (Temp_Estourado == Cod_Temp_TR)
      {
      Tratar_Estouro_Temp_TR ();
      return;
      }
    if (Temp_Estourado == Cod_Temp_TIM)
      {
      Tratar_Estouro_Temp_TIM ();
      return;
      }
    if (Temp_Estourado == Cod_Temp_TRQ)
      {
      Tratar_Estouro_Temp_TRQ ();
      return;
      }
    if (Temp_Estourado == Cod_Temp_TIP)
      {
      Tratar_Estouro_Temp_TIP ();
      return;
      }
    if (Temp_Estourado == Cod_Temp_TKPR)
      {
      Tratar_Estouro_Temp_TKPR ();
      return;
      }
    i=1;
    while ((Temp_Estourado!=Cod_Temp_TI[i]) && (i<=Num_Estacoes))
      i++;
    if (Temp_Estourado==Cod_Temp_TI[i])
      Tratar_Estouro_Temp_TI (i);
      #ifdef MSG_ERR
    else
      Msg_Status("Cod_Temp_???");
      cprintf(" %u",Temp_Estourado); //,Cod_Temp_TMT,Cod_Temp_TACK);
//      fprintf(arq_timer,"***");
      #endif
    } while (Timer_Estourado[0]>0);
  } // fim Tratar_Temp_Estourado


void Tratar_Estouro_Temp_TRQ (void)
  {
  Ptr_Estrutura_Parametros  Ptr_Estrutura_PLIST;
  Long                      Ns;

  Cod_Temp_TRQ = 0;
  if ((Estado == OPEN_MASTER) || (Estado == AW_UN_REL))
    {
    if (Prim_Lista_Quadros_Armazenados)   // NP5
      Retransmite_Todos_os_Quadros();     // A11
    else
      {        // P5
      Ns = Vs;      // PLIST
      if ((Ptr_Estrutura_PLIST=Alocar_Estrutura_Parametros_Tx())!=NULL)
        {
        if ((Ptr_Estrutura_PLIST->Ptr_Dados_Usuario=Alocar_Memoria_Tx (Num_Estacoes))!=NULL)
          {
          Ptr_Estrutura_PLIST->Ptr_Proximo=NULL;
          Ptr_Estrutura_PLIST->Ptr_Parametros=(unsigned char*) &Var_Cod_PLIST;
          memcpy(Ptr_Estrutura_PLIST->Ptr_Dados_Usuario,&lista_part[1],Num_Estacoes);
          Ptr_Estrutura_PLIST->Tam_Dados_Usuario=Num_Estacoes;

          if ((Inserir_na_Lista_de_Quadros_Armazenados(Ptr_Estrutura_PLIST, Ns))
             && (Enviar_PLIST(Ns)))
            Vs++;
          }
        else
          Liberar_Estrutura_Parametros_Tx(Ptr_Estrutura_PLIST);
        }
      }
    #ifdef MSG_TIMER
    Msg_Status("MPDL: TRQ");
    #endif

    if (!Reiniciar_Timer (Cod_Temp_TRQ, Tempo_TRQ))  // A69
      Criar_Timer(0,Tempo_TRQ,&Cod_Temp_TRQ);
    if (!Reiniciar_Timer (Cod_Temp_TIM, Tempo_TIM))  // A65
      Criar_Timer(0,Tempo_TIM,&Cod_Temp_TIM);
    }
  }

void Tratar_Estouro_Temp_TIM (void)
  {
  Ptr_Estrutura_Parametros  Ptr_Estrutura_PLIST;
  Long                      Ns;

  Cod_Temp_TIM = 0;
  if ((Estado == OPEN_MASTER) || (Estado == AW_UN_REL))
    {
    if (Prim_Lista_Quadros_Armazenados)   // NP5
      Retransmite_Todos_os_Quadros();     // A11
    else
      {        // P5
      Ns = Vs;      // PLIST
      if ((Ptr_Estrutura_PLIST=Alocar_Estrutura_Parametros_Tx())!=NULL)
        {
        if ((Ptr_Estrutura_PLIST->Ptr_Dados_Usuario=Alocar_Memoria_Tx (Num_Estacoes))!=NULL)
          {
          Ptr_Estrutura_PLIST->Ptr_Proximo=NULL;
          Ptr_Estrutura_PLIST->Ptr_Parametros=(unsigned char*) &Var_Cod_PLIST;
          memcpy(Ptr_Estrutura_PLIST->Ptr_Dados_Usuario,&lista_part[1],Num_Estacoes);
          Ptr_Estrutura_PLIST->Tam_Dados_Usuario=Num_Estacoes;

          if ((Inserir_na_Lista_de_Quadros_Armazenados(Ptr_Estrutura_PLIST, Ns))
             && (Enviar_PLIST(Ns)))
            Vs++;
          }
        else
          Liberar_Estrutura_Parametros_Tx(Ptr_Estrutura_PLIST);
        }
      }
    if (!Reiniciar_Timer (Cod_Temp_TRQ, Tempo_TRQ))  // A69
      Criar_Timer (0,Tempo_TRQ,&Cod_Temp_TRQ);
    if (!Reiniciar_Timer (Cod_Temp_TIM, Tempo_TIM))  // A65
      Criar_Timer(0,Tempo_TIM,&Cod_Temp_TIM);
    #ifdef MSG_TIMER
    Msg_Status("MPDL: TIM");
    #endif
    }
  }


void Tratar_Estouro_Temp_TMT (void)
  {
  Ptr_Estrutura_Parametros  Ptr_Estrutura_PLIST;
  Long                      Ns;
  unsigned char             i;

  Cod_Temp_TMT = 0;
  switch (Estado)
    {
    case OPEN_MASTER:  // TMT
      #ifdef MSG_TIMER
      Msg_Status("MPDL: TMT em Open_Master");
      #endif
      if (prim_fila == ult_fila) // P13
        {
        if (!Reiniciar_Timer (Cod_Temp_TMT,Tempo_TMT)) // A27
          Criar_Timer (0,Tempo_TMT,&Cod_Temp_TMT);
        }
      else  // NP13
        {
        Finalizar_Timer (&Cod_Temp_TRQ);       // A70
        for (i=1;i<=Num_Estacoes;i++)
          if (lista_part[i])
            Finalizar_Timer (&Cod_Temp_TI[i]);       // A8
        Enviar_MPDL_STOP_TRANSMISSION_Ind (); // A59
        esperando_STOP_Resp=true;
        id_nova_mestra=fila_esp[prim_fila];
        prim_fila=(prim_fila % Num_Estacoes)+1; // A24
        Num_Tentativas = 1;
        if (!Reiniciar_Timer (Cod_Temp_TR,Tempo_TR)) // A0
          Criar_Timer (0,Tempo_TR,&Cod_Temp_TR);
        Ns = Vs;
        if ((Ptr_Estrutura_PLIST=Alocar_Estrutura_Parametros_Tx())!=NULL)
          {
          if ((Ptr_Estrutura_PLIST->Ptr_Dados_Usuario=Alocar_Memoria_Tx (Num_Estacoes))!=NULL)
            {
            Ptr_Estrutura_PLIST->Ptr_Proximo=NULL;
            Ptr_Estrutura_PLIST->Ptr_Parametros=(unsigned char*) &Var_Cod_PLIST;
            memcpy(Ptr_Estrutura_PLIST->Ptr_Dados_Usuario,&lista_part[1],Num_Estacoes);
            Ptr_Estrutura_PLIST->Tam_Dados_Usuario=Num_Estacoes;

            if ((Inserir_na_Lista_de_Quadros_Armazenados(Ptr_Estrutura_PLIST, Ns))
               && (Enviar_PLIST(Ns)))
              Vs++;
            }
          else
            Liberar_Estrutura_Parametros_Tx(Ptr_Estrutura_PLIST);
          }
        for (i=1;i<=Num_Estacoes;i++)
          if (!lista_part[i]) prim_quadro_rec[i]=true;  //A71

//        Enviar_TG(id_nova_mestra); foi para tratar_AW_TK_REC;
        Estado = AW_TK_REC;
        #ifdef MSG_TIMER
        Msg_Maq(">AW_TK_REC");
        #endif

        }
      break;

    case AW_UN_REL:       // TMT
      #ifdef MSG_TIMER
      Msg_Status("MPDL: TMT em Aw_Un_Rel");
      #endif
      if (prim_fila == ult_fila) // P13
        {
        if (!Reiniciar_Timer (Cod_Temp_TMT,Tempo_TMT)) // A27
          Criar_Timer (0,Tempo_TMT,&Cod_Temp_TMT);
        }
      else
        {
        Finalizar_Timer (&Cod_Temp_TI[esperando_discac]); // A34
        lista_part[esperando_discac]=false;
        num_part--;
        if (num_part < 2) // P11
          {
          Enviar_MPDISC();
          Enviar_MPDL_ABORT_Ind(LVZ);  // A50
          #ifdef MSG_TIMER
          Msg_Status("MPDL: TMT em Aw_Un_Rel e Fechou por LVZ");
          #endif
          Reiniciar_Camada_MPDL(); // A42 A43 A8 A28 A66 A70 A12 A76 => CLOSED
          }
        else    // NP11
          {
          Retirar_da_Fila_de_Espera(esperando_discac); // P12: A22
          Descartar_Lista_Quadros_Esperados (esperando_discac);       // A42
          Descartar_Lista_Quadros_Rec_Fora_Ordem (esperando_discac);  // A43
          for (i=1;i<=Num_Tentativas*2;i++)
            Enviar_DISC(esperando_discac);
          for (i=1;i<=Num_Estacoes;i++)
            if (lista_part[i])
              Finalizar_Timer (&Cod_Temp_TI[i]);       // A8
          Finalizar_Timer (&Cod_Temp_TRQ);       // A70
          Enviar_MPDL_STOP_TRANSMISSION_Ind (); // A59
          esperando_STOP_Resp=true;
          id_nova_mestra=fila_esp[prim_fila];
          prim_fila=(prim_fila % Num_Estacoes)+1; // A24
          Num_Tentativas = 1;
          if (!Reiniciar_Timer (Cod_Temp_TR,Tempo_TR)) // A0
            Criar_Timer (0,Tempo_TR,&Cod_Temp_TR);
          Ns = Vs;
          if ((Ptr_Estrutura_PLIST=Alocar_Estrutura_Parametros_Tx())!=NULL)
            {
            if ((Ptr_Estrutura_PLIST->Ptr_Dados_Usuario=Alocar_Memoria_Tx (Num_Estacoes))!=NULL)
              {
              Ptr_Estrutura_PLIST->Ptr_Proximo=NULL;
              Ptr_Estrutura_PLIST->Ptr_Parametros=(unsigned char*) &Var_Cod_PLIST;
              memcpy(Ptr_Estrutura_PLIST->Ptr_Dados_Usuario,&lista_part[1],Num_Estacoes);
              Ptr_Estrutura_PLIST->Tam_Dados_Usuario=Num_Estacoes;

              if ((Inserir_na_Lista_de_Quadros_Armazenados(Ptr_Estrutura_PLIST, Ns))
                 && (Enviar_PLIST(Ns)))
                Vs++;
              }
            else
              Liberar_Estrutura_Parametros_Tx(Ptr_Estrutura_PLIST);
            }
          for (i=1;i<=Num_Estacoes;i++)
            if (!lista_part[i]) prim_quadro_rec[i]=true;  //A71

          //  Enviar_TG(id_nova_mestra);
          #ifdef MSG_TIMER
          Msg_Maq(">AW_TK_REC");
          #endif
          Estado = AW_TK_REC;
          }  // NP11
        }
      break;

    }
  }


void Tratar_Estouro_Temp_TKPR (void)
  {
  Cod_Temp_TKPR = 0;
  if (Estado == OPEN_REC)
    {
    if (!Esta_na_Fila_de_Espera(id_est))  // NP12
      Enviar_TP();
    Criar_Timer(0,Tempo_TKPR,&Cod_Temp_TKPR);
    } // fim if Estado
  } // fim Tratar_Estouro_Temp_TKPR

void  Tratar_Estouro_Temp_TR (void)
  {
  unsigned char             i;
  Long                      Ns;
  Ptr_Estrutura_Parametros  Ptr_Estrutura_PLIST;

    #ifdef MSG_TIMER
    Msg_Status("MPDL: TR");
    #endif
  Cod_Temp_TR = 0;
  switch (Estado)
    {
    case ESTABLISH:  // TR
      if (Num_Tentativas <= Num_Max_Tent)  // NP2
        {
         Enviar_SMPARM (0xFF);  // difusao
         Criar_Timer (0,Tempo_TR,&Cod_Temp_TR); // A7
         Num_Tentativas++;
         #ifdef MSG_TIMER
         Msg_Status("TR: Establish:  SMPARM");
         #endif
        }
      else // P2
        {
        if (num_part == 0)  // P1
          {
          #ifdef MSG_TIMER
          Msg_Status("MPDL: Num_Max_Tent com num_part == 0 => ABORT");
          #endif
          Enviar_MPDL_ABORT_Ind (NMT);
          Reiniciar_Camada_MPDL(); // A42 A43 A8 A28 A66 A70 A12 A76 => CLOSED
          break;
          }
        else
          {
          Enviar_BM();
          #ifdef MSG_TIMER
          Msg_Status("MPDL: Enviei MPDL_ESTABLISH_Conf (conferencia_nova)");
          #endif
          pediu_ficha=false;  // A13
          mestra=true;
          id_mestra=id_est;
          Num_Tentativas=1;
          lista_part [id_est] = true;
          num_part++;
          if (!Reiniciar_Timer (Cod_Temp_TIM, Tempo_TIM))  // A65
            Criar_Timer (0,Tempo_TIM,&Cod_Temp_TIM);

          Vs = 0;
          Enviar_MPDL_ESTABLISH_Conf(conferencia_nova);  // A49

          Ns = Vs;                          //  PLIST
          if ((Ptr_Estrutura_PLIST=Alocar_Estrutura_Parametros_Tx())!=NULL)
            {
            if ((Ptr_Estrutura_PLIST->Ptr_Dados_Usuario=Alocar_Memoria_Tx (Num_Estacoes))!=NULL)
              {
              Ptr_Estrutura_PLIST->Ptr_Proximo=NULL;
              Ptr_Estrutura_PLIST->Ptr_Parametros=(unsigned char*) &Var_Cod_PLIST;
              memcpy(Ptr_Estrutura_PLIST->Ptr_Dados_Usuario,&lista_part[1],Num_Estacoes);
              Ptr_Estrutura_PLIST->Tam_Dados_Usuario=Num_Estacoes;

              if ((Inserir_na_Lista_de_Quadros_Armazenados(Ptr_Estrutura_PLIST, Ns))
                 && (Enviar_PLIST(Ns)))
                Vs++;
              }
            else
              Liberar_Estrutura_Parametros_Tx(Ptr_Estrutura_PLIST);
            }

          for (i = 1; i <= Num_Estacoes; i++)
            if ((lista_part[i]) && (i!=id_est))
              Criar_Timer (0,Tempo_TI,&Cod_Temp_TI[i]); // A2
          Criar_Timer (0,Tempo_TMT,&Cod_Temp_TMT); // A26
          Criar_Timer (0,Tempo_TRQ,&Cod_Temp_TRQ); // A68
          Estado = OPEN_MASTER;
          }
        }
      break;

    case AWAIT_REL:  // TR
      if (Num_Tentativas <= Num_Max_Tent)
        {                                 // NP2
        Enviar_MPDISC ();
        Criar_Timer (0,Tempo_TR,&Cod_Temp_TR);  // A7
        Num_Tentativas++;
        }
      else  // Num_Tent > Num_Max
        {
        Enviar_MPDL_ABORT_Conf ();  // A51
        Reiniciar_Camada_MPDL(); // A42 A43 A8 A28 A66 A70 A12 A76 => CLOSED
        }
      break;

    case AW_UN_REL:  // TR
      if (Num_Tentativas <= Num_Max_Tent)
        {                                 // NP2
        for (i=1;i<=Num_Tentativas;i++)
          Enviar_DISC(esperando_discac);
        Criar_Timer (0,Tempo_TR,&Cod_Temp_TR);  // A7
        Num_Tentativas++;
        }
      else
        {
        if (lista_part[esperando_discac]) // P10
          {
          Finalizar_Timer (&Cod_Temp_TI[esperando_discac]);  // A34
          lista_part[esperando_discac]=false; // A21
          num_part--;
          }
        if (num_part < 2)  // P11
          {
          Enviar_MPDISC();
          Enviar_MPDL_ABORT_Ind(LVZ);  // A50
          #ifdef MSG_TIMER
          Msg_Status("MPDL: TR Aw_Un_Rel =>CLOSED");
          #endif
          Reiniciar_Camada_MPDL(); // A42 A43 A8 A28 A66 A70 A12 A76 => CLOSED
          }
        else
          {
          Retirar_da_Fila_de_Espera(esperando_discac); // P12: A22
          Ns = Vs;  // PLIST
          if ((Ptr_Estrutura_PLIST=Alocar_Estrutura_Parametros_Tx())!=NULL)
            {
            if ((Ptr_Estrutura_PLIST->Ptr_Dados_Usuario=Alocar_Memoria_Tx (Num_Estacoes))!=NULL)
              {
              Ptr_Estrutura_PLIST->Ptr_Proximo=NULL;
              Ptr_Estrutura_PLIST->Ptr_Parametros=(unsigned char*) &Var_Cod_PLIST;
              memcpy(Ptr_Estrutura_PLIST->Ptr_Dados_Usuario,&lista_part[1],Num_Estacoes);
              Ptr_Estrutura_PLIST->Tam_Dados_Usuario=Num_Estacoes;

              if ((Inserir_na_Lista_de_Quadros_Armazenados(Ptr_Estrutura_PLIST, Ns))
                 && (Enviar_PLIST(Ns)))
                Vs++;
              }
            else
              Liberar_Estrutura_Parametros_Tx(Ptr_Estrutura_PLIST);
            }
          Enviar_MPDL_INDIVIDUAL_ABORT_Conf(esperando_discac); // A35
          esperando_discac=0;
          Estado=OPEN_MASTER;
          }
        }
      break;

    case AW_TK_REC:  // TR
      if (Num_Tentativas <= Num_Max_Tent)
        {                                 // NP2
        Enviar_TG(id_nova_mestra);
        Criar_Timer (0,Tempo_TR,&Cod_Temp_TR);  // A7
        Num_Tentativas++;
        }
      else     // P2
        {
        Enviar_DISC(id_nova_mestra);
        Finalizar_Timer (&Cod_Temp_TI[id_nova_mestra]);  // A34
        lista_part[id_nova_mestra]=false; // A21
        num_part--;
        if (num_part < 2)  // P11
          {
          Enviar_MPDISC();
          Enviar_MPDL_ABORT_Ind(LVZ);  // A50
          #ifdef MSG_TIMER
          Msg_Status("MPDL: TR Aw_Tk_Rec =>CLOSED");
          #endif
          Reiniciar_Camada_MPDL(); // A42 A43 A8 A28 A66 A70 A12 A76 => CLOSED
          }
        else
          {
          Ns = Vs;  // PLIST
          if ((Ptr_Estrutura_PLIST=Alocar_Estrutura_Parametros_Tx())!=NULL)
            {
            if ((Ptr_Estrutura_PLIST->Ptr_Dados_Usuario=Alocar_Memoria_Tx (Num_Estacoes))!=NULL)
              {
              Ptr_Estrutura_PLIST->Ptr_Proximo=NULL;
              Ptr_Estrutura_PLIST->Ptr_Parametros=(unsigned char*) &Var_Cod_PLIST;
              memcpy(Ptr_Estrutura_PLIST->Ptr_Dados_Usuario,&lista_part[1],Num_Estacoes);
              Ptr_Estrutura_PLIST->Tam_Dados_Usuario=Num_Estacoes;

              if ((Inserir_na_Lista_de_Quadros_Armazenados(Ptr_Estrutura_PLIST, Ns))
                 && (Enviar_PLIST(Ns)))
                Vs++;
              }
            else
              Liberar_Estrutura_Parametros_Tx(Ptr_Estrutura_PLIST);
            }
          Verificar_Descarte_Quadros (id_nova_mestra, Vs);  // A61 A10
          if (prim_fila == ult_fila) // P13
            {
            Criar_Timer (0,Tempo_TMT,&Cod_Temp_TMT); // A26
            Enviar_MPDL_TOKEN_GIVE_Ind (); // A58
            Estado=OPEN_MASTER;
            }
          else  // NP13
            {
            id_nova_mestra=fila_esp[prim_fila];
            prim_fila=(prim_fila % Num_Estacoes)+1; // A24
            Criar_Timer (0,Tempo_TR,&Cod_Temp_TR);  // A4
            Num_Tentativas = 1;
            for (i=1;i<=Num_Estacoes;i++)
              if (!lista_part[i]) prim_quadro_rec[i]=true;  //A71
            Enviar_TG(id_nova_mestra);
            } // NP13
          } // else (num_part < 2)
        } // P2
      break;

  case OPEN_REC:     // TR
    if (!Prim_Lista_Quadros_Armazenados)   // NP5
      Enviar_TP();
    break;

//    case CLOSED:
//  case OPEN_MASTER: // nada a fazer. Retransmissao feita por TRQ
//  case ESTABLISH_REC:;
    } // fim switch

  } // fim Tratar_Estouro_Temp_TR


void  Tratar_Estouro_Temp_TI (unsigned char id_estacao)
  {
  Ptr_Estrutura_Parametros  Ptr_Estrutura_PLIST;
  Long                      Ns;

    #ifdef MSG_TIMER
    Msg_Status("MPDL: TI");
    #endif
  Cod_Temp_TI[id_estacao] = 0;
  if (lista_part[id_estacao])
    switch (Estado)
      {
      case OPEN_MASTER:    // TI
        Enviar_DISC(id_estacao);
        esperando_discac=id_estacao;
        if (lista_part[id_estacao])
          {
          Descartar_Lista_Quadros_Esperados (id_estacao);       // A42
          Descartar_Lista_Quadros_Rec_Fora_Ordem (id_estacao);  // A43
          lista_part[id_estacao]=false; // A21
          num_part--;
          }
        if (num_part < 2)  // P11
          {
          Enviar_MPDISC();
          Enviar_MPDL_ABORT_Ind(LVZ);  // A50
          #ifdef MSG_TIMER
          Msg_Status("MPDL: TI Open_Master =>CLOSED");
          #endif
          Reiniciar_Camada_MPDL(); // A42 A43 A8 A28 A66 A70 A12 A76 => CLOSED
          }
        else
          {
          Enviar_MPDL_INDIVIDUAL_ABORT_Ind(id_estacao);  // A61
          Ns = Vs;  // PLIST
          if ((Ptr_Estrutura_PLIST=Alocar_Estrutura_Parametros_Tx())!=NULL)
            {
            if ((Ptr_Estrutura_PLIST->Ptr_Dados_Usuario=Alocar_Memoria_Tx (Num_Estacoes))!=NULL)
              {
              Ptr_Estrutura_PLIST->Ptr_Proximo=NULL;
              Ptr_Estrutura_PLIST->Ptr_Parametros=(unsigned char*) &Var_Cod_PLIST;
              memcpy(Ptr_Estrutura_PLIST->Ptr_Dados_Usuario,&lista_part[1],Num_Estacoes);
              Ptr_Estrutura_PLIST->Tam_Dados_Usuario=Num_Estacoes;

              if ((Inserir_na_Lista_de_Quadros_Armazenados(Ptr_Estrutura_PLIST, Ns))
                 && (Enviar_PLIST(Ns)))
                Vs++;
              }
            else
              Liberar_Estrutura_Parametros_Tx(Ptr_Estrutura_PLIST);
            }
          Verificar_Descarte_Quadros (id_estacao, Vs);  // A61 A10
          Estado=AW_UN_REL;
          } // else (num_part < 2)
        break;

      case AW_UN_REL:     // TI
      case AW_TK_REC:     // TI
        Enviar_DISC(id_estacao);
        Descartar_Lista_Quadros_Esperados (id_estacao);       // A42
        Descartar_Lista_Quadros_Rec_Fora_Ordem (id_estacao);  // A43
        lista_part[id_estacao]=false; // A21
        num_part--;
        if (num_part < 2)  // P11
          {
          Finalizar_Timer (&Cod_Temp_TR);           // A6
          Enviar_MPDISC();
          Enviar_MPDL_ABORT_Ind(LVZ);  // A50
          #ifdef MSG_TIMER
          Msg_Status("MPDL: TI Aw_Un_Rel =>CLOSED");
          #endif
          Reiniciar_Camada_MPDL(); // A42 A43 A8 A28 A66 A70 A12 A76 => CLOSED
          }
        else
          {
          Enviar_MPDL_INDIVIDUAL_ABORT_Ind(id_estacao);
          Ns = Vs;  // PLIST
          if ((Ptr_Estrutura_PLIST=Alocar_Estrutura_Parametros_Tx())!=NULL)
            {
            if ((Ptr_Estrutura_PLIST->Ptr_Dados_Usuario=Alocar_Memoria_Tx (Num_Estacoes))!=NULL)
              {
              Ptr_Estrutura_PLIST->Ptr_Proximo=NULL;
              Ptr_Estrutura_PLIST->Ptr_Parametros=(unsigned char*) &Var_Cod_PLIST;
              memcpy(Ptr_Estrutura_PLIST->Ptr_Dados_Usuario,&lista_part[1],Num_Estacoes);
              Ptr_Estrutura_PLIST->Tam_Dados_Usuario=Num_Estacoes;

              if ((Inserir_na_Lista_de_Quadros_Armazenados(Ptr_Estrutura_PLIST, Ns))
                 && (Enviar_PLIST(Ns)))
                Vs++;
              }
            else
              Liberar_Estrutura_Parametros_Tx(Ptr_Estrutura_PLIST);
            }
          Verificar_Descarte_Quadros (id_estacao, Vs);  // A61 A10
          } // else (num_part < 2)
        break;


      case AWAIT_REL:     // TI
        if (lista_part[id_estacao])
          {
          lista_part[id_estacao]=false;       // A21
          num_part--;
          Retirar_da_Fila_de_Espera(id_estacao); //P12: A22
          if (num_part < 2)  // P11
            {
            Finalizar_Timer (&Cod_Temp_TR);           // A6
            Enviar_MPDL_ABORT_Conf();  // A51
            Reiniciar_Camada_MPDL(); // A42 A43 A8 A28 A66 A70 A12 A76 => CLOSED
            }
          }


  //    case CLOSED:        // TI
  //    case ESTABLISH:
  //    case OPEN_REC:
  //    case ESTABLISH_REC:
  //      break;
      } // fim do switch

  } // fim Tratar_Estouro_Temp_TI

void  Tratar_Estouro_Temp_TACK (void) // ok 1
  {
  Cod_Temp_TACK = 0;
  if (Estado==OPEN_REC)
    {
    #ifdef MSG_TIMER
    Msg_Status("MPDL: TACK");
    #endif
    if (!Prim_Lista_Quadros_Esperados [id_mestra])  // Lista vazia P7
      Enviar_RR (Vr [id_mestra]);
    else
      Enviar_RR (Prim_Lista_Quadros_Esperados [id_mestra]->Num_Quadro);
    Criar_Timer (0,Tempo_TACK,&Cod_Temp_TACK);  // A38
    }

//  case CLOSED:
//  case ESTABLISH:
//  case AWAIT_REL:
//  case AW_UN_REL:
//  case AW_TK_REC:
//  case OPEN_MASTER:
//  case ESTABLISH_REC:

  } // fim Tratar_Estouro_Temp_TACK

void Tratar_Estouro_Temp_TIP (void)
  {
  Cod_Temp_TIP = 0;
  if (Estado == OPEN_REC)
    {
    if (num_tent_TIP==1) // P18
      {
      #ifdef MSG_TIMER
      Msg_Status("MPDL: TIP = 1");
      #endif
      Finalizar_Timer (&Cod_Temp_TACK);  // A40
      id_nova_mestra=1;
      while ((!lista_part[id_nova_mestra]) && (id_nova_mestra<Num_Estacoes)) // A32
        id_nova_mestra++;
      Criar_Timer(0,Tempo_TIP,&Cod_Temp_TIP); // A33
      num_tent_TIP++;
      if (id_nova_mestra!=id_est) // NP17
        Enviar_CM(id_nova_mestra);
      }
    else  // NP18
      {
      if (num_tent_TIP > Num_Max_Tent) // P2
        {
        if (lista_part[id_nova_mestra])
          {
          lista_part[id_nova_mestra]=false;
          num_part--;
          }
        if (num_part<2)  // P11
          {
          Enviar_MPDL_ABORT_Ind(LVZ);  // A50
          #ifdef MSG_TIMER
          Msg_Status("MPDL: TIP MAX =>CLOSED");
          #endif
          Reiniciar_Camada_MPDL(); // A42 A43 A8 A28 A66 A70 A12 A76 => CLOSED
          }
        else
          {
          #ifdef MSG_TIMER
          Msg_Status("MPDL: TIP > Max e num_part > 1");
          #endif
          Descartar_Lista_Quadros_Esperados (id_nova_mestra);       // A42
          Descartar_Lista_Quadros_Rec_Fora_Ordem (id_nova_mestra);  // A43
          id_nova_mestra=1;
          while ((!lista_part[id_nova_mestra]) && (id_nova_mestra<Num_Estacoes)) // A32
            id_nova_mestra++;
          Criar_Timer(0,Tempo_TIP,&Cod_Temp_TIP); // A33
          num_tent_TIP=1;
          if (id_nova_mestra!=id_est) // NP17
            Enviar_CM(id_nova_mestra);
          }
        }
      else  // NP18:NP2
        {
        if (id_nova_mestra!=id_est) // NP17
          {
          Enviar_CM(id_nova_mestra);
          Criar_Timer(0,Tempo_TIP,&Cod_Temp_TIP); // A33
          }
        num_tent_TIP++;
        } // fim NP2
      } // fim NP18
    } // fim if Estado==...
  } // fim Tratar_Estouro_Temp_TIP
