/* Arquivo: VarMPDL.c              */
/*                                 */
/* Autor: Marcos Tadeu             */
/*                                 */
/* Data Inicio:         21/10/93   */
/* Data Ultima Revisao: 14/11/93   */

#ifndef VARIAVEISMPDL_C
#define VARIAVEISMPDL_C

#include  <tipglob.h>
#include  <tipmpdl.h>

Tipo_Estado    Estado;

Ptr_Elemento_Lista_Quadros_Armazenados  Prim_Lista_Quadros_Armazenados;
Ptr_Elemento_Lista_Quadros_Armazenados  Ult_Lista_Quadros_Armazenados;
unsigned char                           Num_Elem_Lista_Quadros_Armazenados;

Ptr_Elemento_Lista_Quadros_Esperados  Prim_Lista_Quadros_Esperados [Num_Estacoes + 1];
Ptr_Elemento_Lista_Quadros_Esperados  Ult_Lista_Quadros_Esperados [Num_Estacoes + 1];

Ptr_Elemento_Lista_Quadros_Rec_Fora_Ordem  Prim_Lista_Quadros_Rec_Fora_Ordem [Num_Estacoes + 1];
Ptr_Elemento_Lista_Quadros_Rec_Fora_Ordem  Ult_Lista_Quadros_Rec_Fora_Ordem [Num_Estacoes + 1];


Long
  Vs,
  Vr [Num_Estacoes + 1];

unsigned int
           /* Contadores de tempo */
  Cod_Temp_TR,   /* Retransmissao (menos quadros de dados) */
  Cod_Temp_TIM,  /* Inatividade na mestra (sem dados a transmitir) */
  Cod_Temp_TRQ,  /* Retransmissao de quadros de dados */
  Cod_Temp_TIP,  /* Inat. canal principal (ou da mestra - nas receptoras) */
  Cod_Temp_TMT,  /* Fatia maxima de transmissao por estacao */
  Cod_Temp_TACK, /* Envio de Ack (RR) */
  Cod_Temp_TKPR, /* Retransmissao de pedido de ficha */
  Cod_Temp_TI [Num_Estacoes + 1], /* inatividade de estacao (na mestra) */
/* num_estouros_janela=0, num_vezes_faltou_memo=0, num_vezes_faltou_primit=0;*/

  num_srej;


const
  Var_Cod_PLIST = Cod_PLIST,
  Var_Cod_MPI   = Cod_MPI;

unsigned char
  Num_Tentativas,
  num_tent_TIP,
  id_est,
  falta_mandar_conf,
  num_cm_rec,     /* num. de PDU CM recebidas de estacoes diferentes */
  id_nova_mestra, /* id da estacao para onde foi enviada a ficha */
  id_mestra,      /* identidade da mestra atual */
  prim_fila,      /* indice do primeiro da fila */
  ult_fila,       /* indice do ultimo da fila   */
  num_fila,       /* num de est na fila de espera */
  num_part,       /* numero de estacoes participantes */
  esperando_discac; // Id da estacao para a qual se enviou um DISC (0 se nenhuma)

Tipo_Fila
  fila_esp;    /* fila de espera para tx (pediram ficha) */

Tipo_Lista
  nao_rec_cm,  /* nao recebeu CM da estacao */
  prim_quadro_rec, // primeiro quadro numerado recebido da estacao i
  lista_part;  /* lista das estacoes participantes */

Boolean
  prim_q_env=true,       /* primeiro quadro enviado */
  canal_p_ocupado=false, /* canal principal ocupado */
  mestra=false,          /* a estacao  a mestra */
  pediu_ficha=false,     /* a estacao pediu a ficha */
  Mandou_Conf [Num_Estacoes + 1],
  estourou_janela=false,
  faltou_memo=false,
  faltou_primit=false,
  quadro_transmitido=false,
  esperando_STOP_Resp=false;

/*
unsigned char num_alocacoes_Tx,
              num_dealocacoes_Rx,
              num_aloc_fila_LM,
              num_dealoc_fila_ML;
*/
#endif