/* Arquivo: TipMPDL.h                   */
/*                                      */
/*    Versao para rede (packet driver)  */
/*                                      */
/* Autor: Marcos Tadeu von Lutzow Vidal */
/* Data Inicio:         21/10/93        */
/* Data Ultima Revisao: 14/01/94        */

#ifndef TIPOSMPDL
#define TIPOSMPDL

#include "tipglob.h"
#include "cntmpdl.h"

typedef enum
  {
  CLOSED,
  ESTABLISH,
  AWAIT_REL,
  AW_UN_REL,
  AW_TK_REC,
  OPEN_REC,
  OPEN_MASTER,
  ESTABLISH_REC
  }  Tipo_Estado;

typedef enum
  {
  USU,
  NMT,
  SVC,
  LVZ,
  ERR
  } Tipo_Razao;

typedef unsigned char Tipo_Fila[Num_Estacoes+1];

//typedef Boolean Tipo_Lista[Num_Estacoes+1];
typedef unsigned char Tipo_Lista[Num_Estacoes+1];

typedef struct Tipo_Lista_Quadros_Armazenados
  {
  struct Tipo_Lista_Quadros_Armazenados   *Ptr_Proximo;
  Long                                    Num_Quadro;
  Ptr_Estrutura_Parametros                Ptr_Quadro;
  Boolean                                 Quadro_Confirmado [Num_Estacoes + 1];
  unsigned char                           num_conf_pendentes;

  } Tipo_Lista_Quadros_Armazenados;

typedef struct Tipo_Lista_Quadros_Armazenados *Ptr_Elemento_Lista_Quadros_Armazenados;

typedef struct Tipo_Lista_Quadros_Esperados
  {
  struct Tipo_Lista_Quadros_Esperados  *Ptr_Proximo;
  Long                                 Num_Quadro;

  } Tipo_Lista_Quadros_Esperados;

typedef struct Tipo_Lista_Quadros_Esperados *Ptr_Elemento_Lista_Quadros_Esperados;


typedef struct Tipo_Lista_Quadros_Rec_Fora_Ordem
  {
  struct Tipo_Lista_Quadros_Rec_Fora_Ordem   *Ptr_Proximo,
                                             *Ptr_Anterior;
  Long                                       Num_Quadro;
  Ptr_Estrutura_Parametros                   Ptr_Quadro;

  } Tipo_Lista_Quadros_Rec_Fora_Ordem;

typedef struct Tipo_Lista_Quadros_Rec_Fora_Ordem  *Ptr_Elemento_Lista_Quadros_Rec_Fora_Ordem;

#endif
