/* Arquivo: VarMPDL.h                   */
/*                                 			*/
/* Autor: Marcos Tadeu von Lutzow Vidal */
/* Data Inicio:         21/10/93   			*/
/* Data Ultima Revisao: 21/10/93   			*/

#ifndef VARIAVEISMPDL_H
#define VARIAVEISMPDL_H

#include  <tipglob.h>
#include  <cntmpdl.h>
#include  <tipmpdl.h>

extern  Tipo_Estado    Estado;

extern  Ptr_Elemento_Lista_Quadros_Armazenados  Prim_Lista_Quadros_Armazenados;
extern  Ptr_Elemento_Lista_Quadros_Armazenados  Ult_Lista_Quadros_Armazenados;
extern  unsigned char                           Num_Elem_Lista_Quadros_Armazenados;

extern  Ptr_Elemento_Lista_Quadros_Esperados  Prim_Lista_Quadros_Esperados [Num_Estacoes + 1];
extern  Ptr_Elemento_Lista_Quadros_Esperados  Ult_Lista_Quadros_Esperados [Num_Estacoes + 1];

extern  Ptr_Elemento_Lista_Quadros_Rec_Fora_Ordem  Prim_Lista_Quadros_Rec_Fora_Ordem [Num_Estacoes + 1];
extern  Ptr_Elemento_Lista_Quadros_Rec_Fora_Ordem  Ult_Lista_Quadros_Rec_Fora_Ordem [Num_Estacoes + 1];

extern Long
  Vs,
  Vr [Num_Estacoes + 1];


extern unsigned int
           /* Contadores de tempo */
  Cod_Temp_TR,   /* Retransmissao (menos quadros de dados) */
  Cod_Temp_TIM,  /* Inatividade na mestra (sem dados a transmitir) */
  Cod_Temp_TRQ,  /* Retransmissao de quadros de dados */
  Cod_Temp_TIP,  /* Inat. canal principal (ou da mestra - nas receptoras) */
  Cod_Temp_TMT,  /* Fatia maxima de transmissao por estacao */
  Cod_Temp_TACK, /* Envio de Ack (RR) */
  Cod_Temp_TKPR, /* Retransmissao de pedido de ficha */
  Cod_Temp_TI [Num_Estacoes + 1], /* inatividade de estacao (na mestra) */

  num_srej;


extern unsigned char
  Num_Tentativas,
  num_tent_TIP,
  id_est,
  falta_mandar_conf,
  num_cm_rec,     /* num. de PDU CM recebidas de estacoes diferentes */
  id_nova_mestra, /* id da estacao para onde foi enviada a ficha */
  id_mestra,      /* identidade da mestra atual */
  prim_fila,      /* indice do primeiro da fila */
  ult_fila,       /* indice do ultimo da fila   */
  num_fila,       /* num de est na fila de espera */
  num_part,       /* numero de estacoes participantes */
  esperando_discac,// Id da estacao para a qual se enviou um DISC (0 se nenhuma)
  Var_Cod_PLIST,
  Var_Cod_MPI;

/* num_estouros_janela=0, num_vezes_faltou_memo=0, num_vezes_faltou_primit=0;*/

extern Tipo_Fila
  fila_esp;    /* fila de espera para tx (pediram ficha) */

extern Tipo_Lista
  nao_rec_cm,  /* nao recebeu CM da estacao */
  prim_quadro_rec, // primeiro quadro numerado recebido da estacao i
  lista_part;  /* lista das estacoes participantes */

extern Boolean
  prim_q_env,      /* primeiro quadro enviado */
  canal_p_ocupado, /* canal principal ocupado */
  mestra,          /* a estacao  a mestra */
  pediu_ficha,     /* a estacao pediu a ficha */
  Mandou_Conf [Num_Estacoes + 1],
  estourou_janela,
  faltou_memo,
  faltou_primit,
  quadro_transmitido,
  esperando_STOP_Resp;

/*
extern unsigned char num_alocacoes_Tx,
              num_dealocacoes_Rx,
              num_aloc_fila_LM,
              num_dealoc_fila_ML;
*/
#endif
